/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "core/cfg.y"


#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <arpa/inet.h>
#include <string.h>
#include <errno.h>
#include "route_struct.h"
#include "globals.h"
#include "shm_init.h"
#include "route.h"
#include "switch.h"
#include "dprint.h"
#include "sr_module.h"
#include "modparam.h"
#include "ip_addr.h"
#include "resolve.h"
#include "socket_info.h"
#include "name_alias.h"
#include "ut.h"
#include "dset.h"
#include "select.h"
#include "flags.h"
#include "tcp_init.h"
#include "tcp_options.h"
#include "sctp_core.h"
#include "pvar.h"
#include "lvalue.h"
#include "rvalue.h"
#include "sr_compat.h"
#include "msg_translator.h"
#include "async_task.h"

#include "kemi.h"
#include "ppcfg.h"
#include "pvapi.h"
#include "config.h"
#include "daemonize.h"
#include "cfg_core.h"
#include "cfg/cfg.h"
#ifdef CORE_TLS
#include "tls/tls_config.h"
#endif
#include "timer_ticks.h"

#ifdef DEBUG_DMALLOC
#include <dmalloc.h>
#endif

/* hack to avoid alloca usage in the generated C file (needed for compiler
 with no built in alloca, like icc*/
#undef _ALLOCA_H

#define onsend_check(s) \
	do{\
		if (rt!=ONSEND_ROUTE) yyerror( s " allowed only in onsend_routes");\
	}while(0)

	#define IF_AUTO_BIND_IPV6(x) x

#ifdef USE_DNS_CACHE
	#define IF_DNS_CACHE(x) x
#else
	#define IF_DNS_CACHE(x) warn("dns cache support not compiled in")
#endif

#ifdef USE_DNS_FAILOVER
	#define IF_DNS_FAILOVER(x) x
#else
	#define IF_DNS_FAILOVER(x) warn("dns failover support not compiled in")
#endif

#ifdef USE_NAPTR
	#define IF_NAPTR(x) x
#else
	#define IF_NAPTR(x) warn("dns naptr support not compiled in")
#endif

#ifdef USE_DST_BLOCKLIST
	#define IF_DST_BLOCKLIST(x) x
#else
	#define IF_DST_BLOCKLIST(x) warn("dst blocklist support not compiled in")
#endif

#ifdef USE_SCTP
	#define IF_SCTP(x) x
#else
	#define IF_SCTP(x) warn("sctp support not compiled in")
#endif

#ifdef USE_RAW_SOCKS
	#define IF_RAW_SOCKS(x) x
#else
	#define IF_RAW_SOCKS(x) warn("raw socket support not compiled in")
#endif


extern int yylex();
/* safer than using yytext which can be array or pointer */
extern char* yy_number_str;

static void yyerror(char* s, ...);
static void yyerror_at(struct cfg_pos* pos, char* s, ...);
static char* tmp = NULL;
static int i_tmp = 0;
static struct socket_id* lst_tmp = NULL;
static struct name_lst* nl_tmp = NULL;
static int rt = 0;  /* Type of route block for find_export */
static str* str_tmp = NULL;
static str s_tmp = STR_NULL;
static struct ip_addr* ip_tmp = NULL;
static struct avp_spec* s_attr = NULL;
static select_t sel;
static select_t* sel_ptr = NULL;
static pv_spec_t* pv_spec = NULL;
static struct action *mod_func_action = NULL;
static struct lvalue* lval_tmp = NULL;
static struct rvalue* rval_tmp = NULL;
static struct rval_expr* rve_tmp = NULL;
static socket_attrs_t tmp_sa;

static void warn(char* s, ...);
static void warn_at(struct cfg_pos* pos, char* s, ...);
static void get_cpos(struct cfg_pos* pos);
static struct rval_expr* mk_rve_rval(enum rval_type, void* v);
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1);
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2);
static int rval_expr_int_check(struct rval_expr *rve);
static int warn_ct_rve(struct rval_expr *rve, char* name);
static struct socket_id* mk_listen_id(char*, int, int);
static struct name_lst* mk_name_lst(char* name, int flags);
static struct socket_id* mk_listen_id2(struct name_lst*, int, int);
static void free_name_lst(struct name_lst* lst);
static void free_socket_id_lst(struct socket_id* i);

static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
									struct action* a, int* err);
static int case_check_type(struct case_stms* stms);
static int case_check_default(struct case_stms* stms);
static int mod_f_params_pre_fixup(struct action* a);
static void free_mod_func_action(struct action* a);


extern int line;
extern int column;
extern int startcolumn;
extern int startline;
extern char *finame;
extern char *routename;
extern char *default_routename;

#define set_cfg_pos(x) \
	do{\
		if(x) {\
		(x)->cline = line;\
		(x)->cfile = (finame!=0)?finame:((cfg_file!=0)?cfg_file:"default");\
		(x)->rname = (routename!=0)?routename:((default_routename!=0)?default_routename:"DEFAULT");\
		}\
	}while(0)



#line 240 "core/cfg.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "cfg.tab.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_FORWARD = 3,                    /* FORWARD  */
  YYSYMBOL_FORWARD_TCP = 4,                /* FORWARD_TCP  */
  YYSYMBOL_FORWARD_TLS = 5,                /* FORWARD_TLS  */
  YYSYMBOL_FORWARD_SCTP = 6,               /* FORWARD_SCTP  */
  YYSYMBOL_FORWARD_UDP = 7,                /* FORWARD_UDP  */
  YYSYMBOL_EXIT = 8,                       /* EXIT  */
  YYSYMBOL_DROP = 9,                       /* DROP  */
  YYSYMBOL_RETURN = 10,                    /* RETURN  */
  YYSYMBOL_RETURN_MODE = 11,               /* RETURN_MODE  */
  YYSYMBOL_BREAK = 12,                     /* BREAK  */
  YYSYMBOL_LOG_TOK = 13,                   /* LOG_TOK  */
  YYSYMBOL_ERROR = 14,                     /* ERROR  */
  YYSYMBOL_ROUTE = 15,                     /* ROUTE  */
  YYSYMBOL_ROUTE_REQUEST = 16,             /* ROUTE_REQUEST  */
  YYSYMBOL_ROUTE_FAILURE = 17,             /* ROUTE_FAILURE  */
  YYSYMBOL_ROUTE_ONREPLY = 18,             /* ROUTE_ONREPLY  */
  YYSYMBOL_ROUTE_REPLY = 19,               /* ROUTE_REPLY  */
  YYSYMBOL_ROUTE_BRANCH = 20,              /* ROUTE_BRANCH  */
  YYSYMBOL_ROUTE_SEND = 21,                /* ROUTE_SEND  */
  YYSYMBOL_ROUTE_EVENT = 22,               /* ROUTE_EVENT  */
  YYSYMBOL_EXEC = 23,                      /* EXEC  */
  YYSYMBOL_SET_HOST = 24,                  /* SET_HOST  */
  YYSYMBOL_SET_HOSTPORT = 25,              /* SET_HOSTPORT  */
  YYSYMBOL_SET_HOSTPORTTRANS = 26,         /* SET_HOSTPORTTRANS  */
  YYSYMBOL_PREFIX = 27,                    /* PREFIX  */
  YYSYMBOL_STRIP = 28,                     /* STRIP  */
  YYSYMBOL_STRIP_TAIL = 29,                /* STRIP_TAIL  */
  YYSYMBOL_SET_USERPHONE = 30,             /* SET_USERPHONE  */
  YYSYMBOL_APPEND_BRANCH = 31,             /* APPEND_BRANCH  */
  YYSYMBOL_REMOVE_BRANCH = 32,             /* REMOVE_BRANCH  */
  YYSYMBOL_CLEAR_BRANCHES = 33,            /* CLEAR_BRANCHES  */
  YYSYMBOL_SET_USER = 34,                  /* SET_USER  */
  YYSYMBOL_SET_USERPASS = 35,              /* SET_USERPASS  */
  YYSYMBOL_SET_PORT = 36,                  /* SET_PORT  */
  YYSYMBOL_SET_URI = 37,                   /* SET_URI  */
  YYSYMBOL_REVERT_URI = 38,                /* REVERT_URI  */
  YYSYMBOL_FORCE_RPORT = 39,               /* FORCE_RPORT  */
  YYSYMBOL_ADD_LOCAL_RPORT = 40,           /* ADD_LOCAL_RPORT  */
  YYSYMBOL_LOCAL_RPORT = 41,               /* LOCAL_RPORT  */
  YYSYMBOL_FORCE_TCP_ALIAS = 42,           /* FORCE_TCP_ALIAS  */
  YYSYMBOL_UDP_MTU = 43,                   /* UDP_MTU  */
  YYSYMBOL_UDP_MTU_TRY_PROTO = 44,         /* UDP_MTU_TRY_PROTO  */
  YYSYMBOL_UDP4_RAW = 45,                  /* UDP4_RAW  */
  YYSYMBOL_UDP4_RAW_MTU = 46,              /* UDP4_RAW_MTU  */
  YYSYMBOL_UDP4_RAW_TTL = 47,              /* UDP4_RAW_TTL  */
  YYSYMBOL_IF = 48,                        /* IF  */
  YYSYMBOL_ELSE = 49,                      /* ELSE  */
  YYSYMBOL_SET_ADV_ADDRESS = 50,           /* SET_ADV_ADDRESS  */
  YYSYMBOL_SET_ADV_PORT = 51,              /* SET_ADV_PORT  */
  YYSYMBOL_FORCE_SEND_SOCKET = 52,         /* FORCE_SEND_SOCKET  */
  YYSYMBOL_SET_FWD_NO_CONNECT = 53,        /* SET_FWD_NO_CONNECT  */
  YYSYMBOL_SET_RPL_NO_CONNECT = 54,        /* SET_RPL_NO_CONNECT  */
  YYSYMBOL_SET_FWD_CLOSE = 55,             /* SET_FWD_CLOSE  */
  YYSYMBOL_SET_RPL_CLOSE = 56,             /* SET_RPL_CLOSE  */
  YYSYMBOL_SWITCH = 57,                    /* SWITCH  */
  YYSYMBOL_CASE = 58,                      /* CASE  */
  YYSYMBOL_DEFAULT = 59,                   /* DEFAULT  */
  YYSYMBOL_WHILE = 60,                     /* WHILE  */
  YYSYMBOL_CFG_SELECT = 61,                /* CFG_SELECT  */
  YYSYMBOL_CFG_RESET = 62,                 /* CFG_RESET  */
  YYSYMBOL_URIHOST = 63,                   /* URIHOST  */
  YYSYMBOL_URIPORT = 64,                   /* URIPORT  */
  YYSYMBOL_MAX_LEN = 65,                   /* MAX_LEN  */
  YYSYMBOL_SETFLAG = 66,                   /* SETFLAG  */
  YYSYMBOL_RESETFLAG = 67,                 /* RESETFLAG  */
  YYSYMBOL_ISFLAGSET = 68,                 /* ISFLAGSET  */
  YYSYMBOL_SETAVPFLAG = 69,                /* SETAVPFLAG  */
  YYSYMBOL_RESETAVPFLAG = 70,              /* RESETAVPFLAG  */
  YYSYMBOL_ISAVPFLAGSET = 71,              /* ISAVPFLAGSET  */
  YYSYMBOL_METHOD = 72,                    /* METHOD  */
  YYSYMBOL_URI = 73,                       /* URI  */
  YYSYMBOL_FROM_URI = 74,                  /* FROM_URI  */
  YYSYMBOL_TO_URI = 75,                    /* TO_URI  */
  YYSYMBOL_SRCIP = 76,                     /* SRCIP  */
  YYSYMBOL_SRCPORT = 77,                   /* SRCPORT  */
  YYSYMBOL_DSTIP = 78,                     /* DSTIP  */
  YYSYMBOL_DSTPORT = 79,                   /* DSTPORT  */
  YYSYMBOL_TOIP = 80,                      /* TOIP  */
  YYSYMBOL_TOPORT = 81,                    /* TOPORT  */
  YYSYMBOL_SNDIP = 82,                     /* SNDIP  */
  YYSYMBOL_SNDPORT = 83,                   /* SNDPORT  */
  YYSYMBOL_SNDPROTO = 84,                  /* SNDPROTO  */
  YYSYMBOL_SNDAF = 85,                     /* SNDAF  */
  YYSYMBOL_PROTO = 86,                     /* PROTO  */
  YYSYMBOL_AF = 87,                        /* AF  */
  YYSYMBOL_MYSELF = 88,                    /* MYSELF  */
  YYSYMBOL_MSGLEN = 89,                    /* MSGLEN  */
  YYSYMBOL_UDP = 90,                       /* UDP  */
  YYSYMBOL_TCP = 91,                       /* TCP  */
  YYSYMBOL_TLS = 92,                       /* TLS  */
  YYSYMBOL_SCTP = 93,                      /* SCTP  */
  YYSYMBOL_WS = 94,                        /* WS  */
  YYSYMBOL_WSS = 95,                       /* WSS  */
  YYSYMBOL_DEBUG_V = 96,                   /* DEBUG_V  */
  YYSYMBOL_FORK = 97,                      /* FORK  */
  YYSYMBOL_FORK_DELAY = 98,                /* FORK_DELAY  */
  YYSYMBOL_MODINIT_DELAY = 99,             /* MODINIT_DELAY  */
  YYSYMBOL_LOGSTDERROR = 100,              /* LOGSTDERROR  */
  YYSYMBOL_LOGFACILITY = 101,              /* LOGFACILITY  */
  YYSYMBOL_LOGNAME = 102,                  /* LOGNAME  */
  YYSYMBOL_LOGCOLOR = 103,                 /* LOGCOLOR  */
  YYSYMBOL_LOGPREFIX = 104,                /* LOGPREFIX  */
  YYSYMBOL_LOGPREFIXMODE = 105,            /* LOGPREFIXMODE  */
  YYSYMBOL_LOGENGINETYPE = 106,            /* LOGENGINETYPE  */
  YYSYMBOL_LOGENGINEDATA = 107,            /* LOGENGINEDATA  */
  YYSYMBOL_XAVPVIAPARAMS = 108,            /* XAVPVIAPARAMS  */
  YYSYMBOL_XAVPVIAFIELDS = 109,            /* XAVPVIAFIELDS  */
  YYSYMBOL_XAVPVIAREPLYPARAMS = 110,       /* XAVPVIAREPLYPARAMS  */
  YYSYMBOL_LISTEN = 111,                   /* LISTEN  */
  YYSYMBOL_ADVERTISE = 112,                /* ADVERTISE  */
  YYSYMBOL_VIRTUAL = 113,                  /* VIRTUAL  */
  YYSYMBOL_STRNAME = 114,                  /* STRNAME  */
  YYSYMBOL_ALIAS = 115,                    /* ALIAS  */
  YYSYMBOL_SR_AUTO_ALIASES = 116,          /* SR_AUTO_ALIASES  */
  YYSYMBOL_DOMAIN = 117,                   /* DOMAIN  */
  YYSYMBOL_SR_AUTO_DOMAINS = 118,          /* SR_AUTO_DOMAINS  */
  YYSYMBOL_DNS = 119,                      /* DNS  */
  YYSYMBOL_REV_DNS = 120,                  /* REV_DNS  */
  YYSYMBOL_DNS_TRY_IPV6 = 121,             /* DNS_TRY_IPV6  */
  YYSYMBOL_DNS_TRY_NAPTR = 122,            /* DNS_TRY_NAPTR  */
  YYSYMBOL_DNS_SRV_LB = 123,               /* DNS_SRV_LB  */
  YYSYMBOL_DNS_UDP_PREF = 124,             /* DNS_UDP_PREF  */
  YYSYMBOL_DNS_TCP_PREF = 125,             /* DNS_TCP_PREF  */
  YYSYMBOL_DNS_TLS_PREF = 126,             /* DNS_TLS_PREF  */
  YYSYMBOL_DNS_SCTP_PREF = 127,            /* DNS_SCTP_PREF  */
  YYSYMBOL_DNS_RETR_TIME = 128,            /* DNS_RETR_TIME  */
  YYSYMBOL_DNS_SLOW_QUERY_MS = 129,        /* DNS_SLOW_QUERY_MS  */
  YYSYMBOL_DNS_RETR_NO = 130,              /* DNS_RETR_NO  */
  YYSYMBOL_DNS_SERVERS_NO = 131,           /* DNS_SERVERS_NO  */
  YYSYMBOL_DNS_USE_SEARCH = 132,           /* DNS_USE_SEARCH  */
  YYSYMBOL_DNS_SEARCH_FMATCH = 133,        /* DNS_SEARCH_FMATCH  */
  YYSYMBOL_DNS_NAPTR_IGNORE_RFC = 134,     /* DNS_NAPTR_IGNORE_RFC  */
  YYSYMBOL_DNS_CACHE_INIT = 135,           /* DNS_CACHE_INIT  */
  YYSYMBOL_DNS_USE_CACHE = 136,            /* DNS_USE_CACHE  */
  YYSYMBOL_DNS_USE_FAILOVER = 137,         /* DNS_USE_FAILOVER  */
  YYSYMBOL_DNS_CACHE_FLAGS = 138,          /* DNS_CACHE_FLAGS  */
  YYSYMBOL_DNS_CACHE_NEG_TTL = 139,        /* DNS_CACHE_NEG_TTL  */
  YYSYMBOL_DNS_CACHE_MIN_TTL = 140,        /* DNS_CACHE_MIN_TTL  */
  YYSYMBOL_DNS_CACHE_MAX_TTL = 141,        /* DNS_CACHE_MAX_TTL  */
  YYSYMBOL_DNS_CACHE_MEM = 142,            /* DNS_CACHE_MEM  */
  YYSYMBOL_DNS_CACHE_GC_INT = 143,         /* DNS_CACHE_GC_INT  */
  YYSYMBOL_DNS_CACHE_DEL_NONEXP = 144,     /* DNS_CACHE_DEL_NONEXP  */
  YYSYMBOL_DNS_CACHE_REC_PREF = 145,       /* DNS_CACHE_REC_PREF  */
  YYSYMBOL_AUTO_BIND_IPV6 = 146,           /* AUTO_BIND_IPV6  */
  YYSYMBOL_BIND_IPV6_LINK_LOCAL = 147,     /* BIND_IPV6_LINK_LOCAL  */
  YYSYMBOL_IPV6_HEX_STYLE = 148,           /* IPV6_HEX_STYLE  */
  YYSYMBOL_DST_BLST_INIT = 149,            /* DST_BLST_INIT  */
  YYSYMBOL_USE_DST_BLST = 150,             /* USE_DST_BLST  */
  YYSYMBOL_DST_BLST_MEM = 151,             /* DST_BLST_MEM  */
  YYSYMBOL_DST_BLST_TTL = 152,             /* DST_BLST_TTL  */
  YYSYMBOL_DST_BLST_GC_INT = 153,          /* DST_BLST_GC_INT  */
  YYSYMBOL_DST_BLST_UDP_IMASK = 154,       /* DST_BLST_UDP_IMASK  */
  YYSYMBOL_DST_BLST_TCP_IMASK = 155,       /* DST_BLST_TCP_IMASK  */
  YYSYMBOL_DST_BLST_TLS_IMASK = 156,       /* DST_BLST_TLS_IMASK  */
  YYSYMBOL_DST_BLST_SCTP_IMASK = 157,      /* DST_BLST_SCTP_IMASK  */
  YYSYMBOL_IP_FREE_BIND = 158,             /* IP_FREE_BIND  */
  YYSYMBOL_PORT = 159,                     /* PORT  */
  YYSYMBOL_STAT = 160,                     /* STAT  */
  YYSYMBOL_STATS_NAMESEP = 161,            /* STATS_NAMESEP  */
  YYSYMBOL_CHILDREN = 162,                 /* CHILDREN  */
  YYSYMBOL_SOCKET = 163,                   /* SOCKET  */
  YYSYMBOL_BIND = 164,                     /* BIND  */
  YYSYMBOL_WORKERS = 165,                  /* WORKERS  */
  YYSYMBOL_SOCKET_WORKERS = 166,           /* SOCKET_WORKERS  */
  YYSYMBOL_ASYNC_WORKERS = 167,            /* ASYNC_WORKERS  */
  YYSYMBOL_ASYNC_USLEEP = 168,             /* ASYNC_USLEEP  */
  YYSYMBOL_ASYNC_NONBLOCK = 169,           /* ASYNC_NONBLOCK  */
  YYSYMBOL_ASYNC_WORKERS_GROUP = 170,      /* ASYNC_WORKERS_GROUP  */
  YYSYMBOL_CHECK_VIA = 171,                /* CHECK_VIA  */
  YYSYMBOL_PHONE2TEL = 172,                /* PHONE2TEL  */
  YYSYMBOL_MEMLOG = 173,                   /* MEMLOG  */
  YYSYMBOL_MEMDBG = 174,                   /* MEMDBG  */
  YYSYMBOL_MEMSUM = 175,                   /* MEMSUM  */
  YYSYMBOL_MEMSAFETY = 176,                /* MEMSAFETY  */
  YYSYMBOL_MEMJOIN = 177,                  /* MEMJOIN  */
  YYSYMBOL_MEMSTATUSMODE = 178,            /* MEMSTATUSMODE  */
  YYSYMBOL_SIP_PARSER_LOG_ONELINE = 179,   /* SIP_PARSER_LOG_ONELINE  */
  YYSYMBOL_SIP_PARSER_LOG = 180,           /* SIP_PARSER_LOG  */
  YYSYMBOL_SIP_PARSER_MODE = 181,          /* SIP_PARSER_MODE  */
  YYSYMBOL_CORELOG = 182,                  /* CORELOG  */
  YYSYMBOL_SIP_WARNING = 183,              /* SIP_WARNING  */
  YYSYMBOL_SERVER_SIGNATURE = 184,         /* SERVER_SIGNATURE  */
  YYSYMBOL_SERVER_HEADER = 185,            /* SERVER_HEADER  */
  YYSYMBOL_USER_AGENT_HEADER = 186,        /* USER_AGENT_HEADER  */
  YYSYMBOL_REPLY_TO_VIA = 187,             /* REPLY_TO_VIA  */
  YYSYMBOL_LOADMODULE = 188,               /* LOADMODULE  */
  YYSYMBOL_LOADMODULEX = 189,              /* LOADMODULEX  */
  YYSYMBOL_LOADPATH = 190,                 /* LOADPATH  */
  YYSYMBOL_MODPARAM = 191,                 /* MODPARAM  */
  YYSYMBOL_MODPARAMX = 192,                /* MODPARAMX  */
  YYSYMBOL_CFGENGINE = 193,                /* CFGENGINE  */
  YYSYMBOL_MAXBUFFER = 194,                /* MAXBUFFER  */
  YYSYMBOL_MAXSNDBUFFER = 195,             /* MAXSNDBUFFER  */
  YYSYMBOL_SQL_BUFFER_SIZE = 196,          /* SQL_BUFFER_SIZE  */
  YYSYMBOL_MSG_RECV_MAX_SIZE = 197,        /* MSG_RECV_MAX_SIZE  */
  YYSYMBOL_TCP_MSG_READ_TIMEOUT = 198,     /* TCP_MSG_READ_TIMEOUT  */
  YYSYMBOL_TCP_MSG_DATA_TIMEOUT = 199,     /* TCP_MSG_DATA_TIMEOUT  */
  YYSYMBOL_TCP_ACCEPT_IPLIMIT = 200,       /* TCP_ACCEPT_IPLIMIT  */
  YYSYMBOL_TCP_CHECK_TIMER = 201,          /* TCP_CHECK_TIMER  */
  YYSYMBOL_USER = 202,                     /* USER  */
  YYSYMBOL_GROUP = 203,                    /* GROUP  */
  YYSYMBOL_CHROOT = 204,                   /* CHROOT  */
  YYSYMBOL_WDIR = 205,                     /* WDIR  */
  YYSYMBOL_RUNDIR = 206,                   /* RUNDIR  */
  YYSYMBOL_MHOMED = 207,                   /* MHOMED  */
  YYSYMBOL_DISABLE_TCP = 208,              /* DISABLE_TCP  */
  YYSYMBOL_TCP_ACCEPT_ALIASES = 209,       /* TCP_ACCEPT_ALIASES  */
  YYSYMBOL_TCP_ACCEPT_UNIQUE = 210,        /* TCP_ACCEPT_UNIQUE  */
  YYSYMBOL_TCP_CONNECTION_MATCH = 211,     /* TCP_CONNECTION_MATCH  */
  YYSYMBOL_TCP_CHILDREN = 212,             /* TCP_CHILDREN  */
  YYSYMBOL_TCP_CONNECT_TIMEOUT = 213,      /* TCP_CONNECT_TIMEOUT  */
  YYSYMBOL_TCP_SEND_TIMEOUT = 214,         /* TCP_SEND_TIMEOUT  */
  YYSYMBOL_TCP_CON_LIFETIME = 215,         /* TCP_CON_LIFETIME  */
  YYSYMBOL_TCP_POLL_METHOD = 216,          /* TCP_POLL_METHOD  */
  YYSYMBOL_TCP_MAX_CONNECTIONS = 217,      /* TCP_MAX_CONNECTIONS  */
  YYSYMBOL_TLS_MAX_CONNECTIONS = 218,      /* TLS_MAX_CONNECTIONS  */
  YYSYMBOL_TCP_NO_CONNECT = 219,           /* TCP_NO_CONNECT  */
  YYSYMBOL_TCP_SOURCE_IPV4 = 220,          /* TCP_SOURCE_IPV4  */
  YYSYMBOL_TCP_SOURCE_IPV6 = 221,          /* TCP_SOURCE_IPV6  */
  YYSYMBOL_TCP_OPT_FD_CACHE = 222,         /* TCP_OPT_FD_CACHE  */
  YYSYMBOL_TCP_OPT_BUF_WRITE = 223,        /* TCP_OPT_BUF_WRITE  */
  YYSYMBOL_TCP_OPT_CONN_WQ_MAX = 224,      /* TCP_OPT_CONN_WQ_MAX  */
  YYSYMBOL_TCP_OPT_WQ_MAX = 225,           /* TCP_OPT_WQ_MAX  */
  YYSYMBOL_TCP_OPT_RD_BUF = 226,           /* TCP_OPT_RD_BUF  */
  YYSYMBOL_TCP_OPT_WQ_BLK = 227,           /* TCP_OPT_WQ_BLK  */
  YYSYMBOL_TCP_OPT_DEFER_ACCEPT = 228,     /* TCP_OPT_DEFER_ACCEPT  */
  YYSYMBOL_TCP_OPT_DELAYED_ACK = 229,      /* TCP_OPT_DELAYED_ACK  */
  YYSYMBOL_TCP_OPT_SYNCNT = 230,           /* TCP_OPT_SYNCNT  */
  YYSYMBOL_TCP_OPT_LINGER2 = 231,          /* TCP_OPT_LINGER2  */
  YYSYMBOL_TCP_OPT_KEEPALIVE = 232,        /* TCP_OPT_KEEPALIVE  */
  YYSYMBOL_TCP_OPT_KEEPIDLE = 233,         /* TCP_OPT_KEEPIDLE  */
  YYSYMBOL_TCP_OPT_KEEPINTVL = 234,        /* TCP_OPT_KEEPINTVL  */
  YYSYMBOL_TCP_OPT_KEEPCNT = 235,          /* TCP_OPT_KEEPCNT  */
  YYSYMBOL_TCP_OPT_CRLF_PING = 236,        /* TCP_OPT_CRLF_PING  */
  YYSYMBOL_TCP_OPT_ACCEPT_NO_CL = 237,     /* TCP_OPT_ACCEPT_NO_CL  */
  YYSYMBOL_TCP_OPT_ACCEPT_HEP3 = 238,      /* TCP_OPT_ACCEPT_HEP3  */
  YYSYMBOL_TCP_OPT_ACCEPT_HAPROXY = 239,   /* TCP_OPT_ACCEPT_HAPROXY  */
  YYSYMBOL_TCP_OPT_CLOSE_RST = 240,        /* TCP_OPT_CLOSE_RST  */
  YYSYMBOL_TCP_CLONE_RCVBUF = 241,         /* TCP_CLONE_RCVBUF  */
  YYSYMBOL_TCP_REUSE_PORT = 242,           /* TCP_REUSE_PORT  */
  YYSYMBOL_TCP_WAIT_DATA = 243,            /* TCP_WAIT_DATA  */
  YYSYMBOL_TCP_SCRIPT_MODE = 244,          /* TCP_SCRIPT_MODE  */
  YYSYMBOL_DISABLE_TLS = 245,              /* DISABLE_TLS  */
  YYSYMBOL_ENABLE_TLS = 246,               /* ENABLE_TLS  */
  YYSYMBOL_TLSLOG = 247,                   /* TLSLOG  */
  YYSYMBOL_TLS_PORT_NO = 248,              /* TLS_PORT_NO  */
  YYSYMBOL_TLS_METHOD = 249,               /* TLS_METHOD  */
  YYSYMBOL_TLS_HANDSHAKE_TIMEOUT = 250,    /* TLS_HANDSHAKE_TIMEOUT  */
  YYSYMBOL_TLS_SEND_TIMEOUT = 251,         /* TLS_SEND_TIMEOUT  */
  YYSYMBOL_SSLv23 = 252,                   /* SSLv23  */
  YYSYMBOL_SSLv2 = 253,                    /* SSLv2  */
  YYSYMBOL_SSLv3 = 254,                    /* SSLv3  */
  YYSYMBOL_TLSv1 = 255,                    /* TLSv1  */
  YYSYMBOL_TLS_VERIFY = 256,               /* TLS_VERIFY  */
  YYSYMBOL_TLS_REQUIRE_CERTIFICATE = 257,  /* TLS_REQUIRE_CERTIFICATE  */
  YYSYMBOL_TLS_CERTIFICATE = 258,          /* TLS_CERTIFICATE  */
  YYSYMBOL_TLS_PRIVATE_KEY = 259,          /* TLS_PRIVATE_KEY  */
  YYSYMBOL_TLS_CA_LIST = 260,              /* TLS_CA_LIST  */
  YYSYMBOL_DISABLE_SCTP = 261,             /* DISABLE_SCTP  */
  YYSYMBOL_ENABLE_SCTP = 262,              /* ENABLE_SCTP  */
  YYSYMBOL_SCTP_CHILDREN = 263,            /* SCTP_CHILDREN  */
  YYSYMBOL_ADVERTISED_ADDRESS = 264,       /* ADVERTISED_ADDRESS  */
  YYSYMBOL_ADVERTISED_PORT = 265,          /* ADVERTISED_PORT  */
  YYSYMBOL_DISABLE_CORE = 266,             /* DISABLE_CORE  */
  YYSYMBOL_OPEN_FD_LIMIT = 267,            /* OPEN_FD_LIMIT  */
  YYSYMBOL_SHM_MEM_SZ = 268,               /* SHM_MEM_SZ  */
  YYSYMBOL_SHM_FORCE_ALLOC = 269,          /* SHM_FORCE_ALLOC  */
  YYSYMBOL_MLOCK_PAGES = 270,              /* MLOCK_PAGES  */
  YYSYMBOL_REAL_TIME = 271,                /* REAL_TIME  */
  YYSYMBOL_RT_PRIO = 272,                  /* RT_PRIO  */
  YYSYMBOL_RT_POLICY = 273,                /* RT_POLICY  */
  YYSYMBOL_RT_TIMER1_PRIO = 274,           /* RT_TIMER1_PRIO  */
  YYSYMBOL_RT_TIMER1_POLICY = 275,         /* RT_TIMER1_POLICY  */
  YYSYMBOL_RT_TIMER2_PRIO = 276,           /* RT_TIMER2_PRIO  */
  YYSYMBOL_RT_TIMER2_POLICY = 277,         /* RT_TIMER2_POLICY  */
  YYSYMBOL_MCAST_LOOPBACK = 278,           /* MCAST_LOOPBACK  */
  YYSYMBOL_MCAST_TTL = 279,                /* MCAST_TTL  */
  YYSYMBOL_MCAST = 280,                    /* MCAST  */
  YYSYMBOL_TOS = 281,                      /* TOS  */
  YYSYMBOL_PMTU_DISCOVERY = 282,           /* PMTU_DISCOVERY  */
  YYSYMBOL_KILL_TIMEOUT = 283,             /* KILL_TIMEOUT  */
  YYSYMBOL_MAX_WLOOPS = 284,               /* MAX_WLOOPS  */
  YYSYMBOL_PVBUFSIZE = 285,                /* PVBUFSIZE  */
  YYSYMBOL_PVBUFSLOTS = 286,               /* PVBUFSLOTS  */
  YYSYMBOL_PVCACHELIMIT = 287,             /* PVCACHELIMIT  */
  YYSYMBOL_PVCACHEACTION = 288,            /* PVCACHEACTION  */
  YYSYMBOL_HTTP_REPLY_PARSE = 289,         /* HTTP_REPLY_PARSE  */
  YYSYMBOL_VERSION_TABLE_CFG = 290,        /* VERSION_TABLE_CFG  */
  YYSYMBOL_VERBOSE_STARTUP = 291,          /* VERBOSE_STARTUP  */
  YYSYMBOL_ROUTE_LOCKS_SIZE = 292,         /* ROUTE_LOCKS_SIZE  */
  YYSYMBOL_WAIT_WORKER1_MODE = 293,        /* WAIT_WORKER1_MODE  */
  YYSYMBOL_WAIT_WORKER1_TIME = 294,        /* WAIT_WORKER1_TIME  */
  YYSYMBOL_WAIT_WORKER1_USLEEP = 295,      /* WAIT_WORKER1_USLEEP  */
  YYSYMBOL_CFG_DESCRIPTION = 296,          /* CFG_DESCRIPTION  */
  YYSYMBOL_SERVER_ID = 297,                /* SERVER_ID  */
  YYSYMBOL_KEMI = 298,                     /* KEMI  */
  YYSYMBOL_REQUEST_ROUTE_CALLBACK = 299,   /* REQUEST_ROUTE_CALLBACK  */
  YYSYMBOL_ONSEND_ROUTE_CALLBACK = 300,    /* ONSEND_ROUTE_CALLBACK  */
  YYSYMBOL_REPLY_ROUTE_CALLBACK = 301,     /* REPLY_ROUTE_CALLBACK  */
  YYSYMBOL_EVENT_ROUTE_CALLBACK = 302,     /* EVENT_ROUTE_CALLBACK  */
  YYSYMBOL_RECEIVED_ROUTE_CALLBACK = 303,  /* RECEIVED_ROUTE_CALLBACK  */
  YYSYMBOL_RECEIVED_ROUTE_MODE = 304,      /* RECEIVED_ROUTE_MODE  */
  YYSYMBOL_PRE_ROUTING_CALLBACK = 305,     /* PRE_ROUTING_CALLBACK  */
  YYSYMBOL_MAX_RECURSIVE_LEVEL = 306,      /* MAX_RECURSIVE_LEVEL  */
  YYSYMBOL_MAX_BRANCHES_PARAM = 307,       /* MAX_BRANCHES_PARAM  */
  YYSYMBOL_LATENCY_CFG_LOG = 308,          /* LATENCY_CFG_LOG  */
  YYSYMBOL_LATENCY_LOG = 309,              /* LATENCY_LOG  */
  YYSYMBOL_LATENCY_LIMIT_DB = 310,         /* LATENCY_LIMIT_DB  */
  YYSYMBOL_LATENCY_LIMIT_ACTION = 311,     /* LATENCY_LIMIT_ACTION  */
  YYSYMBOL_LATENCY_LIMIT_CFG = 312,        /* LATENCY_LIMIT_CFG  */
  YYSYMBOL_RPC_EXEC_DELTA_CFG = 313,       /* RPC_EXEC_DELTA_CFG  */
  YYSYMBOL_MSG_TIME = 314,                 /* MSG_TIME  */
  YYSYMBOL_ONSEND_RT_REPLY = 315,          /* ONSEND_RT_REPLY  */
  YYSYMBOL_URI_HOST_EXTRA_CHARS = 316,     /* URI_HOST_EXTRA_CHARS  */
  YYSYMBOL_HDR_NAME_EXTRA_CHARS = 317,     /* HDR_NAME_EXTRA_CHARS  */
  YYSYMBOL_FLAGS_DECL = 318,               /* FLAGS_DECL  */
  YYSYMBOL_AVPFLAGS_DECL = 319,            /* AVPFLAGS_DECL  */
  YYSYMBOL_ATTR_MARK = 320,                /* ATTR_MARK  */
  YYSYMBOL_SELECT_MARK = 321,              /* SELECT_MARK  */
  YYSYMBOL_ATTR_FROM = 322,                /* ATTR_FROM  */
  YYSYMBOL_ATTR_TO = 323,                  /* ATTR_TO  */
  YYSYMBOL_ATTR_FROMURI = 324,             /* ATTR_FROMURI  */
  YYSYMBOL_ATTR_TOURI = 325,               /* ATTR_TOURI  */
  YYSYMBOL_ATTR_FROMUSER = 326,            /* ATTR_FROMUSER  */
  YYSYMBOL_ATTR_TOUSER = 327,              /* ATTR_TOUSER  */
  YYSYMBOL_ATTR_FROMDOMAIN = 328,          /* ATTR_FROMDOMAIN  */
  YYSYMBOL_ATTR_TODOMAIN = 329,            /* ATTR_TODOMAIN  */
  YYSYMBOL_ATTR_GLOBAL = 330,              /* ATTR_GLOBAL  */
  YYSYMBOL_ADDEQ = 331,                    /* ADDEQ  */
  YYSYMBOL_SUBST = 332,                    /* SUBST  */
  YYSYMBOL_SUBSTDEF = 333,                 /* SUBSTDEF  */
  YYSYMBOL_SUBSTDEFS = 334,                /* SUBSTDEFS  */
  YYSYMBOL_EQUAL = 335,                    /* EQUAL  */
  YYSYMBOL_LOG_OR = 336,                   /* LOG_OR  */
  YYSYMBOL_LOG_AND = 337,                  /* LOG_AND  */
  YYSYMBOL_BIN_OR = 338,                   /* BIN_OR  */
  YYSYMBOL_BIN_AND = 339,                  /* BIN_AND  */
  YYSYMBOL_BIN_XOR = 340,                  /* BIN_XOR  */
  YYSYMBOL_BIN_LSHIFT = 341,               /* BIN_LSHIFT  */
  YYSYMBOL_BIN_RSHIFT = 342,               /* BIN_RSHIFT  */
  YYSYMBOL_EQUAL_T = 343,                  /* EQUAL_T  */
  YYSYMBOL_DIFF = 344,                     /* DIFF  */
  YYSYMBOL_MATCH = 345,                    /* MATCH  */
  YYSYMBOL_INTEQ = 346,                    /* INTEQ  */
  YYSYMBOL_INTDIFF = 347,                  /* INTDIFF  */
  YYSYMBOL_STREQ = 348,                    /* STREQ  */
  YYSYMBOL_STRDIFF = 349,                  /* STRDIFF  */
  YYSYMBOL_GT = 350,                       /* GT  */
  YYSYMBOL_LT = 351,                       /* LT  */
  YYSYMBOL_GTE = 352,                      /* GTE  */
  YYSYMBOL_LTE = 353,                      /* LTE  */
  YYSYMBOL_PLUS = 354,                     /* PLUS  */
  YYSYMBOL_MINUS = 355,                    /* MINUS  */
  YYSYMBOL_STAR = 356,                     /* STAR  */
  YYSYMBOL_SLASH = 357,                    /* SLASH  */
  YYSYMBOL_MODULO = 358,                   /* MODULO  */
  YYSYMBOL_NOT = 359,                      /* NOT  */
  YYSYMBOL_UNARY = 360,                    /* UNARY  */
  YYSYMBOL_BIN_NOT = 361,                  /* BIN_NOT  */
  YYSYMBOL_DEFINED = 362,                  /* DEFINED  */
  YYSYMBOL_INTCAST = 363,                  /* INTCAST  */
  YYSYMBOL_STRCAST = 364,                  /* STRCAST  */
  YYSYMBOL_DOT = 365,                      /* DOT  */
  YYSYMBOL_STRLEN = 366,                   /* STRLEN  */
  YYSYMBOL_STREMPTY = 367,                 /* STREMPTY  */
  YYSYMBOL_SELVAL = 368,                   /* SELVAL  */
  YYSYMBOL_NUMBER = 369,                   /* NUMBER  */
  YYSYMBOL_ID = 370,                       /* ID  */
  YYSYMBOL_NUM_ID = 371,                   /* NUM_ID  */
  YYSYMBOL_STRING = 372,                   /* STRING  */
  YYSYMBOL_IPV6ADDR = 373,                 /* IPV6ADDR  */
  YYSYMBOL_PVAR = 374,                     /* PVAR  */
  YYSYMBOL_AVP_OR_PVAR = 375,              /* AVP_OR_PVAR  */
  YYSYMBOL_EVENT_RT_NAME = 376,            /* EVENT_RT_NAME  */
  YYSYMBOL_COMMA = 377,                    /* COMMA  */
  YYSYMBOL_SEMICOLON = 378,                /* SEMICOLON  */
  YYSYMBOL_RPAREN = 379,                   /* RPAREN  */
  YYSYMBOL_LPAREN = 380,                   /* LPAREN  */
  YYSYMBOL_LBRACE = 381,                   /* LBRACE  */
  YYSYMBOL_RBRACE = 382,                   /* RBRACE  */
  YYSYMBOL_LBRACK = 383,                   /* LBRACK  */
  YYSYMBOL_RBRACK = 384,                   /* RBRACK  */
  YYSYMBOL_CR = 385,                       /* CR  */
  YYSYMBOL_COLON = 386,                    /* COLON  */
  YYSYMBOL_YYACCEPT = 387,                 /* $accept  */
  YYSYMBOL_cfg = 388,                      /* cfg  */
  YYSYMBOL_statements = 389,               /* statements  */
  YYSYMBOL_statement = 390,                /* statement  */
  YYSYMBOL_391_1 = 391,                    /* $@1  */
  YYSYMBOL_392_2 = 392,                    /* $@2  */
  YYSYMBOL_393_3 = 393,                    /* $@3  */
  YYSYMBOL_394_4 = 394,                    /* $@4  */
  YYSYMBOL_395_5 = 395,                    /* $@5  */
  YYSYMBOL_listen_id = 396,                /* listen_id  */
  YYSYMBOL_listen_id_lst = 397,            /* listen_id_lst  */
  YYSYMBOL_listen_id2 = 398,               /* listen_id2  */
  YYSYMBOL_proto = 399,                    /* proto  */
  YYSYMBOL_eqproto = 400,                  /* eqproto  */
  YYSYMBOL_xproto = 401,                   /* xproto  */
  YYSYMBOL_port = 402,                     /* port  */
  YYSYMBOL_phostport = 403,                /* phostport  */
  YYSYMBOL_listen_phostport = 404,         /* listen_phostport  */
  YYSYMBOL_id_lst = 405,                   /* id_lst  */
  YYSYMBOL_intno = 406,                    /* intno  */
  YYSYMBOL_flags_decl = 407,               /* flags_decl  */
  YYSYMBOL_flag_list = 408,                /* flag_list  */
  YYSYMBOL_flag_spec = 409,                /* flag_spec  */
  YYSYMBOL_flag_name = 410,                /* flag_name  */
  YYSYMBOL_avpflags_decl = 411,            /* avpflags_decl  */
  YYSYMBOL_avpflag_list = 412,             /* avpflag_list  */
  YYSYMBOL_avpflag_spec = 413,             /* avpflag_spec  */
  YYSYMBOL_socket_lattr = 414,             /* socket_lattr  */
  YYSYMBOL_socket_lattrs = 415,            /* socket_lattrs  */
  YYSYMBOL_assign_stm = 416,               /* assign_stm  */
  YYSYMBOL_417_6 = 417,                    /* $@6  */
  YYSYMBOL_cfg_var_id = 418,               /* cfg_var_id  */
  YYSYMBOL_cfg_var_idn = 419,              /* cfg_var_idn  */
  YYSYMBOL_cfg_var = 420,                  /* cfg_var  */
  YYSYMBOL_module_stm = 421,               /* module_stm  */
  YYSYMBOL_ip = 422,                       /* ip  */
  YYSYMBOL_ipv4 = 423,                     /* ipv4  */
  YYSYMBOL_ipv6addr = 424,                 /* ipv6addr  */
  YYSYMBOL_ipv6 = 425,                     /* ipv6  */
  YYSYMBOL_route_name = 426,               /* route_name  */
  YYSYMBOL_route_main = 427,               /* route_main  */
  YYSYMBOL_route_stm = 428,                /* route_stm  */
  YYSYMBOL_failure_route_main = 429,       /* failure_route_main  */
  YYSYMBOL_failure_route_stm = 430,        /* failure_route_stm  */
  YYSYMBOL_route_reply_main = 431,         /* route_reply_main  */
  YYSYMBOL_onreply_route_stm = 432,        /* onreply_route_stm  */
  YYSYMBOL_433_7 = 433,                    /* $@7  */
  YYSYMBOL_434_8 = 434,                    /* $@8  */
  YYSYMBOL_branch_route_main = 435,        /* branch_route_main  */
  YYSYMBOL_branch_route_stm = 436,         /* branch_route_stm  */
  YYSYMBOL_send_route_main = 437,          /* send_route_main  */
  YYSYMBOL_send_route_stm = 438,           /* send_route_stm  */
  YYSYMBOL_event_route_main = 439,         /* event_route_main  */
  YYSYMBOL_event_route_stm = 440,          /* event_route_stm  */
  YYSYMBOL_preprocess_stm = 441,           /* preprocess_stm  */
  YYSYMBOL_equalop = 442,                  /* equalop  */
  YYSYMBOL_cmpop = 443,                    /* cmpop  */
  YYSYMBOL_strop = 444,                    /* strop  */
  YYSYMBOL_rve_equalop = 445,              /* rve_equalop  */
  YYSYMBOL_rve_cmpop = 446,                /* rve_cmpop  */
  YYSYMBOL_uri_type = 447,                 /* uri_type  */
  YYSYMBOL_eint_op_onsend = 448,           /* eint_op_onsend  */
  YYSYMBOL_eint_op = 449,                  /* eint_op  */
  YYSYMBOL_eip_op_onsend = 450,            /* eip_op_onsend  */
  YYSYMBOL_eip_op = 451,                   /* eip_op  */
  YYSYMBOL_exp_elem = 452,                 /* exp_elem  */
  YYSYMBOL_ipnet = 453,                    /* ipnet  */
  YYSYMBOL_host = 454,                     /* host  */
  YYSYMBOL_host_if_id = 455,               /* host_if_id  */
  YYSYMBOL_host_or_if = 456,               /* host_or_if  */
  YYSYMBOL_fcmd = 457,                     /* fcmd  */
  YYSYMBOL_stm = 458,                      /* stm  */
  YYSYMBOL_actions = 459,                  /* actions  */
  YYSYMBOL_action = 460,                   /* action  */
  YYSYMBOL_if_cmd = 461,                   /* if_cmd  */
  YYSYMBOL_ct_rval = 462,                  /* ct_rval  */
  YYSYMBOL_single_case = 463,              /* single_case  */
  YYSYMBOL_case_stms = 464,                /* case_stms  */
  YYSYMBOL_switch_cmd = 465,               /* switch_cmd  */
  YYSYMBOL_while_cmd = 466,                /* while_cmd  */
  YYSYMBOL_select_param = 467,             /* select_param  */
  YYSYMBOL_select_params = 468,            /* select_params  */
  YYSYMBOL_select_id = 469,                /* select_id  */
  YYSYMBOL_470_9 = 470,                    /* $@9  */
  YYSYMBOL_attr_class_spec = 471,          /* attr_class_spec  */
  YYSYMBOL_attr_name_spec = 472,           /* attr_name_spec  */
  YYSYMBOL_attr_spec = 473,                /* attr_spec  */
  YYSYMBOL_attr_mark = 474,                /* attr_mark  */
  YYSYMBOL_attr_id = 475,                  /* attr_id  */
  YYSYMBOL_attr_id_num_idx = 476,          /* attr_id_num_idx  */
  YYSYMBOL_attr_id_no_idx = 477,           /* attr_id_no_idx  */
  YYSYMBOL_attr_id_ass = 478,              /* attr_id_ass  */
  YYSYMBOL_attr_id_any = 479,              /* attr_id_any  */
  YYSYMBOL_attr_id_any_str = 480,          /* attr_id_any_str  */
  YYSYMBOL_pvar = 481,                     /* pvar  */
  YYSYMBOL_avp_pvar = 482,                 /* avp_pvar  */
  YYSYMBOL_assign_op = 483,                /* assign_op  */
  YYSYMBOL_lval = 484,                     /* lval  */
  YYSYMBOL_rval = 485,                     /* rval  */
  YYSYMBOL_rve_un_op = 486,                /* rve_un_op  */
  YYSYMBOL_rval_expr = 487,                /* rval_expr  */
  YYSYMBOL_assign_action = 488,            /* assign_action  */
  YYSYMBOL_avpflag_oper = 489,             /* avpflag_oper  */
  YYSYMBOL_cmd = 490,                      /* cmd  */
  YYSYMBOL_491_10 = 491,                   /* $@10  */
  YYSYMBOL_func_params = 492,              /* func_params  */
  YYSYMBOL_func_param = 493,               /* func_param  */
  YYSYMBOL_ret_cmd = 494                   /* ret_cmd  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  528
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   12763

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  387
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  108
/* YYNRULES -- Number of rules.  */
#define YYNRULES  1009
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1907

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   641


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   665,   665,   668,   669,   670,   673,   674,   675,   676,
     677,   678,   678,   679,   679,   680,   681,   681,   682,   682,
     683,   683,   684,   685,   688,   705,   714,   729,   730,   736,
     737,   741,   742,   743,   744,   745,   748,   749,   750,   751,
     752,   753,   754,   757,   758,   759,   760,   761,   762,   766,
     767,   770,   771,   772,   773,   774,   778,   779,   780,   781,
     782,   786,   787,   790,   791,   794,   795,   797,   798,   801,
     804,   810,   811,   815,   816,   819,   820,   823,   829,   835,
     840,   845,   849,   850,   854,   855,   860,   866,   867,   868,
     869,   870,   873,   874,   877,   878,   879,   880,   881,   882,
     883,   884,   885,   888,   889,   895,   896,   897,   898,   899,
     900,   901,   902,   903,   904,   905,   906,   907,   908,   911,
     912,   915,   916,   919,   920,   921,   922,   923,   924,   925,
     926,   927,   928,   929,   930,   931,   932,   933,   934,   935,
     936,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   951,   952,   953,   954,   955,   956,
     957,   958,   959,   960,   961,   962,   963,   964,   965,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   985,   986,   987,   988,   989,   990,   993,   994,   997,
     998,  1001,  1002,  1003,  1004,  1007,  1008,  1011,  1012,  1015,
    1016,  1019,  1020,  1021,  1022,  1023,  1024,  1025,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,  1036,  1037,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1044,  1053,  1054,
    1055,  1056,  1057,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  1066,  1067,  1068,  1069,  1070,  1071,  1072,  1073,  1074,
    1075,  1076,  1077,  1078,  1079,  1080,  1081,  1082,  1083,  1084,
    1085,  1086,  1087,  1088,  1089,  1092,  1093,  1100,  1107,  1108,
    1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,  1118,
    1119,  1120,  1121,  1122,  1129,  1130,  1137,  1138,  1145,  1146,
    1153,  1154,  1161,  1162,  1169,  1170,  1177,  1178,  1188,  1189,
    1203,  1217,  1218,  1225,  1226,  1233,  1234,  1241,  1242,  1251,
    1252,  1261,  1262,  1269,  1270,  1277,  1278,  1285,  1286,  1293,
    1294,  1301,  1302,  1309,  1310,  1317,  1318,  1325,  1326,  1333,
    1334,  1341,  1342,  1349,  1350,  1357,  1358,  1365,  1366,  1373,
    1374,  1381,  1382,  1389,  1390,  1397,  1398,  1405,  1406,  1413,
    1415,  1422,  1423,  1434,  1435,  1442,  1443,  1450,  1451,  1458,
    1459,  1466,  1467,  1474,  1475,  1482,  1483,  1490,  1497,  1504,
    1511,  1518,  1525,  1526,  1533,  1534,  1541,  1542,  1549,  1550,
    1557,  1558,  1565,  1566,  1573,  1574,  1581,  1582,  1589,  1590,
    1597,  1598,  1599,  1600,  1603,  1604,  1607,  1608,  1609,  1610,
    1611,  1612,  1613,  1614,  1626,  1639,  1651,  1664,  1677,  1690,
    1704,  1717,  1730,  1744,  1758,  1771,  1785,  1798,  1812,  1814,
    1825,  1826,  1837,  1838,  1839,  1840,  1841,  1842,  1848,  1849,
    1859,  1860,  1861,  1862,  1863,  1864,  1871,  1872,  1879,  1880,
    1881,  1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,
    1891,  1892,  1893,  1894,  1895,  1896,  1903,  1904,  1911,  1912,
    1919,  1926,  1927,  1928,  1955,  1956,  1957,  1958,  1959,  1960,
    1961,  1962,  1963,  1964,  1965,  1966,  1967,  1968,  1969,  1970,
    1971,  1972,  1973,  1974,  1975,  1976,  1977,  1978,  1979,  1980,
    1981,  1982,  1983,  1984,  1985,  1986,  1993,  1994,  2003,  2004,
    2013,  2014,  2023,  2024,  2033,  2034,  2043,  2044,  2045,  2046,
    2047,  2048,  2049,  2050,  2051,  2052,  2053,  2054,  2055,  2056,
    2057,  2058,  2059,  2060,  2061,  2062,  2063,  2064,  2065,  2066,
    2068,  2069,  2070,  2071,  2073,  2075,  2076,  2077,  2080,  2081,
    2084,  2085,  2086,  2089,  2090,  2093,  2094,  2095,  2103,  2108,
    2113,  2118,  2123,  2126,  2131,  2139,  2145,  2151,  2157,  2158,
    2164,  2170,  2176,  2177,  2187,  2188,  2198,  2199,  2208,  2217,
    2218,  2227,  2236,  2245,  2246,  2252,  2253,  2259,  2263,  2264,
    2267,  2296,  2311,  2312,  2316,  2327,  2328,  2332,  2333,  2337,
    2344,  2360,  2361,  2364,  2367,  2374,  2390,  2394,  2395,  2400,
    2400,  2407,  2408,  2410,  2409,  2432,  2437,  2440,  2447,  2463,
    2466,  2469,  2476,  2492,  2495,  2498,  2515,  2518,  2519,  2520,
    2521,  2522,  2523,  2545,  2546,  2547,  2548,  2551,  2552,  2553,
    2554,  2557,  2558,  2564,  2565,  2566,  2567,  2568,  2569,  2570,
    2573,  2574,  2575,  2576,  2583,  2584,  2585,  2592,  2593,  2594,
    2598,  2599,  2600,  2601,  2602,  2607,  2608,  2611,  2612,  2613,
    2619,  2621,  2623,  2624,  2626,  2628,  2630,  2632,  2634,  2635,
    2637,  2638,  2639,  2640,  2642,  2644,  2646,  2648,  2650,  2652,
    2653,  2689,  2691,  2693,  2695,  2698,  2700,  2702,  2704,  2708,
    2709,  2720,  2721,  2725,  2726,  2741,  2756,  2757,  2760,  2761,
    2762,  2776,  2777,  2792,  2807,  2809,  2816,  2858,  2859,  2862,
    2863,  2864,  2867,  2868,  2869,  2870,  2871,  2872,  2873,  2874,
    2877,  2885,  2895,  2912,  2919,  2926,  2933,  2940,  2945,  2950,
    2951,  2952,  2953,  2954,  2957,  2966,  2973,  2998,  3014,  3015,
    3020,  3039,  3048,  3060,  3075,  3076,  3079,  3079,  3089,  3090,
    3091,  3092,  3093,  3094,  3095,  3096,  3097,  3100,  3103,  3104,
    3107,  3114,  3117,  3124,  3130,  3131,  3140,  3141,  3142,  3145,
    3146,  3158,  3182,  3193,  3224,  3228,  3238,  3252,  3264,  3265,
    3267,  3268,  3269,  3283,  3284,  3285,  3286,  3287,  3288,  3289,
    3293,  3294,  3295,  3308,  3314,  3315,  3316,  3317,  3318,  3319,
    3320,  3321,  3322,  3323,  3324,  3325,  3326,  3327,  3328,  3346,
    3347,  3348,  3349,  3350,  3351,  3352,  3360,  3361,  3362,  3363,
    3364,  3365,  3366,  3367,  3368,  3369,  3370,  3372,  3374,  3375,
    3376,  3377,  3378,  3379,  3382,  3400,  3401,  3402,  3405,  3406,
    3407,  3408,  3409,  3410,  3411,  3412,  3413,  3414,  3415,  3416,
    3417,  3418,  3419,  3420,  3421,  3422,  3423,  3424,  3425,  3426,
    3427,  3428,  3429,  3430,  3431,  3432,  3433,  3434,  3435,  3436,
    3437,  3438,  3439,  3447,  3455,  3463,  3471,  3479,  3487,  3495,
    3503,  3511,  3512,  3514,  3522,  3530,  3538,  3547,  3556,  3565,
    3573,  3582,  3590,  3591,  3593,  3596,  3597,  3598,  3599,  3606,
    3613,  3614,  3620,  3627,  3628,  3634,  3641,  3642,  3648,  3651,
    3654,  3655,  3656,  3659,  3660,  3661,  3670,  3679,  3680,  3681,
    3682,  3683,  3684,  3685,  3686,  3687,  3688,  3689,  3690,  3691,
    3692,  3693,  3694,  3695,  3696,  3700,  3704,  3705,  3706,  3707,
    3708,  3709,  3710,  3711,  3712,  3713,  3714,  3715,  3716,  3717,
    3718,  3719,  3720,  3721,  3722,  3723,  3724,  3725,  3726,  3727,
    3728,  3729,  3730,  3731,  3739,  3747,  3755,  3756,  3758,  3760,
    3771,  3772,  3773,  3789,  3790,  3791,  3795,  3798,  3799,  3802,
    3805,  3808,  3811,  3814,  3817,  3820,  3823,  3826,  3829,  3830,
    3831,  3834,  3835,  3836,  3836,  3869,  3871,  3873,  3874,  3877,
    3894,  3898,  3902,  3906,  3911,  3915,  3920,  3924,  3928,  3932
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "FORWARD",
  "FORWARD_TCP", "FORWARD_TLS", "FORWARD_SCTP", "FORWARD_UDP", "EXIT",
  "DROP", "RETURN", "RETURN_MODE", "BREAK", "LOG_TOK", "ERROR", "ROUTE",
  "ROUTE_REQUEST", "ROUTE_FAILURE", "ROUTE_ONREPLY", "ROUTE_REPLY",
  "ROUTE_BRANCH", "ROUTE_SEND", "ROUTE_EVENT", "EXEC", "SET_HOST",
  "SET_HOSTPORT", "SET_HOSTPORTTRANS", "PREFIX", "STRIP", "STRIP_TAIL",
  "SET_USERPHONE", "APPEND_BRANCH", "REMOVE_BRANCH", "CLEAR_BRANCHES",
  "SET_USER", "SET_USERPASS", "SET_PORT", "SET_URI", "REVERT_URI",
  "FORCE_RPORT", "ADD_LOCAL_RPORT", "LOCAL_RPORT", "FORCE_TCP_ALIAS",
  "UDP_MTU", "UDP_MTU_TRY_PROTO", "UDP4_RAW", "UDP4_RAW_MTU",
  "UDP4_RAW_TTL", "IF", "ELSE", "SET_ADV_ADDRESS", "SET_ADV_PORT",
  "FORCE_SEND_SOCKET", "SET_FWD_NO_CONNECT", "SET_RPL_NO_CONNECT",
  "SET_FWD_CLOSE", "SET_RPL_CLOSE", "SWITCH", "CASE", "DEFAULT", "WHILE",
  "CFG_SELECT", "CFG_RESET", "URIHOST", "URIPORT", "MAX_LEN", "SETFLAG",
  "RESETFLAG", "ISFLAGSET", "SETAVPFLAG", "RESETAVPFLAG", "ISAVPFLAGSET",
  "METHOD", "URI", "FROM_URI", "TO_URI", "SRCIP", "SRCPORT", "DSTIP",
  "DSTPORT", "TOIP", "TOPORT", "SNDIP", "SNDPORT", "SNDPROTO", "SNDAF",
  "PROTO", "AF", "MYSELF", "MSGLEN", "UDP", "TCP", "TLS", "SCTP", "WS",
  "WSS", "DEBUG_V", "FORK", "FORK_DELAY", "MODINIT_DELAY", "LOGSTDERROR",
  "LOGFACILITY", "LOGNAME", "LOGCOLOR", "LOGPREFIX", "LOGPREFIXMODE",
  "LOGENGINETYPE", "LOGENGINEDATA", "XAVPVIAPARAMS", "XAVPVIAFIELDS",
  "XAVPVIAREPLYPARAMS", "LISTEN", "ADVERTISE", "VIRTUAL", "STRNAME",
  "ALIAS", "SR_AUTO_ALIASES", "DOMAIN", "SR_AUTO_DOMAINS", "DNS",
  "REV_DNS", "DNS_TRY_IPV6", "DNS_TRY_NAPTR", "DNS_SRV_LB", "DNS_UDP_PREF",
  "DNS_TCP_PREF", "DNS_TLS_PREF", "DNS_SCTP_PREF", "DNS_RETR_TIME",
  "DNS_SLOW_QUERY_MS", "DNS_RETR_NO", "DNS_SERVERS_NO", "DNS_USE_SEARCH",
  "DNS_SEARCH_FMATCH", "DNS_NAPTR_IGNORE_RFC", "DNS_CACHE_INIT",
  "DNS_USE_CACHE", "DNS_USE_FAILOVER", "DNS_CACHE_FLAGS",
  "DNS_CACHE_NEG_TTL", "DNS_CACHE_MIN_TTL", "DNS_CACHE_MAX_TTL",
  "DNS_CACHE_MEM", "DNS_CACHE_GC_INT", "DNS_CACHE_DEL_NONEXP",
  "DNS_CACHE_REC_PREF", "AUTO_BIND_IPV6", "BIND_IPV6_LINK_LOCAL",
  "IPV6_HEX_STYLE", "DST_BLST_INIT", "USE_DST_BLST", "DST_BLST_MEM",
  "DST_BLST_TTL", "DST_BLST_GC_INT", "DST_BLST_UDP_IMASK",
  "DST_BLST_TCP_IMASK", "DST_BLST_TLS_IMASK", "DST_BLST_SCTP_IMASK",
  "IP_FREE_BIND", "PORT", "STAT", "STATS_NAMESEP", "CHILDREN", "SOCKET",
  "BIND", "WORKERS", "SOCKET_WORKERS", "ASYNC_WORKERS", "ASYNC_USLEEP",
  "ASYNC_NONBLOCK", "ASYNC_WORKERS_GROUP", "CHECK_VIA", "PHONE2TEL",
  "MEMLOG", "MEMDBG", "MEMSUM", "MEMSAFETY", "MEMJOIN", "MEMSTATUSMODE",
  "SIP_PARSER_LOG_ONELINE", "SIP_PARSER_LOG", "SIP_PARSER_MODE", "CORELOG",
  "SIP_WARNING", "SERVER_SIGNATURE", "SERVER_HEADER", "USER_AGENT_HEADER",
  "REPLY_TO_VIA", "LOADMODULE", "LOADMODULEX", "LOADPATH", "MODPARAM",
  "MODPARAMX", "CFGENGINE", "MAXBUFFER", "MAXSNDBUFFER", "SQL_BUFFER_SIZE",
  "MSG_RECV_MAX_SIZE", "TCP_MSG_READ_TIMEOUT", "TCP_MSG_DATA_TIMEOUT",
  "TCP_ACCEPT_IPLIMIT", "TCP_CHECK_TIMER", "USER", "GROUP", "CHROOT",
  "WDIR", "RUNDIR", "MHOMED", "DISABLE_TCP", "TCP_ACCEPT_ALIASES",
  "TCP_ACCEPT_UNIQUE", "TCP_CONNECTION_MATCH", "TCP_CHILDREN",
  "TCP_CONNECT_TIMEOUT", "TCP_SEND_TIMEOUT", "TCP_CON_LIFETIME",
  "TCP_POLL_METHOD", "TCP_MAX_CONNECTIONS", "TLS_MAX_CONNECTIONS",
  "TCP_NO_CONNECT", "TCP_SOURCE_IPV4", "TCP_SOURCE_IPV6",
  "TCP_OPT_FD_CACHE", "TCP_OPT_BUF_WRITE", "TCP_OPT_CONN_WQ_MAX",
  "TCP_OPT_WQ_MAX", "TCP_OPT_RD_BUF", "TCP_OPT_WQ_BLK",
  "TCP_OPT_DEFER_ACCEPT", "TCP_OPT_DELAYED_ACK", "TCP_OPT_SYNCNT",
  "TCP_OPT_LINGER2", "TCP_OPT_KEEPALIVE", "TCP_OPT_KEEPIDLE",
  "TCP_OPT_KEEPINTVL", "TCP_OPT_KEEPCNT", "TCP_OPT_CRLF_PING",
  "TCP_OPT_ACCEPT_NO_CL", "TCP_OPT_ACCEPT_HEP3", "TCP_OPT_ACCEPT_HAPROXY",
  "TCP_OPT_CLOSE_RST", "TCP_CLONE_RCVBUF", "TCP_REUSE_PORT",
  "TCP_WAIT_DATA", "TCP_SCRIPT_MODE", "DISABLE_TLS", "ENABLE_TLS",
  "TLSLOG", "TLS_PORT_NO", "TLS_METHOD", "TLS_HANDSHAKE_TIMEOUT",
  "TLS_SEND_TIMEOUT", "SSLv23", "SSLv2", "SSLv3", "TLSv1", "TLS_VERIFY",
  "TLS_REQUIRE_CERTIFICATE", "TLS_CERTIFICATE", "TLS_PRIVATE_KEY",
  "TLS_CA_LIST", "DISABLE_SCTP", "ENABLE_SCTP", "SCTP_CHILDREN",
  "ADVERTISED_ADDRESS", "ADVERTISED_PORT", "DISABLE_CORE", "OPEN_FD_LIMIT",
  "SHM_MEM_SZ", "SHM_FORCE_ALLOC", "MLOCK_PAGES", "REAL_TIME", "RT_PRIO",
  "RT_POLICY", "RT_TIMER1_PRIO", "RT_TIMER1_POLICY", "RT_TIMER2_PRIO",
  "RT_TIMER2_POLICY", "MCAST_LOOPBACK", "MCAST_TTL", "MCAST", "TOS",
  "PMTU_DISCOVERY", "KILL_TIMEOUT", "MAX_WLOOPS", "PVBUFSIZE",
  "PVBUFSLOTS", "PVCACHELIMIT", "PVCACHEACTION", "HTTP_REPLY_PARSE",
  "VERSION_TABLE_CFG", "VERBOSE_STARTUP", "ROUTE_LOCKS_SIZE",
  "WAIT_WORKER1_MODE", "WAIT_WORKER1_TIME", "WAIT_WORKER1_USLEEP",
  "CFG_DESCRIPTION", "SERVER_ID", "KEMI", "REQUEST_ROUTE_CALLBACK",
  "ONSEND_ROUTE_CALLBACK", "REPLY_ROUTE_CALLBACK", "EVENT_ROUTE_CALLBACK",
  "RECEIVED_ROUTE_CALLBACK", "RECEIVED_ROUTE_MODE", "PRE_ROUTING_CALLBACK",
  "MAX_RECURSIVE_LEVEL", "MAX_BRANCHES_PARAM", "LATENCY_CFG_LOG",
  "LATENCY_LOG", "LATENCY_LIMIT_DB", "LATENCY_LIMIT_ACTION",
  "LATENCY_LIMIT_CFG", "RPC_EXEC_DELTA_CFG", "MSG_TIME", "ONSEND_RT_REPLY",
  "URI_HOST_EXTRA_CHARS", "HDR_NAME_EXTRA_CHARS", "FLAGS_DECL",
  "AVPFLAGS_DECL", "ATTR_MARK", "SELECT_MARK", "ATTR_FROM", "ATTR_TO",
  "ATTR_FROMURI", "ATTR_TOURI", "ATTR_FROMUSER", "ATTR_TOUSER",
  "ATTR_FROMDOMAIN", "ATTR_TODOMAIN", "ATTR_GLOBAL", "ADDEQ", "SUBST",
  "SUBSTDEF", "SUBSTDEFS", "EQUAL", "LOG_OR", "LOG_AND", "BIN_OR",
  "BIN_AND", "BIN_XOR", "BIN_LSHIFT", "BIN_RSHIFT", "EQUAL_T", "DIFF",
  "MATCH", "INTEQ", "INTDIFF", "STREQ", "STRDIFF", "GT", "LT", "GTE",
  "LTE", "PLUS", "MINUS", "STAR", "SLASH", "MODULO", "NOT", "UNARY",
  "BIN_NOT", "DEFINED", "INTCAST", "STRCAST", "DOT", "STRLEN", "STREMPTY",
  "SELVAL", "NUMBER", "ID", "NUM_ID", "STRING", "IPV6ADDR", "PVAR",
  "AVP_OR_PVAR", "EVENT_RT_NAME", "COMMA", "SEMICOLON", "RPAREN", "LPAREN",
  "LBRACE", "RBRACE", "LBRACK", "RBRACK", "CR", "COLON", "$accept", "cfg",
  "statements", "statement", "$@1", "$@2", "$@3", "$@4", "$@5",
  "listen_id", "listen_id_lst", "listen_id2", "proto", "eqproto", "xproto",
  "port", "phostport", "listen_phostport", "id_lst", "intno", "flags_decl",
  "flag_list", "flag_spec", "flag_name", "avpflags_decl", "avpflag_list",
  "avpflag_spec", "socket_lattr", "socket_lattrs", "assign_stm", "$@6",
  "cfg_var_id", "cfg_var_idn", "cfg_var", "module_stm", "ip", "ipv4",
  "ipv6addr", "ipv6", "route_name", "route_main", "route_stm",
  "failure_route_main", "failure_route_stm", "route_reply_main",
  "onreply_route_stm", "$@7", "$@8", "branch_route_main",
  "branch_route_stm", "send_route_main", "send_route_stm",
  "event_route_main", "event_route_stm", "preprocess_stm", "equalop",
  "cmpop", "strop", "rve_equalop", "rve_cmpop", "uri_type",
  "eint_op_onsend", "eint_op", "eip_op_onsend", "eip_op", "exp_elem",
  "ipnet", "host", "host_if_id", "host_or_if", "fcmd", "stm", "actions",
  "action", "if_cmd", "ct_rval", "single_case", "case_stms", "switch_cmd",
  "while_cmd", "select_param", "select_params", "select_id", "$@9",
  "attr_class_spec", "attr_name_spec", "attr_spec", "attr_mark", "attr_id",
  "attr_id_num_idx", "attr_id_no_idx", "attr_id_ass", "attr_id_any",
  "attr_id_any_str", "pvar", "avp_pvar", "assign_op", "lval", "rval",
  "rve_un_op", "rval_expr", "assign_action", "avpflag_oper", "cmd", "$@10",
  "func_params", "func_param", "ret_cmd", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641
};
#endif

#define YYPACT_NINF (-1320)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-994)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    2635,  -304,  -289,    28,    16,  -248,  -241,  -230,  -164,  -121,
    -106,   -72, -1320,   -39,   -16,     2,   111,   452,   455,   501,
     517,   518,   539,   550,   562,   578,   579,   583,   586,   587,
     614,   622,   634,   639,   663,    24,    25,   327,   760,   761,
     762,   832,   836,   860,   861,   892,   901,   902,   933,   937,
     941,   952,   976,   985,   989,   992,   999,  1000,  1006,  1010,
    1015,  1028,  1034,  1058,  1060,  1062,  1064,  1088,  1089,  1100,
    1101,  1105,   668,   680,   706,   712, -1320,   722,   731,   738,
     747,   770,   813,   825,   859,   914,   928,   942,   943,   966,
     967,   970,   971,   974,   987,   990,   991,  1011,  1012,   102,
     103,    80,    38,    42,   202,  1018,  1027,  1029,  1032,  1033,
    1037,  1053,  1061,  1083,  1114,  1120,  1121,  1137,  1143,  1156,
    1163,  1164,  1170,  1174,  1186,  1202,  1204,  1205,  1206,  1236,
    1237,  1238,  1244,  1246,  1247,  1106,  1107,  1115,  1119,  1248,
    1249,  1252,  1254,  1255,  1261,  1266,  1267,  1268,  1269,  1294,
    1295,  1296,  1297,  1299,  1300,  1303,  1304,  1305,  1311,  1312,
    1313,  1315,  1316,  1322,  1324,  1325,  1328,  1330,  1331,  1345,
    1360,  1368,  1369,  1370,  1372,  1374,  1386,  1388,  1390,  1394,
    1395,  1396,  1397,  1398,  1399,  1400,  1401,  1402,  1403,  1122,
    1404,  1405,  1407,  1408,  1409,  1410,  1411,  1413,  1414,  1415,
    1419,  1421,  1422,  1424,   -20,  1425,  1427,  1444,  1445,  1446,
    1492,  1496,  1584,  1585,  1586,  1587,  1628,  1631,    13,   205,
      67,    73,    99, -1320, -1320, -1320,   381,  1667, -1320,   194,
     399,   938,   973,   986, -1320, -1320, -1320,  -311, -1320, -1320,
     584, -1320, -1320, -1320,    62, -1320,   -99, -1320,   256,   333,
     341,   929,   137,   362,   364,   345,   365,   370,   509,   623,
      19,   148,   671,   204,   673,   210,   218,   238,   251,   264,
      64,   107,   676,   125,   679,   682,   683, -1320,     4, -1320,
     640, -1320,   681, -1320,  -221, -1320,  -221, -1320,  -221, -1320,
    -221, -1320,   716, -1320,   725, -1320,   735, -1320,   748, -1320,
     766, -1320,   771, -1320,   772, -1320,   778, -1320,   784, -1320,
     790, -1320,   809, -1320,   828, -1320,   838, -1320,   844, -1320,
     849, -1320,   854, -1320,   870, -1320,   906, -1320,  1057, -1320,
    1095, -1320,   677, -1320,  1123, -1320,  1310, -1320,  1598, -1320,
    1599, -1320,  1600, -1320,  1601, -1320,  1603, -1320,  1618, -1320,
    1619,   346,   689,   265,   698,  1654,   703,   711,   715,   723,
     266,   729,   744,   348,   350,   351,   352,   353,   354,   356,
     363,   373,   374,   745,   746,   273,   274,   749, -1320, -1320,
     709, -1320, -1320,   728, -1320,   277, -1320, -1320,  1309, -1320,
    1620, -1320,   278, -1320,   750,   752,   753,   755,   756,   757,
     758,   759,   211,   227,   231,   239,   243,   763,   764,   765,
     767,   768,   769,   500,   560,   626,   244,   774,   775,   776,
     777,    21,   780,   781, -1320,  1621, -1320,  1622, -1320,  1624,
   -1320,  1633,   787,   788,   792,   793,   794,   795,   796,   799,
     800,   801,   803,   804,   805,   806,   807,   657,   658,   808,
     810,   811,   812,   930,   817,   818,   819,   820,   279,   281,
     283,   821,   822,   823,     7,   824,   829,   830,   831,   833,
     834,   837,   839,   840,   841,   842,   843,   850,   862,   864,
     258,   328, -1320,  1634,   866,   869,   871,   872,   874,   876,
     878,   284,   879,   881,   882,   883,   885,   886,  1391,   659,
    1635,  1636,   669,   670,   888,   889,   890,   891,   893,   895,
     285,   289, -1320, -1320, -1320, -1320,  1629,   924, -1320, -1320,
   -1320,  1630, -1320, -1320, -1320, -1320, -1320, -1320, -1320,  -304,
   -1320,    36,    46,  1651, -1320,    40,  1652, -1320,    59,  1653,
   -1320,    85,  1655, -1320,     9,  1656, -1320,    -2,  1666, -1320,
   -1320, -1320, -1320, -1320, -1320,  1657, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
    1669, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,  1675, -1320,
   -1320, -1320, -1320,  1272,  1670, -1320,  1658,  1660,  1124,   964,
   -1320, -1320, -1320, -1320, -1320,  -270, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320,  1661, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,  -194,  -175,
   -1320, -1320,  1671,  1672, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320,  1675, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320,  1712,  1726,  1731,  1732,  1733,  1734, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320,  -137,  1701,  -137, -1320,   -99, -1320, 12385, -1320,   -99,
   12385, -1320,   -99, 12385, -1320,   -99, 12385, -1320,  1695, -1320,
   -1320, -1320,  1737,  1697, 12385,    49, -1320,  1722,  1716,  1717,
    1711,   371,  1197, -1320,  1625, -1320,  1725,   322,   325,  1349,
    1727, -1320,  1736, -1320,  1741,  1742,   291,   292,   293,   294,
     296,   297, -1320, -1320, -1320,  1739,    75,    78,   105,   106,
     108, 11289, 11376, 11463, -1320,   122,   123,   124,  1729,   127,
     129,   131,   132,   136,   141,   144,   151,  1735,   158,   159,
     167,   168,  1752,  1757,  1758,  1759,  1760, 11842,   174,   178,
     179,  1761,  1762,  1763,  1772,  6349, 11842,   180,   186,   187,
     191,   192, -1320, -1320, -1320, -1320,   193, -1320, -1320, -1320,
      10,  3770, -1320, -1320, -1320, -1320,  1160, -1320, -1320, -1320,
   -1320, -1320,  1827,  1786,   200, -1320,  1788,  1783,  3841,  1784,
    3912,  1795,  4068,  1796,   172,  1805,  4292, -1320,  1803,  1820,
    1272, -1320, -1320, -1320, -1320, -1320, -1320,  1800, -1320, -1320,
   -1320, -1320, -1320, -1320,   -17,  1808,  1026, -1320, -1320, -1320,
   -1320, -1320,  1868,  1873,  1874,  1875,  1876, -1320, -1320,  1346,
    1833,  1834,  1837,  1846, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320,  1852, -1320,    29, -1320,
      81, -1320,    87, -1320,   145, -1320,   157,   955, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,   688,
   -1320,   688, -1320,  1022, -1320, -1320,  1669, -1320, -1320,  6730,
    6819,  6908,  1855,  1857,  1858, -1320,  5701, 12087, -1320,   988,
   -1320,   940, -1320,   995, -1320, -1320, -1320,  1160, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320,  7289,  3673,  5790,  3673,  6171,
    3673, -1320,   260, -1320,   301, -1320,  7378,  1867, -1320,   303,
   -1320,   304, -1320,   306, -1320,   307, -1320,   897, -1320,   898,
   -1320,  1862, -1320,   223,  1871, -1320,   309, -1320,   310, -1320,
     313, -1320,   314,  1872,  1877,  1878,   120,   963,  7467, 11929,
   -1320,   271, -1320,   900, -1320,   163,  1886,  1895,  1900,  1901,
   -1320,  1207, 11929, -1320,   315, -1320,   316, -1320,   674, -1320,
     782, -1320,   856, -1320,  1902, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
    1890, -1320,  1898, -1320, 11842, -1320, -1320,    12, -1320,  1903,
   -1320,  1904, -1320,  1913, -1320,  1923, -1320,  1987,  2010,    -2,
   -1320, 12385,  1939, -1320,  -267, -1320,  1937,  1941,  1272, -1320,
    1222,   904,   317,   248,   905, -1320, -1320, -1320, -1320,  -271,
     630, 12385,  1933,   -52, -1320,   -44, -1320,   533,  -188,  1942,
     549,   569,   575,  1043,  1943,   714,   855,   918,  1157,  1947,
     944,   975,  1090,  1220,  1948,  1091,  1102,  1129,  1221, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320,  7848,  5225,  5606, -1320,
    1451,  1958, -1320, -1320, -1320, -1320, -1320, -1320,  7937,  8026,
    8407,  1979, -1320,  2024,  2025,  2026,  2027,  1270,  1984,  1982,
    4366, -1320,  8496, -1320, -1320, -1320, -1320, -1320,  8585,  8966,
   -1320,  3003,  1983, -1320, -1320,  9055,  9144,  9525,  9614, 11842,
   11842, 11842, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320,  9703, 10084, 10173, 10262, 10643, 10732, 10821,
   -1320, -1320,  1986,  1990,  1989,  1992,  1995,  1994,    82,  1999,
    1996,  1997,  1998,  2000,  2001,  2002,  2003,  2004,  2005,  2006,
    2030,  2031,  2032, -1320,  2033, -1320,  2034, -1320,  2035,  2037,
    2038,  2039,  2040,  2042,  2043,  2044, -1320, -1320, -1320,  2047,
    2053, -1320,  2054,  2055, 12385,  2320, -1320,  2056,  2058,  2059,
    2060,  2061,  1988,  2057,  2063, -1320, -1320, -1320, -1320,    32,
   -1320,  2065,  2068,  2067,  2069,  2070,  2071,  2072,  2073,  2074,
    2075, 11842,  2077,  2096,  3673,  1139, -1320,  1160, -1320,  2078,
   -1320, 12385, 12385, 12385, 12385,  2084,  2109,  2147,  4448,  2118,
   -1320,  2371,   109,  2099,  2100,  2101, -1320, -1320, -1320, -1320,
   -1320,  2102,  2103, -1320, -1320,  2111,  2113,  2114,  2115,  2124,
    4519, -1320,   -48, -1320,  2128, -1320,  2135, -1320,    79,   282,
    2136, -1320, -1320,   -45, -1320,  2137, -1320,  2139, -1320,  2140,
   -1320, -1320,   -11, -1320,  2141, -1320,  2142, -1320,  2144, -1320,
   -1320,    -8, -1320,  2145, -1320,  2146, -1320,  2148, -1320, -1320,
     734, -1320,  2149, -1320,  2150, -1320,  2151, -1320, -1320,  2121,
    1319, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
    1319, -1320, -1320,  1319, -1320, -1320, -1320,  2133, -1320,  2156,
    2143,  2368,  2172,  2636,  2173,  1673, -1320, -1320, -1320, -1320,
   -1320, -1320,  2192,  1319, -1320,  1319, -1320,  1344, -1320,  2263,
    1675,  2050,  2166, -1320,  -189,  1319,  -148, -1320,  3695, -1320,
    3824, -1320,  3168, -1320,  3843,  3237,  2964,  2315, -1320,  -115,
   -1320,  -115, -1320, -1320, -1320, -1320, -1320, -1320, -1320,  1319,
   -1320,  1344, -1320,  2152, -1320, -1320,  2153, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320,  4590,  1377, -1320,
   -1320, -1320, -1320, -1320,   490,  1272, -1320,  2171,  6260,  2168,
   -1320, -1320,   925, -1320, 11998, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320,  3673,  1140, -1320, -1320, -1320,  -137, -1320,
   -1320,   263,  4746,  4970,  5044,  5126, -1320, -1320,  -138, -1320,
    2157, -1320, -1320,  2155,  2186,  2187,  1272,  -267,  1272, -1320,
   -1320, -1320, -1320, -1320, -1320,  2178,  2179,  2180,  2181, -1320,
   -1320, -1320, -1320,  2182,  2184,  2185,  2189,  2193,  2195,  2196,
    2197,  2198,  2200,  2201,  2202,  2203,  2205,  2206,  2207,  2208,
    2209,  2210,  2211,  2212,  -142,  1958, -1320, -1320, -1320, -1320,
   -1320, 11842,    27,  2213,  2214,  2215, -1320, -1320, -1320, -1320,
    2236, -1320,  2237, 11202,  2238,  3673, 12385, -1320, -1320,  2216,
    2989, 11842, -1320,  2217,  2219,  2246, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320,  2452,  2478, -1320,  2240, -1320,  2241, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320,  2244,  2245, -1320,  3219, -1320,  1675,
   -1320, -1320, -1320, -1320,  -267, 12385,  2248,  2249,  3092,  3163,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320,  2258,  2262,  -267,
   -1320, -1320, 11842, -1320,  3234, 12385, 12385, -1320,  3390,  2519,
   -1320, -1320,  3148,  3614,  3688, -1320, -1320
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   544,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   226,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   543,    22,    23,     0,     0,     4,     0,
       0,     0,     0,     0,     8,     9,     6,     0,   541,    10,
       0,    15,     7,   542,     0,   601,     0,   602,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   129,     0,   131,
       0,   133,     0,   135,     0,   137,     0,   139,     0,   141,
       0,   143,     0,   145,     0,   147,     0,   149,     0,   151,
       0,   153,     0,   155,     0,   157,     0,   159,     0,   161,
       0,   163,     0,   165,     0,   169,     0,   167,     0,   171,
       0,   173,     0,   175,     0,   177,     0,   179,     0,   183,
       0,   181,     0,   185,     0,   187,     0,   189,     0,   191,
       0,   193,     0,   195,     0,   197,     0,   199,     0,   201,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   558,   555,
       0,   562,   559,     0,   564,     0,   563,   569,     0,   573,
       0,   575,     0,   574,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   317,     0,   319,     0,   321,     0,
     323,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   466,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    66,    72,    71,    65,    67,    69,    74,    77,
      73,    75,   618,   617,   620,   619,   622,   621,     1,     5,
       3,     0,     0,     0,    12,     0,     0,    14,     0,     0,
      17,     0,     0,    19,     0,     0,    21,     0,     0,   599,
     494,   493,   584,   585,   586,     0,   530,   529,   532,   531,
     528,   527,   534,    31,    32,    33,    34,    35,   533,   536,
       0,    63,   535,   538,   537,   540,   539,    95,    94,    97,
      96,    99,    98,   101,   100,   103,   102,   105,   104,   107,
     106,   109,   108,   111,   110,   113,   112,   115,   114,   117,
     116,   119,   118,   121,   120,   123,   122,   418,   700,   698,
     699,    25,   581,     0,     0,    30,    56,     0,    61,   403,
      24,   578,   582,   579,   701,    26,   420,   419,   424,   423,
     422,   421,   426,   425,   125,   124,   127,   126,   128,   130,
     132,   134,   136,   138,   140,   142,   144,   146,   148,   150,
     152,   154,   156,   158,   160,   162,   164,   168,   166,   170,
     172,   174,   176,   178,   182,   180,   184,   186,   188,   190,
     192,   194,   196,   198,   200,   203,   202,   205,   204,   225,
     224,   223,   222,     0,   229,   228,   231,   230,   233,   232,
     235,   234,   237,   236,   239,   238,   241,   240,   243,   242,
     245,   244,   247,   246,   249,   248,   251,   250,   253,   252,
     255,   254,   257,   256,   259,   258,   261,   260,   263,   262,
     392,   391,   394,   393,   396,   395,   402,   401,     0,     0,
     566,   565,     0,     0,   577,   576,   207,   206,   209,   208,
     211,   210,   213,   212,   215,   214,   217,   216,   219,   218,
     221,   220,   268,   267,   266,   271,   270,   269,   274,   273,
     272,   277,   276,   275,   280,   279,   278,   282,   281,   284,
     283,   286,   285,   288,   287,   290,   289,   292,   291,   294,
     293,   296,   295,   298,   297,   301,   299,   300,   303,   302,
     305,   304,   307,   306,   309,     0,   308,   311,   310,   313,
     312,   315,   314,   316,   318,   320,   322,   325,   324,   327,
     326,   329,   328,   331,   330,   333,   332,   335,   334,   337,
     336,   339,   338,   341,   340,   343,   342,   345,   344,   347,
     346,   349,   348,   351,   350,   353,   352,   355,   354,   357,
     356,   359,   358,   361,   360,   363,   362,   365,   364,   370,
     366,   367,   368,   369,   382,   381,   384,   383,   372,   371,
     374,   373,   376,   375,   378,   377,   380,   379,   386,   385,
     388,   387,   390,   389,   428,   427,   430,   429,   432,   431,
     434,   433,   436,   435,   438,   437,   440,   439,   442,   441,
     444,   443,   446,   445,   448,   447,   450,   449,   452,   451,
     454,   453,   456,   455,   458,   457,   461,   459,   460,   464,
     462,   463,   465,   468,   467,   470,   469,   472,   471,   474,
     473,   476,   475,   478,   477,   480,   479,   265,   264,   482,
     481,   484,   483,   486,   485,   488,   487,   490,   489,   492,
     491,     0,     0,     0,     0,     0,     0,   508,   507,   509,
     510,   514,   513,   512,   511,   516,   515,   518,   517,   520,
     519,   522,   521,   524,   523,   526,   525,   398,   397,   400,
     399,     0,     0,     0,   591,     0,   592,     0,   596,     0,
       0,   609,     0,     0,   613,     0,     0,   616,     0,   546,
     547,   545,     0,     0,     0,     0,    64,     0,    27,     0,
       0,     0,     0,    62,     0,   404,     0,     0,     0,     0,
       0,   556,     0,   560,     0,     0,     0,     0,     0,     0,
       0,     0,    68,    70,    76,     0,     0,     0,     0,     0,
       0,  1005,  1002,  1006,  1009,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   958,   960,   962,   965,     0,     0,     0,     0,
       0,   979,   981,   983,   985,     0,     0,     0,     0,     0,
       0,     0,   835,   836,   837,   760,     0,   772,   773,   718,
       0,     0,   710,   713,   714,   715,     0,   764,   765,   775,
     776,   777,     0,     0,     0,   706,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   605,     0,     0,
       0,    29,   583,    60,    50,    49,    57,    58,    43,    44,
      45,    46,    47,    48,   414,     0,   405,   705,   700,   703,
     704,   702,     0,     0,     0,     0,     0,    91,    93,     0,
       0,     0,     0,     0,   496,   495,   498,   497,   500,   499,
     502,   501,   504,   503,   506,   505,     0,   848,     0,   870,
       0,   881,     0,   892,     0,   859,     0,     0,   644,   645,
     646,   657,   650,   658,   651,   656,   648,   655,   647,     0,
     649,     0,   652,     0,   653,   746,   792,   790,   791,     0,
       0,     0,     0,     0,     0,   779,     0,     0,   778,     0,
     654,     0,   659,     0,   785,   784,   783,     0,   766,   768,
     767,   780,   781,   782,   793,     0,  1004,     0,  1001,     0,
    1008,   896,     0,   913,     0,   917,     0,     0,   921,     0,
     940,     0,   943,     0,   924,     0,   930,     0,   927,     0,
     933,     0,   936,     0,     0,   949,     0,   952,     0,   946,
       0,   955,     0,     0,     0,     0,     0,     0,     0,     0,
     971,     0,   974,     0,   977,     0,     0,     0,     0,     0,
     738,     0,     0,   988,     0,   991,     0,   900,     0,   903,
       0,   906,     0,   995,     0,   719,   712,   711,   589,   709,
     748,   749,   750,   751,   752,   753,   754,   755,   756,   757,
       0,   758,   761,   774,     0,   717,   911,     0,   716,     0,
     594,     0,   607,     0,   611,     0,   552,   548,   549,     0,
     600,     0,     0,    28,     0,   415,     0,     0,     0,   406,
       0,     0,     0,     0,     0,   227,    92,   557,   561,     0,
       0,     0,     0,     0,   693,     0,   838,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   663,
     623,   624,   632,   625,   626,   631,     0,     0,     0,   688,
       0,     0,   833,   814,   817,   795,   818,   796,     0,     0,
       0,     0,  1003,   766,   767,   781,   782,     0,     0,     0,
       0,   667,     0,   672,   627,   628,   629,   630,     0,     0,
     684,     0,   761,   816,   794,     0,     0,     0,     0,     0,
       0,     0,   633,   634,   639,   635,   636,   637,   638,   640,
     641,   642,   643,     0,     0,     0,     0,     0,     0,     0,
    1000,  1007,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   932,     0,   935,     0,   938,     0,     0,
       0,     0,     0,     0,     0,     0,   957,   959,   961,     0,
       0,   964,     0,     0,     0,   720,   707,     0,     0,     0,
       0,     0,    51,     0,     0,   978,   980,   982,   984,     0,
     740,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,   834,     0,   771,     0,   769,     0,
     770,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      59,   416,   407,     0,     0,     0,    90,    89,    84,    83,
      82,    81,     0,    88,    87,     0,     0,     0,     0,     0,
       0,   849,     0,   847,     0,   840,     0,   841,     0,     0,
       0,   839,   871,     0,   869,     0,   862,     0,   863,     0,
     861,   882,     0,   880,     0,   873,     0,   874,     0,   872,
     893,     0,   891,     0,   884,     0,   885,     0,   883,   860,
       0,   858,     0,   851,     0,   852,     0,   850,   662,     0,
     660,   678,    36,    37,    38,    39,    40,    41,    42,   676,
     677,   675,   673,   674,   687,   685,   686,   741,   745,   747,
       0,     0,     0,     0,     0,     0,   789,   811,   788,   787,
     786,   666,     0,   664,   671,   669,   670,   668,   683,     0,
      63,     0,   691,   679,   681,   680,     0,   829,   810,   828,
     809,   824,   802,   825,   803,   804,   805,   806,   819,   797,
     820,   798,   821,   799,   822,   800,   823,   801,   827,   808,
     826,   807,   897,     0,   894,   914,     0,   918,   916,   915,
     919,   922,   920,   941,   939,   944,   942,   925,   923,   931,
     929,   928,   926,   937,   934,   950,   948,   953,   951,   947,
     945,   956,   954,   966,   963,   968,   967,     0,     0,   970,
     969,   973,   972,   976,     0,     0,   975,     0,     0,     0,
     737,   735,     0,   989,     0,   992,   990,   898,   899,   901,
     902,   904,   905,   999,     0,   998,   759,   763,     0,   910,
     761,     0,     0,     0,     0,     0,   550,   551,     0,   604,
       0,   417,   409,     0,     0,     0,     0,     0,     0,   567,
     568,   570,   572,   571,   590,     0,     0,     0,     0,   697,
     695,   696,   694,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   830,   812,   831,   813,
     832,     0,     0,     0,     0,     0,   708,   721,    55,    52,
      53,   739,     0,     0,     0,   722,   728,   736,   734,    63,
       0,     0,   994,     0,     0,     0,   595,   608,   612,   615,
     553,   554,   580,   410,   408,    85,     0,    79,    80,   845,
     846,   843,   844,   842,   867,   868,   865,   866,   864,   878,
     879,   876,   877,   875,   889,   890,   887,   888,   886,   856,
     857,   854,   855,   853,     0,     0,   744,     0,   692,   690,
     689,   762,   895,   912,     0,   731,     0,     0,     0,     0,
     986,   987,   997,   909,   908,   907,   412,     0,     0,     0,
     743,   742,     0,    54,     0,   732,   726,   733,     0,   411,
      86,    78,     0,     0,     0,   413,   815
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1320, -1320, -1320,  2412, -1320, -1320, -1320, -1320, -1320,  -462,
    1533,  1643,  -247,  1306, -1320, -1319, -1320, -1320,   638,  -252,
   -1320,  1676, -1320,  -218, -1320,  1702, -1320,  1509, -1320, -1320,
   -1320, -1320,  1358, -1320, -1320, -1089,  2265,  2076,  2266,   553,
   -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320, -1320,
   -1320, -1320, -1320, -1320, -1320, -1139, -1320, -1063, -1320, -1320,
    1308, -1320, -1320, -1320,  1317, -1320, -1320,   311,  -731, -1320,
    -242, -1265,  -935,  -633, -1320,   873,   961, -1320, -1320, -1320,
     894, -1320, -1320, -1320, -1320,  1179, -1114,  -916,  -971, -1320,
    -928, -1320, -1320, -1320,  -674,  -959, -1320, -1320, -1320, -1320,
     -60,   257, -1320, -1320, -1320, -1320,   875, -1320
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,   226,   227,   228,   229,   230,   231,   232,   233,   615,
     999,   616,   617,  1609,  1125,  1116,  1494,   618,   619,  1198,
     234,   515,   516,   517,   235,   520,   521,  1138,  1139,   236,
     355,   237,   992,   238,   239,   620,   621,   622,   623,   555,
     533,   534,   536,   537,   240,   241,   994,  1108,   539,   540,
     542,   543,   545,   546,   242,  1375,  1409,  1376,  1438,  1439,
    1199,  1200,  1201,  1202,  1203,  1204,  1643,  1348,   624,   625,
    1205,  1485,  1081,  1082,  1083,  1814,  1721,  1722,  1084,  1085,
    1618,  1619,  1206,  1381,  1300,  1301,  1302,  1207,  1208,  1209,
    1210,  1089,  1211,  1519,  1212,  1213,  1304,  1092,  1214,  1215,
    1397,  1093,  1094,  1095,  1284,  1734,  1735,  1096
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     572,   519,   875,   578,   568,  1530,  1087,  1500,   874,  1087,
     987,  1285,  1087,  1515,   512,  1087,  1765,   247,  1091,  1774,
     587,  1091,   797,  1087,  1091,   277,   279,  1091,  1868,   245,
    1342,   243,   641,  1717,   642,  1091,   643,   974,   644,   387,
    1377,   978,  1378,   389,  1380,  1098,   244,   976,  1100,  1088,
    1107,  1102,  1088,  1779,   547,  1088,  1784,   989,  1088,  1106,
     981,  1086,  1408,   550,  1086,   607,  1088,  1086,   522,  1347,
    1086,  1352,   548,  1357,   524,  1362,  1157,  1367,  1086,  1159,
    1769,   384,  1349,  1283,   570,  1007,   984,   248,  1354,  1114,
    1718,  1719,  1343,  1412,   249,  1008,  1325,  1326,   571,   676,
     526,  1545,  1115,   378,   381,   250,  1161,  1163,   626,  1165,
    1087,   699,   701,   703,   705,   707,   709,   711,   713,   715,
     717,  1479,  1091,  1221,  1223,  1225,   630,  1087,  1228,  1087,
    1230,  1087,  1232,  1234,   570,  1087,  1402,  1236,   569,  1091,
    1411,  1091,  1238,  1091,  1350,  1240,  1359,  1091,   571,   589,
    1355,   998,  1242,  1088,   563,   564,   565,   566,  1364,  1245,
    1247,   780,   782,   784,  1491,  1086,  1558,  1558,  1249,  1251,
    1088,   251,  1088,  1316,  1088,  1260,  1559,  1559,  1088,  1262,
    1264,  1273,  1086,  1010,  1086,  1011,  1086,  1275,  1277,  1560,
    1086,  1561,  1279,  1281,  1283,   838,   840,   563,   564,   565,
     566,  1306,  1012,   391,  1013,   593,   518,   570,  1360,   531,
     532,   597,   752,   570,   252,   563,   564,   565,   566,   599,
    1365,   571,  1752,  1753,  1464,  1393,  1087,   571,   755,   253,
    1864,  1830,   758,   513,  1831,   514,  1737,  1396,  1091,   601,
     761,  1435,  1436,  1437,   764,   785,  1393,   948,  1393,  1540,
     952,   954,   603,   563,   564,   565,   566,   556,  1396,   906,
    1396,  1442,  1400,   254,  1824,   605,   679,   692,  1394,  1088,
     552,   553,  1487,   554,   722,   724,  1129,  1131,   730,   734,
     862,  1086,   864,  1771,   866,   927,   967,  1393,  1087,  1394,
     969,  1394,  1144,  1146,  1148,  1150,   255,  1152,  1154,  1396,
    1091,  1087,  1445,  1090,  1451,  1453,  1090,  1455,  1457,  1090,
    1468,  1470,  1090,  1091,  1472,  1474,  1501,  1503,  1538,   256,
    1090,  1766,  1642,  1127,  1775,  1552,  1130,  1553,   281,   909,
    1394,  1088,  1075,  1554,   558,  1555,  1518,   257,   563,   564,
     565,   566,   560,  1086,  1088,   498,   577,   675,  1520,   698,
    1087,   700,   702,   704,   706,   708,  1086,   710,  1780,   278,
     280,  1785,  1091,   573,   712,   575,   579,   990,   991,  1327,
    1087,   581,  1113,   638,   714,   716,   608,   609,   610,   611,
     612,   528,  1091,   513,  1516,   514,  1528,  1078,  1286,   588,
     614,  1517,  -614,  1088,   612,  1809,  1869,  -598,   795,  1344,
     612,  1345,   612,  1740,   614,  1086,  1550,  1090,  1346,  -597,
     614,   246,   614,  1088,  1720,   385,   535,  -587,   388,   975,
     567,  -593,   390,   979,  1090,  1086,  1090,  -588,  1090,  1087,
    -603,   551,  1090,   608,   609,   610,   611,   612,  1837,   523,
    -606,  1091,   982,  1807,   613,   525,   258,   614,  1289,  1770,
     795,  1344,   386,  1351,   612,  1158,   795,  1344,  1160,  1356,
     612,  1678,  -993,   567,   614,  1289,  -610,  1289,   985,  1289,
     614,   527,  1088,  1289,   379,   382,   608,   609,   610,   611,
     612,   567,   380,   383,  1086,  1162,  1164,   613,  1166,  1480,
     614,  1808,   570,  1380,   608,   609,   610,   611,   612,  1481,
    1380,   779,  1222,  1224,  1226,   613,   571,  1229,   614,  1231,
     583,  1233,  1235,  1087,   795,  1344,  1237,  1361,   612,   567,
     590,  1239,  1395,  1090,  1241,  1091,   795,  1344,   614,  1366,
     612,  1243,   608,   609,   610,   611,   612,   392,  1246,  1248,
     614,  1317,  1124,  1395,  1318,  1395,   614,  1250,  1252,  1707,
    1087,  1087,  1087,  1087,  1261,  1893,  1088,  1087,  1263,  1265,
    1274,   781,  1091,  1091,  1091,  1091,  1276,  1278,  1086,  1091,
    1901,  1280,  1282,  -993,   393,   513,   594,   514,   570,  1087,
    1307,   753,   598,   754,  1395,  1090,  1742,  1743,  1744,  1745,
     600,  1091,   571,  1088,  1088,  1088,  1088,   756,  1090,   757,
    1088,   759,  1465,   760,   567,  1086,  1086,  1086,  1086,   762,
     602,   763,  1086,   765,   786,   766,   787,   608,   609,   610,
     611,   612,  1088,   604,   585,   557,  1486,   783,   907,  1443,
     908,   614,  1444,   513,  1086,   514,   606,   680,   693,  1486,
     608,   609,   610,   611,   612,   723,   725,  1090,   998,   731,
     735,   863,  1772,   865,   614,   867,   928,   968,   837,   839,
     947,   970,   282,  1145,  1147,  1149,  1151,  1090,  1153,  1155,
     951,   953,   591,  1446,   595,  1452,  1454,   628,  1456,  1458,
     632,  1469,  1471,   634,   636,  1473,  1475,  1502,  1504,  1539,
     677,  1128,   609,   610,  1128,   609,   610,   910,   911,   681,
     570,   570,   559,   570,   684,   570,   570,   570,   570,   570,
     561,   570,   686,  1870,   571,   571,   688,   571,   570,   571,
     571,   571,   571,   571,   690,   571,  1090,  1114,   570,   570,
     694,   574,   571,   576,   580,  1080,  1087,  1087,  1080,   582,
    1115,  1080,   571,   571,  1080,   696,   718,   720,  1091,  1091,
     726,   736,  1080,   738,   740,   519,   742,   744,   746,   748,
     750,   283,   285,   287,   767,   769,   771,  1289,   773,   775,
     777,  1087,  1087,  1087,  1087,   788,   790,   792,   794,  1088,
    1088,   799,   801,  1091,  1091,  1091,  1091,   259,   807,   809,
     260,  1086,  1086,   811,   813,   815,   817,   819,  1789,  1488,
     821,   823,   825,  1492,   827,   829,   831,   833,   835,   841,
    1090,   843,   845,   847,  1088,  1088,  1088,  1088,   854,   856,
     858,   860,   868,   870,   872,   876,  1086,  1086,  1086,  1086,
     878,   880,   882,   289,   884,   886,   261,   291,   888,  1080,
     890,   892,   894,   896,   898,  1087,  1114,  1090,  1090,  1090,
    1090,   900,   262,   263,  1090,   570,  1080,  1091,  1080,  1115,
    1080,   293,   295,   902,  1080,   904,  1533,   913,  1534,   571,
     915,  1541,   917,   919,   264,   921,  1090,   923,   584,   925,
     929,  1879,   931,   933,   935,   265,   937,   939,  1088,   955,
     957,   959,   961,   297,   963,  1289,   965,   266,  1459,  1461,
    1086,  1489,   299,   301,  1087,  1536,  1543,  1087,  1087,   627,
    1556,   631,  1557,   267,   268,   570,  1091,  1289,   269,  1091,
    1091,   270,   271,  1087,  1087,  1087,  1563,  1087,  1564,   571,
     562,   849,  1087,  1087,   303,  1091,  1091,  1091,   305,  1091,
    1894,  1403,   307,  1898,  1091,  1091,  1565,  1088,  1566,   272,
    1088,  1088,  1567,   309,  1568,  1080,  1369,   273,   538,  1086,
    1903,  1904,  1086,  1086,  1482,   549,  1088,  1088,  1088,   274,
    1088,  1216,  1218,  1220,   275,  1088,  1088,   311,  1086,  1086,
    1086,   570,  1086,  1718,  1719,   570,   313,  1086,  1086,  1401,
     315,  1466,   586,   317,   541,   571,  1410,  1259,   276,   571,
     319,   321,  1547,   351,  1548,  1271,  1272,   323,   544,   639,
    1483,   325,   570,   570,   570,   352,   327,  1080,  1493,   563,
     564,   565,   566,  1379,   570,   570,   571,   571,   571,   329,
    1080,  1370,  1371,  1090,  1090,   331,  1373,  1374,   571,   571,
     592,   353,   596,  1505,   513,   629,   514,   354,   633,   665,
     640,   635,   637,   563,   564,   565,   566,   356,   678,   333,
    1506,   335,  1508,   337,  1510,   339,   357,   682,  1090,  1090,
    1090,  1090,   685,   358,  1289,  1486,  1004,  1005,  1006,  1080,
     687,   728,   359,  1535,   689,   645,  1542,  1546,  1549,   341,
     343,  1572,   691,  1573,   646,   284,   286,   288,   695,  1080,
     729,   345,   347,  1790,   647,   360,   349,   424,   426,  1289,
    1289,  1289,  1289,   697,   719,   721,   428,   648,   727,   737,
     430,   739,   741,   482,   743,   745,   747,   749,   751,  1383,
    1385,  1387,   768,   770,   772,   649,   774,   776,   778,  1329,
     650,   651,  1090,   789,   791,   793,   795,   652,   361,   800,
     802,  1507,   513,   653,   514,  1414,   808,   810,  1080,   654,
     362,   812,   814,   816,   818,   820,  1449,   290,   822,   824,
     826,   292,   828,   830,   832,   834,   836,   842,   655,   844,
     846,   848,   850,   851,   852,   853,   855,   857,   859,   861,
     869,   871,   873,   877,   363,   294,   296,   656,   879,   881,
     883,  1090,   885,   887,  1090,  1090,   889,   657,   891,   893,
     895,   897,   899,   658,   563,   564,   565,   566,   659,   901,
    1090,  1090,  1090,   660,  1090,  1509,   513,   298,   514,  1090,
    1090,   903,  1574,   905,  1575,   914,   300,   302,   916,   661,
     918,   920,  1080,   922,  1514,   924,  1289,   926,   930,   364,
     932,   934,   936,  1810,   938,   940,  1003,   956,   958,   960,
     962,  1289,   964,   365,   966,  1289,  1460,  1462,   304,  1490,
    1289,  1289,   306,  1537,  1544,   662,   308,   366,   367,  1080,
    1080,  1080,  1080,  1370,  1371,   567,  1080,   310,  1373,  1374,
    1404,  1405,  1406,  1407,  1836,  1576,  1838,  1577,  1370,  1371,
    1372,   368,   369,  1373,  1374,   370,   371,  1817,  1080,   372,
     972,   312,   563,   564,   565,   566,  1600,  1610,  1613,   567,
     314,  1581,   373,  1582,   316,   374,   375,   318,  1621,  1623,
    1625,  1370,  1371,  1372,   320,   322,  1373,  1374,  1370,  1371,
    1372,   324,  1633,  1373,  1374,   326,   376,   377,  1635,  1637,
     328,  1645,  1583,   394,  1584,  1648,  1650,  1652,  1654,  1655,
    1656,  1657,   395,   330,   396,  1370,  1371,   397,   398,   332,
    1373,  1374,   399,  1659,  1661,  1663,  1665,  1667,  1669,  1671,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,   400,  1034,
    1035,  1036,  1037,   334,  1803,   336,   401,   338,  1558,   340,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,  1559,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,   402,  1055,
    1569,  1056,  1570,   342,   344,  1057,   663,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,   346,   348,  1066,  1067,  1068,
     350,   425,   427,  1069,  1070,  1071,  1072,  1073,  1074,   403,
     429,  1733,  1614,  1398,   431,   404,   405,   483,  1132,  1133,
    1134,  1132,  1133,  1134,   664,  1080,  1080,  1585,  1590,  1586,
    1591,  1353,   406,  1358,  1398,  1363,  1398,  1368,   407,  1592,
     567,  1593,  1290,  1291,  1292,  1293,  1294,  1295,  1296,  1297,
    1298,   408,   666,   608,   609,   610,   611,   612,   409,   410,
    1080,  1080,  1080,  1080,   613,   411,  1594,   614,  1595,   412,
    1135,  1136,  1558,  1135,  1136,  1398,  1738,  1821,  1739,  1822,
    1823,   413,  1559,  1825,  1168,  1169,  1170,  1171,  1025,  1173,
    1299,  1175,  1097,  1177,  1578,  1099,  1579,   414,  1101,   415,
     416,   417,  1865,  1415,  1416,  1417,  1418,  1419,  1420,  1421,
    1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,  1431,
    1432,  1433,  1434,  1435,  1436,  1437,   608,   609,   610,   611,
     612,   418,   419,   420,  1080,  1558,  1558,   613,   567,   421,
     614,   422,   423,   432,   433,  1559,  1559,   434,  1499,   435,
     436,   608,   609,   610,   611,   612,   437,  1587,  1596,  1588,
    1597,   438,   439,   440,   441,   614,  1415,  1416,  1417,  1418,
    1419,  1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,
    1429,  1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,   442,
     443,   444,   445,  1080,   446,   447,  1080,  1080,   448,   449,
     450,   608,   609,   610,   611,   612,   451,   452,   453,  1627,
     454,   455,  1080,  1080,  1080,   614,  1080,   456,  1815,   457,
     458,  1080,  1080,   459,  1820,   460,   461,    -2,   529,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,     2,   667,
     462,   732,   -11,   -11,   -13,     3,     4,   -16,   -18,   -20,
     941,   942,   943,   944,   945,   463,   946,  1075,  1433,  1434,
    1435,  1436,  1437,   464,   465,   466,     5,   467,     6,   468,
       7,     8,     9,    10,    11,  1118,  1119,  1120,  1121,  1122,
    1123,   469,  1644,   470,  1137,   471,    12,  1137,  1335,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   484,
     485,  1867,   486,   487,   488,   489,   490,  1076,   491,   492,
     493,  1077,  1078,  1815,   494,  1079,   495,   496,  1484,   497,
     499,  1733,   500,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,   501,
     502,   503,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,   504,    74,    75,
      76,   505,  1902,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   506,
     507,   508,   509,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   510,   203,   204,   511,   668,   669,   670,
     671,   205,   672,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   673,   674,   683,
     803,   804,   733,   805,   608,   609,   610,   611,   612,   220,
     221,   222,   806,   912,   949,   950,   971,   973,   614,  1415,
    1416,  1417,  1418,  1419,  1420,  1421,  1422,  1423,  1424,  1425,
    1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,
    1436,  1437,   977,   980,   983,   993,   986,   223,   996,   988,
     997,   995,  1009,   612,  1001,   224,  1002,  1016,  1014,  1015,
    1801,  1283,   225,  -693,  -693,  -693,  -693,  -693,  -693,  -693,
    -693,  1017,  -693,  -693,  -693,  -693,  1018,  1019,  1020,  1021,
    1023,  1103,  1104,  -693,  -693,  -693,  -693,  -693,  -693,  -693,
    -693,  1105,  -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,
    -693,  1109,  -693,  1110,  -693,  1112,  1111,  1126,  -693,  1140,
    -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,  1141,  1227,
    -693,  -693,  -693,  1142,  1143,  1244,  -693,  -693,  -693,  -693,
    -693,  -693,  1283,  1156,  -661,  -661,  -661,  -661,  -661,  -661,
    -661,  -661,  1253,  -661,  -661,  -661,  -661,  1254,  1255,  1256,
    1257,  1266,  1267,  1268,  -661,  -661,  -661,  -661,  -661,  -661,
    -661,  -661,  1269,  -661,  -661,  -661,  -661,  -661,  -661,  -661,
    -661,  -661,  1303,  -661,  1305,  -661,  1308,  1309,  1311,  -661,
    1319,  -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,  1313,
    1315,  -661,  -661,  -661,  1321,  1322,  1324,  -661,  -661,  -661,
    -661,  -661,  -661,  1379,  1328,  -665,  -665,  -665,  -665,  -665,
    -665,  -665,  -665,  1330,  -665,  -665,  -665,  -665,  1331,  1332,
    1333,  1334,  1337,  1338,  1339,  -665,  -665,  -665,  -665,  -665,
    -665,  -665,  -665,  1340,  -665,  -665,  -665,  -665,  -665,  -665,
    -665,  -665,  -665,  1341,  -665,  1388,  -665,  1389,  1390,  1450,
    -665,  1463,  -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,
    1467,  1476,  -665,  -665,  -665,  1512,  1477,  1478,  -665,  -665,
    -665,  -665,  -665,  -665,  1379,  1495,  -682,  -682,  -682,  -682,
    -682,  -682,  -682,  -682,  1496,  -682,  -682,  -682,  -682,  1497,
    1498,  1513,  1511,  1525,  1521,  1522,  -682,  -682,  -682,  -682,
    -682,  -682,  -682,  -682,  1523,  -682,  -682,  -682,  -682,  -682,
    -682,  -682,  -682,  -682,  1524,  -682,  1526,  -682,  1529,  1531,
    1532,  -682,  1551,  -682,  -682,  -682,  -682,  -682,  -682,  -682,
    -682,  1562,  1571,  -682,  -682,  -682,  1580,  1589,  1617,  -682,
    -682,  -682,  -682,  -682,  -682,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,  1626,  -764,
    -765,  -776,  -777,  1628,  1629,  1672,  1646,  1673,  1674,  1708,
    -693,  1675,  1676,  1677,  1714,  1680,  1681,  1682,  1679,  1683,
    1684,  1685,  1686,  1687,  1688,  1689,  -693,  -693,  -693,  -693,
    -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,
    -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,  -693,  1690,
    1691,  1692,  1693,  1694,  1695,  -693,  1696,  1697,  1698,  1699,
    -693,  1700,  1701,  1702,  -693,  -693,  1703,  -693,  -693,  -693,
    -993,  -693,  1704,  1705,  1706,  1709,  -693,  1710,  1711,  1712,
    1713,  -661,  1716,  1715,  1723,  1724,  1725,  1299,  1726,  1727,
    1728,  1729,  1730,  1731,  1732,  1741,  1746,  -661,  -661,  -661,
    -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,
    -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,  -661,
    1737,  1747,  1748,  1750,  1751,  1754,  1755,  1756,  1757,  1758,
    1759,  -661,  1760,  1761,  1762,  -661,  -661,  1767,  -661,  -661,
    -661,  -993,  -661,  1763,  1768,  1773,  1776,  -661,  1777,  1778,
    1781,  1782,  -665,  1783,  1786,  1787,  1794,  1788,  1791,  1792,
    1793,  1795,  1796,  1802,  1804,  1805,  1832,  1833,  -665,  -665,
    -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,
    -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,  -665,
    -665,  1798,  1800,  1811,  1816,  1834,  1835,  1839,  1840,  1841,
    1842,  1843,  -665,  1844,  1845,  1886,  -665,  -665,  1846,  -665,
    -665,  -665,  1847,  -665,  1848,  1849,  1850,  1851,  -665,  1852,
    1853,  1854,  1855,  -682,  1856,  1857,  1858,  1859,  1860,  1861,
    1862,  1863,  1887,  1872,  1873,  1880,  1883,  1871,  1884,  -682,
    -682,  -682,  -682,  -682,  -682,  -682,  -682,  -682,  -682,  -682,
    -682,  -682,  -682,  -682,  -682,  -682,  -682,  -682,  -682,  -682,
    -682,  -682,  1874,  1875,  1878,  1885,  1888,  1889,  1890,  1891,
    1899,  1900,  1905,  -682,  1895,  1896,     1,  -682,  -682,   530,
    -682,  -682,  -682,  1323,  -682,  1117,     2,  1022,  1336,  -682,
     -11,   -11,   -13,     3,     4,   -16,   -18,   -20,  1422,  1423,
    1424,  1425,  1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,
    1434,  1435,  1436,  1437,     5,  1024,     6,  1527,     7,     8,
       9,    10,    11,  1818,  1612,   796,  1877,   798,  1615,  1866,
    1000,  1736,     0,     0,    12,     0,  1882,  1616,     0,     0,
       0,     0,     0,     0,  1415,  1416,  1417,  1418,  1419,  1420,
    1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,  1434,  1435,  1436,  1437,     0,     0,     0,
       0,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,  1797,     0,     0,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,     0,    74,    75,    76,     0,
       0,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,     0,     0,     0,
       0,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,     0,   203,   204,     0,     0,     0,     0,     0,   205,
       0,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   220,   221,   222,
       0,     0,  1415,  1416,  1417,  1418,  1419,  1420,  1421,  1422,
    1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,  1431,  1432,
    1433,  1434,  1435,  1436,  1437,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1638,   223,  1026,  1027,  1028,  1029,
    1030,     0,     0,   224,     0,  1799,  1035,  1036,  1037,     0,
     225,     0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
       0,     0,     0,     0,  1067,  1068,     0,     0,     0,  1069,
    1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1639,  1184,  1897,     0,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
    1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
    -725,  -725,  1066,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,  1287,     0,  1026,  1027,  1028,  1029,
    1030,  1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,     0,
       0,     0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,
       0,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
    1065,  -727,  -727,  1066,  1067,  1068,     0,     0,     0,  1069,
    1070,  1071,  1072,  1073,  1074,  1287,     0,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,     0,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,
       0,     0,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,  1065,  -729,  -729,  1066,  1067,  1068,     0,     0,     0,
    1069,  1070,  1071,  1072,  1073,  1074,  1421,  1422,  1423,  1424,
    1425,  1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,
    1435,  1436,  1437,  1075,  1185,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1186,     0,
       0,     0,  1187,     0,  1188,  1189,  1190,  1191,  1881,  1192,
    1193,  1194,  1640,  1641,     0,  1195,   612,  1077,  1078,     0,
       0,     0,     0,  1258,  1197,     0,   614,     0,     0,     0,
       0,  1287,     0,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,     0,  1034,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,  1075,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,  1057,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,  -723,  -723,
    1066,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,  1076,     0,     0,     0,  1077,  1078,     0,     0,
    1079,     0,     0,     0,  -725,     0,     0,     0,     0,     0,
       0,     0,     0,  1075,  1415,  1416,  1417,  1418,  1419,  1420,
    1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,  1434,  1435,  1436,  1437,  1418,  1419,  1420,
    1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,
    1431,  1432,  1433,  1434,  1435,  1436,  1437,  1906,     0,     0,
       0,     0,     0,  1076,     0,     0,     0,  1077,  1078,     0,
       0,  1079,     0,     0,     0,  -727,     0,     0,     0,     0,
       0,     0,     0,     0,  1075,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,  1420,  1421,
    1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,  1430,  1431,
    1432,  1433,  1434,  1435,  1436,  1437,  1892,     0,     0,     0,
       0,     0,     0,     0,  1076,     0,     0,     0,  1077,  1078,
       0,     0,  1079,     0,     0,  1287,  -729,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,     0,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,
       0,     0,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,  1065,  -730,  -730,  1066,  1067,  1068,     0,     0,     0,
    1069,  1070,  1071,  1072,  1073,  1074,     0,     0,     0,  1287,
       0,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,
    1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
    1075,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,  1057,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,  -724,  -724,  1066,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1076,     0,     0,     0,  1077,  1078,     0,     0,  1079,     0,
       0,  1287,  -723,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,     0,  1034,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,  1057,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,     0,     0,
    1066,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,  1287,     0,  1026,  1027,  1028,  1029,  1030,  1031,
    1032,  1033,     0,  1034,  1035,  1036,  1037,     0,     0,     0,
       0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,  1057,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,     0,
       0,  1066,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,
    1072,  1073,  1074,  1287,     0,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,  1075,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
    1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
       0,     0,  1066,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,  1076,     0,     0,     0,  1077,  1078,
       0,     0,  1079,     0,     0,     0,  -730,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1075,  1415,
    1416,  1417,  1418,  1419,  1420,  1421,  1422,  1423,  1424,  1425,
    1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,
    1436,  1437,  1416,  1417,  1418,  1419,  1420,  1421,  1422,  1423,
    1424,  1425,  1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,
    1434,  1435,  1436,  1437,     0,     0,     0,     0,  1076,     0,
       0,     0,  1077,  1078,     0,     0,  1079,     0,     0,  1287,
    -724,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,
    1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
    1075,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,  1057,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,     0,     0,  1066,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1076,     0,     0,     0,  1077,  1078,     0,     0,  1079,     0,
       0,     0,  1288,     0,     0,     0,     0,     0,     0,     0,
       0,  1075,  1417,  1418,  1419,  1420,  1421,  1422,  1423,  1424,
    1425,  1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,
    1435,  1436,  1437,  1419,  1420,  1421,  1422,  1423,  1424,  1425,
    1426,  1427,  1428,  1429,  1430,  1431,  1432,  1433,  1434,  1435,
    1436,  1437,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1076,     0,     0,     0,  1077,  1078,     0,     0,  1079,
       0,     0,     0,  1310,     0,     0,     0,     0,     0,     0,
       0,     0,  1075,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1076,     0,     0,     0,  1077,  1078,     0,     0,
    1079,     0,     0,  1287,  1312,  1026,  1027,  1028,  1029,  1030,
    1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
    1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,
       0,     0,  1066,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,     0,     0,     0,  1287,     0,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,  1075,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,  1057,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,     0,     0,  1066,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1076,     0,
       0,     0,  1077,  1078,     0,     0,  1079,     0,     0,  1287,
    1314,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,
    1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,  1057,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,  1065,     0,     0,  1066,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1287,     0,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,  1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,  1055,     0,  1056,     0,     0,     0,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,     0,     0,  1066,
    1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,
    1074,  1287,     0,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,     0,  1034,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,  1075,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,  1057,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,     0,     0,
    1066,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,  1076,     0,     0,     0,  1077,  1078,     0,     0,
    1079,     0,     0,     0,  1320,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1076,     0,     0,     0,
    1077,  1078,     0,     0,  1079,     0,     0,  1287,  1630,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,  1075,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,  1057,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,     0,     0,  1066,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1076,     0,
       0,     0,  1077,  1078,     0,     0,  1079,     0,     0,     0,
    1749,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1076,
       0,     0,     0,  1077,  1078,     0,     0,  1079,     0,     0,
       0,  1764,     0,     0,     0,     0,     0,     0,     0,     0,
    1075,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1076,     0,     0,     0,  1077,  1078,     0,     0,  1079,     0,
       0,  1287,  1806,  1026,  1027,  1028,  1029,  1030,  1031,  1032,
    1033,     0,  1034,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,  1057,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,  1065,     0,     0,
    1066,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,     0,     0,     0,  1287,     0,  1026,  1027,  1028,
    1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,  1075,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,
       0,     0,  1057,     0,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,  1065,     0,     0,  1066,  1067,  1068,     0,     0,     0,
    1069,  1070,  1071,  1072,  1073,  1074,  1076,     0,     0,     0,
    1077,  1078,     0,     0,  1079,     0,     0,  1287,  1826,  1026,
    1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,  1057,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,  1065,     0,     0,  1066,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1601,     0,  1026,  1027,
    1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,     0,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,     0,
    1075,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,
    1180,  1181,  1182,  1183,  1184,  1602,  1603,  1604,  1605,  1606,
    1607,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1076,     0,     0,     0,  1077,  1078,     0,     0,  1079,     0,
       0,     0,  1827,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1075,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1076,     0,     0,     0,  1077,  1078,
       0,     0,  1079,     0,     0,     0,  1828,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1076,     0,     0,     0,
    1077,  1078,     0,     0,  1079,     0,     0,     0,  1829,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1075,  1185,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1186,  1608,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,
       0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,
    1078,     0,     0,     0,     0,  1258,  1197,  1611,     0,  1026,
    1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,  1602,  1603,  1604,  1605,
    1606,  1607,  1391,     0,  1026,  1027,  1028,  1029,  1030,     0,
       0,     0,     0,     0,  1035,  1036,  1037,     0,     0,     0,
       0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,
       0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,
    1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,
    1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,
    1184,  1391,     0,  1026,  1027,  1028,  1029,  1030,     0,     0,
       0,     0,     0,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,     0,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,
       0,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,  1185,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1186,  1608,     0,     0,  1187,     0,  1188,  1189,  1190,
    1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,
    1077,  1078,     0,     0,     0,     0,  1258,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1075,  1185,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1186,     0,     0,     0,
    1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,
     571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,     0,
    1392,  1258,  1197,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1075,  1185,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1186,     0,     0,     0,  1187,
       0,  1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,
    1076,     0,  1195,     0,  1077,  1078,     0,     0,     0,  1440,
    1258,  1197,  1391,     0,  1026,  1027,  1028,  1029,  1030,     0,
       0,     0,     0,     0,  1035,  1036,  1037,     0,     0,     0,
       0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,
       0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,
    1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,
    1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,
    1184,  1812,     0,  1026,  1027,  1028,  1029,  1030,     0,     0,
       0,     0,     0,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,     0,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,
       0,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1270,     0,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,
       0,     0,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,
    1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,
    1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1075,  1185,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1186,     0,     0,     0,
    1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,
     571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,     0,
    1441,  1258,  1197,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1075,  1185,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1186,     0,  1813,     0,  1187,
       0,  1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,
    1076,     0,  1195,     0,  1077,  1078,     0,     0,     0,     0,
    1258,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
    1185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1186,     0,     0,     0,  1187,     0,
    1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1076,
       0,  1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,
    1197,  1382,     0,  1026,  1027,  1028,  1029,  1030,     0,     0,
       0,     0,     0,  1035,  1036,  1037,     0,     0,     0,     0,
       0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,
    1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,
    1054,     0,  1055,     0,  1056,     0,     0,     0,     0,     0,
    1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,
       0,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,
    1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,
    1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,
    1384,     0,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,
       0,     0,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,
    1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,
    1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1386,
       0,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,
       0,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,     0,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1075,  1185,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1186,     0,     0,     0,  1187,
       0,  1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,
    1076,     0,  1195,     0,  1077,  1078,     0,     0,     0,     0,
    1258,  1197,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
    1185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1186,     0,     0,     0,  1187,     0,
    1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1076,
       0,  1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,
    1197,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1075,  1185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1186,     0,     0,     0,  1187,     0,  1188,
    1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1076,     0,
    1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,
    1413,     0,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,
       0,     0,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,
    1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,
    1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1447,
       0,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,
       0,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,     0,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1391,     0,
    1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,
    1035,  1036,  1037,     0,     0,     0,     0,     0,     0,     0,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,
       0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,
    1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,
    1178,  1179,  1180,  1181,  1182,  1183,  1184,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
    1185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1186,     0,     0,     0,  1187,     0,
    1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1076,
       0,  1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,
    1197,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1075,  1185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1186,     0,     0,     0,  1187,     0,  1188,
    1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1448,     0,
    1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1075,  1185,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,
    1190,  1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,
       0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,  1598,
       0,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,
       0,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,     0,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1620,     0,
    1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,
    1035,  1036,  1037,     0,     0,     0,     0,     0,     0,     0,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,
       0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,
    1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,
    1178,  1179,  1180,  1181,  1182,  1183,  1184,  1622,     0,  1026,
    1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1075,  1185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1186,     0,     0,     0,  1187,     0,  1188,
    1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1599,     0,
    1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1075,  1185,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,
    1190,  1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,
       0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,  1185,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,
    1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,
    1077,  1078,     0,     0,     0,     0,  1258,  1197,  1624,     0,
    1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,
    1035,  1036,  1037,     0,     0,     0,     0,     0,     0,     0,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,
       0,  1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,
       0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,
    1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,
    1178,  1179,  1180,  1181,  1182,  1183,  1184,  1631,     0,  1026,
    1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1632,  1184,  1634,     0,  1026,  1027,
    1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,     0,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,     0,
       0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,
    1180,  1181,  1182,  1183,  1184,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1075,  1185,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,
    1190,  1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,
       0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,  1185,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,
    1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,
    1077,  1078,     0,     0,     0,     0,  1258,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1075,  1185,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,
       0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,
    1078,     0,     0,     0,     0,  1258,  1197,  1636,     0,  1026,
    1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,  1647,     0,  1026,  1027,
    1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,     0,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,     0,
       0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,
    1180,  1181,  1182,  1183,  1184,  1649,     0,  1026,  1027,  1028,
    1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,     0,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,
       0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,     0,     0,     0,     0,  1067,  1068,     0,     0,     0,
    1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,
    1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1184,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,  1185,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,
    1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,
    1077,  1078,     0,     0,     0,     0,  1258,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1075,  1185,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,
       0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,
    1078,     0,     0,     0,     0,  1258,  1197,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1075,  1185,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1186,
       0,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,
    1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,
       0,     0,     0,     0,  1258,  1197,  1651,     0,  1026,  1027,
    1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,     0,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,
       0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,     0,
       0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,
    1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,
    1180,  1181,  1182,  1183,  1184,  1653,     0,  1026,  1027,  1028,
    1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,     0,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,
       0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,     0,     0,     0,     0,  1067,  1068,     0,     0,     0,
    1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,
    1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1184,  1658,     0,  1026,  1027,  1028,  1029,
    1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,     0,
       0,     0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
       0,     0,     0,     0,  1067,  1068,     0,     0,     0,  1069,
    1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1184,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1075,  1185,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,
       0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,
    1078,     0,     0,     0,     0,  1258,  1197,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1075,  1185,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1186,
       0,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,
    1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,
       0,     0,     0,     0,  1258,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1075,  1185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1186,     0,
       0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,
    1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,
       0,     0,     0,  1258,  1197,  1660,     0,  1026,  1027,  1028,
    1029,  1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,
       0,     0,     0,     0,     0,     0,     0,  1038,  1039,  1040,
    1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,
    1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,
       0,     0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,
    1064,     0,     0,     0,     0,  1067,  1068,     0,     0,     0,
    1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,
    1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,
    1181,  1182,  1183,  1184,  1662,     0,  1026,  1027,  1028,  1029,
    1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,     0,
       0,     0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
       0,     0,     0,     0,  1067,  1068,     0,     0,     0,  1069,
    1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1184,  1664,     0,  1026,  1027,  1028,  1029,  1030,
       0,     0,     0,     0,     0,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
       0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,
       0,     0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,
    1183,  1184,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1075,  1185,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1186,
       0,     0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,
    1192,  1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,
       0,     0,     0,     0,  1258,  1197,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1075,  1185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1186,     0,
       0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,
    1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,
       0,     0,     0,  1258,  1197,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1075,  1185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1186,     0,     0,
       0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,
    1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,
       0,     0,  1258,  1197,  1666,     0,  1026,  1027,  1028,  1029,
    1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,     0,
       0,     0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
       0,     0,     0,     0,  1067,  1068,     0,     0,     0,  1069,
    1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1184,  1668,     0,  1026,  1027,  1028,  1029,  1030,
       0,     0,     0,     0,     0,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
       0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,
       0,     0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,
    1183,  1184,  1670,     0,  1026,  1027,  1028,  1029,  1030,     0,
       0,     0,     0,     0,  1035,  1036,  1037,     0,     0,     0,
       0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,  1043,
    1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,
    1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,     0,
       0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,     0,
       0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,  1071,
    1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,
    1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,
    1184,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1075,  1185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1186,     0,
       0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,
    1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,
       0,     0,     0,  1258,  1197,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1075,  1185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1186,     0,     0,
       0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,
    1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,
       0,     0,  1258,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1075,  1185,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1186,     0,     0,     0,
    1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,
     571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,     0,
       0,  1258,  1197,  1876,     0,  1026,  1027,  1028,  1029,  1030,
       0,     0,     0,     0,     0,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
       0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,
       0,     0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,
    1183,  1184,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,
       0,     0,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,  1055,     0,  1056,     0,     0,     0,     0,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,
    1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,
    1074,  1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,
    1176,  1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1026,
    1027,  1028,  1029,  1030,     0,     0,     0,     0,     0,  1035,
    1036,  1037,     0,     0,     0,     0,     0,     0,     0,  1038,
    1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,
    1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,
    1056,     0,     0,     0,     0,     0,  1058,  1059,  1060,  1061,
    1062,  1063,  1064,     0,     0,     0,     0,  1067,  1068,     0,
       0,     0,  1069,  1070,  1071,  1072,  1073,  1074,  1167,  1168,
    1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,  1177,  1178,
    1179,  1180,  1181,  1182,  1183,  1184,  1026,  1027,  1028,  1029,
    1030,     0,     0,     0,     0,     0,  1035,  1036,  1037,     0,
       0,     0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,
    1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,
    1051,  1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,
       0,     0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,
       0,     0,  1075,  1185,  1067,  1068,     0,     0,     0,  1069,
    1070,  1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,
    1172,  1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1184,     0,     0,     0,     0,  1186,     0,     0,
       0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,
    1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,
       0,     0,  1258,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
    1185,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1186,     0,     0,     0,  1187,     0,
    1188,  1189,  1190,  1191,     0,  1192,  1193,  1194,   571,  1076,
       0,  1195,     0,  1077,  1078,     0,     0,     0,     0,  1196,
    1197,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1075,  1185,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1186,     0,     0,     0,  1187,     0,  1188,  1189,  1190,
    1191,     0,  1192,  1193,  1194,   571,  1076,     0,  1195,     0,
    1077,  1078,     0,     0,     0,     0,  1217,  1197,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1075,  1185,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1186,     0,
       0,     0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,
    1193,  1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,
       0,     0,     0,  1219,  1197,  1026,  1027,  1028,  1029,  1030,
       0,     0,     0,     0,     0,  1035,  1036,  1037,     0,     0,
       0,     0,     0,     0,     0,  1038,  1039,  1040,  1041,  1042,
    1043,  1044,  1045,     0,  1046,  1047,  1048,  1049,  1050,  1051,
    1052,  1053,  1054,     0,  1055,     0,  1056,     0,     0,     0,
       0,     0,  1058,  1059,  1060,  1061,  1062,  1063,  1064,     0,
       0,     0,     0,  1067,  1068,     0,     0,     0,  1069,  1070,
    1071,  1072,  1073,  1074,  1167,  1168,  1169,  1170,  1171,  1172,
    1173,  1174,  1175,  1176,  1177,  1178,  1179,  1180,  1181,  1182,
    1183,  1184,  1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,
       0,  1034,  1035,  1036,  1037,     0,     0,     0,     0,     0,
       0,     0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,
       0,  1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,
       0,  1055,     0,  1056,     0,     0,     0,  1057,     0,  1058,
    1059,  1060,  1061,  1062,  1063,  1064,  1065,     0,     0,  1066,
    1067,  1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,
    1074,  1026,  1027,  1028,  1029,  1030,     0,     0,     0,     0,
       0,  1035,  1036,  1037,     0,     0,     0,     0,     0,     0,
       0,  1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,
    1046,  1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,
    1055,     0,  1056,     0,     0,     0,     0,     0,  1058,  1059,
    1060,  1061,  1062,  1063,  1064,     0,     0,     0,     0,  1067,
    1068,     0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,
    1167,  1168,  1169,  1170,  1171,  1172,  1173,  1174,  1175,  1176,
    1177,  1178,  1179,  1180,  1181,  1182,  1183,  1184,  1399,     0,
    1026,  1027,  1028,  1029,  1030,  1031,  1032,  1033,     0,  1034,
    1035,  1036,  1037,     0,     0,     0,     0,     0,     0,     0,
    1038,  1039,  1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,
       0,  1056,     0,     0,     0,  1057,     0,  1058,  1059,  1060,
    1061,  1062,  1063,  1064,  1065,     0,     0,  1066,  1067,  1068,
       0,     0,     0,  1069,  1070,  1071,  1072,  1073,  1074,     0,
       0,     0,  1075,  1185,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1186,     0,     0,
       0,  1187,     0,  1188,  1189,  1190,  1191,     0,  1192,  1193,
    1194,   571,  1076,     0,  1195,     0,  1077,  1078,     0,     0,
       0,     0,  1258,  1197,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1075,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,  1422,  1423,  1424,  1425,  1426,  1427,  1428,  1429,
    1430,  1431,  1432,  1433,  1434,  1435,  1436,  1437,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1076,
       0,     0,     0,  1077,  1078,     0,     0,  1079,     0,     0,
    1484,     0,     0,     0,     0,     0,     0,     0,  1075,  1185,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1186,     0,     0,     0,  1187,     0,  1188,
    1189,  1190,  1191,     0,  1192,  1193,  1194,  1819,  1076,     0,
    1195,     0,  1077,  1078,     0,     0,     0,     0,  1258,  1197,
       0,     0,     0,     0,     0,     0,     0,     0,  1026,  1027,
    1028,  1029,  1030,  1031,  1032,  1033,     0,  1034,  1035,  1036,
    1037,     0,     0,     0,     0,     0,     0,  1075,  1038,  1039,
    1040,  1041,  1042,  1043,  1044,  1045,     0,  1046,  1047,  1048,
    1049,  1050,  1051,  1052,  1053,  1054,     0,  1055,     0,  1056,
       0,     0,     0,  1057,     0,  1058,  1059,  1060,  1061,  1062,
    1063,  1064,  1065,     0,     0,  1066,  1067,  1068,     0,     0,
       0,  1069,  1070,  1071,  1072,  1073,  1074,  1076,     0,     0,
       0,  1077,  1078,     0,     0,  1079,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1075,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1076,     0,     0,     0,  1077,
    1078,     0,     0,  1079
};

static const yytype_int16 yycheck[] =
{
     252,   219,   464,   255,   251,  1324,   977,  1272,     1,   980,
       1,     1,   983,     1,     1,   986,    64,     1,   977,    64,
       1,   980,     1,   994,   983,     1,     1,   986,     1,     1,
       1,   335,   284,     1,   286,   994,   288,     1,   290,     1,
    1179,     1,  1181,     1,  1183,   980,   335,     1,   983,   977,
       1,   986,   980,    64,   365,   983,    64,    59,   986,   994,
       1,   977,  1201,     1,   980,     1,   994,   983,     1,  1158,
     986,  1160,   383,  1162,     1,  1164,     1,  1166,   994,     1,
       1,     1,     1,     1,   355,   355,     1,   335,     1,   356,
      58,    59,    63,  1207,   335,   365,   113,   114,   369,   351,
       1,   372,   369,     1,     1,   335,     1,     1,     1,     1,
    1081,   363,   364,   365,   366,   367,   368,   369,   370,   371,
     372,     1,  1081,     1,     1,     1,     1,  1098,     1,  1100,
       1,  1102,     1,     1,   355,  1106,  1199,     1,     1,  1098,
    1203,  1100,     1,  1102,    63,     1,     1,  1106,   369,     1,
      63,   613,     1,  1081,    90,    91,    92,    93,     1,     1,
       1,   413,   414,   415,     1,  1081,   355,   355,     1,     1,
    1098,   335,  1100,     1,  1102,     1,   365,   365,  1106,     1,
       1,     1,  1098,   377,  1100,   379,  1102,     1,     1,   377,
    1106,   379,     1,     1,     1,   447,   448,    90,    91,    92,
      93,     1,   377,     1,   379,     1,     1,   355,    63,    15,
      16,     1,     1,   355,   335,    90,    91,    92,    93,     1,
      63,   369,   113,   114,     1,  1196,  1197,   369,     1,   335,
     372,   369,     1,   370,   372,   372,   384,  1196,  1197,     1,
       1,   356,   357,   358,     1,     1,  1217,   499,  1219,     1,
     502,   503,     1,    90,    91,    92,    93,     1,  1217,     1,
    1219,     1,  1197,   335,     1,     1,     1,     1,  1196,  1197,
     369,   370,     1,   372,     1,     1,  1007,  1008,     1,     1,
       1,  1197,     1,     1,     1,     1,     1,  1258,  1259,  1217,
       1,  1219,     1,     1,     1,     1,   335,     1,     1,  1258,
    1259,  1272,     1,   977,     1,     1,   980,     1,     1,   983,
       1,     1,   986,  1272,     1,     1,     1,     1,     1,   335,
     994,   369,  1411,     1,   369,   377,     1,   379,     1,     1,
    1258,  1259,   320,   377,     1,   379,  1307,   335,    90,    91,
      92,    93,     1,  1259,  1272,   365,     1,     1,  1307,     1,
    1321,     1,     1,     1,     1,     1,  1272,     1,   369,   335,
     335,   369,  1321,     1,     1,     1,     1,   369,   370,   386,
    1341,     1,     1,   369,     1,     1,   369,   370,   371,   372,
     373,     0,  1341,   370,   372,   372,  1321,   375,   378,   370,
     383,  1307,   383,  1321,   373,  1714,   369,   381,   369,   370,
     373,   372,   373,  1517,   383,  1321,  1341,  1081,   379,   381,
     383,   383,   383,  1341,   382,   335,    17,   381,   380,   383,
     356,   381,   380,   383,  1098,  1341,  1100,   381,  1102,  1400,
     381,   369,  1106,   369,   370,   371,   372,   373,  1757,   372,
     381,  1400,   383,  1708,   380,   372,   335,   383,  1081,   370,
     369,   370,   372,   372,   373,   380,   369,   370,   380,   372,
     373,   379,   380,   356,   383,  1098,   381,  1100,   383,  1102,
     383,   372,  1400,  1106,   372,   372,   369,   370,   371,   372,
     373,   356,   380,   380,  1400,   380,   380,   380,   380,   369,
     383,     1,   355,  1632,   369,   370,   371,   372,   373,   379,
    1639,     1,   380,   380,   380,   380,   369,   380,   383,   380,
       1,   380,   380,  1484,   369,   370,   380,   372,   373,   356,
     372,   380,  1196,  1197,   380,  1484,   369,   370,   383,   372,
     373,   380,   369,   370,   371,   372,   373,   335,   380,   380,
     383,   369,  1004,  1217,   372,  1219,   383,   380,   380,  1484,
    1521,  1522,  1523,  1524,   380,  1874,  1484,  1528,   380,   380,
     380,     1,  1521,  1522,  1523,  1524,   380,   380,  1484,  1528,
    1889,   380,   380,   380,   372,   370,   372,   372,   355,  1550,
     380,   370,   372,   372,  1258,  1259,  1521,  1522,  1523,  1524,
     372,  1550,   369,  1521,  1522,  1523,  1524,   370,  1272,   372,
    1528,   370,   379,   372,   356,  1521,  1522,  1523,  1524,   370,
     372,   372,  1528,   370,   370,   372,   372,   369,   370,   371,
     372,   373,  1550,   372,     1,   369,  1259,     1,   370,   369,
     372,   383,   372,   370,  1550,   372,   372,   372,   372,  1272,
     369,   370,   371,   372,   373,   372,   372,  1321,  1110,   372,
     372,   372,   370,   372,   383,   372,   372,   372,     1,     1,
       1,   372,   335,   372,   372,   372,   372,  1341,   372,   372,
       1,     1,     1,   372,     1,   372,   372,     1,   372,   372,
       1,   372,   372,     1,     1,   372,   372,   372,   372,   372,
       1,   369,   370,   371,   369,   370,   371,   369,   370,     1,
     355,   355,   369,   355,     1,   355,   355,   355,   355,   355,
     369,   355,     1,  1802,   369,   369,     1,   369,   355,   369,
     369,   369,   369,   369,     1,   369,  1400,   356,   355,   355,
       1,   369,   369,   369,   369,   977,  1707,  1708,   980,   369,
     369,   983,   369,   369,   986,     1,     1,     1,  1707,  1708,
       1,     1,   994,     1,     1,   973,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,  1400,     1,     1,
       1,  1742,  1743,  1744,  1745,     1,     1,     1,     1,  1707,
    1708,     1,     1,  1742,  1743,  1744,  1745,   335,     1,     1,
     335,  1707,  1708,     1,     1,     1,     1,     1,    64,  1261,
       1,     1,     1,  1265,     1,     1,     1,     1,     1,     1,
    1484,     1,     1,     1,  1742,  1743,  1744,  1745,     1,     1,
       1,     1,     1,     1,     1,     1,  1742,  1743,  1744,  1745,
       1,     1,     1,     1,     1,     1,   335,     1,     1,  1081,
       1,     1,     1,     1,     1,  1816,   356,  1521,  1522,  1523,
    1524,     1,   335,   335,  1528,   355,  1098,  1816,  1100,   369,
    1102,     1,     1,     1,  1106,     1,  1328,     1,  1330,   369,
       1,  1333,     1,     1,   335,     1,  1550,     1,   369,     1,
       1,  1816,     1,     1,     1,   335,     1,     1,  1816,     1,
       1,     1,     1,     1,     1,  1528,     1,   335,     1,     1,
    1816,     1,     1,     1,  1875,     1,     1,  1878,  1879,   271,
     377,   273,   379,   335,   335,   355,  1875,  1550,   335,  1878,
    1879,   335,   335,  1894,  1895,  1896,   377,  1898,   379,   369,
       1,     1,  1903,  1904,     1,  1894,  1895,  1896,     1,  1898,
    1875,     1,     1,  1878,  1903,  1904,   377,  1875,   379,   335,
    1878,  1879,   377,     1,   379,  1197,     1,   335,    20,  1875,
    1895,  1896,  1878,  1879,     1,   381,  1894,  1895,  1896,   335,
    1898,  1031,  1032,  1033,   335,  1903,  1904,     1,  1894,  1895,
    1896,   355,  1898,    58,    59,   355,     1,  1903,  1904,     1,
       1,  1243,   369,     1,    21,   369,     1,  1057,   335,   369,
       1,     1,   372,   335,   374,  1065,  1066,     1,    22,   369,
    1257,     1,   355,   355,   355,   335,     1,  1259,  1265,    90,
      91,    92,    93,     1,   355,   355,   369,   369,   369,     1,
    1272,   343,   344,  1707,  1708,     1,   348,   349,   369,   369,
     369,   335,   369,   369,   370,   369,   372,   335,   369,   372,
     369,   369,   369,    90,    91,    92,    93,   335,   369,     1,
    1278,     1,  1280,     1,  1282,     1,   335,   369,  1742,  1743,
    1744,  1745,   369,   335,  1707,  1708,   112,   113,   114,  1321,
     369,   372,   335,  1330,   369,   369,  1333,  1339,  1340,     1,
       1,   377,   369,   379,   369,   335,   335,   335,   369,  1341,
     372,     1,     1,   369,   369,   335,     1,     1,     1,  1742,
    1743,  1744,  1745,   369,   369,   369,     1,   369,   369,   369,
       1,   369,   369,     1,   369,   369,   369,   369,   369,  1189,
    1190,  1191,   369,   369,   369,   369,   369,   369,   369,   113,
     369,   369,  1816,   369,   369,   369,   369,   369,   335,   369,
     369,   369,   370,   369,   372,  1215,   369,   369,  1400,   369,
     335,   369,   369,   369,   369,   369,  1226,   335,   369,   369,
     369,   335,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   252,   253,   254,   255,   369,   369,   369,   369,
     369,   369,   369,   369,   335,   335,   335,   369,   369,   369,
     369,  1875,   369,   369,  1878,  1879,   369,   369,   369,   369,
     369,   369,   369,   369,    90,    91,    92,    93,   369,   369,
    1894,  1895,  1896,   369,  1898,   369,   370,   335,   372,  1903,
    1904,   369,   377,   369,   379,   369,   335,   335,   369,   369,
     369,   369,  1484,   369,  1304,   369,  1879,   369,   369,   335,
     369,   369,   369,  1715,   369,   369,   618,   369,   369,   369,
     369,  1894,   369,   335,   369,  1898,   369,   369,   335,   369,
    1903,  1904,   335,   369,   369,   369,   335,   335,   335,  1521,
    1522,  1523,  1524,   343,   344,   356,  1528,   335,   348,   349,
     350,   351,   352,   353,  1756,   377,  1758,   379,   343,   344,
     345,   335,   335,   348,   349,   335,   335,   382,  1550,   335,
     386,   335,    90,    91,    92,    93,  1376,  1377,  1378,   356,
     335,   377,   335,   379,   335,   335,   335,   335,  1388,  1389,
    1390,   343,   344,   345,   335,   335,   348,   349,   343,   344,
     345,   335,  1402,   348,   349,   335,   335,   335,  1408,  1409,
     335,  1411,   377,   335,   379,  1415,  1416,  1417,  1418,  1419,
    1420,  1421,   335,   335,   335,   343,   344,   335,   335,   335,
     348,   349,   335,  1433,  1434,  1435,  1436,  1437,  1438,  1439,
       3,     4,     5,     6,     7,     8,     9,    10,   335,    12,
      13,    14,    15,   335,  1646,   335,   335,   335,   355,   335,
      23,    24,    25,    26,    27,    28,    29,    30,   365,    32,
      33,    34,    35,    36,    37,    38,    39,    40,   335,    42,
     377,    44,   379,   335,   335,    48,   369,    50,    51,    52,
      53,    54,    55,    56,    57,   335,   335,    60,    61,    62,
     335,   335,   335,    66,    67,    68,    69,    70,    71,   335,
     335,  1511,     1,  1196,   335,   335,   335,   335,   112,   113,
     114,   112,   113,   114,   369,  1707,  1708,   377,   377,   379,
     379,  1160,   335,  1162,  1217,  1164,  1219,  1166,   335,   377,
     356,   379,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   335,   369,   369,   370,   371,   372,   373,   335,   335,
    1742,  1743,  1744,  1745,   380,   335,   377,   383,   379,   335,
     164,   165,   355,   164,   165,  1258,   377,   377,   379,   379,
    1738,   335,   365,  1741,    73,    74,    75,    76,   975,    78,
     370,    80,   979,    82,   377,   982,   379,   335,   985,   335,
     335,   335,  1794,   336,   337,   338,   339,   340,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   369,   370,   371,   372,
     373,   335,   335,   335,  1816,   355,   355,   380,   356,   335,
     383,   335,   335,   335,   335,   365,   365,   335,   381,   335,
     335,   369,   370,   371,   372,   373,   335,   377,   377,   379,
     379,   335,   335,   335,   335,   383,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   335,
     335,   335,   335,  1875,   335,   335,  1878,  1879,   335,   335,
     335,   369,   370,   371,   372,   373,   335,   335,   335,   379,
     335,   335,  1894,  1895,  1896,   383,  1898,   335,  1718,   335,
     335,  1903,  1904,   335,  1724,   335,   335,     0,     1,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    11,   369,
     335,   372,    15,    16,    17,    18,    19,    20,    21,    22,
     299,   300,   301,   302,   303,   335,   305,   320,   354,   355,
     356,   357,   358,   335,   335,   335,    39,   335,    41,   335,
      43,    44,    45,    46,    47,    90,    91,    92,    93,    94,
      95,   335,  1411,   335,   378,   335,    59,   378,   382,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,  1801,   335,   335,   335,   335,   335,   370,   335,   335,
     335,   374,   375,  1813,   335,   378,   335,   335,   381,   335,
     335,  1821,   335,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   335,
     335,   335,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   335,   161,   162,
     163,   335,  1892,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   335,
     335,   335,   335,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   335,   297,   298,   335,   369,   369,   369,
     369,   304,   369,   306,   307,   308,   309,   310,   311,   312,
     313,   314,   315,   316,   317,   318,   319,   369,   369,   335,
     369,   369,   372,   369,   369,   370,   371,   372,   373,   332,
     333,   334,   369,   369,   369,   369,   377,   377,   383,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   381,   381,   381,   369,   381,   370,   369,   383,
     365,   384,   381,   373,   386,   378,   386,   335,   377,   377,
     377,     1,   385,     3,     4,     5,     6,     7,     8,     9,
      10,   335,    12,    13,    14,    15,   335,   335,   335,   335,
     369,   376,   335,    23,    24,    25,    26,    27,    28,    29,
      30,   384,    32,    33,    34,    35,    36,    37,    38,    39,
      40,   369,    42,   377,    44,   384,   379,   372,    48,   372,
      50,    51,    52,    53,    54,    55,    56,    57,   372,   380,
      60,    61,    62,   372,   372,   380,    66,    67,    68,    69,
      70,    71,     1,   384,     3,     4,     5,     6,     7,     8,
       9,    10,   380,    12,    13,    14,    15,   380,   380,   380,
     380,   380,   380,   380,    23,    24,    25,    26,    27,    28,
      29,    30,   380,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   335,    42,   378,    44,   378,   384,   384,    48,
     365,    50,    51,    52,    53,    54,    55,    56,    57,   384,
     384,    60,    61,    62,   381,   365,   386,    66,    67,    68,
      69,    70,    71,     1,   386,     3,     4,     5,     6,     7,
       8,     9,    10,   335,    12,    13,    14,    15,   335,   335,
     335,   335,   379,   379,   377,    23,    24,    25,    26,    27,
      28,    29,    30,   377,    32,    33,    34,    35,    36,    37,
      38,    39,    40,   381,    42,   380,    44,   380,   380,   372,
      48,   379,    50,    51,    52,    53,    54,    55,    56,    57,
     379,   379,    60,    61,    62,   365,   379,   379,    66,    67,
      68,    69,    70,    71,     1,   379,     3,     4,     5,     6,
       7,     8,     9,    10,   379,    12,    13,    14,    15,   379,
     379,   383,   380,   296,   381,   381,    23,    24,    25,    26,
      27,    28,    29,    30,   381,    32,    33,    34,    35,    36,
      37,    38,    39,    40,   381,    42,   296,    44,   369,   372,
     369,    48,   379,    50,    51,    52,    53,    54,    55,    56,
      57,   379,   379,    60,    61,    62,   379,   379,   370,    66,
      67,    68,    69,    70,    71,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   379,   335,
     335,   335,   335,   379,   382,   379,   383,   377,   379,    49,
     320,   379,   377,   379,   386,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   336,   337,   338,   339,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,   358,   379,
     379,   379,   379,   379,   379,   365,   379,   379,   379,   379,
     370,   379,   379,   379,   374,   375,   379,   377,   378,   379,
     380,   381,   379,   379,   379,   379,   386,   379,   379,   379,
     379,   320,   379,   386,   379,   377,   379,   370,   379,   379,
     379,   379,   379,   379,   379,   377,   372,   336,   337,   338,
     339,   340,   341,   342,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   353,   354,   355,   356,   357,   358,
     384,   372,   335,   365,   113,   386,   386,   386,   386,   386,
     379,   370,   379,   379,   379,   374,   375,   369,   377,   378,
     379,   380,   381,   379,   369,   369,   369,   386,   369,   369,
     369,   369,   320,   369,   369,   369,   383,   369,   369,   369,
     369,   365,   379,   357,   372,   372,   369,   372,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   379,   379,   382,   386,   369,   369,   379,   379,   379,
     379,   379,   370,   379,   379,   113,   374,   375,   379,   377,
     378,   379,   379,   381,   379,   379,   379,   379,   386,   379,
     379,   379,   379,   320,   379,   379,   379,   379,   379,   379,
     379,   379,   114,   379,   379,   379,   379,   384,   379,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   386,   386,   386,   379,   386,   386,   384,   384,
     372,   369,   113,   370,   386,   386,     1,   374,   375,   227,
     377,   378,   379,  1110,   381,  1002,    11,   971,  1139,   386,
      15,    16,    17,    18,    19,    20,    21,    22,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    39,   973,    41,  1319,    43,    44,
      45,    46,    47,  1722,  1378,   420,  1813,   421,  1380,  1795,
     614,  1512,    -1,    -1,    59,    -1,  1821,  1380,    -1,    -1,
      -1,    -1,    -1,    -1,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,    -1,    -1,    -1,
      -1,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   379,    -1,    -1,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,    -1,   161,   162,   163,    -1,
      -1,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,    -1,    -1,    -1,
      -1,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,    -1,   297,   298,    -1,    -1,    -1,    -1,    -1,   304,
      -1,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   332,   333,   334,
      -1,    -1,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,   370,     3,     4,     5,     6,
       7,    -1,    -1,   378,    -1,   379,    13,    14,    15,    -1,
     385,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    12,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    48,    -1,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   320,   321,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,   359,    -1,   361,   362,   363,   364,   379,   366,
     367,   368,   369,   370,    -1,   372,   373,   374,   375,    -1,
      -1,    -1,    -1,   380,   381,    -1,   383,    -1,    -1,    -1,
      -1,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,   320,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,   370,    -1,    -1,    -1,   374,   375,    -1,    -1,
     378,    -1,    -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   379,    -1,    -1,
      -1,    -1,    -1,   370,    -1,    -1,    -1,   374,   375,    -1,
      -1,   378,    -1,    -1,    -1,   382,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   341,   342,
     343,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   357,   358,   377,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,   374,   375,
      -1,    -1,   378,    -1,    -1,     1,   382,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    -1,    -1,    -1,     1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
     320,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
     370,    -1,    -1,    -1,   374,   375,    -1,    -1,   378,    -1,
      -1,     1,   382,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,
      -1,    50,    51,    52,    53,    54,    55,    56,    57,    -1,
      -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,   320,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,   370,    -1,    -1,    -1,   374,   375,
      -1,    -1,   378,    -1,    -1,    -1,   382,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   336,
     337,   338,   339,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,    -1,    -1,    -1,    -1,   370,    -1,
      -1,    -1,   374,   375,    -1,    -1,   378,    -1,    -1,     1,
     382,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
     320,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
     370,    -1,    -1,    -1,   374,   375,    -1,    -1,   378,    -1,
      -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   320,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   340,   341,   342,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   353,   354,   355,   356,
     357,   358,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   370,    -1,    -1,    -1,   374,   375,    -1,    -1,   378,
      -1,    -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   370,    -1,    -1,    -1,   374,   375,    -1,    -1,
     378,    -1,    -1,     1,   382,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      48,    -1,    50,    51,    52,    53,    54,    55,    56,    57,
      -1,    -1,    60,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    -1,    -1,    -1,     1,    -1,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,   320,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,   370,    -1,
      -1,    -1,   374,   375,    -1,    -1,   378,    -1,    -1,     1,
     382,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,
      52,    53,    54,    55,    56,    57,    -1,    -1,    60,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,     1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,   320,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,   370,    -1,    -1,    -1,   374,   375,    -1,    -1,
     378,    -1,    -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,
     374,   375,    -1,    -1,   378,    -1,    -1,     1,   382,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,   320,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,   370,    -1,
      -1,    -1,   374,   375,    -1,    -1,   378,    -1,    -1,    -1,
     382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   370,
      -1,    -1,    -1,   374,   375,    -1,    -1,   378,    -1,    -1,
      -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     320,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     370,    -1,    -1,    -1,   374,   375,    -1,    -1,   378,    -1,
      -1,     1,   382,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,
      50,    51,    52,    53,    54,    55,    56,    57,    -1,    -1,
      60,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    -1,    -1,    -1,     1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    12,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,   320,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    48,    -1,    50,    51,    52,    53,    54,    55,
      56,    57,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,   370,    -1,    -1,    -1,
     374,   375,    -1,    -1,   378,    -1,    -1,     1,   382,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    12,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,
      54,    55,    56,    57,    -1,    -1,    60,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
     320,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     370,    -1,    -1,    -1,   374,   375,    -1,    -1,   378,    -1,
      -1,    -1,   382,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,   374,   375,
      -1,    -1,   378,    -1,    -1,    -1,   382,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,
     374,   375,    -1,    -1,   378,    -1,    -1,    -1,   382,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     355,   356,    -1,    -1,   359,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,    -1,   374,
     375,    -1,    -1,    -1,    -1,   380,   381,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    52,    53,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   355,   356,    -1,    -1,   359,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,    -1,
     374,   375,    -1,    -1,    -1,    -1,   380,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,
     359,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,
     379,   380,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     320,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   359,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,   379,
     380,   381,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    52,    53,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,
     359,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,
     379,   380,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     320,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   355,    -1,   357,    -1,   359,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,    -1,
     380,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
     321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,
     381,     1,    -1,     3,     4,     5,     6,     7,    -1,    -1,
      -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    24,    25,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,
      50,    51,    52,    53,    54,    55,    56,    -1,    -1,    -1,
      -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     320,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   359,
      -1,   361,   362,   363,   364,    -1,   366,   367,   368,   369,
     370,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,    -1,
     380,   381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
     321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,
       1,    -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
     321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
      -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,     1,
      -1,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
      -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,    -1,
     374,   375,    -1,    -1,    -1,    -1,   380,   381,     1,    -1,
       3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,
     363,   364,    -1,   366,   367,   368,   369,   370,    -1,   372,
      -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,    -1,
     374,   375,    -1,    -1,    -1,    -1,   380,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,    -1,   374,
     375,    -1,    -1,    -1,    -1,   380,   381,     1,    -1,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,    -1,
     374,   375,    -1,    -1,    -1,    -1,   380,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,    -1,   374,
     375,    -1,    -1,    -1,    -1,   380,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,
      -1,    -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,    -1,   374,   375,
      -1,    -1,    -1,    -1,   380,   381,     1,    -1,     3,     4,
       5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,
      55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,   364,
      -1,   366,   367,   368,   369,   370,    -1,   372,    -1,   374,
     375,    -1,    -1,    -1,    -1,   380,   381,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,
      -1,    -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,    -1,   374,   375,
      -1,    -1,    -1,    -1,   380,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,    -1,   374,   375,    -1,
      -1,    -1,    -1,   380,   381,     1,    -1,     3,     4,     5,
       6,     7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,
      26,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    -1,    42,    -1,    44,    -1,
      -1,    -1,    -1,    -1,    50,    51,    52,    53,    54,    55,
      56,    -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,
      -1,    -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,
     366,   367,   368,   369,   370,    -1,   372,    -1,   374,   375,
      -1,    -1,    -1,    -1,   380,   381,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,    -1,   374,   375,    -1,
      -1,    -1,    -1,   380,   381,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,
      -1,   359,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,
      -1,    -1,   380,   381,     1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     1,    -1,     3,     4,     5,     6,     7,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,    28,
      29,    30,    -1,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,    -1,
      -1,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,    -1,   374,   375,    -1,
      -1,    -1,    -1,   380,   381,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,
      -1,   359,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,
      -1,    -1,   380,   381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,
     359,    -1,   361,   362,   363,   364,    -1,   366,   367,   368,
     369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,    -1,
      -1,   380,   381,     1,    -1,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     3,     4,     5,     6,     7,    -1,    -1,    -1,
      -1,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,
      51,    52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,     3,
       4,     5,     6,     7,    -1,    -1,    -1,    -1,    -1,    13,
      14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      24,    25,    26,    27,    28,    29,    30,    -1,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    -1,    42,    -1,
      44,    -1,    -1,    -1,    -1,    -1,    50,    51,    52,    53,
      54,    55,    56,    -1,    -1,    -1,    -1,    61,    62,    -1,
      -1,    -1,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,
      -1,    -1,    -1,    50,    51,    52,    53,    54,    55,    56,
      -1,    -1,   320,   321,    61,    62,    -1,    -1,    -1,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    -1,    -1,    -1,    -1,   355,    -1,    -1,
      -1,   359,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,
      -1,    -1,   380,   381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
     321,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,
     361,   362,   363,   364,    -1,   366,   367,   368,   369,   370,
      -1,   372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   320,   321,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   355,    -1,    -1,    -1,   359,    -1,   361,   362,   363,
     364,    -1,   366,   367,   368,   369,   370,    -1,   372,    -1,
     374,   375,    -1,    -1,    -1,    -1,   380,   381,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,
      -1,    -1,   359,    -1,   361,   362,   363,   364,    -1,   366,
     367,   368,   369,   370,    -1,   372,    -1,   374,   375,    -1,
      -1,    -1,    -1,   380,   381,     3,     4,     5,     6,     7,
      -1,    -1,    -1,    -1,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    -1,    42,    -1,    44,    -1,    -1,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    55,    56,    -1,
      -1,    -1,    -1,    61,    62,    -1,    -1,    -1,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    23,    24,    25,    26,    27,    28,    29,    30,
      -1,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      -1,    42,    -1,    44,    -1,    -1,    -1,    48,    -1,    50,
      51,    52,    53,    54,    55,    56,    57,    -1,    -1,    60,
      61,    62,    -1,    -1,    -1,    66,    67,    68,    69,    70,
      71,     3,     4,     5,     6,     7,    -1,    -1,    -1,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    24,    25,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    -1,
      42,    -1,    44,    -1,    -1,    -1,    -1,    -1,    50,    51,
      52,    53,    54,    55,    56,    -1,    -1,    -1,    -1,    61,
      62,    -1,    -1,    -1,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,     1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    12,
      13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      23,    24,    25,    26,    27,    28,    29,    30,    -1,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    -1,    42,
      -1,    44,    -1,    -1,    -1,    48,    -1,    50,    51,    52,
      53,    54,    55,    56,    57,    -1,    -1,    60,    61,    62,
      -1,    -1,    -1,    66,    67,    68,    69,    70,    71,    -1,
      -1,    -1,   320,   321,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   355,    -1,    -1,
      -1,   359,    -1,   361,   362,   363,   364,    -1,   366,   367,
     368,   369,   370,    -1,   372,    -1,   374,   375,    -1,    -1,
      -1,    -1,   380,   381,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   370,
      -1,    -1,    -1,   374,   375,    -1,    -1,   378,    -1,    -1,
     381,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   320,   321,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   355,    -1,    -1,    -1,   359,    -1,   361,
     362,   363,   364,    -1,   366,   367,   368,   369,   370,    -1,
     372,    -1,   374,   375,    -1,    -1,    -1,    -1,   380,   381,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    -1,    -1,    -1,    -1,    -1,    -1,   320,    23,    24,
      25,    26,    27,    28,    29,    30,    -1,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    -1,    42,    -1,    44,
      -1,    -1,    -1,    48,    -1,    50,    51,    52,    53,    54,
      55,    56,    57,    -1,    -1,    60,    61,    62,    -1,    -1,
      -1,    66,    67,    68,    69,    70,    71,   370,    -1,    -1,
      -1,   374,   375,    -1,    -1,   378,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   320,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   370,    -1,    -1,    -1,   374,
     375,    -1,    -1,   378
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    11,    18,    19,    39,    41,    43,    44,    45,
      46,    47,    59,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   161,   162,   163,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291,   292,
     293,   294,   295,   297,   298,   304,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     332,   333,   334,   370,   378,   385,   388,   389,   390,   391,
     392,   393,   394,   395,   407,   411,   416,   418,   420,   421,
     431,   432,   441,   335,   335,     1,   383,     1,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,     1,   335,     1,   335,     1,   335,     1,   335,     1,
     335,   335,   335,   335,   335,   417,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,     1,   372,
     380,     1,   372,   380,     1,   335,   372,     1,   380,     1,
     380,     1,   335,   372,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,     1,   335,     1,   335,     1,   335,
       1,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,     1,   335,   335,   335,   335,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   365,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   335,     1,   370,   372,   408,   409,   410,     1,   410,
     412,   413,     1,   372,     1,   372,     1,   372,     0,     1,
     390,    15,    16,   427,   428,    17,   429,   430,    20,   435,
     436,    21,   437,   438,    22,   439,   440,   365,   383,   381,
       1,   369,   369,   370,   372,   426,     1,   369,     1,   369,
       1,   369,     1,    90,    91,    92,    93,   356,   399,     1,
     355,   369,   406,     1,   369,     1,   369,     1,   406,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   370,     1,
     372,     1,   369,     1,   372,     1,   369,     1,   372,     1,
     372,     1,   372,     1,   372,     1,   372,     1,   369,   370,
     371,   372,   373,   380,   383,   396,   398,   399,   404,   405,
     422,   423,   424,   425,   455,   456,     1,   405,     1,   369,
       1,   405,     1,   369,     1,   369,     1,   369,   369,   369,
     369,   406,   406,   406,   406,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   372,   369,   369,   369,   369,
     369,   369,   369,   369,   369,     1,   406,     1,   369,     1,
     372,     1,   369,   335,     1,   369,     1,   369,     1,   369,
       1,   369,     1,   372,     1,   369,     1,   369,     1,   406,
       1,   406,     1,   406,     1,   406,     1,   406,     1,   406,
       1,   406,     1,   406,     1,   406,     1,   406,     1,   369,
       1,   369,     1,   372,     1,   372,     1,   369,   372,   372,
       1,   372,   372,   372,     1,   372,     1,   369,     1,   369,
       1,   369,     1,   369,     1,   369,     1,   369,     1,   369,
       1,   369,     1,   370,   372,     1,   370,   372,     1,   370,
     372,     1,   370,   372,     1,   370,   372,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   369,     1,
     406,     1,   406,     1,   406,     1,   370,   372,     1,   369,
       1,   369,     1,   369,     1,   369,   423,     1,   425,     1,
     369,     1,   369,   369,   369,   369,   369,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   406,     1,
     406,     1,   369,     1,   369,     1,   369,     1,   369,     1,
     252,   253,   254,   255,     1,   369,     1,   369,     1,   369,
       1,   369,     1,   372,     1,   372,     1,   372,     1,   369,
       1,   369,     1,   369,     1,   396,     1,   369,     1,   369,
       1,   369,     1,   369,     1,   369,     1,   369,     1,   369,
       1,   369,     1,   369,     1,   369,     1,   369,     1,   369,
       1,   369,     1,   369,     1,   369,     1,   370,   372,     1,
     369,   370,   369,     1,   369,     1,   369,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   372,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   369,     1,
     369,   299,   300,   301,   302,   303,   305,     1,   406,   369,
     369,     1,   406,     1,   406,     1,   369,     1,   369,     1,
     369,     1,   369,     1,   369,     1,   369,     1,   372,     1,
     372,   377,   386,   377,     1,   383,     1,   381,     1,   383,
     381,     1,   383,   381,     1,   383,   381,     1,   383,    59,
     369,   370,   419,   369,   433,   384,   369,   365,   396,   397,
     424,   386,   386,   405,   112,   113,   114,   355,   365,   381,
     377,   379,   377,   379,   377,   377,   335,   335,   335,   335,
     335,   335,   408,   369,   412,   426,     3,     4,     5,     6,
       7,     8,     9,    10,    12,    13,    14,    15,    23,    24,
      25,    26,    27,    28,    29,    30,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    42,    44,    48,    50,    51,
      52,    53,    54,    55,    56,    57,    60,    61,    62,    66,
      67,    68,    69,    70,    71,   320,   370,   374,   375,   378,
     457,   459,   460,   461,   465,   466,   474,   475,   477,   478,
     481,   482,   484,   488,   489,   490,   494,   426,   459,   426,
     459,   426,   459,   376,   335,   384,   459,     1,   434,   369,
     377,   379,   384,     1,   356,   369,   402,   398,    90,    91,
      92,    93,    94,    95,   396,   401,   372,     1,   369,   455,
       1,   455,   112,   113,   114,   164,   165,   378,   414,   415,
     372,   372,   372,   372,     1,   372,     1,   372,     1,   372,
       1,   372,     1,   372,     1,   372,   384,     1,   380,     1,
     380,     1,   380,     1,   380,     1,   380,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,   321,   355,   359,   361,   362,
     363,   364,   366,   367,   368,   372,   380,   381,   406,   447,
     448,   449,   450,   451,   452,   457,   469,   474,   475,   476,
     477,   479,   481,   482,   485,   486,   487,   380,   487,   380,
     487,     1,   380,     1,   380,     1,   380,   380,     1,   380,
       1,   380,     1,   380,     1,   380,     1,   380,     1,   380,
       1,   380,     1,   380,   380,     1,   380,     1,   380,     1,
     380,     1,   380,   380,   380,   380,   380,   380,   380,   487,
       1,   380,     1,   380,     1,   380,   380,   380,   380,   380,
       1,   487,   487,     1,   380,     1,   380,     1,   380,     1,
     380,     1,   380,     1,   491,     1,   378,     1,   382,   460,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   370,
     471,   472,   473,   335,   483,   378,     1,   380,   378,   384,
     382,   384,   382,   384,   382,   384,     1,   369,   372,   365,
     382,   381,   365,   397,   386,   113,   114,   386,   386,   113,
     335,   335,   335,   335,   335,   382,   414,   379,   379,   377,
     377,   381,     1,    63,   370,   372,   379,   422,   454,     1,
      63,   372,   422,   454,     1,    63,   372,   422,   454,     1,
      63,   372,   422,   454,     1,    63,   372,   422,   454,     1,
     343,   344,   345,   348,   349,   442,   444,   442,   442,     1,
     442,   470,     1,   487,     1,   487,     1,   487,   380,   380,
     380,     1,   379,   475,   477,   481,   482,   487,   488,     1,
     459,     1,   444,     1,   350,   351,   352,   353,   442,   443,
       1,   444,   473,     1,   487,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   445,   446,
     379,   379,     1,   369,   372,     1,   372,     1,   370,   487,
     372,     1,   372,     1,   372,     1,   372,     1,   372,     1,
     369,     1,   369,   379,     1,   379,   406,   379,     1,   372,
       1,   372,     1,   372,     1,   372,   379,   379,   379,     1,
     369,   379,     1,   399,   381,   458,   460,     1,   396,     1,
     369,     1,   396,   399,   403,   379,   379,   379,   379,   381,
     458,     1,   372,     1,   372,   369,   410,   369,   410,   369,
     410,   380,   365,   383,   487,     1,   372,   474,   475,   480,
     482,   381,   381,   381,   381,   296,   296,   419,   459,   369,
     402,   372,   369,   396,   396,   399,     1,   369,     1,   372,
       1,   396,   399,     1,   369,   372,   406,   372,   374,   406,
     459,   379,   377,   379,   377,   379,   377,   379,   355,   365,
     377,   379,   379,   377,   379,   377,   379,   377,   379,   377,
     379,   379,   377,   379,   377,   379,   377,   379,   377,   379,
     379,   377,   379,   377,   379,   377,   379,   377,   379,   379,
     377,   379,   377,   379,   377,   379,   377,   379,     1,   370,
     487,     1,    90,    91,    92,    93,    94,    95,   356,   400,
     487,     1,   400,   487,     1,   447,   451,   370,   467,   468,
       1,   487,     1,   487,     1,   487,   379,   379,   379,   382,
     382,     1,    88,   487,     1,   487,     1,   487,     1,    88,
     369,   370,   422,   453,   454,   487,   383,     1,   487,     1,
     487,     1,   487,     1,   487,   487,   487,   487,     1,   487,
       1,   487,     1,   487,     1,   487,     1,   487,     1,   487,
       1,   487,   379,   377,   379,   379,   377,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   459,    49,   379,
     379,   379,   379,   379,   386,   386,   379,     1,    58,    59,
     382,   463,   464,   379,   377,   379,   379,   379,   379,   379,
     379,   379,   379,   487,   492,   493,   472,   384,   377,   379,
     473,   377,   459,   459,   459,   459,   372,   372,   335,   382,
     365,   113,   113,   114,   386,   386,   386,   386,   386,   379,
     379,   379,   379,   379,   382,    64,   369,   369,   369,     1,
     370,     1,   370,   369,    64,   369,   369,   369,   369,    64,
     369,   369,   369,   369,    64,   369,   369,   369,   369,    64,
     369,   369,   369,   369,   383,   365,   379,   379,   379,   379,
     379,   377,   357,   406,   372,   372,   382,   458,     1,   402,
     396,   382,     1,   357,   462,   487,   386,   382,   463,   369,
     487,   377,   379,   410,     1,   410,   382,   382,   382,   382,
     369,   372,   369,   372,   369,   369,   396,   402,   396,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   372,   406,   467,   487,     1,   369,
     422,   384,   379,   379,   386,   386,     1,   462,   386,   459,
     379,   379,   493,   379,   379,   379,   113,   114,   386,   386,
     384,   384,   377,   402,   459,   386,   386,     1,   459,   372,
     369,   402,   487,   459,   459,   113,   379
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   387,   388,   389,   389,   389,   390,   390,   390,   390,
     390,   391,   390,   392,   390,   390,   393,   390,   394,   390,
     395,   390,   390,   390,   396,   396,   396,   397,   397,   398,
     398,   399,   399,   399,   399,   399,   400,   400,   400,   400,
     400,   400,   400,   401,   401,   401,   401,   401,   401,   402,
     402,   403,   403,   403,   403,   403,   404,   404,   404,   404,
     404,   405,   405,   406,   406,   407,   407,   408,   408,   409,
     409,   410,   410,   411,   411,   412,   412,   413,   414,   414,
     414,   414,   414,   414,   414,   414,   414,   414,   414,   414,
     414,   414,   415,   415,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   417,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   416,   416,   416,   416,   416,   416,   416,
     416,   416,   416,   418,   418,   419,   419,   419,   420,   420,
     420,   420,   420,   420,   420,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   421,   421,
     421,   421,   421,   421,   421,   421,   421,   421,   422,   422,
     423,   424,   425,   425,   426,   426,   426,   427,   427,   428,
     428,   428,   428,   429,   430,   430,   430,   431,   431,   433,
     432,   432,   432,   434,   432,   432,   435,   436,   436,   436,
     437,   438,   438,   438,   439,   440,   440,   441,   441,   441,
     441,   441,   441,   442,   442,   442,   442,   443,   443,   443,
     443,   444,   444,   445,   445,   445,   445,   445,   445,   445,
     446,   446,   446,   446,   447,   447,   447,   448,   448,   448,
     449,   449,   449,   449,   449,   450,   450,   451,   451,   451,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   452,
     452,   452,   452,   452,   452,   452,   452,   452,   452,   453,
     453,   453,   453,   454,   454,   454,   454,   454,   455,   455,
     455,   456,   456,   456,   456,   456,   457,   458,   458,   459,
     459,   459,   460,   460,   460,   460,   460,   460,   460,   460,
     461,   461,   462,   463,   463,   463,   463,   463,   463,   463,
     463,   463,   463,   463,   464,   464,   465,   465,   465,   465,
     466,   467,   467,   467,   468,   468,   470,   469,   471,   471,
     471,   471,   471,   471,   471,   471,   471,   472,   473,   473,
     474,   475,   476,   477,   478,   478,   479,   479,   479,   480,
     480,   480,   481,   482,   483,   484,   484,   484,   485,   485,
     485,   485,   485,   485,   485,   485,   485,   485,   485,   485,
     486,   486,   486,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   487,   487,   487,   487,   487,   487,
     487,   487,   487,   487,   488,   489,   489,   489,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   490,   490,   490,   490,   490,   490,   490,
     490,   490,   490,   491,   490,   490,   492,   492,   492,   493,
     494,   494,   494,   494,   494,   494,   494,   494,   494,   494
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     2,     1,     1,     1,     1,
       1,     0,     2,     0,     2,     1,     0,     2,     0,     2,
       0,     2,     1,     1,     1,     1,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     3,     5,     3,     1,     3,     3,     5,
       3,     1,     2,     1,     2,     2,     2,     1,     3,     1,
       3,     1,     1,     2,     2,     1,     3,     1,     7,     5,
       5,     3,     3,     3,     3,     5,     7,     3,     3,     3,
       3,     1,     2,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     2,     3,     2,     3,     2,
       3,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     0,     6,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     4,     5,     6,     7,     9,     8,
       9,    11,    10,    12,     5,     6,     7,     8,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     5,     5,     5,     5,
       5,     5,     5,     5,     5,     5,     5,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     1,     2,     1,     1,     1,     1,     1,     5,     5,
       7,     7,     5,     8,     8,     2,     4,     6,     2,     2,
       4,     6,     2,     2,     2,     3,     3,     8,     8,     2,
       8,     8,     8,     2,     2,     2,     3,     3,     1,     1,
       7,     1,     1,     3,     1,     1,     1,     1,     1,     4,
       7,     2,     2,     1,     4,     7,     2,     1,     1,     0,
       5,     2,     2,     0,     8,     5,     1,     4,     7,     2,
       1,     4,     7,     2,     1,     7,     2,     2,     2,     2,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     2,     3,     3,     3,     2,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     3,     3,     2,     3,
       3,     1,     3,     1,     3,     3,     3,     3,     1,     1,
       1,     1,     3,     3,     3,     3,     1,     1,     3,     2,
       1,     2,     2,     1,     1,     1,     2,     2,     1,     2,
       3,     5,     1,     4,     5,     3,     4,     3,     2,     4,
       5,     3,     4,     4,     2,     1,     5,     4,     2,     5,
       3,     1,     4,     4,     3,     1,     0,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       1,     2,     5,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     3,     3,
       1,     1,     1,     1,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     4,     4,     2,     8,     2,     2,     2,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       4,     4,     4,     2,     3,     1,     1,     1,     3,     4,
       4,     4,     6,     6,     6,     6,     6,     4,     2,     4,
       4,     4,     4,     6,     6,     6,     6,     6,     4,     2,
       4,     4,     4,     4,     6,     6,     6,     6,     6,     4,
       2,     4,     4,     4,     4,     6,     6,     6,     6,     6,
       4,     2,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     4,     2,     4,     4,     6,     2,     4,     4,     4,
       2,     4,     4,     2,     4,     4,     2,     6,     6,     6,
       4,     2,     6,     2,     4,     4,     4,     2,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     4,     4,
       2,     4,     3,     2,     4,     3,     2,     4,     3,     4,
       2,     4,     4,     2,     4,     4,     2,     4,     4,     2,
       4,     4,     2,     4,     4,     2,     4,     3,     1,     3,
       1,     3,     1,     4,     3,     1,     4,     4,     4,     4,
       4,     2,     4,     4,     2,     4,     4,     2,     3,     1,
       3,     1,     3,     1,     3,     1,     6,     6,     2,     4,
       4,     2,     4,     0,     5,     2,     0,     3,     1,     1,
       3,     2,     1,     3,     2,     1,     1,     3,     2,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3: /* statements: statements statement  */
#line 668 "core/cfg.y"
                             {}
#line 5327 "core/cfg.tab.c"
    break;

  case 4: /* statements: statement  */
#line 669 "core/cfg.y"
                    {}
#line 5333 "core/cfg.tab.c"
    break;

  case 5: /* statements: statements error  */
#line 670 "core/cfg.y"
                           { yyerror(""); YYABORT;}
#line 5339 "core/cfg.tab.c"
    break;

  case 11: /* $@1: %empty  */
#line 678 "core/cfg.y"
          {rt=REQUEST_ROUTE;}
#line 5345 "core/cfg.tab.c"
    break;

  case 13: /* $@2: %empty  */
#line 679 "core/cfg.y"
          {rt=FAILURE_ROUTE;}
#line 5351 "core/cfg.tab.c"
    break;

  case 16: /* $@3: %empty  */
#line 681 "core/cfg.y"
          {rt=BRANCH_ROUTE;}
#line 5357 "core/cfg.tab.c"
    break;

  case 18: /* $@4: %empty  */
#line 682 "core/cfg.y"
          {rt=ONSEND_ROUTE;}
#line 5363 "core/cfg.tab.c"
    break;

  case 20: /* $@5: %empty  */
#line 683 "core/cfg.y"
          {rt=EVENT_ROUTE;}
#line 5369 "core/cfg.tab.c"
    break;

  case 24: /* listen_id: ip  */
#line 688 "core/cfg.y"
           {
		if ((yyvsp[0].ipaddr)){
			tmp=ip_addr2a((yyvsp[0].ipaddr));
			if (tmp==0) {
				LM_CRIT("cfg. parser: bad ip address.\n");
				(yyval.strval)=0;
			} else {
				i_tmp=strlen(tmp)+1;
				(yyval.strval)=pkg_malloc(i_tmp);
				if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
				} else {
					strncpy((yyval.strval), tmp, i_tmp);
				}
			}
		}
	}
#line 5391 "core/cfg.tab.c"
    break;

  case 25: /* listen_id: STRING  */
#line 705 "core/cfg.y"
                 {
		(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
		if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
		} else {
				i_tmp=strlen((yyvsp[0].strval))+1;
				strncpy((yyval.strval), (yyvsp[0].strval), i_tmp);
		}
	}
#line 5405 "core/cfg.tab.c"
    break;

  case 26: /* listen_id: host_or_if  */
#line 714 "core/cfg.y"
                     {
		if ((yyvsp[0].strval)){
			(yyval.strval)=pkg_malloc(strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
					PKG_MEM_CRITICAL;
			} else {
					i_tmp=strlen((yyvsp[0].strval))+1;
					strncpy((yyval.strval), (yyvsp[0].strval), i_tmp);
			}
		}
	}
#line 5421 "core/cfg.tab.c"
    break;

  case 27: /* listen_id_lst: listen_id  */
#line 729 "core/cfg.y"
                        { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), SI_IS_MHOMED); }
#line 5427 "core/cfg.tab.c"
    break;

  case 28: /* listen_id_lst: listen_id COMMA listen_id_lst  */
#line 730 "core/cfg.y"
                                        { (yyval.name_l)=mk_name_lst((yyvsp[-2].strval), SI_IS_MHOMED);
										if ((yyval.name_l)) (yyval.name_l)->next=(yyvsp[0].name_l);
									}
#line 5435 "core/cfg.tab.c"
    break;

  case 29: /* listen_id2: LPAREN listen_id_lst RPAREN  */
#line 736 "core/cfg.y"
                                    { (yyval.name_l)=(yyvsp[-1].name_l); }
#line 5441 "core/cfg.tab.c"
    break;

  case 30: /* listen_id2: listen_id  */
#line 737 "core/cfg.y"
                        { (yyval.name_l)=mk_name_lst((yyvsp[0].strval), 0); }
#line 5447 "core/cfg.tab.c"
    break;

  case 31: /* proto: UDP  */
#line 741 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5453 "core/cfg.tab.c"
    break;

  case 32: /* proto: TCP  */
#line 742 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5459 "core/cfg.tab.c"
    break;

  case 33: /* proto: TLS  */
#line 743 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5465 "core/cfg.tab.c"
    break;

  case 34: /* proto: SCTP  */
#line 744 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5471 "core/cfg.tab.c"
    break;

  case 35: /* proto: STAR  */
#line 745 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5477 "core/cfg.tab.c"
    break;

  case 36: /* eqproto: UDP  */
#line 748 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5483 "core/cfg.tab.c"
    break;

  case 37: /* eqproto: TCP  */
#line 749 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5489 "core/cfg.tab.c"
    break;

  case 38: /* eqproto: TLS  */
#line 750 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5495 "core/cfg.tab.c"
    break;

  case 39: /* eqproto: SCTP  */
#line 751 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5501 "core/cfg.tab.c"
    break;

  case 40: /* eqproto: WS  */
#line 752 "core/cfg.y"
                { (yyval.intval)=PROTO_WS; }
#line 5507 "core/cfg.tab.c"
    break;

  case 41: /* eqproto: WSS  */
#line 753 "core/cfg.y"
                { (yyval.intval)=PROTO_WSS; }
#line 5513 "core/cfg.tab.c"
    break;

  case 42: /* eqproto: STAR  */
#line 754 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5519 "core/cfg.tab.c"
    break;

  case 43: /* xproto: UDP  */
#line 757 "core/cfg.y"
                { (yyval.intval)=PROTO_UDP; }
#line 5525 "core/cfg.tab.c"
    break;

  case 44: /* xproto: TCP  */
#line 758 "core/cfg.y"
                { (yyval.intval)=PROTO_TCP; }
#line 5531 "core/cfg.tab.c"
    break;

  case 45: /* xproto: TLS  */
#line 759 "core/cfg.y"
                { (yyval.intval)=PROTO_TLS; }
#line 5537 "core/cfg.tab.c"
    break;

  case 46: /* xproto: SCTP  */
#line 760 "core/cfg.y"
                { (yyval.intval)=PROTO_SCTP; }
#line 5543 "core/cfg.tab.c"
    break;

  case 47: /* xproto: WS  */
#line 761 "core/cfg.y"
                { (yyval.intval)=PROTO_WS; }
#line 5549 "core/cfg.tab.c"
    break;

  case 48: /* xproto: WSS  */
#line 762 "core/cfg.y"
                { (yyval.intval)=PROTO_WSS; }
#line 5555 "core/cfg.tab.c"
    break;

  case 49: /* port: NUMBER  */
#line 766 "core/cfg.y"
                { (yyval.intval)=(yyvsp[0].intval); }
#line 5561 "core/cfg.tab.c"
    break;

  case 50: /* port: STAR  */
#line 767 "core/cfg.y"
                { (yyval.intval)=0; }
#line 5567 "core/cfg.tab.c"
    break;

  case 51: /* phostport: listen_id  */
#line 770 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), 0, 0); }
#line 5573 "core/cfg.tab.c"
    break;

  case 52: /* phostport: listen_id COLON port  */
#line 771 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), 0, (yyvsp[0].intval)); }
#line 5579 "core/cfg.tab.c"
    break;

  case 53: /* phostport: proto COLON listen_id  */
#line 772 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id((yyvsp[0].strval), (yyvsp[-2].intval), 0); }
#line 5585 "core/cfg.tab.c"
    break;

  case 54: /* phostport: proto COLON listen_id COLON port  */
#line 773 "core/cfg.y"
                                                { (yyval.sockid)=mk_listen_id((yyvsp[-2].strval), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5591 "core/cfg.tab.c"
    break;

  case 55: /* phostport: listen_id COLON error  */
#line 774 "core/cfg.y"
                                { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5597 "core/cfg.tab.c"
    break;

  case 56: /* listen_phostport: listen_id2  */
#line 778 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), 0, 0); }
#line 5603 "core/cfg.tab.c"
    break;

  case 57: /* listen_phostport: listen_id2 COLON port  */
#line 779 "core/cfg.y"
                                { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), 0, (yyvsp[0].intval)); }
#line 5609 "core/cfg.tab.c"
    break;

  case 58: /* listen_phostport: proto COLON listen_id2  */
#line 780 "core/cfg.y"
                                        { (yyval.sockid)=mk_listen_id2((yyvsp[0].name_l), (yyvsp[-2].intval), 0); }
#line 5615 "core/cfg.tab.c"
    break;

  case 59: /* listen_phostport: proto COLON listen_id2 COLON port  */
#line 781 "core/cfg.y"
                                                { (yyval.sockid)=mk_listen_id2((yyvsp[-2].name_l), (yyvsp[-4].intval), (yyvsp[0].intval));}
#line 5621 "core/cfg.tab.c"
    break;

  case 60: /* listen_phostport: listen_id2 COLON error  */
#line 782 "core/cfg.y"
                                 { (yyval.sockid)=0; yyerror("port number expected"); }
#line 5627 "core/cfg.tab.c"
    break;

  case 61: /* id_lst: listen_phostport  */
#line 786 "core/cfg.y"
                                        {  (yyval.sockid)=(yyvsp[0].sockid) ; }
#line 5633 "core/cfg.tab.c"
    break;

  case 62: /* id_lst: listen_phostport id_lst  */
#line 787 "core/cfg.y"
                                        { (yyval.sockid)=(yyvsp[-1].sockid);  if ((yyval.sockid)) (yyval.sockid)->next=(yyvsp[0].sockid); }
#line 5639 "core/cfg.tab.c"
    break;

  case 64: /* intno: MINUS NUMBER  */
#line 791 "core/cfg.y"
                                    { (yyval.intval)=-(yyvsp[0].intval); }
#line 5645 "core/cfg.tab.c"
    break;

  case 66: /* flags_decl: FLAGS_DECL error  */
#line 795 "core/cfg.y"
                                                 { yyerror("flag list expected\n"); }
#line 5651 "core/cfg.tab.c"
    break;

  case 69: /* flag_spec: flag_name  */
#line 801 "core/cfg.y"
                                        { if (register_flag((yyvsp[0].strval),-1)<0)
								yyerror("register flag failed");
						}
#line 5659 "core/cfg.tab.c"
    break;

  case 70: /* flag_spec: flag_name COLON NUMBER  */
#line 804 "core/cfg.y"
                                                       {
						if (register_flag((yyvsp[-2].strval), (yyvsp[0].intval))<0)
								yyerror("register flag failed");
										}
#line 5668 "core/cfg.tab.c"
    break;

  case 71: /* flag_name: STRING  */
#line 810 "core/cfg.y"
                                { (yyval.strval)=(yyvsp[0].strval); }
#line 5674 "core/cfg.tab.c"
    break;

  case 72: /* flag_name: ID  */
#line 811 "core/cfg.y"
                                                { (yyval.strval)=(yyvsp[0].strval); }
#line 5680 "core/cfg.tab.c"
    break;

  case 74: /* avpflags_decl: AVPFLAGS_DECL error  */
#line 816 "core/cfg.y"
                              { yyerror("avpflag list expected\n"); }
#line 5686 "core/cfg.tab.c"
    break;

  case 77: /* avpflag_spec: flag_name  */
#line 823 "core/cfg.y"
                  {
		if (register_avpflag((yyvsp[0].strval))==0)
			yyerror("cannot declare avpflag");
	}
#line 5695 "core/cfg.tab.c"
    break;

  case 78: /* socket_lattr: BIND EQUAL proto COLON listen_id COLON port  */
#line 829 "core/cfg.y"
                                                        {
			tmp_sa.bindproto = (yyvsp[-4].intval);
			tmp_sa.bindaddr.s = (yyvsp[-2].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
			tmp_sa.bindport = (yyvsp[0].intval);
		}
#line 5706 "core/cfg.tab.c"
    break;

  case 79: /* socket_lattr: BIND EQUAL listen_id COLON port  */
#line 835 "core/cfg.y"
                                                {
			tmp_sa.bindaddr.s = (yyvsp[-2].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
			tmp_sa.bindport = (yyvsp[0].intval);
		}
#line 5716 "core/cfg.tab.c"
    break;

  case 80: /* socket_lattr: BIND EQUAL proto COLON listen_id  */
#line 840 "core/cfg.y"
                                                {
			tmp_sa.bindproto = (yyvsp[-2].intval);
			tmp_sa.bindaddr.s = (yyvsp[0].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
		}
#line 5726 "core/cfg.tab.c"
    break;

  case 81: /* socket_lattr: BIND EQUAL listen_id  */
#line 845 "core/cfg.y"
                                {
			tmp_sa.bindaddr.s = (yyvsp[0].strval);
			tmp_sa.bindaddr.len = strlen(tmp_sa.bindaddr.s);
		}
#line 5735 "core/cfg.tab.c"
    break;

  case 82: /* socket_lattr: BIND EQUAL error  */
#line 849 "core/cfg.y"
                           { yyerror("string value expected"); }
#line 5741 "core/cfg.tab.c"
    break;

  case 83: /* socket_lattr: STRNAME EQUAL STRING  */
#line 850 "core/cfg.y"
                               {
			tmp_sa.sockname.s = (yyvsp[0].strval);
			tmp_sa.sockname.len = strlen(tmp_sa.sockname.s);
		}
#line 5750 "core/cfg.tab.c"
    break;

  case 84: /* socket_lattr: STRNAME EQUAL error  */
#line 854 "core/cfg.y"
                              { yyerror("string value expected"); }
#line 5756 "core/cfg.tab.c"
    break;

  case 85: /* socket_lattr: ADVERTISE EQUAL listen_id COLON NUMBER  */
#line 855 "core/cfg.y"
                                                 {
			tmp_sa.useaddr.s = (yyvsp[-2].strval);
			tmp_sa.useaddr.len = strlen(tmp_sa.useaddr.s);
			tmp_sa.useport = (yyvsp[0].intval);
		}
#line 5766 "core/cfg.tab.c"
    break;

  case 86: /* socket_lattr: ADVERTISE EQUAL proto COLON listen_id COLON NUMBER  */
#line 860 "core/cfg.y"
                                                             {
			tmp_sa.useproto = (yyvsp[-4].intval);
			tmp_sa.useaddr.s = (yyvsp[-2].strval);
			tmp_sa.useaddr.len = strlen(tmp_sa.useaddr.s);
			tmp_sa.useport = (yyvsp[0].intval);
		}
#line 5777 "core/cfg.tab.c"
    break;

  case 87: /* socket_lattr: WORKERS EQUAL NUMBER  */
#line 866 "core/cfg.y"
                               { tmp_sa.workers=(yyvsp[0].intval); }
#line 5783 "core/cfg.tab.c"
    break;

  case 88: /* socket_lattr: WORKERS EQUAL error  */
#line 867 "core/cfg.y"
                              { yyerror("number expected"); }
#line 5789 "core/cfg.tab.c"
    break;

  case 89: /* socket_lattr: VIRTUAL EQUAL NUMBER  */
#line 868 "core/cfg.y"
                               { if((yyvsp[0].intval)!=0) { tmp_sa.sflags |= SI_IS_VIRTUAL; } }
#line 5795 "core/cfg.tab.c"
    break;

  case 90: /* socket_lattr: VIRTUAL EQUAL error  */
#line 869 "core/cfg.y"
                              { yyerror("number expected"); }
#line 5801 "core/cfg.tab.c"
    break;

  case 91: /* socket_lattr: SEMICOLON  */
#line 870 "core/cfg.y"
                    {}
#line 5807 "core/cfg.tab.c"
    break;

  case 92: /* socket_lattrs: socket_lattrs socket_lattr  */
#line 873 "core/cfg.y"
                                   {}
#line 5813 "core/cfg.tab.c"
    break;

  case 93: /* socket_lattrs: socket_lattr  */
#line 874 "core/cfg.y"
                       {}
#line 5819 "core/cfg.tab.c"
    break;

  case 94: /* assign_stm: DEBUG_V EQUAL intno  */
#line 877 "core/cfg.y"
                            { default_core_cfg.debug=(yyvsp[0].intval); }
#line 5825 "core/cfg.tab.c"
    break;

  case 95: /* assign_stm: DEBUG_V EQUAL error  */
#line 878 "core/cfg.y"
                               { yyerror("number  expected"); }
#line 5831 "core/cfg.tab.c"
    break;

  case 96: /* assign_stm: FORK EQUAL NUMBER  */
#line 879 "core/cfg.y"
                             { dont_fork= ! (yyvsp[0].intval); }
#line 5837 "core/cfg.tab.c"
    break;

  case 97: /* assign_stm: FORK EQUAL error  */
#line 880 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 5843 "core/cfg.tab.c"
    break;

  case 98: /* assign_stm: FORK_DELAY EQUAL NUMBER  */
#line 881 "core/cfg.y"
                                   { set_fork_delay((yyvsp[0].intval)); }
#line 5849 "core/cfg.tab.c"
    break;

  case 99: /* assign_stm: FORK_DELAY EQUAL error  */
#line 882 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 5855 "core/cfg.tab.c"
    break;

  case 100: /* assign_stm: MODINIT_DELAY EQUAL NUMBER  */
#line 883 "core/cfg.y"
                                      { set_modinit_delay((yyvsp[0].intval)); }
#line 5861 "core/cfg.tab.c"
    break;

  case 101: /* assign_stm: MODINIT_DELAY EQUAL error  */
#line 884 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 5867 "core/cfg.tab.c"
    break;

  case 102: /* assign_stm: LOGSTDERROR EQUAL NUMBER  */
#line 885 "core/cfg.y"
                                   { if (!config_check)  /* if set from cmd line, don't overwrite from yyparse()*/
					if(log_stderr == 0) log_stderr=(yyvsp[0].intval);
				   }
#line 5875 "core/cfg.tab.c"
    break;

  case 103: /* assign_stm: LOGSTDERROR EQUAL error  */
#line 888 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 5881 "core/cfg.tab.c"
    break;

  case 104: /* assign_stm: LOGFACILITY EQUAL ID  */
#line 889 "core/cfg.y"
                               {
		if ( (i_tmp=str2facility((yyvsp[0].strval)))==-1)
			yyerror("bad facility (see syslog(3) man page)");
		if (!config_check)
			default_core_cfg.log_facility=i_tmp;
	}
#line 5892 "core/cfg.tab.c"
    break;

  case 105: /* assign_stm: LOGFACILITY EQUAL error  */
#line 895 "core/cfg.y"
                                  { yyerror("ID expected"); }
#line 5898 "core/cfg.tab.c"
    break;

  case 106: /* assign_stm: LOGNAME EQUAL STRING  */
#line 896 "core/cfg.y"
                               { log_name=(yyvsp[0].strval); }
#line 5904 "core/cfg.tab.c"
    break;

  case 107: /* assign_stm: LOGNAME EQUAL error  */
#line 897 "core/cfg.y"
                              { yyerror("string value expected"); }
#line 5910 "core/cfg.tab.c"
    break;

  case 108: /* assign_stm: LOGCOLOR EQUAL NUMBER  */
#line 898 "core/cfg.y"
                                { log_color=(yyvsp[0].intval); }
#line 5916 "core/cfg.tab.c"
    break;

  case 109: /* assign_stm: LOGCOLOR EQUAL error  */
#line 899 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 5922 "core/cfg.tab.c"
    break;

  case 110: /* assign_stm: LOGPREFIX EQUAL STRING  */
#line 900 "core/cfg.y"
                                 { log_prefix_fmt=(yyvsp[0].strval); }
#line 5928 "core/cfg.tab.c"
    break;

  case 111: /* assign_stm: LOGPREFIX EQUAL error  */
#line 901 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 5934 "core/cfg.tab.c"
    break;

  case 112: /* assign_stm: LOGPREFIXMODE EQUAL NUMBER  */
#line 902 "core/cfg.y"
                                     { log_prefix_mode=(yyvsp[0].intval); }
#line 5940 "core/cfg.tab.c"
    break;

  case 113: /* assign_stm: LOGPREFIXMODE EQUAL error  */
#line 903 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 5946 "core/cfg.tab.c"
    break;

  case 114: /* assign_stm: LOGENGINETYPE EQUAL STRING  */
#line 904 "core/cfg.y"
                                     { _km_log_engine_type=(yyvsp[0].strval); }
#line 5952 "core/cfg.tab.c"
    break;

  case 115: /* assign_stm: LOGENGINETYPE EQUAL error  */
#line 905 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5958 "core/cfg.tab.c"
    break;

  case 116: /* assign_stm: LOGENGINEDATA EQUAL STRING  */
#line 906 "core/cfg.y"
                                     { _km_log_engine_data=(yyvsp[0].strval); }
#line 5964 "core/cfg.tab.c"
    break;

  case 117: /* assign_stm: LOGENGINEDATA EQUAL error  */
#line 907 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5970 "core/cfg.tab.c"
    break;

  case 118: /* assign_stm: XAVPVIAPARAMS EQUAL STRING  */
#line 908 "core/cfg.y"
                                     { _ksr_xavp_via_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_params.len=strlen((yyvsp[0].strval));
		}
#line 5978 "core/cfg.tab.c"
    break;

  case 119: /* assign_stm: XAVPVIAPARAMS EQUAL error  */
#line 911 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5984 "core/cfg.tab.c"
    break;

  case 120: /* assign_stm: XAVPVIAFIELDS EQUAL STRING  */
#line 912 "core/cfg.y"
                                     { _ksr_xavp_via_fields.s=(yyvsp[0].strval);
			_ksr_xavp_via_fields.len=strlen((yyvsp[0].strval));
		}
#line 5992 "core/cfg.tab.c"
    break;

  case 121: /* assign_stm: XAVPVIAFIELDS EQUAL error  */
#line 915 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 5998 "core/cfg.tab.c"
    break;

  case 122: /* assign_stm: XAVPVIAREPLYPARAMS EQUAL STRING  */
#line 916 "core/cfg.y"
                                          { _ksr_xavp_via_reply_params.s=(yyvsp[0].strval);
			_ksr_xavp_via_reply_params.len=strlen((yyvsp[0].strval));
		}
#line 6006 "core/cfg.tab.c"
    break;

  case 123: /* assign_stm: XAVPVIAREPLYPARAMS EQUAL error  */
#line 919 "core/cfg.y"
                                         { yyerror("string value expected"); }
#line 6012 "core/cfg.tab.c"
    break;

  case 124: /* assign_stm: DNS EQUAL NUMBER  */
#line 920 "core/cfg.y"
                             { received_dns|= ((yyvsp[0].intval))?DO_DNS:0; }
#line 6018 "core/cfg.tab.c"
    break;

  case 125: /* assign_stm: DNS EQUAL error  */
#line 921 "core/cfg.y"
                          { yyerror("boolean value expected"); }
#line 6024 "core/cfg.tab.c"
    break;

  case 126: /* assign_stm: REV_DNS EQUAL NUMBER  */
#line 922 "core/cfg.y"
                               { received_dns|= ((yyvsp[0].intval))?DO_REV_DNS:0; }
#line 6030 "core/cfg.tab.c"
    break;

  case 127: /* assign_stm: REV_DNS EQUAL error  */
#line 923 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6036 "core/cfg.tab.c"
    break;

  case 128: /* assign_stm: DNS_TRY_IPV6 EQUAL NUMBER  */
#line 924 "core/cfg.y"
                                      { default_core_cfg.dns_try_ipv6=(yyvsp[0].intval); }
#line 6042 "core/cfg.tab.c"
    break;

  case 129: /* assign_stm: DNS_TRY_IPV6 error  */
#line 925 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6048 "core/cfg.tab.c"
    break;

  case 130: /* assign_stm: DNS_TRY_NAPTR EQUAL NUMBER  */
#line 926 "core/cfg.y"
                                       { IF_NAPTR(default_core_cfg.dns_try_naptr=(yyvsp[0].intval)); }
#line 6054 "core/cfg.tab.c"
    break;

  case 131: /* assign_stm: DNS_TRY_NAPTR error  */
#line 927 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6060 "core/cfg.tab.c"
    break;

  case 132: /* assign_stm: DNS_SRV_LB EQUAL NUMBER  */
#line 928 "core/cfg.y"
                                    { IF_DNS_FAILOVER(default_core_cfg.dns_srv_lb=(yyvsp[0].intval)); }
#line 6066 "core/cfg.tab.c"
    break;

  case 133: /* assign_stm: DNS_SRV_LB error  */
#line 929 "core/cfg.y"
                           { yyerror("boolean value expected"); }
#line 6072 "core/cfg.tab.c"
    break;

  case 134: /* assign_stm: DNS_UDP_PREF EQUAL intno  */
#line 930 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_udp_pref=(yyvsp[0].intval));}
#line 6078 "core/cfg.tab.c"
    break;

  case 135: /* assign_stm: DNS_UDP_PREF error  */
#line 931 "core/cfg.y"
                             { yyerror("number expected"); }
#line 6084 "core/cfg.tab.c"
    break;

  case 136: /* assign_stm: DNS_TCP_PREF EQUAL intno  */
#line 932 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_tcp_pref=(yyvsp[0].intval));}
#line 6090 "core/cfg.tab.c"
    break;

  case 137: /* assign_stm: DNS_TCP_PREF error  */
#line 933 "core/cfg.y"
                             { yyerror("number expected"); }
#line 6096 "core/cfg.tab.c"
    break;

  case 138: /* assign_stm: DNS_TLS_PREF EQUAL intno  */
#line 934 "core/cfg.y"
                                   { IF_NAPTR(default_core_cfg.dns_tls_pref=(yyvsp[0].intval));}
#line 6102 "core/cfg.tab.c"
    break;

  case 139: /* assign_stm: DNS_TLS_PREF error  */
#line 935 "core/cfg.y"
                             { yyerror("number expected"); }
#line 6108 "core/cfg.tab.c"
    break;

  case 140: /* assign_stm: DNS_SCTP_PREF EQUAL intno  */
#line 936 "core/cfg.y"
                                    {
								IF_NAPTR(default_core_cfg.dns_sctp_pref=(yyvsp[0].intval)); }
#line 6115 "core/cfg.tab.c"
    break;

  case 141: /* assign_stm: DNS_SCTP_PREF error  */
#line 938 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6121 "core/cfg.tab.c"
    break;

  case 142: /* assign_stm: DNS_RETR_TIME EQUAL NUMBER  */
#line 939 "core/cfg.y"
                                       { default_core_cfg.dns_retr_time=(yyvsp[0].intval); }
#line 6127 "core/cfg.tab.c"
    break;

  case 143: /* assign_stm: DNS_RETR_TIME error  */
#line 940 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6133 "core/cfg.tab.c"
    break;

  case 144: /* assign_stm: DNS_SLOW_QUERY_MS EQUAL NUMBER  */
#line 941 "core/cfg.y"
                                           { default_core_cfg.dns_slow_query_ms=(yyvsp[0].intval); }
#line 6139 "core/cfg.tab.c"
    break;

  case 145: /* assign_stm: DNS_SLOW_QUERY_MS error  */
#line 942 "core/cfg.y"
                                  { yyerror("number expected"); }
#line 6145 "core/cfg.tab.c"
    break;

  case 146: /* assign_stm: DNS_RETR_NO EQUAL NUMBER  */
#line 943 "core/cfg.y"
                                     { default_core_cfg.dns_retr_no=(yyvsp[0].intval); }
#line 6151 "core/cfg.tab.c"
    break;

  case 147: /* assign_stm: DNS_RETR_NO error  */
#line 944 "core/cfg.y"
                            { yyerror("number expected"); }
#line 6157 "core/cfg.tab.c"
    break;

  case 148: /* assign_stm: DNS_SERVERS_NO EQUAL NUMBER  */
#line 945 "core/cfg.y"
                                        { default_core_cfg.dns_servers_no=(yyvsp[0].intval); }
#line 6163 "core/cfg.tab.c"
    break;

  case 149: /* assign_stm: DNS_SERVERS_NO error  */
#line 946 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6169 "core/cfg.tab.c"
    break;

  case 150: /* assign_stm: DNS_USE_SEARCH EQUAL NUMBER  */
#line 947 "core/cfg.y"
                                        { default_core_cfg.dns_search_list=(yyvsp[0].intval); }
#line 6175 "core/cfg.tab.c"
    break;

  case 151: /* assign_stm: DNS_USE_SEARCH error  */
#line 948 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6181 "core/cfg.tab.c"
    break;

  case 152: /* assign_stm: DNS_SEARCH_FMATCH EQUAL NUMBER  */
#line 949 "core/cfg.y"
                                           { default_core_cfg.dns_search_fmatch=(yyvsp[0].intval); }
#line 6187 "core/cfg.tab.c"
    break;

  case 153: /* assign_stm: DNS_SEARCH_FMATCH error  */
#line 950 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6193 "core/cfg.tab.c"
    break;

  case 154: /* assign_stm: DNS_NAPTR_IGNORE_RFC EQUAL NUMBER  */
#line 951 "core/cfg.y"
                                              { default_core_cfg.dns_naptr_ignore_rfc=(yyvsp[0].intval); }
#line 6199 "core/cfg.tab.c"
    break;

  case 155: /* assign_stm: DNS_NAPTR_IGNORE_RFC error  */
#line 952 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6205 "core/cfg.tab.c"
    break;

  case 156: /* assign_stm: DNS_CACHE_INIT EQUAL NUMBER  */
#line 953 "core/cfg.y"
                                        { IF_DNS_CACHE(dns_cache_init=(yyvsp[0].intval)); }
#line 6211 "core/cfg.tab.c"
    break;

  case 157: /* assign_stm: DNS_CACHE_INIT error  */
#line 954 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6217 "core/cfg.tab.c"
    break;

  case 158: /* assign_stm: DNS_USE_CACHE EQUAL NUMBER  */
#line 955 "core/cfg.y"
                                       { IF_DNS_CACHE(default_core_cfg.use_dns_cache=(yyvsp[0].intval)); }
#line 6223 "core/cfg.tab.c"
    break;

  case 159: /* assign_stm: DNS_USE_CACHE error  */
#line 956 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6229 "core/cfg.tab.c"
    break;

  case 160: /* assign_stm: DNS_USE_FAILOVER EQUAL NUMBER  */
#line 957 "core/cfg.y"
                                          { IF_DNS_FAILOVER(default_core_cfg.use_dns_failover=(yyvsp[0].intval));}
#line 6235 "core/cfg.tab.c"
    break;

  case 161: /* assign_stm: DNS_USE_FAILOVER error  */
#line 958 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 6241 "core/cfg.tab.c"
    break;

  case 162: /* assign_stm: DNS_CACHE_FLAGS EQUAL NUMBER  */
#line 959 "core/cfg.y"
                                         { IF_DNS_CACHE(default_core_cfg.dns_cache_flags=(yyvsp[0].intval)); }
#line 6247 "core/cfg.tab.c"
    break;

  case 163: /* assign_stm: DNS_CACHE_FLAGS error  */
#line 960 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6253 "core/cfg.tab.c"
    break;

  case 164: /* assign_stm: DNS_CACHE_NEG_TTL EQUAL NUMBER  */
#line 961 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_neg_cache_ttl=(yyvsp[0].intval)); }
#line 6259 "core/cfg.tab.c"
    break;

  case 165: /* assign_stm: DNS_CACHE_NEG_TTL error  */
#line 962 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6265 "core/cfg.tab.c"
    break;

  case 166: /* assign_stm: DNS_CACHE_MAX_TTL EQUAL NUMBER  */
#line 963 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_cache_max_ttl=(yyvsp[0].intval)); }
#line 6271 "core/cfg.tab.c"
    break;

  case 167: /* assign_stm: DNS_CACHE_MAX_TTL error  */
#line 964 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6277 "core/cfg.tab.c"
    break;

  case 168: /* assign_stm: DNS_CACHE_MIN_TTL EQUAL NUMBER  */
#line 965 "core/cfg.y"
                                           { IF_DNS_CACHE(default_core_cfg.dns_cache_min_ttl=(yyvsp[0].intval)); }
#line 6283 "core/cfg.tab.c"
    break;

  case 169: /* assign_stm: DNS_CACHE_MIN_TTL error  */
#line 966 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6289 "core/cfg.tab.c"
    break;

  case 170: /* assign_stm: DNS_CACHE_MEM EQUAL NUMBER  */
#line 967 "core/cfg.y"
                                       { IF_DNS_CACHE(default_core_cfg.dns_cache_max_mem=(yyvsp[0].intval)); }
#line 6295 "core/cfg.tab.c"
    break;

  case 171: /* assign_stm: DNS_CACHE_MEM error  */
#line 968 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6301 "core/cfg.tab.c"
    break;

  case 172: /* assign_stm: DNS_CACHE_GC_INT EQUAL NUMBER  */
#line 969 "core/cfg.y"
                                          { IF_DNS_CACHE(dns_timer_interval=(yyvsp[0].intval)); }
#line 6307 "core/cfg.tab.c"
    break;

  case 173: /* assign_stm: DNS_CACHE_GC_INT error  */
#line 970 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 6313 "core/cfg.tab.c"
    break;

  case 174: /* assign_stm: DNS_CACHE_DEL_NONEXP EQUAL NUMBER  */
#line 971 "core/cfg.y"
                                              { IF_DNS_CACHE(default_core_cfg.dns_cache_del_nonexp=(yyvsp[0].intval)); }
#line 6319 "core/cfg.tab.c"
    break;

  case 175: /* assign_stm: DNS_CACHE_DEL_NONEXP error  */
#line 972 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6325 "core/cfg.tab.c"
    break;

  case 176: /* assign_stm: DNS_CACHE_REC_PREF EQUAL NUMBER  */
#line 973 "core/cfg.y"
                                            { IF_DNS_CACHE(default_core_cfg.dns_cache_rec_pref=(yyvsp[0].intval)); }
#line 6331 "core/cfg.tab.c"
    break;

  case 177: /* assign_stm: DNS_CACHE_REC_PREF error  */
#line 974 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 6337 "core/cfg.tab.c"
    break;

  case 178: /* assign_stm: AUTO_BIND_IPV6 EQUAL NUMBER  */
#line 975 "core/cfg.y"
                                      {IF_AUTO_BIND_IPV6(auto_bind_ipv6 = (yyvsp[0].intval));}
#line 6343 "core/cfg.tab.c"
    break;

  case 179: /* assign_stm: AUTO_BIND_IPV6 error  */
#line 976 "core/cfg.y"
                               { yyerror("boolean value expected"); }
#line 6349 "core/cfg.tab.c"
    break;

  case 180: /* assign_stm: IPV6_HEX_STYLE EQUAL STRING  */
#line 977 "core/cfg.y"
                                      {
		ksr_ipv6_hex_style.s = (yyvsp[0].strval);
		if(ksr_ipv6_hex_style.s[0]!='a' && ksr_ipv6_hex_style.s[0]!='A'
				&& ksr_ipv6_hex_style.s[0]!='c') {
			yyerror("expected \"a\", \"A\" or \"c\" value");
		}
		ksr_ipv6_hex_style.len = strlen(ksr_ipv6_hex_style.s);
	}
#line 6362 "core/cfg.tab.c"
    break;

  case 181: /* assign_stm: IPV6_HEX_STYLE error  */
#line 985 "core/cfg.y"
                               { yyerror("string value expected"); }
#line 6368 "core/cfg.tab.c"
    break;

  case 182: /* assign_stm: BIND_IPV6_LINK_LOCAL EQUAL NUMBER  */
#line 986 "core/cfg.y"
                                            {sr_bind_ipv6_link_local = (yyvsp[0].intval);}
#line 6374 "core/cfg.tab.c"
    break;

  case 183: /* assign_stm: BIND_IPV6_LINK_LOCAL error  */
#line 987 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 6380 "core/cfg.tab.c"
    break;

  case 184: /* assign_stm: DST_BLST_INIT EQUAL NUMBER  */
#line 988 "core/cfg.y"
                                       { IF_DST_BLOCKLIST(dst_blocklist_init=(yyvsp[0].intval)); }
#line 6386 "core/cfg.tab.c"
    break;

  case 185: /* assign_stm: DST_BLST_INIT error  */
#line 989 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 6392 "core/cfg.tab.c"
    break;

  case 186: /* assign_stm: USE_DST_BLST EQUAL NUMBER  */
#line 990 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.use_dst_blocklist=(yyvsp[0].intval));
	}
#line 6400 "core/cfg.tab.c"
    break;

  case 187: /* assign_stm: USE_DST_BLST error  */
#line 993 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6406 "core/cfg.tab.c"
    break;

  case 188: /* assign_stm: DST_BLST_MEM EQUAL NUMBER  */
#line 994 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_max_mem=(yyvsp[0].intval));
	}
#line 6414 "core/cfg.tab.c"
    break;

  case 189: /* assign_stm: DST_BLST_MEM error  */
#line 997 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6420 "core/cfg.tab.c"
    break;

  case 190: /* assign_stm: DST_BLST_TTL EQUAL NUMBER  */
#line 998 "core/cfg.y"
                                    {
		IF_DST_BLOCKLIST(default_core_cfg.blst_timeout=(yyvsp[0].intval));
	}
#line 6428 "core/cfg.tab.c"
    break;

  case 191: /* assign_stm: DST_BLST_TTL error  */
#line 1001 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 6434 "core/cfg.tab.c"
    break;

  case 192: /* assign_stm: DST_BLST_GC_INT EQUAL NUMBER  */
#line 1002 "core/cfg.y"
                                       { IF_DST_BLOCKLIST(blst_timer_interval=(yyvsp[0].intval));}
#line 6440 "core/cfg.tab.c"
    break;

  case 193: /* assign_stm: DST_BLST_GC_INT error  */
#line 1003 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6446 "core/cfg.tab.c"
    break;

  case 194: /* assign_stm: DST_BLST_UDP_IMASK EQUAL NUMBER  */
#line 1004 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_udp_imask=(yyvsp[0].intval));
	}
#line 6454 "core/cfg.tab.c"
    break;

  case 195: /* assign_stm: DST_BLST_UDP_IMASK error  */
#line 1007 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6460 "core/cfg.tab.c"
    break;

  case 196: /* assign_stm: DST_BLST_TCP_IMASK EQUAL NUMBER  */
#line 1008 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tcp_imask=(yyvsp[0].intval));
	}
#line 6468 "core/cfg.tab.c"
    break;

  case 197: /* assign_stm: DST_BLST_TCP_IMASK error  */
#line 1011 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6474 "core/cfg.tab.c"
    break;

  case 198: /* assign_stm: DST_BLST_TLS_IMASK EQUAL NUMBER  */
#line 1012 "core/cfg.y"
                                          {
		IF_DST_BLOCKLIST(default_core_cfg.blst_tls_imask=(yyvsp[0].intval));
	}
#line 6482 "core/cfg.tab.c"
    break;

  case 199: /* assign_stm: DST_BLST_TLS_IMASK error  */
#line 1015 "core/cfg.y"
                                   { yyerror("number(flags) expected"); }
#line 6488 "core/cfg.tab.c"
    break;

  case 200: /* assign_stm: DST_BLST_SCTP_IMASK EQUAL NUMBER  */
#line 1016 "core/cfg.y"
                                           {
		IF_DST_BLOCKLIST(default_core_cfg.blst_sctp_imask=(yyvsp[0].intval));
	}
#line 6496 "core/cfg.tab.c"
    break;

  case 201: /* assign_stm: DST_BLST_SCTP_IMASK error  */
#line 1019 "core/cfg.y"
                                    { yyerror("number(flags) expected"); }
#line 6502 "core/cfg.tab.c"
    break;

  case 202: /* assign_stm: IP_FREE_BIND EQUAL intno  */
#line 1020 "core/cfg.y"
                                   { _sr_ip_free_bind=(yyvsp[0].intval); }
#line 6508 "core/cfg.tab.c"
    break;

  case 203: /* assign_stm: IP_FREE_BIND EQUAL error  */
#line 1021 "core/cfg.y"
                                   { yyerror("int value expected"); }
#line 6514 "core/cfg.tab.c"
    break;

  case 204: /* assign_stm: PORT EQUAL NUMBER  */
#line 1022 "core/cfg.y"
                              { port_no=(yyvsp[0].intval); }
#line 6520 "core/cfg.tab.c"
    break;

  case 205: /* assign_stm: PORT EQUAL error  */
#line 1023 "core/cfg.y"
                              { yyerror("number expected"); }
#line 6526 "core/cfg.tab.c"
    break;

  case 206: /* assign_stm: MAXBUFFER EQUAL NUMBER  */
#line 1024 "core/cfg.y"
                                 { maxbuffer=(yyvsp[0].intval); }
#line 6532 "core/cfg.tab.c"
    break;

  case 207: /* assign_stm: MAXBUFFER EQUAL error  */
#line 1025 "core/cfg.y"
                                { yyerror("number expected"); }
#line 6538 "core/cfg.tab.c"
    break;

  case 208: /* assign_stm: MAXSNDBUFFER EQUAL NUMBER  */
#line 1026 "core/cfg.y"
                                    { maxsndbuffer=(yyvsp[0].intval); }
#line 6544 "core/cfg.tab.c"
    break;

  case 209: /* assign_stm: MAXSNDBUFFER EQUAL error  */
#line 1027 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 6550 "core/cfg.tab.c"
    break;

  case 210: /* assign_stm: SQL_BUFFER_SIZE EQUAL NUMBER  */
#line 1028 "core/cfg.y"
                                       { sql_buffer_size=(yyvsp[0].intval); }
#line 6556 "core/cfg.tab.c"
    break;

  case 211: /* assign_stm: SQL_BUFFER_SIZE EQUAL error  */
#line 1029 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 6562 "core/cfg.tab.c"
    break;

  case 212: /* assign_stm: MSG_RECV_MAX_SIZE EQUAL NUMBER  */
#line 1030 "core/cfg.y"
                                         { ksr_msg_recv_max_size=(yyvsp[0].intval); }
#line 6568 "core/cfg.tab.c"
    break;

  case 213: /* assign_stm: MSG_RECV_MAX_SIZE EQUAL error  */
#line 1031 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 6574 "core/cfg.tab.c"
    break;

  case 214: /* assign_stm: TCP_MSG_READ_TIMEOUT EQUAL NUMBER  */
#line 1032 "core/cfg.y"
                                            { ksr_tcp_msg_read_timeout=(yyvsp[0].intval); }
#line 6580 "core/cfg.tab.c"
    break;

  case 215: /* assign_stm: TCP_MSG_READ_TIMEOUT EQUAL error  */
#line 1033 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 6586 "core/cfg.tab.c"
    break;

  case 216: /* assign_stm: TCP_MSG_DATA_TIMEOUT EQUAL NUMBER  */
#line 1034 "core/cfg.y"
                                            { ksr_tcp_msg_data_timeout=(yyvsp[0].intval); }
#line 6592 "core/cfg.tab.c"
    break;

  case 217: /* assign_stm: TCP_MSG_DATA_TIMEOUT EQUAL error  */
#line 1035 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 6598 "core/cfg.tab.c"
    break;

  case 218: /* assign_stm: TCP_ACCEPT_IPLIMIT EQUAL NUMBER  */
#line 1036 "core/cfg.y"
                                          { ksr_tcp_accept_iplimit=(yyvsp[0].intval); }
#line 6604 "core/cfg.tab.c"
    break;

  case 219: /* assign_stm: TCP_ACCEPT_IPLIMIT EQUAL error  */
#line 1037 "core/cfg.y"
                                         { yyerror("number expected"); }
#line 6610 "core/cfg.tab.c"
    break;

  case 220: /* assign_stm: TCP_CHECK_TIMER EQUAL NUMBER  */
#line 1038 "core/cfg.y"
                                       { ksr_tcp_check_timer=(yyvsp[0].intval); }
#line 6616 "core/cfg.tab.c"
    break;

  case 221: /* assign_stm: TCP_CHECK_TIMER EQUAL error  */
#line 1039 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 6622 "core/cfg.tab.c"
    break;

  case 222: /* assign_stm: CHILDREN EQUAL NUMBER  */
#line 1040 "core/cfg.y"
                                { children_no=(yyvsp[0].intval); }
#line 6628 "core/cfg.tab.c"
    break;

  case 223: /* assign_stm: CHILDREN EQUAL error  */
#line 1041 "core/cfg.y"
                               { yyerror("number expected"); }
#line 6634 "core/cfg.tab.c"
    break;

  case 224: /* assign_stm: STATS_NAMESEP EQUAL STRING  */
#line 1042 "core/cfg.y"
                                     { ksr_stats_namesep=(yyvsp[0].strval); }
#line 6640 "core/cfg.tab.c"
    break;

  case 225: /* assign_stm: STATS_NAMESEP EQUAL error  */
#line 1043 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 6646 "core/cfg.tab.c"
    break;

  case 226: /* $@6: %empty  */
#line 1044 "core/cfg.y"
                 {
				memset(&tmp_sa, 0, sizeof(socket_attrs_t));
			}
#line 6654 "core/cfg.tab.c"
    break;

  case 227: /* assign_stm: SOCKET $@6 EQUAL LBRACE socket_lattrs RBRACE  */
#line 1046 "core/cfg.y"
                                                            {
				if(add_listen_socket(&tmp_sa)<0) {
					LM_ERR("failed to add listen socket\n");
					yyerror("failed to add listen socket");
					ksr_exit(-1);
				}
	}
#line 6666 "core/cfg.tab.c"
    break;

  case 228: /* assign_stm: SOCKET_WORKERS EQUAL NUMBER  */
#line 1053 "core/cfg.y"
                                      { socket_workers=(yyvsp[0].intval); }
#line 6672 "core/cfg.tab.c"
    break;

  case 229: /* assign_stm: SOCKET_WORKERS EQUAL error  */
#line 1054 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 6678 "core/cfg.tab.c"
    break;

  case 230: /* assign_stm: ASYNC_WORKERS EQUAL NUMBER  */
#line 1055 "core/cfg.y"
                                     { async_task_set_workers((yyvsp[0].intval)); }
#line 6684 "core/cfg.tab.c"
    break;

  case 231: /* assign_stm: ASYNC_WORKERS EQUAL error  */
#line 1056 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 6690 "core/cfg.tab.c"
    break;

  case 232: /* assign_stm: ASYNC_USLEEP EQUAL NUMBER  */
#line 1057 "core/cfg.y"
                                    { async_task_set_usleep((yyvsp[0].intval)); }
#line 6696 "core/cfg.tab.c"
    break;

  case 233: /* assign_stm: ASYNC_USLEEP EQUAL error  */
#line 1058 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 6702 "core/cfg.tab.c"
    break;

  case 234: /* assign_stm: ASYNC_NONBLOCK EQUAL NUMBER  */
#line 1059 "core/cfg.y"
                                      { async_task_set_nonblock((yyvsp[0].intval)); }
#line 6708 "core/cfg.tab.c"
    break;

  case 235: /* assign_stm: ASYNC_NONBLOCK EQUAL error  */
#line 1060 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 6714 "core/cfg.tab.c"
    break;

  case 236: /* assign_stm: ASYNC_WORKERS_GROUP EQUAL STRING  */
#line 1061 "core/cfg.y"
                                           { async_task_set_workers_group((yyvsp[0].strval)); }
#line 6720 "core/cfg.tab.c"
    break;

  case 237: /* assign_stm: ASYNC_WORKERS_GROUP EQUAL error  */
#line 1062 "core/cfg.y"
                                          { yyerror("string expected"); }
#line 6726 "core/cfg.tab.c"
    break;

  case 238: /* assign_stm: CHECK_VIA EQUAL NUMBER  */
#line 1063 "core/cfg.y"
                                 { check_via=(yyvsp[0].intval); }
#line 6732 "core/cfg.tab.c"
    break;

  case 239: /* assign_stm: CHECK_VIA EQUAL error  */
#line 1064 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6738 "core/cfg.tab.c"
    break;

  case 240: /* assign_stm: PHONE2TEL EQUAL NUMBER  */
#line 1065 "core/cfg.y"
                                 { phone2tel=(yyvsp[0].intval); }
#line 6744 "core/cfg.tab.c"
    break;

  case 241: /* assign_stm: PHONE2TEL EQUAL error  */
#line 1066 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 6750 "core/cfg.tab.c"
    break;

  case 242: /* assign_stm: MEMLOG EQUAL intno  */
#line 1067 "core/cfg.y"
                             { default_core_cfg.memlog=(yyvsp[0].intval); }
#line 6756 "core/cfg.tab.c"
    break;

  case 243: /* assign_stm: MEMLOG EQUAL error  */
#line 1068 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6762 "core/cfg.tab.c"
    break;

  case 244: /* assign_stm: MEMDBG EQUAL intno  */
#line 1069 "core/cfg.y"
                             { default_core_cfg.memdbg=(yyvsp[0].intval); }
#line 6768 "core/cfg.tab.c"
    break;

  case 245: /* assign_stm: MEMDBG EQUAL error  */
#line 1070 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6774 "core/cfg.tab.c"
    break;

  case 246: /* assign_stm: MEMSUM EQUAL intno  */
#line 1071 "core/cfg.y"
                             { default_core_cfg.mem_summary=(yyvsp[0].intval); }
#line 6780 "core/cfg.tab.c"
    break;

  case 247: /* assign_stm: MEMSUM EQUAL error  */
#line 1072 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 6786 "core/cfg.tab.c"
    break;

  case 248: /* assign_stm: MEMSAFETY EQUAL intno  */
#line 1073 "core/cfg.y"
                                { default_core_cfg.mem_safety=(yyvsp[0].intval); }
#line 6792 "core/cfg.tab.c"
    break;

  case 249: /* assign_stm: MEMSAFETY EQUAL error  */
#line 1074 "core/cfg.y"
                                { yyerror("int value expected"); }
#line 6798 "core/cfg.tab.c"
    break;

  case 250: /* assign_stm: MEMJOIN EQUAL intno  */
#line 1075 "core/cfg.y"
                              { default_core_cfg.mem_join=(yyvsp[0].intval); }
#line 6804 "core/cfg.tab.c"
    break;

  case 251: /* assign_stm: MEMJOIN EQUAL error  */
#line 1076 "core/cfg.y"
                              { yyerror("int value expected"); }
#line 6810 "core/cfg.tab.c"
    break;

  case 252: /* assign_stm: MEMSTATUSMODE EQUAL intno  */
#line 1077 "core/cfg.y"
                                    { default_core_cfg.mem_status_mode=(yyvsp[0].intval); }
#line 6816 "core/cfg.tab.c"
    break;

  case 253: /* assign_stm: MEMSTATUSMODE EQUAL error  */
#line 1078 "core/cfg.y"
                                    { yyerror("int value expected"); }
#line 6822 "core/cfg.tab.c"
    break;

  case 254: /* assign_stm: SIP_PARSER_LOG_ONELINE EQUAL intno  */
#line 1079 "core/cfg.y"
                                             { default_core_cfg.sip_parser_log_oneline=(yyvsp[0].intval); }
#line 6828 "core/cfg.tab.c"
    break;

  case 255: /* assign_stm: SIP_PARSER_LOG_ONELINE EQUAL error  */
#line 1080 "core/cfg.y"
                                             { yyerror("int value expected"); }
#line 6834 "core/cfg.tab.c"
    break;

  case 256: /* assign_stm: SIP_PARSER_LOG EQUAL intno  */
#line 1081 "core/cfg.y"
                                     { default_core_cfg.sip_parser_log=(yyvsp[0].intval); }
#line 6840 "core/cfg.tab.c"
    break;

  case 257: /* assign_stm: SIP_PARSER_LOG EQUAL error  */
#line 1082 "core/cfg.y"
                                     { yyerror("int value expected"); }
#line 6846 "core/cfg.tab.c"
    break;

  case 258: /* assign_stm: SIP_PARSER_MODE EQUAL intno  */
#line 1083 "core/cfg.y"
                                      { ksr_sip_parser_mode=(yyvsp[0].intval); }
#line 6852 "core/cfg.tab.c"
    break;

  case 259: /* assign_stm: SIP_PARSER_MODE EQUAL error  */
#line 1084 "core/cfg.y"
                                      { yyerror("int value expected"); }
#line 6858 "core/cfg.tab.c"
    break;

  case 260: /* assign_stm: CORELOG EQUAL intno  */
#line 1085 "core/cfg.y"
                              { default_core_cfg.corelog=(yyvsp[0].intval); }
#line 6864 "core/cfg.tab.c"
    break;

  case 261: /* assign_stm: CORELOG EQUAL error  */
#line 1086 "core/cfg.y"
                              { yyerror("int value expected"); }
#line 6870 "core/cfg.tab.c"
    break;

  case 262: /* assign_stm: SIP_WARNING EQUAL NUMBER  */
#line 1087 "core/cfg.y"
                                   { sip_warning=(yyvsp[0].intval); }
#line 6876 "core/cfg.tab.c"
    break;

  case 263: /* assign_stm: SIP_WARNING EQUAL error  */
#line 1088 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 6882 "core/cfg.tab.c"
    break;

  case 264: /* assign_stm: VERSION_TABLE_CFG EQUAL STRING  */
#line 1089 "core/cfg.y"
                                         { version_table.s=(yyvsp[0].strval);
			version_table.len=strlen(version_table.s);
	}
#line 6890 "core/cfg.tab.c"
    break;

  case 265: /* assign_stm: VERSION_TABLE_CFG EQUAL error  */
#line 1092 "core/cfg.y"
                                        { yyerror("string value expected"); }
#line 6896 "core/cfg.tab.c"
    break;

  case 266: /* assign_stm: USER EQUAL STRING  */
#line 1093 "core/cfg.y"
                                {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6908 "core/cfg.tab.c"
    break;

  case 267: /* assign_stm: USER EQUAL ID  */
#line 1100 "core/cfg.y"
                                {
		if (shm_initialized())
			yyerror("user must be before any modparam or the"
					" route blocks");
		else if (user==0)
			user=(yyvsp[0].strval);
	}
#line 6920 "core/cfg.tab.c"
    break;

  case 268: /* assign_stm: USER EQUAL error  */
#line 1107 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 6926 "core/cfg.tab.c"
    break;

  case 269: /* assign_stm: GROUP EQUAL STRING  */
#line 1108 "core/cfg.y"
                                 { group=(yyvsp[0].strval); }
#line 6932 "core/cfg.tab.c"
    break;

  case 270: /* assign_stm: GROUP EQUAL ID  */
#line 1109 "core/cfg.y"
                                 { group=(yyvsp[0].strval); }
#line 6938 "core/cfg.tab.c"
    break;

  case 271: /* assign_stm: GROUP EQUAL error  */
#line 1110 "core/cfg.y"
                                 { yyerror("string value expected"); }
#line 6944 "core/cfg.tab.c"
    break;

  case 272: /* assign_stm: CHROOT EQUAL STRING  */
#line 1111 "core/cfg.y"
                                  { chroot_dir=(yyvsp[0].strval); }
#line 6950 "core/cfg.tab.c"
    break;

  case 273: /* assign_stm: CHROOT EQUAL ID  */
#line 1112 "core/cfg.y"
                                  { chroot_dir=(yyvsp[0].strval); }
#line 6956 "core/cfg.tab.c"
    break;

  case 274: /* assign_stm: CHROOT EQUAL error  */
#line 1113 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 6962 "core/cfg.tab.c"
    break;

  case 275: /* assign_stm: WDIR EQUAL STRING  */
#line 1114 "core/cfg.y"
                                { working_dir=(yyvsp[0].strval); }
#line 6968 "core/cfg.tab.c"
    break;

  case 276: /* assign_stm: WDIR EQUAL ID  */
#line 1115 "core/cfg.y"
                                { working_dir=(yyvsp[0].strval); }
#line 6974 "core/cfg.tab.c"
    break;

  case 277: /* assign_stm: WDIR EQUAL error  */
#line 1116 "core/cfg.y"
                                { yyerror("string value expected"); }
#line 6980 "core/cfg.tab.c"
    break;

  case 278: /* assign_stm: RUNDIR EQUAL STRING  */
#line 1117 "core/cfg.y"
                                  { runtime_dir=(yyvsp[0].strval); }
#line 6986 "core/cfg.tab.c"
    break;

  case 279: /* assign_stm: RUNDIR EQUAL ID  */
#line 1118 "core/cfg.y"
                                  { runtime_dir=(yyvsp[0].strval); }
#line 6992 "core/cfg.tab.c"
    break;

  case 280: /* assign_stm: RUNDIR EQUAL error  */
#line 1119 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 6998 "core/cfg.tab.c"
    break;

  case 281: /* assign_stm: MHOMED EQUAL NUMBER  */
#line 1120 "core/cfg.y"
                              { mhomed=(yyvsp[0].intval); }
#line 7004 "core/cfg.tab.c"
    break;

  case 282: /* assign_stm: MHOMED EQUAL error  */
#line 1121 "core/cfg.y"
                             { yyerror("boolean value expected"); }
#line 7010 "core/cfg.tab.c"
    break;

  case 283: /* assign_stm: DISABLE_TCP EQUAL NUMBER  */
#line 1122 "core/cfg.y"
                                   {
		#ifdef USE_TCP
			tcp_disable=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7022 "core/cfg.tab.c"
    break;

  case 284: /* assign_stm: DISABLE_TCP EQUAL error  */
#line 1129 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 7028 "core/cfg.tab.c"
    break;

  case 285: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL NUMBER  */
#line 1130 "core/cfg.y"
                                          {
		#ifdef USE_TCP
			tcp_default_cfg.accept_aliases=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7040 "core/cfg.tab.c"
    break;

  case 286: /* assign_stm: TCP_ACCEPT_ALIASES EQUAL error  */
#line 1137 "core/cfg.y"
                                         { yyerror("boolean value expected"); }
#line 7046 "core/cfg.tab.c"
    break;

  case 287: /* assign_stm: TCP_ACCEPT_UNIQUE EQUAL NUMBER  */
#line 1138 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_accept_unique=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7058 "core/cfg.tab.c"
    break;

  case 288: /* assign_stm: TCP_ACCEPT_UNIQUE EQUAL error  */
#line 1145 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 7064 "core/cfg.tab.c"
    break;

  case 289: /* assign_stm: TCP_CONNECTION_MATCH EQUAL NUMBER  */
#line 1146 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_connection_match=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7076 "core/cfg.tab.c"
    break;

  case 290: /* assign_stm: TCP_CONNECTION_MATCH EQUAL error  */
#line 1153 "core/cfg.y"
                                           { yyerror("number expected"); }
#line 7082 "core/cfg.tab.c"
    break;

  case 291: /* assign_stm: TCP_CHILDREN EQUAL NUMBER  */
#line 1154 "core/cfg.y"
                                    {
		#ifdef USE_TCP
			tcp_cfg_children_no=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7094 "core/cfg.tab.c"
    break;

  case 292: /* assign_stm: TCP_CHILDREN EQUAL error  */
#line 1161 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 7100 "core/cfg.tab.c"
    break;

  case 293: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL intno  */
#line 1162 "core/cfg.y"
                                          {
		#ifdef USE_TCP
			tcp_default_cfg.connect_timeout_s=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7112 "core/cfg.tab.c"
    break;

  case 294: /* assign_stm: TCP_CONNECT_TIMEOUT EQUAL error  */
#line 1169 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 7118 "core/cfg.tab.c"
    break;

  case 295: /* assign_stm: TCP_SEND_TIMEOUT EQUAL intno  */
#line 1170 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.send_timeout=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7130 "core/cfg.tab.c"
    break;

  case 296: /* assign_stm: TCP_SEND_TIMEOUT EQUAL error  */
#line 1177 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7136 "core/cfg.tab.c"
    break;

  case 297: /* assign_stm: TCP_CON_LIFETIME EQUAL intno  */
#line 1178 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			if ((yyvsp[0].intval)<0)
				tcp_default_cfg.con_lifetime=-1;
			else
				tcp_default_cfg.con_lifetime=S_TO_TICKS((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7151 "core/cfg.tab.c"
    break;

  case 298: /* assign_stm: TCP_CON_LIFETIME EQUAL error  */
#line 1188 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7157 "core/cfg.tab.c"
    break;

  case 299: /* assign_stm: TCP_POLL_METHOD EQUAL ID  */
#line 1189 "core/cfg.y"
                                   {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7176 "core/cfg.tab.c"
    break;

  case 300: /* assign_stm: TCP_POLL_METHOD EQUAL STRING  */
#line 1203 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_poll_method=get_poll_type((yyvsp[0].strval));
			if (tcp_poll_method==POLL_NONE) {
				LOG(L_CRIT, "bad poll method name:"
						" %s\n, try one of %s.\n",
						(yyvsp[0].strval), poll_support);
				yyerror("bad tcp_poll_method "
						"value");
			}
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7195 "core/cfg.tab.c"
    break;

  case 301: /* assign_stm: TCP_POLL_METHOD EQUAL error  */
#line 1217 "core/cfg.y"
                                      { yyerror("poll method name expected"); }
#line 7201 "core/cfg.tab.c"
    break;

  case 302: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1218 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_max_connections=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7213 "core/cfg.tab.c"
    break;

  case 303: /* assign_stm: TCP_MAX_CONNECTIONS EQUAL error  */
#line 1225 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 7219 "core/cfg.tab.c"
    break;

  case 304: /* assign_stm: TLS_MAX_CONNECTIONS EQUAL NUMBER  */
#line 1226 "core/cfg.y"
                                           {
		#ifdef USE_TLS
			tls_max_connections=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7231 "core/cfg.tab.c"
    break;

  case 305: /* assign_stm: TLS_MAX_CONNECTIONS EQUAL error  */
#line 1233 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 7237 "core/cfg.tab.c"
    break;

  case 306: /* assign_stm: TCP_NO_CONNECT EQUAL NUMBER  */
#line 1234 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.no_connect=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7249 "core/cfg.tab.c"
    break;

  case 307: /* assign_stm: TCP_NO_CONNECT EQUAL error  */
#line 1241 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7255 "core/cfg.tab.c"
    break;

  case 308: /* assign_stm: TCP_SOURCE_IPV4 EQUAL ipv4  */
#line 1242 "core/cfg.y"
                                     {
		#ifdef USE_TCP
			if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
				warn("tcp_source_ipv4 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 7269 "core/cfg.tab.c"
    break;

  case 309: /* assign_stm: TCP_SOURCE_IPV4 EQUAL error  */
#line 1251 "core/cfg.y"
                                      { yyerror("IPv4 address expected"); }
#line 7275 "core/cfg.tab.c"
    break;

  case 310: /* assign_stm: TCP_SOURCE_IPV6 EQUAL ipv6  */
#line 1252 "core/cfg.y"
                                     {
		#ifdef USE_TCP
				if (tcp_set_src_addr((yyvsp[0].ipaddr))<0)
					warn("tcp_source_ipv6 failed");
		#else
			warn("tcp support not compiled in");
		#endif
		pkg_free((yyvsp[0].ipaddr));
	}
#line 7289 "core/cfg.tab.c"
    break;

  case 311: /* assign_stm: TCP_SOURCE_IPV6 EQUAL error  */
#line 1261 "core/cfg.y"
                                      { yyerror("IPv6 address expected"); }
#line 7295 "core/cfg.tab.c"
    break;

  case 312: /* assign_stm: TCP_OPT_FD_CACHE EQUAL NUMBER  */
#line 1262 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_default_cfg.fd_cache=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7307 "core/cfg.tab.c"
    break;

  case 313: /* assign_stm: TCP_OPT_FD_CACHE EQUAL error  */
#line 1269 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 7313 "core/cfg.tab.c"
    break;

  case 314: /* assign_stm: TCP_OPT_BUF_WRITE EQUAL NUMBER  */
#line 1270 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.async=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7325 "core/cfg.tab.c"
    break;

  case 315: /* assign_stm: TCP_OPT_BUF_WRITE EQUAL error  */
#line 1277 "core/cfg.y"
                                        { yyerror("boolean value expected"); }
#line 7331 "core/cfg.tab.c"
    break;

  case 316: /* assign_stm: TCP_OPT_CONN_WQ_MAX EQUAL NUMBER  */
#line 1278 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_default_cfg.tcpconn_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7343 "core/cfg.tab.c"
    break;

  case 317: /* assign_stm: TCP_OPT_CONN_WQ_MAX error  */
#line 1285 "core/cfg.y"
                                    { yyerror("boolean value expected"); }
#line 7349 "core/cfg.tab.c"
    break;

  case 318: /* assign_stm: TCP_OPT_WQ_MAX EQUAL NUMBER  */
#line 1286 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.tcp_wq_max=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7361 "core/cfg.tab.c"
    break;

  case 319: /* assign_stm: TCP_OPT_WQ_MAX error  */
#line 1293 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7367 "core/cfg.tab.c"
    break;

  case 320: /* assign_stm: TCP_OPT_RD_BUF EQUAL NUMBER  */
#line 1294 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.rd_buf_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7379 "core/cfg.tab.c"
    break;

  case 321: /* assign_stm: TCP_OPT_RD_BUF error  */
#line 1301 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7385 "core/cfg.tab.c"
    break;

  case 322: /* assign_stm: TCP_OPT_WQ_BLK EQUAL NUMBER  */
#line 1302 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.wq_blk_size=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7397 "core/cfg.tab.c"
    break;

  case 323: /* assign_stm: TCP_OPT_WQ_BLK error  */
#line 1309 "core/cfg.y"
                               { yyerror("number expected"); }
#line 7403 "core/cfg.tab.c"
    break;

  case 324: /* assign_stm: TCP_OPT_DEFER_ACCEPT EQUAL NUMBER  */
#line 1310 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_default_cfg.defer_accept=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7415 "core/cfg.tab.c"
    break;

  case 325: /* assign_stm: TCP_OPT_DEFER_ACCEPT EQUAL error  */
#line 1317 "core/cfg.y"
                                           { yyerror("boolean value expected"); }
#line 7421 "core/cfg.tab.c"
    break;

  case 326: /* assign_stm: TCP_OPT_DELAYED_ACK EQUAL NUMBER  */
#line 1318 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			tcp_default_cfg.delayed_ack=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7433 "core/cfg.tab.c"
    break;

  case 327: /* assign_stm: TCP_OPT_DELAYED_ACK EQUAL error  */
#line 1325 "core/cfg.y"
                                          { yyerror("boolean value expected"); }
#line 7439 "core/cfg.tab.c"
    break;

  case 328: /* assign_stm: TCP_OPT_SYNCNT EQUAL NUMBER  */
#line 1326 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			tcp_default_cfg.syncnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7451 "core/cfg.tab.c"
    break;

  case 329: /* assign_stm: TCP_OPT_SYNCNT EQUAL error  */
#line 1333 "core/cfg.y"
                                     { yyerror("number expected"); }
#line 7457 "core/cfg.tab.c"
    break;

  case 330: /* assign_stm: TCP_OPT_LINGER2 EQUAL NUMBER  */
#line 1334 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.linger2=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7469 "core/cfg.tab.c"
    break;

  case 331: /* assign_stm: TCP_OPT_LINGER2 EQUAL error  */
#line 1341 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7475 "core/cfg.tab.c"
    break;

  case 332: /* assign_stm: TCP_OPT_KEEPALIVE EQUAL NUMBER  */
#line 1342 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.keepalive=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7487 "core/cfg.tab.c"
    break;

  case 333: /* assign_stm: TCP_OPT_KEEPALIVE EQUAL error  */
#line 1349 "core/cfg.y"
                                        { yyerror("boolean value expected");}
#line 7493 "core/cfg.tab.c"
    break;

  case 334: /* assign_stm: TCP_OPT_KEEPIDLE EQUAL NUMBER  */
#line 1350 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_default_cfg.keepidle=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7505 "core/cfg.tab.c"
    break;

  case 335: /* assign_stm: TCP_OPT_KEEPIDLE EQUAL error  */
#line 1357 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7511 "core/cfg.tab.c"
    break;

  case 336: /* assign_stm: TCP_OPT_KEEPINTVL EQUAL NUMBER  */
#line 1358 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.keepintvl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7523 "core/cfg.tab.c"
    break;

  case 337: /* assign_stm: TCP_OPT_KEEPINTVL EQUAL error  */
#line 1365 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 7529 "core/cfg.tab.c"
    break;

  case 338: /* assign_stm: TCP_OPT_KEEPCNT EQUAL NUMBER  */
#line 1366 "core/cfg.y"
                                       {
		#ifdef USE_TCP
			tcp_default_cfg.keepcnt=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7541 "core/cfg.tab.c"
    break;

  case 339: /* assign_stm: TCP_OPT_KEEPCNT EQUAL error  */
#line 1373 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7547 "core/cfg.tab.c"
    break;

  case 340: /* assign_stm: TCP_OPT_CRLF_PING EQUAL NUMBER  */
#line 1374 "core/cfg.y"
                                         {
		#ifdef USE_TCP
			tcp_default_cfg.crlf_ping=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7559 "core/cfg.tab.c"
    break;

  case 341: /* assign_stm: TCP_OPT_CRLF_PING EQUAL error  */
#line 1381 "core/cfg.y"
                                        { yyerror("boolean value expected"); }
#line 7565 "core/cfg.tab.c"
    break;

  case 342: /* assign_stm: TCP_OPT_ACCEPT_NO_CL EQUAL NUMBER  */
#line 1382 "core/cfg.y"
                                            {
		#ifdef USE_TCP
			tcp_default_cfg.accept_no_cl=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7577 "core/cfg.tab.c"
    break;

  case 343: /* assign_stm: TCP_OPT_ACCEPT_NO_CL EQUAL error  */
#line 1389 "core/cfg.y"
                                           { yyerror("boolean value expected"); }
#line 7583 "core/cfg.tab.c"
    break;

  case 344: /* assign_stm: TCP_OPT_ACCEPT_HEP3 EQUAL NUMBER  */
#line 1390 "core/cfg.y"
                                           {
		#ifdef USE_TCP
			ksr_tcp_accept_hep3=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7595 "core/cfg.tab.c"
    break;

  case 345: /* assign_stm: TCP_OPT_ACCEPT_HEP3 EQUAL error  */
#line 1397 "core/cfg.y"
                                          { yyerror("boolean value expected"); }
#line 7601 "core/cfg.tab.c"
    break;

  case 346: /* assign_stm: TCP_OPT_ACCEPT_HAPROXY EQUAL NUMBER  */
#line 1398 "core/cfg.y"
                                              {
		#ifdef USE_TCP
			ksr_tcp_accept_haproxy=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7613 "core/cfg.tab.c"
    break;

  case 347: /* assign_stm: TCP_OPT_ACCEPT_HAPROXY EQUAL error  */
#line 1405 "core/cfg.y"
                                             { yyerror("boolean value expected"); }
#line 7619 "core/cfg.tab.c"
    break;

  case 348: /* assign_stm: TCP_OPT_CLOSE_RST EQUAL NUMBER  */
#line 1406 "core/cfg.y"
                                         {
         #ifdef USE_TCP
             tcp_default_cfg.close_rst=(yyvsp[0].intval);
         #else
             warn("tcp support not compiled in");
         #endif
     }
#line 7631 "core/cfg.tab.c"
    break;

  case 349: /* assign_stm: TCP_OPT_CLOSE_RST EQUAL error  */
#line 1413 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7637 "core/cfg.tab.c"
    break;

  case 350: /* assign_stm: TCP_CLONE_RCVBUF EQUAL NUMBER  */
#line 1415 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			tcp_set_clone_rcvbuf((yyvsp[0].intval));
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7649 "core/cfg.tab.c"
    break;

  case 351: /* assign_stm: TCP_CLONE_RCVBUF EQUAL error  */
#line 1422 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7655 "core/cfg.tab.c"
    break;

  case 352: /* assign_stm: TCP_REUSE_PORT EQUAL NUMBER  */
#line 1423 "core/cfg.y"
                                      {
		#ifdef USE_TCP
		#ifdef SO_REUSEPORT
			tcp_default_cfg.reuse_port=(yyvsp[0].intval);
		#else
			warn("support for SO_REUSEPORT not compiled in");
		#endif
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7671 "core/cfg.tab.c"
    break;

  case 353: /* assign_stm: TCP_REUSE_PORT EQUAL error  */
#line 1434 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 7677 "core/cfg.tab.c"
    break;

  case 354: /* assign_stm: TCP_WAIT_DATA EQUAL intno  */
#line 1435 "core/cfg.y"
                                    {
		#ifdef USE_TCP
			tcp_default_cfg.wait_data_ms=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7689 "core/cfg.tab.c"
    break;

  case 355: /* assign_stm: TCP_WAIT_DATA EQUAL error  */
#line 1442 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 7695 "core/cfg.tab.c"
    break;

  case 356: /* assign_stm: TCP_SCRIPT_MODE EQUAL intno  */
#line 1443 "core/cfg.y"
                                      {
		#ifdef USE_TCP
			ksr_tcp_script_mode=(yyvsp[0].intval);
		#else
			warn("tcp support not compiled in");
		#endif
	}
#line 7707 "core/cfg.tab.c"
    break;

  case 357: /* assign_stm: TCP_SCRIPT_MODE EQUAL error  */
#line 1450 "core/cfg.y"
                                      { yyerror("number expected"); }
#line 7713 "core/cfg.tab.c"
    break;

  case 358: /* assign_stm: DISABLE_TLS EQUAL NUMBER  */
#line 1451 "core/cfg.y"
                                   {
		#ifdef USE_TLS
			tls_disable=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7725 "core/cfg.tab.c"
    break;

  case 359: /* assign_stm: DISABLE_TLS EQUAL error  */
#line 1458 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 7731 "core/cfg.tab.c"
    break;

  case 360: /* assign_stm: ENABLE_TLS EQUAL NUMBER  */
#line 1459 "core/cfg.y"
                                  {
		#ifdef USE_TLS
			tls_disable=!((yyvsp[0].intval));
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7743 "core/cfg.tab.c"
    break;

  case 361: /* assign_stm: ENABLE_TLS EQUAL error  */
#line 1466 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 7749 "core/cfg.tab.c"
    break;

  case 362: /* assign_stm: TLSLOG EQUAL NUMBER  */
#line 1467 "core/cfg.y"
                              {
		#ifdef CORE_TLS
			tls_log=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7761 "core/cfg.tab.c"
    break;

  case 363: /* assign_stm: TLSLOG EQUAL error  */
#line 1474 "core/cfg.y"
                             { yyerror("int value expected"); }
#line 7767 "core/cfg.tab.c"
    break;

  case 364: /* assign_stm: TLS_PORT_NO EQUAL NUMBER  */
#line 1475 "core/cfg.y"
                                   {
		#ifdef USE_TLS
			tls_port_no=(yyvsp[0].intval);
		#else
			warn("tls support not compiled in");
		#endif
	}
#line 7779 "core/cfg.tab.c"
    break;

  case 365: /* assign_stm: TLS_PORT_NO EQUAL error  */
#line 1482 "core/cfg.y"
                                  { yyerror("number expected"); }
#line 7785 "core/cfg.tab.c"
    break;

  case 366: /* assign_stm: TLS_METHOD EQUAL SSLv23  */
#line 1483 "core/cfg.y"
                                  {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv23;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7797 "core/cfg.tab.c"
    break;

  case 367: /* assign_stm: TLS_METHOD EQUAL SSLv2  */
#line 1490 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv2;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7809 "core/cfg.tab.c"
    break;

  case 368: /* assign_stm: TLS_METHOD EQUAL SSLv3  */
#line 1497 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_SSLv3;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7821 "core/cfg.tab.c"
    break;

  case 369: /* assign_stm: TLS_METHOD EQUAL TLSv1  */
#line 1504 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			tls_method=TLS_USE_TLSv1;
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7833 "core/cfg.tab.c"
    break;

  case 370: /* assign_stm: TLS_METHOD EQUAL error  */
#line 1511 "core/cfg.y"
                                 {
		#ifdef CORE_TLS
			yyerror("SSLv23, SSLv2, SSLv3 or TLSv1 expected");
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7845 "core/cfg.tab.c"
    break;

  case 371: /* assign_stm: TLS_VERIFY EQUAL NUMBER  */
#line 1518 "core/cfg.y"
                                  {
		#ifdef CORE_TLS
			tls_verify_cert=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7857 "core/cfg.tab.c"
    break;

  case 372: /* assign_stm: TLS_VERIFY EQUAL error  */
#line 1525 "core/cfg.y"
                                 { yyerror("boolean value expected"); }
#line 7863 "core/cfg.tab.c"
    break;

  case 373: /* assign_stm: TLS_REQUIRE_CERTIFICATE EQUAL NUMBER  */
#line 1526 "core/cfg.y"
                                               {
		#ifdef CORE_TLS
			tls_require_cert=(yyvsp[0].intval);
		#else
			warn( "tls-in-core support not compiled in");
		#endif
	}
#line 7875 "core/cfg.tab.c"
    break;

  case 374: /* assign_stm: TLS_REQUIRE_CERTIFICATE EQUAL error  */
#line 1533 "core/cfg.y"
                                              { yyerror("boolean value expected"); }
#line 7881 "core/cfg.tab.c"
    break;

  case 375: /* assign_stm: TLS_CERTIFICATE EQUAL STRING  */
#line 1534 "core/cfg.y"
                                       {
		#ifdef CORE_TLS
			tls_cert_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7893 "core/cfg.tab.c"
    break;

  case 376: /* assign_stm: TLS_CERTIFICATE EQUAL error  */
#line 1541 "core/cfg.y"
                                      { yyerror("string value expected"); }
#line 7899 "core/cfg.tab.c"
    break;

  case 377: /* assign_stm: TLS_PRIVATE_KEY EQUAL STRING  */
#line 1542 "core/cfg.y"
                                       {
		#ifdef CORE_TLS
			tls_pkey_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7911 "core/cfg.tab.c"
    break;

  case 378: /* assign_stm: TLS_PRIVATE_KEY EQUAL error  */
#line 1549 "core/cfg.y"
                                      { yyerror("string value expected"); }
#line 7917 "core/cfg.tab.c"
    break;

  case 379: /* assign_stm: TLS_CA_LIST EQUAL STRING  */
#line 1550 "core/cfg.y"
                                   {
		#ifdef CORE_TLS
			tls_ca_file=(yyvsp[0].strval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7929 "core/cfg.tab.c"
    break;

  case 380: /* assign_stm: TLS_CA_LIST EQUAL error  */
#line 1557 "core/cfg.y"
                                  { yyerror("string value expected"); }
#line 7935 "core/cfg.tab.c"
    break;

  case 381: /* assign_stm: TLS_HANDSHAKE_TIMEOUT EQUAL NUMBER  */
#line 1558 "core/cfg.y"
                                             {
		#ifdef CORE_TLS
			tls_handshake_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7947 "core/cfg.tab.c"
    break;

  case 382: /* assign_stm: TLS_HANDSHAKE_TIMEOUT EQUAL error  */
#line 1565 "core/cfg.y"
                                            { yyerror("number expected"); }
#line 7953 "core/cfg.tab.c"
    break;

  case 383: /* assign_stm: TLS_SEND_TIMEOUT EQUAL NUMBER  */
#line 1566 "core/cfg.y"
                                        {
		#ifdef CORE_TLS
			tls_send_timeout=(yyvsp[0].intval);
		#else
			warn("tls-in-core support not compiled in");
		#endif
	}
#line 7965 "core/cfg.tab.c"
    break;

  case 384: /* assign_stm: TLS_SEND_TIMEOUT EQUAL error  */
#line 1573 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 7971 "core/cfg.tab.c"
    break;

  case 385: /* assign_stm: DISABLE_SCTP EQUAL NUMBER  */
#line 1574 "core/cfg.y"
                                    {
		#ifdef USE_SCTP
			sctp_disable=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 7983 "core/cfg.tab.c"
    break;

  case 386: /* assign_stm: DISABLE_SCTP EQUAL error  */
#line 1581 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 7989 "core/cfg.tab.c"
    break;

  case 387: /* assign_stm: ENABLE_SCTP EQUAL NUMBER  */
#line 1582 "core/cfg.y"
                                   {
		#ifdef USE_SCTP
			sctp_disable=((yyvsp[0].intval)<=1)?!(yyvsp[0].intval):(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 8001 "core/cfg.tab.c"
    break;

  case 388: /* assign_stm: ENABLE_SCTP EQUAL error  */
#line 1589 "core/cfg.y"
                                  { yyerror("boolean or number expected"); }
#line 8007 "core/cfg.tab.c"
    break;

  case 389: /* assign_stm: SCTP_CHILDREN EQUAL NUMBER  */
#line 1590 "core/cfg.y"
                                     {
		#ifdef USE_SCTP
			sctp_children_no=(yyvsp[0].intval);
		#else
			warn("sctp support not compiled in");
		#endif
	}
#line 8019 "core/cfg.tab.c"
    break;

  case 390: /* assign_stm: SCTP_CHILDREN EQUAL error  */
#line 1597 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8025 "core/cfg.tab.c"
    break;

  case 391: /* assign_stm: SERVER_SIGNATURE EQUAL NUMBER  */
#line 1598 "core/cfg.y"
                                        { server_signature=(yyvsp[0].intval); }
#line 8031 "core/cfg.tab.c"
    break;

  case 392: /* assign_stm: SERVER_SIGNATURE EQUAL error  */
#line 1599 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8037 "core/cfg.tab.c"
    break;

  case 393: /* assign_stm: SERVER_HEADER EQUAL STRING  */
#line 1600 "core/cfg.y"
                                     { server_hdr.s=(yyvsp[0].strval);
			server_hdr.len=strlen(server_hdr.s);
	}
#line 8045 "core/cfg.tab.c"
    break;

  case 394: /* assign_stm: SERVER_HEADER EQUAL error  */
#line 1603 "core/cfg.y"
                                    { yyerror("string value expected"); }
#line 8051 "core/cfg.tab.c"
    break;

  case 395: /* assign_stm: USER_AGENT_HEADER EQUAL STRING  */
#line 1604 "core/cfg.y"
                                         { user_agent_hdr.s=(yyvsp[0].strval);
			user_agent_hdr.len=strlen(user_agent_hdr.s);
	}
#line 8059 "core/cfg.tab.c"
    break;

  case 396: /* assign_stm: USER_AGENT_HEADER EQUAL error  */
#line 1607 "core/cfg.y"
                                        { yyerror("string value expected"); }
#line 8065 "core/cfg.tab.c"
    break;

  case 397: /* assign_stm: URI_HOST_EXTRA_CHARS EQUAL STRING  */
#line 1608 "core/cfg.y"
                                            { _sr_uri_host_extra_chars=(yyvsp[0].strval); }
#line 8071 "core/cfg.tab.c"
    break;

  case 398: /* assign_stm: URI_HOST_EXTRA_CHARS EQUAL error  */
#line 1609 "core/cfg.y"
                                           { yyerror("string value expected"); }
#line 8077 "core/cfg.tab.c"
    break;

  case 399: /* assign_stm: HDR_NAME_EXTRA_CHARS EQUAL STRING  */
#line 1610 "core/cfg.y"
                                            { _ksr_hname_extra_chars=(unsigned char*)(yyvsp[0].strval); }
#line 8083 "core/cfg.tab.c"
    break;

  case 400: /* assign_stm: HDR_NAME_EXTRA_CHARS EQUAL error  */
#line 1611 "core/cfg.y"
                                           { yyerror("string value expected"); }
#line 8089 "core/cfg.tab.c"
    break;

  case 401: /* assign_stm: REPLY_TO_VIA EQUAL NUMBER  */
#line 1612 "core/cfg.y"
                                    { reply_to_via=(yyvsp[0].intval); }
#line 8095 "core/cfg.tab.c"
    break;

  case 402: /* assign_stm: REPLY_TO_VIA EQUAL error  */
#line 1613 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 8101 "core/cfg.tab.c"
    break;

  case 403: /* assign_stm: LISTEN EQUAL id_lst  */
#line 1614 "core/cfg.y"
                              {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8118 "core/cfg.tab.c"
    break;

  case 404: /* assign_stm: LISTEN EQUAL id_lst VIRTUAL  */
#line 1626 "core/cfg.y"
                                      {
                for(lst_tmp=(yyvsp[-1].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface(   lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-1].sockid));
        }
#line 8136 "core/cfg.tab.c"
    break;

  case 405: /* assign_stm: LISTEN EQUAL id_lst STRNAME STRING  */
#line 1639 "core/cfg.y"
                                             {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 8153 "core/cfg.tab.c"
    break;

  case 406: /* assign_stm: LISTEN EQUAL id_lst STRNAME STRING VIRTUAL  */
#line 1651 "core/cfg.y"
                                                     {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
                        lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 8171 "core/cfg.tab.c"
    break;

  case 407: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER  */
#line 1664 "core/cfg.y"
                                                               {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 8189 "core/cfg.tab.c"
    break;

  case 408: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE xproto COLON listen_id COLON NUMBER  */
#line 1677 "core/cfg.y"
                                                                            {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-4].intval), (yyvsp[-2].strval), (yyvsp[0].intval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 8207 "core/cfg.tab.c"
    break;

  case 409: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER VIRTUAL  */
#line 1690 "core/cfg.y"
                                                                       {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-3].strval), (yyvsp[-1].intval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 8226 "core/cfg.tab.c"
    break;

  case 410: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER STRNAME STRING  */
#line 1704 "core/cfg.y"
                                                                              {
		for(lst_tmp=(yyvsp[-6].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-6].sockid));
	}
#line 8244 "core/cfg.tab.c"
    break;

  case 411: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE xproto COLON listen_id COLON NUMBER STRNAME STRING  */
#line 1717 "core/cfg.y"
                                                                                           {
		for(lst_tmp=(yyvsp[-8].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									(yyvsp[-6].intval), (yyvsp[-4].strval), (yyvsp[-2].intval), (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-8].sockid));
	}
#line 8262 "core/cfg.tab.c"
    break;

  case 412: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id COLON NUMBER STRNAME STRING VIRTUAL  */
#line 1730 "core/cfg.y"
                                                                                      {
                for(lst_tmp=(yyvsp[-7].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-7].sockid));
        }
#line 8281 "core/cfg.tab.c"
    break;

  case 413: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE xproto COLON listen_id COLON NUMBER STRNAME STRING VIRTUAL  */
#line 1744 "core/cfg.y"
                                                                                                   {
                for(lst_tmp=(yyvsp[-9].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        (yyvsp[-7].intval), (yyvsp[-5].strval), (yyvsp[-3].intval), (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-9].sockid));
        }
#line 8300 "core/cfg.tab.c"
    break;

  case 414: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id  */
#line 1758 "core/cfg.y"
                                                  {
		for(lst_tmp=(yyvsp[-2].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface(	lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[0].strval), 0,
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-2].sockid));
	}
#line 8318 "core/cfg.tab.c"
    break;

  case 415: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id VIRTUAL  */
#line 1771 "core/cfg.y"
                                                          {
                for(lst_tmp=(yyvsp[-3].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface( lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-1].strval), 0,
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-3].sockid));
        }
#line 8337 "core/cfg.tab.c"
    break;

  case 416: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id STRNAME STRING  */
#line 1785 "core/cfg.y"
                                                                 {
		for(lst_tmp=(yyvsp[-4].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
									lst_tmp->addr_lst->next,
									lst_tmp->port, lst_tmp->proto,
									PROTO_NONE, (yyvsp[-2].strval), 0, (yyvsp[0].strval),
									lst_tmp->flags)!=0) {
				LM_CRIT("cfg. parser: failed to add listen address\n");
				break;
			}
		}
		free_socket_id_lst((yyvsp[-4].sockid));
	}
#line 8355 "core/cfg.tab.c"
    break;

  case 417: /* assign_stm: LISTEN EQUAL id_lst ADVERTISE listen_id STRNAME STRING VIRTUAL  */
#line 1798 "core/cfg.y"
                                                                         {
                for(lst_tmp=(yyvsp[-5].sockid); lst_tmp; lst_tmp=lst_tmp->next) {
			lst_tmp->flags |= SI_IS_VIRTUAL;
                        if (add_listen_advertise_iface_name(lst_tmp->addr_lst->name,
                                                                        lst_tmp->addr_lst->next,
                                                                        lst_tmp->port, lst_tmp->proto,
                                                                        PROTO_NONE, (yyvsp[-3].strval), 0, (yyvsp[-1].strval),
                                                                        lst_tmp->flags)!=0) {
                                LM_CRIT("cfg. parser: failed to add listen address\n");
                                break;
                        }
                }
                free_socket_id_lst((yyvsp[-5].sockid));
        }
#line 8374 "core/cfg.tab.c"
    break;

  case 418: /* assign_stm: LISTEN EQUAL error  */
#line 1812 "core/cfg.y"
                              { yyerror("ip address, interface name or"
									" hostname expected"); }
#line 8381 "core/cfg.tab.c"
    break;

  case 419: /* assign_stm: ALIAS EQUAL id_lst  */
#line 1814 "core/cfg.y"
                              {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8397 "core/cfg.tab.c"
    break;

  case 420: /* assign_stm: ALIAS EQUAL error  */
#line 1825 "core/cfg.y"
                              { yyerror("hostname expected"); }
#line 8403 "core/cfg.tab.c"
    break;

  case 421: /* assign_stm: DOMAIN EQUAL id_lst  */
#line 1826 "core/cfg.y"
                               {
		for(lst_tmp=(yyvsp[0].sockid); lst_tmp; lst_tmp=lst_tmp->next){
			add_alias(	lst_tmp->addr_lst->name,
						strlen(lst_tmp->addr_lst->name),
						lst_tmp->port, lst_tmp->proto);
			for (nl_tmp=lst_tmp->addr_lst->next; nl_tmp; nl_tmp=nl_tmp->next)
				add_alias(nl_tmp->name, strlen(nl_tmp->name),
							lst_tmp->port, lst_tmp->proto);
		}
		free_socket_id_lst((yyvsp[0].sockid));
	}
#line 8419 "core/cfg.tab.c"
    break;

  case 422: /* assign_stm: DOMAIN EQUAL error  */
#line 1837 "core/cfg.y"
                               { yyerror("hostname expected"); }
#line 8425 "core/cfg.tab.c"
    break;

  case 423: /* assign_stm: SR_AUTO_ALIASES EQUAL NUMBER  */
#line 1838 "core/cfg.y"
                                       { sr_auto_aliases=(yyvsp[0].intval); }
#line 8431 "core/cfg.tab.c"
    break;

  case 424: /* assign_stm: SR_AUTO_ALIASES EQUAL error  */
#line 1839 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8437 "core/cfg.tab.c"
    break;

  case 425: /* assign_stm: SR_AUTO_DOMAINS EQUAL NUMBER  */
#line 1840 "core/cfg.y"
                                       { sr_auto_aliases=(yyvsp[0].intval); }
#line 8443 "core/cfg.tab.c"
    break;

  case 426: /* assign_stm: SR_AUTO_DOMAINS EQUAL error  */
#line 1841 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8449 "core/cfg.tab.c"
    break;

  case 427: /* assign_stm: ADVERTISED_ADDRESS EQUAL listen_id  */
#line 1842 "core/cfg.y"
                                             {
		if ((yyvsp[0].strval)){
			default_global_address.s=(yyvsp[0].strval);
			default_global_address.len=strlen((yyvsp[0].strval));
		}
	}
#line 8460 "core/cfg.tab.c"
    break;

  case 428: /* assign_stm: ADVERTISED_ADDRESS EQUAL error  */
#line 1848 "core/cfg.y"
                                         {yyerror("ip address or hostname expected"); }
#line 8466 "core/cfg.tab.c"
    break;

  case 429: /* assign_stm: ADVERTISED_PORT EQUAL NUMBER  */
#line 1849 "core/cfg.y"
                                       {
		tmp=int2str((yyvsp[0].intval), &i_tmp);
		if ((default_global_port.s=pkg_malloc(i_tmp))==0) {
			PKG_MEM_CRITICAL;
			default_global_port.len=0;
		} else {
			default_global_port.len=i_tmp;
			memcpy(default_global_port.s, tmp, default_global_port.len);
		};
	}
#line 8481 "core/cfg.tab.c"
    break;

  case 430: /* assign_stm: ADVERTISED_PORT EQUAL error  */
#line 1859 "core/cfg.y"
                                     {yyerror("ip address or hostname expected"); }
#line 8487 "core/cfg.tab.c"
    break;

  case 431: /* assign_stm: DISABLE_CORE EQUAL NUMBER  */
#line 1860 "core/cfg.y"
                                    { disable_core_dump=(yyvsp[0].intval); }
#line 8493 "core/cfg.tab.c"
    break;

  case 432: /* assign_stm: DISABLE_CORE EQUAL error  */
#line 1861 "core/cfg.y"
                                   { yyerror("boolean value expected"); }
#line 8499 "core/cfg.tab.c"
    break;

  case 433: /* assign_stm: OPEN_FD_LIMIT EQUAL NUMBER  */
#line 1862 "core/cfg.y"
                                     { open_files_limit=(yyvsp[0].intval); }
#line 8505 "core/cfg.tab.c"
    break;

  case 434: /* assign_stm: OPEN_FD_LIMIT EQUAL error  */
#line 1863 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8511 "core/cfg.tab.c"
    break;

  case 435: /* assign_stm: SHM_MEM_SZ EQUAL NUMBER  */
#line 1864 "core/cfg.y"
                                  {
		if (shm_initialized())
			yyerror("shm/shm_mem_size must be before any modparam or the"
					" route blocks");
		else if (shm_mem_size == 0 || shm_mem_size == SHM_MEM_POOL_SIZE)
			shm_mem_size=(yyvsp[0].intval) * 1024 * 1024;
	}
#line 8523 "core/cfg.tab.c"
    break;

  case 436: /* assign_stm: SHM_MEM_SZ EQUAL error  */
#line 1871 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8529 "core/cfg.tab.c"
    break;

  case 437: /* assign_stm: SHM_FORCE_ALLOC EQUAL NUMBER  */
#line 1872 "core/cfg.y"
                                       {
		if (shm_initialized())
			yyerror("shm_force_alloc must be before any modparam or the"
					" route blocks");
		else
			shm_force_alloc=(yyvsp[0].intval);
	}
#line 8541 "core/cfg.tab.c"
    break;

  case 438: /* assign_stm: SHM_FORCE_ALLOC EQUAL error  */
#line 1879 "core/cfg.y"
                                      { yyerror("boolean value expected"); }
#line 8547 "core/cfg.tab.c"
    break;

  case 439: /* assign_stm: MLOCK_PAGES EQUAL NUMBER  */
#line 1880 "core/cfg.y"
                                   { mlock_pages=(yyvsp[0].intval); }
#line 8553 "core/cfg.tab.c"
    break;

  case 440: /* assign_stm: MLOCK_PAGES EQUAL error  */
#line 1881 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 8559 "core/cfg.tab.c"
    break;

  case 441: /* assign_stm: REAL_TIME EQUAL NUMBER  */
#line 1882 "core/cfg.y"
                                 { real_time=(yyvsp[0].intval); }
#line 8565 "core/cfg.tab.c"
    break;

  case 442: /* assign_stm: REAL_TIME EQUAL error  */
#line 1883 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 8571 "core/cfg.tab.c"
    break;

  case 443: /* assign_stm: RT_PRIO EQUAL NUMBER  */
#line 1884 "core/cfg.y"
                               { rt_prio=(yyvsp[0].intval); }
#line 8577 "core/cfg.tab.c"
    break;

  case 444: /* assign_stm: RT_PRIO EQUAL error  */
#line 1885 "core/cfg.y"
                              { yyerror("boolean value expected"); }
#line 8583 "core/cfg.tab.c"
    break;

  case 445: /* assign_stm: RT_POLICY EQUAL NUMBER  */
#line 1886 "core/cfg.y"
                                 { rt_policy=(yyvsp[0].intval); }
#line 8589 "core/cfg.tab.c"
    break;

  case 446: /* assign_stm: RT_POLICY EQUAL error  */
#line 1887 "core/cfg.y"
                                { yyerror("boolean value expected"); }
#line 8595 "core/cfg.tab.c"
    break;

  case 447: /* assign_stm: RT_TIMER1_PRIO EQUAL NUMBER  */
#line 1888 "core/cfg.y"
                                      { rt_timer1_prio=(yyvsp[0].intval); }
#line 8601 "core/cfg.tab.c"
    break;

  case 448: /* assign_stm: RT_TIMER1_PRIO EQUAL error  */
#line 1889 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8607 "core/cfg.tab.c"
    break;

  case 449: /* assign_stm: RT_TIMER1_POLICY EQUAL NUMBER  */
#line 1890 "core/cfg.y"
                                        { rt_timer1_policy=(yyvsp[0].intval); }
#line 8613 "core/cfg.tab.c"
    break;

  case 450: /* assign_stm: RT_TIMER1_POLICY EQUAL error  */
#line 1891 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8619 "core/cfg.tab.c"
    break;

  case 451: /* assign_stm: RT_TIMER2_PRIO EQUAL NUMBER  */
#line 1892 "core/cfg.y"
                                      { rt_timer2_prio=(yyvsp[0].intval); }
#line 8625 "core/cfg.tab.c"
    break;

  case 452: /* assign_stm: RT_TIMER2_PRIO EQUAL error  */
#line 1893 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8631 "core/cfg.tab.c"
    break;

  case 453: /* assign_stm: RT_TIMER2_POLICY EQUAL NUMBER  */
#line 1894 "core/cfg.y"
                                        { rt_timer2_policy=(yyvsp[0].intval); }
#line 8637 "core/cfg.tab.c"
    break;

  case 454: /* assign_stm: RT_TIMER2_POLICY EQUAL error  */
#line 1895 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8643 "core/cfg.tab.c"
    break;

  case 455: /* assign_stm: MCAST_LOOPBACK EQUAL NUMBER  */
#line 1896 "core/cfg.y"
                                      {
		#ifdef USE_MCAST
			mcast_loopback=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8655 "core/cfg.tab.c"
    break;

  case 456: /* assign_stm: MCAST_LOOPBACK EQUAL error  */
#line 1903 "core/cfg.y"
                                     { yyerror("boolean value expected"); }
#line 8661 "core/cfg.tab.c"
    break;

  case 457: /* assign_stm: MCAST_TTL EQUAL NUMBER  */
#line 1904 "core/cfg.y"
                                 {
		#ifdef USE_MCAST
			mcast_ttl=(yyvsp[0].intval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8673 "core/cfg.tab.c"
    break;

  case 458: /* assign_stm: MCAST_TTL EQUAL error  */
#line 1911 "core/cfg.y"
                                { yyerror("number expected"); }
#line 8679 "core/cfg.tab.c"
    break;

  case 459: /* assign_stm: MCAST EQUAL ID  */
#line 1912 "core/cfg.y"
                         {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8691 "core/cfg.tab.c"
    break;

  case 460: /* assign_stm: MCAST EQUAL STRING  */
#line 1919 "core/cfg.y"
                             {
		#ifdef USE_MCAST
			mcast=(yyvsp[0].strval);
		#else
			warn("no multicast support compiled in");
		#endif
	}
#line 8703 "core/cfg.tab.c"
    break;

  case 461: /* assign_stm: MCAST EQUAL error  */
#line 1926 "core/cfg.y"
                            { yyerror("string expected"); }
#line 8709 "core/cfg.tab.c"
    break;

  case 462: /* assign_stm: TOS EQUAL NUMBER  */
#line 1927 "core/cfg.y"
                           { tos=(yyvsp[0].intval); }
#line 8715 "core/cfg.tab.c"
    break;

  case 463: /* assign_stm: TOS EQUAL ID  */
#line 1928 "core/cfg.y"
                       { if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWDELAY")) {
			tos=IPTOS_LOWDELAY;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_THROUGHPUT")) {
			tos=IPTOS_THROUGHPUT;
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_RELIABILITY")) {
			tos=IPTOS_RELIABILITY;
#if defined(IPTOS_MINCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_MINCOST")) {
			tos=IPTOS_MINCOST;
#endif
#if defined(IPTOS_LOWCOST)
		} else if (strcasecmp((yyvsp[0].strval),"IPTOS_LOWCOST")) {
			tos=IPTOS_LOWCOST;
#endif
		} else {
			yyerror("invalid tos value - allowed: "
				"IPTOS_LOWDELAY,IPTOS_THROUGHPUT,"
				"IPTOS_RELIABILITY"
#if defined(IPTOS_LOWCOST)
				",IPTOS_LOWCOST"
#endif
#if !defined(IPTOS_MINCOST)
				",IPTOS_MINCOST"
#endif
				"\n");
		}
	}
#line 8747 "core/cfg.tab.c"
    break;

  case 464: /* assign_stm: TOS EQUAL error  */
#line 1955 "core/cfg.y"
                          { yyerror("number expected"); }
#line 8753 "core/cfg.tab.c"
    break;

  case 465: /* assign_stm: PMTU_DISCOVERY EQUAL NUMBER  */
#line 1956 "core/cfg.y"
                                      { pmtu_discovery=(yyvsp[0].intval); }
#line 8759 "core/cfg.tab.c"
    break;

  case 466: /* assign_stm: PMTU_DISCOVERY error  */
#line 1957 "core/cfg.y"
                               { yyerror("number expected"); }
#line 8765 "core/cfg.tab.c"
    break;

  case 467: /* assign_stm: KILL_TIMEOUT EQUAL NUMBER  */
#line 1958 "core/cfg.y"
                                    { ser_kill_timeout=(yyvsp[0].intval); }
#line 8771 "core/cfg.tab.c"
    break;

  case 468: /* assign_stm: KILL_TIMEOUT EQUAL error  */
#line 1959 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8777 "core/cfg.tab.c"
    break;

  case 469: /* assign_stm: MAX_WLOOPS EQUAL NUMBER  */
#line 1960 "core/cfg.y"
                                  { default_core_cfg.max_while_loops=(yyvsp[0].intval); }
#line 8783 "core/cfg.tab.c"
    break;

  case 470: /* assign_stm: MAX_WLOOPS EQUAL error  */
#line 1961 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8789 "core/cfg.tab.c"
    break;

  case 471: /* assign_stm: PVBUFSIZE EQUAL NUMBER  */
#line 1962 "core/cfg.y"
                                 { pv_set_buffer_size((yyvsp[0].intval)); }
#line 8795 "core/cfg.tab.c"
    break;

  case 472: /* assign_stm: PVBUFSIZE EQUAL error  */
#line 1963 "core/cfg.y"
                                { yyerror("number expected"); }
#line 8801 "core/cfg.tab.c"
    break;

  case 473: /* assign_stm: PVBUFSLOTS EQUAL NUMBER  */
#line 1964 "core/cfg.y"
                                  { pv_set_buffer_slots((yyvsp[0].intval)); }
#line 8807 "core/cfg.tab.c"
    break;

  case 474: /* assign_stm: PVBUFSLOTS EQUAL error  */
#line 1965 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8813 "core/cfg.tab.c"
    break;

  case 475: /* assign_stm: PVCACHELIMIT EQUAL NUMBER  */
#line 1966 "core/cfg.y"
                                    { default_core_cfg.pv_cache_limit=(yyvsp[0].intval); }
#line 8819 "core/cfg.tab.c"
    break;

  case 476: /* assign_stm: PVCACHELIMIT EQUAL error  */
#line 1967 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8825 "core/cfg.tab.c"
    break;

  case 477: /* assign_stm: PVCACHEACTION EQUAL NUMBER  */
#line 1968 "core/cfg.y"
                                     { default_core_cfg.pv_cache_action=(yyvsp[0].intval); }
#line 8831 "core/cfg.tab.c"
    break;

  case 478: /* assign_stm: PVCACHEACTION EQUAL error  */
#line 1969 "core/cfg.y"
                                    { yyerror("number expected"); }
#line 8837 "core/cfg.tab.c"
    break;

  case 479: /* assign_stm: HTTP_REPLY_PARSE EQUAL NUMBER  */
#line 1970 "core/cfg.y"
                                        { http_reply_parse=(yyvsp[0].intval); }
#line 8843 "core/cfg.tab.c"
    break;

  case 480: /* assign_stm: HTTP_REPLY_PARSE EQUAL error  */
#line 1971 "core/cfg.y"
                                       { yyerror("boolean value expected"); }
#line 8849 "core/cfg.tab.c"
    break;

  case 481: /* assign_stm: VERBOSE_STARTUP EQUAL NUMBER  */
#line 1972 "core/cfg.y"
                                       { ksr_verbose_startup=(yyvsp[0].intval); }
#line 8855 "core/cfg.tab.c"
    break;

  case 482: /* assign_stm: VERBOSE_STARTUP EQUAL error  */
#line 1973 "core/cfg.y"
                                      { yyerror("boolean value expected"); }
#line 8861 "core/cfg.tab.c"
    break;

  case 483: /* assign_stm: ROUTE_LOCKS_SIZE EQUAL NUMBER  */
#line 1974 "core/cfg.y"
                                        { ksr_route_locks_size=(yyvsp[0].intval); }
#line 8867 "core/cfg.tab.c"
    break;

  case 484: /* assign_stm: ROUTE_LOCKS_SIZE EQUAL error  */
#line 1975 "core/cfg.y"
                                       { yyerror("number expected"); }
#line 8873 "core/cfg.tab.c"
    break;

  case 485: /* assign_stm: WAIT_WORKER1_MODE EQUAL NUMBER  */
#line 1976 "core/cfg.y"
                                         { ksr_wait_worker1_mode=(yyvsp[0].intval); }
#line 8879 "core/cfg.tab.c"
    break;

  case 486: /* assign_stm: WAIT_WORKER1_MODE EQUAL error  */
#line 1977 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 8885 "core/cfg.tab.c"
    break;

  case 487: /* assign_stm: WAIT_WORKER1_TIME EQUAL NUMBER  */
#line 1978 "core/cfg.y"
                                         { ksr_wait_worker1_time=(yyvsp[0].intval); }
#line 8891 "core/cfg.tab.c"
    break;

  case 488: /* assign_stm: WAIT_WORKER1_TIME EQUAL error  */
#line 1979 "core/cfg.y"
                                        { yyerror("number expected"); }
#line 8897 "core/cfg.tab.c"
    break;

  case 489: /* assign_stm: WAIT_WORKER1_USLEEP EQUAL NUMBER  */
#line 1980 "core/cfg.y"
                                           { ksr_wait_worker1_usleep=(yyvsp[0].intval); }
#line 8903 "core/cfg.tab.c"
    break;

  case 490: /* assign_stm: WAIT_WORKER1_USLEEP EQUAL error  */
#line 1981 "core/cfg.y"
                                          { yyerror("number expected"); }
#line 8909 "core/cfg.tab.c"
    break;

  case 491: /* assign_stm: SERVER_ID EQUAL NUMBER  */
#line 1982 "core/cfg.y"
                             { server_id=(yyvsp[0].intval); }
#line 8915 "core/cfg.tab.c"
    break;

  case 492: /* assign_stm: SERVER_ID EQUAL error  */
#line 1983 "core/cfg.y"
                                 { yyerror("number expected"); }
#line 8921 "core/cfg.tab.c"
    break;

  case 493: /* assign_stm: RETURN_MODE EQUAL NUMBER  */
#line 1984 "core/cfg.y"
                               { ksr_return_mode=(yyvsp[0].intval); }
#line 8927 "core/cfg.tab.c"
    break;

  case 494: /* assign_stm: RETURN_MODE EQUAL error  */
#line 1985 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 8933 "core/cfg.tab.c"
    break;

  case 495: /* assign_stm: KEMI DOT REQUEST_ROUTE_CALLBACK EQUAL STRING  */
#line 1986 "core/cfg.y"
                                                       {
			kemi_request_route_callback.s = (yyvsp[0].strval);
			kemi_request_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_request_route_callback.len==0) {
				yyerror("empty name for request route callback function");
			}
		}
#line 8945 "core/cfg.tab.c"
    break;

  case 496: /* assign_stm: KEMI DOT REQUEST_ROUTE_CALLBACK EQUAL error  */
#line 1993 "core/cfg.y"
                                                      { yyerror("string expected"); }
#line 8951 "core/cfg.tab.c"
    break;

  case 497: /* assign_stm: KEMI DOT ONSEND_ROUTE_CALLBACK EQUAL STRING  */
#line 1994 "core/cfg.y"
                                                      {
			kemi_onsend_route_callback.s = (yyvsp[0].strval);
			kemi_onsend_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_onsend_route_callback.len==4
					&& strcasecmp(kemi_onsend_route_callback.s, "none")==0) {
				kemi_onsend_route_callback.s = "";
				kemi_onsend_route_callback.len = 0;
			}
		}
#line 8965 "core/cfg.tab.c"
    break;

  case 498: /* assign_stm: KEMI DOT ONSEND_ROUTE_CALLBACK EQUAL error  */
#line 2003 "core/cfg.y"
                                                     { yyerror("string expected"); }
#line 8971 "core/cfg.tab.c"
    break;

  case 499: /* assign_stm: KEMI DOT REPLY_ROUTE_CALLBACK EQUAL STRING  */
#line 2004 "core/cfg.y"
                                                     {
			kemi_reply_route_callback.s = (yyvsp[0].strval);
			kemi_reply_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_reply_route_callback.len==4
					&& strcasecmp(kemi_reply_route_callback.s, "none")==0) {
				kemi_reply_route_callback.s = "";
				kemi_reply_route_callback.len = 0;
			}
		}
#line 8985 "core/cfg.tab.c"
    break;

  case 500: /* assign_stm: KEMI DOT REPLY_ROUTE_CALLBACK EQUAL error  */
#line 2013 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 8991 "core/cfg.tab.c"
    break;

  case 501: /* assign_stm: KEMI DOT EVENT_ROUTE_CALLBACK EQUAL STRING  */
#line 2014 "core/cfg.y"
                                                     {
			kemi_event_route_callback.s = (yyvsp[0].strval);
			kemi_event_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_event_route_callback.len==4
					&& strcasecmp(kemi_event_route_callback.s, "none")==0) {
				kemi_event_route_callback.s = "";
				kemi_event_route_callback.len = 0;
			}
		}
#line 9005 "core/cfg.tab.c"
    break;

  case 502: /* assign_stm: KEMI DOT EVENT_ROUTE_CALLBACK EQUAL error  */
#line 2023 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 9011 "core/cfg.tab.c"
    break;

  case 503: /* assign_stm: KEMI DOT RECEIVED_ROUTE_CALLBACK EQUAL STRING  */
#line 2024 "core/cfg.y"
                                                        {
			kemi_received_route_callback.s = (yyvsp[0].strval);
			kemi_received_route_callback.len = strlen((yyvsp[0].strval));
			if(kemi_received_route_callback.len==4
					&& strcasecmp(kemi_received_route_callback.s, "none")==0) {
				kemi_received_route_callback.s = "";
				kemi_received_route_callback.len = 0;
			}
		}
#line 9025 "core/cfg.tab.c"
    break;

  case 504: /* assign_stm: KEMI DOT RECEIVED_ROUTE_CALLBACK EQUAL error  */
#line 2033 "core/cfg.y"
                                                       { yyerror("string expected"); }
#line 9031 "core/cfg.tab.c"
    break;

  case 505: /* assign_stm: KEMI DOT PRE_ROUTING_CALLBACK EQUAL STRING  */
#line 2034 "core/cfg.y"
                                                     {
			kemi_pre_routing_callback.s = (yyvsp[0].strval);
			kemi_pre_routing_callback.len = strlen((yyvsp[0].strval));
			if(kemi_pre_routing_callback.len==4
					&& strcasecmp(kemi_pre_routing_callback.s, "none")==0) {
				kemi_pre_routing_callback.s = "";
				kemi_pre_routing_callback.len = 0;
			}
		}
#line 9045 "core/cfg.tab.c"
    break;

  case 506: /* assign_stm: KEMI DOT PRE_ROUTING_CALLBACK EQUAL error  */
#line 2043 "core/cfg.y"
                                                    { yyerror("string expected"); }
#line 9051 "core/cfg.tab.c"
    break;

  case 507: /* assign_stm: RECEIVED_ROUTE_MODE EQUAL intno  */
#line 2044 "core/cfg.y"
                                      { ksr_evrt_received_mode=(yyvsp[0].intval); }
#line 9057 "core/cfg.tab.c"
    break;

  case 508: /* assign_stm: RECEIVED_ROUTE_MODE EQUAL error  */
#line 2045 "core/cfg.y"
                                           { yyerror("number  expected"); }
#line 9063 "core/cfg.tab.c"
    break;

  case 509: /* assign_stm: MAX_RECURSIVE_LEVEL EQUAL NUMBER  */
#line 2046 "core/cfg.y"
                                       { set_max_recursive_level((yyvsp[0].intval)); }
#line 9069 "core/cfg.tab.c"
    break;

  case 510: /* assign_stm: MAX_BRANCHES_PARAM EQUAL NUMBER  */
#line 2047 "core/cfg.y"
                                      { sr_dst_max_branches = (yyvsp[0].intval); }
#line 9075 "core/cfg.tab.c"
    break;

  case 511: /* assign_stm: LATENCY_LOG EQUAL intno  */
#line 2048 "core/cfg.y"
                              { default_core_cfg.latency_log=(yyvsp[0].intval); }
#line 9081 "core/cfg.tab.c"
    break;

  case 512: /* assign_stm: LATENCY_LOG EQUAL error  */
#line 2049 "core/cfg.y"
                                   { yyerror("number  expected"); }
#line 9087 "core/cfg.tab.c"
    break;

  case 513: /* assign_stm: LATENCY_CFG_LOG EQUAL intno  */
#line 2050 "core/cfg.y"
                                  { default_core_cfg.latency_cfg_log=(yyvsp[0].intval); }
#line 9093 "core/cfg.tab.c"
    break;

  case 514: /* assign_stm: LATENCY_CFG_LOG EQUAL error  */
#line 2051 "core/cfg.y"
                                       { yyerror("number  expected"); }
#line 9099 "core/cfg.tab.c"
    break;

  case 515: /* assign_stm: LATENCY_LIMIT_DB EQUAL NUMBER  */
#line 2052 "core/cfg.y"
                                    { default_core_cfg.latency_limit_db=(yyvsp[0].intval); }
#line 9105 "core/cfg.tab.c"
    break;

  case 516: /* assign_stm: LATENCY_LIMIT_DB EQUAL error  */
#line 2053 "core/cfg.y"
                                        { yyerror("number  expected"); }
#line 9111 "core/cfg.tab.c"
    break;

  case 517: /* assign_stm: LATENCY_LIMIT_ACTION EQUAL NUMBER  */
#line 2054 "core/cfg.y"
                                        { default_core_cfg.latency_limit_action=(yyvsp[0].intval); }
#line 9117 "core/cfg.tab.c"
    break;

  case 518: /* assign_stm: LATENCY_LIMIT_ACTION EQUAL error  */
#line 2055 "core/cfg.y"
                                            { yyerror("number  expected"); }
#line 9123 "core/cfg.tab.c"
    break;

  case 519: /* assign_stm: LATENCY_LIMIT_CFG EQUAL NUMBER  */
#line 2056 "core/cfg.y"
                                     { default_core_cfg.latency_limit_cfg=(yyvsp[0].intval); }
#line 9129 "core/cfg.tab.c"
    break;

  case 520: /* assign_stm: LATENCY_LIMIT_CFG EQUAL error  */
#line 2057 "core/cfg.y"
                                         { yyerror("number  expected"); }
#line 9135 "core/cfg.tab.c"
    break;

  case 521: /* assign_stm: RPC_EXEC_DELTA_CFG EQUAL NUMBER  */
#line 2058 "core/cfg.y"
                                      { ksr_rpc_exec_delta=(yyvsp[0].intval); }
#line 9141 "core/cfg.tab.c"
    break;

  case 522: /* assign_stm: RPC_EXEC_DELTA_CFG EQUAL error  */
#line 2059 "core/cfg.y"
                                          { yyerror("number  expected"); }
#line 9147 "core/cfg.tab.c"
    break;

  case 523: /* assign_stm: MSG_TIME EQUAL NUMBER  */
#line 2060 "core/cfg.y"
                            { sr_msg_time=(yyvsp[0].intval); }
#line 9153 "core/cfg.tab.c"
    break;

  case 524: /* assign_stm: MSG_TIME EQUAL error  */
#line 2061 "core/cfg.y"
                                { yyerror("number  expected"); }
#line 9159 "core/cfg.tab.c"
    break;

  case 525: /* assign_stm: ONSEND_RT_REPLY EQUAL NUMBER  */
#line 2062 "core/cfg.y"
                                       { onsend_route_reply=(yyvsp[0].intval); }
#line 9165 "core/cfg.tab.c"
    break;

  case 526: /* assign_stm: ONSEND_RT_REPLY EQUAL error  */
#line 2063 "core/cfg.y"
                                      { yyerror("int value expected"); }
#line 9171 "core/cfg.tab.c"
    break;

  case 527: /* assign_stm: UDP_MTU EQUAL NUMBER  */
#line 2064 "core/cfg.y"
                               { default_core_cfg.udp_mtu=(yyvsp[0].intval); }
#line 9177 "core/cfg.tab.c"
    break;

  case 528: /* assign_stm: UDP_MTU EQUAL error  */
#line 2065 "core/cfg.y"
                              { yyerror("number expected"); }
#line 9183 "core/cfg.tab.c"
    break;

  case 529: /* assign_stm: FORCE_RPORT EQUAL NUMBER  */
#line 2067 "core/cfg.y"
                { default_core_cfg.force_rport=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 9189 "core/cfg.tab.c"
    break;

  case 530: /* assign_stm: FORCE_RPORT EQUAL error  */
#line 2068 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 9195 "core/cfg.tab.c"
    break;

  case 531: /* assign_stm: LOCAL_RPORT EQUAL NUMBER  */
#line 2069 "core/cfg.y"
                                   { ksr_local_rport=(yyvsp[0].intval); }
#line 9201 "core/cfg.tab.c"
    break;

  case 532: /* assign_stm: LOCAL_RPORT EQUAL error  */
#line 2070 "core/cfg.y"
                                  { yyerror("boolean value expected"); }
#line 9207 "core/cfg.tab.c"
    break;

  case 533: /* assign_stm: UDP_MTU_TRY_PROTO EQUAL proto  */
#line 2072 "core/cfg.y"
                { default_core_cfg.udp_mtu_try_proto=(yyvsp[0].intval); fix_global_req_flags(0, 0); }
#line 9213 "core/cfg.tab.c"
    break;

  case 534: /* assign_stm: UDP_MTU_TRY_PROTO EQUAL error  */
#line 2074 "core/cfg.y"
                { yyerror("TCP, TLS, SCTP or UDP expected"); }
#line 9219 "core/cfg.tab.c"
    break;

  case 535: /* assign_stm: UDP4_RAW EQUAL intno  */
#line 2075 "core/cfg.y"
                               { IF_RAW_SOCKS(default_core_cfg.udp4_raw=(yyvsp[0].intval)); }
#line 9225 "core/cfg.tab.c"
    break;

  case 536: /* assign_stm: UDP4_RAW EQUAL error  */
#line 2076 "core/cfg.y"
                               { yyerror("number expected"); }
#line 9231 "core/cfg.tab.c"
    break;

  case 537: /* assign_stm: UDP4_RAW_MTU EQUAL NUMBER  */
#line 2077 "core/cfg.y"
                                    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_mtu=(yyvsp[0].intval));
	}
#line 9239 "core/cfg.tab.c"
    break;

  case 538: /* assign_stm: UDP4_RAW_MTU EQUAL error  */
#line 2080 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 9245 "core/cfg.tab.c"
    break;

  case 539: /* assign_stm: UDP4_RAW_TTL EQUAL NUMBER  */
#line 2081 "core/cfg.y"
                                    {
		IF_RAW_SOCKS(default_core_cfg.udp4_raw_ttl=(yyvsp[0].intval));
	}
#line 9253 "core/cfg.tab.c"
    break;

  case 540: /* assign_stm: UDP4_RAW_TTL EQUAL error  */
#line 2084 "core/cfg.y"
                                   { yyerror("number expected"); }
#line 9259 "core/cfg.tab.c"
    break;

  case 542: /* assign_stm: error EQUAL  */
#line 2086 "core/cfg.y"
                      { yyerror("unknown config variable"); }
#line 9265 "core/cfg.tab.c"
    break;

  case 544: /* cfg_var_id: DEFAULT  */
#line 2090 "core/cfg.y"
                  { (yyval.strval)="default" ; }
#line 9271 "core/cfg.tab.c"
    break;

  case 546: /* cfg_var_idn: DEFAULT  */
#line 2094 "core/cfg.y"
                  { (yyval.strval)="default" ; }
#line 9277 "core/cfg.tab.c"
    break;

  case 547: /* cfg_var_idn: NUMBER  */
#line 2095 "core/cfg.y"
                 {
		yyerror("cfg var field name - use of number or reserved token not allowed: %s",
				yy_number_str);
		YYERROR;
	}
#line 9287 "core/cfg.tab.c"
    break;

  case 548: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL NUMBER  */
#line 2103 "core/cfg.y"
                                                {
		if (cfg_declare_int((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].intval), 0, 0, NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 9297 "core/cfg.tab.c"
    break;

  case 549: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL STRING  */
#line 2108 "core/cfg.y"
                                                  {
		if (cfg_declare_str((yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval), NULL)) {
			yyerror("variable cannot be declared");
		}
	}
#line 9307 "core/cfg.tab.c"
    break;

  case 550: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL NUMBER CFG_DESCRIPTION STRING  */
#line 2113 "core/cfg.y"
                                                                         {
		if (cfg_declare_int((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].intval), 0, 0, (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 9317 "core/cfg.tab.c"
    break;

  case 551: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL STRING CFG_DESCRIPTION STRING  */
#line 2118 "core/cfg.y"
                                                                         {
		if (cfg_declare_str((yyvsp[-6].strval), (yyvsp[-4].strval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be declared");
		}
	}
#line 9327 "core/cfg.tab.c"
    break;

  case 552: /* cfg_var: cfg_var_id DOT cfg_var_idn EQUAL error  */
#line 2123 "core/cfg.y"
                                                 {
		yyerror("number or string expected");
	}
#line 9335 "core/cfg.tab.c"
    break;

  case 553: /* cfg_var: cfg_var_id LBRACK NUMBER RBRACK DOT cfg_var_idn EQUAL NUMBER  */
#line 2126 "core/cfg.y"
                                                                       {
		if (cfg_ginst_var_int((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].intval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 9345 "core/cfg.tab.c"
    break;

  case 554: /* cfg_var: cfg_var_id LBRACK NUMBER RBRACK DOT cfg_var_idn EQUAL STRING  */
#line 2131 "core/cfg.y"
                                                                       {
		if (cfg_ginst_var_string((yyvsp[-7].strval), (yyvsp[-5].intval), (yyvsp[-2].strval), (yyvsp[0].strval))) {
			yyerror("variable cannot be added to the group instance");
		}
	}
#line 9355 "core/cfg.tab.c"
    break;

  case 555: /* module_stm: LOADMODULE STRING  */
#line 2139 "core/cfg.y"
                          {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (ksr_load_module((yyvsp[0].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9366 "core/cfg.tab.c"
    break;

  case 556: /* module_stm: LOADMODULE LPAREN STRING RPAREN  */
#line 2145 "core/cfg.y"
                                          {
		LM_DBG("loading module %s\n", (yyvsp[-1].strval));
			if (ksr_load_module((yyvsp[-1].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9377 "core/cfg.tab.c"
    break;

  case 557: /* module_stm: LOADMODULE LPAREN STRING COMMA STRING RPAREN  */
#line 2151 "core/cfg.y"
                                                       {
		LM_DBG("loading module %s opts %s\n", (yyvsp[-3].strval), (yyvsp[-1].strval));
			if (ksr_load_module((yyvsp[-3].strval), (yyvsp[-1].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 9388 "core/cfg.tab.c"
    break;

  case 558: /* module_stm: LOADMODULE error  */
#line 2157 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9394 "core/cfg.tab.c"
    break;

  case 559: /* module_stm: LOADMODULEX STRING  */
#line 2158 "core/cfg.y"
                             {
		LM_DBG("loading module %s\n", (yyvsp[0].strval));
			if (ksr_load_modulex((yyvsp[0].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9405 "core/cfg.tab.c"
    break;

  case 560: /* module_stm: LOADMODULEX LPAREN STRING RPAREN  */
#line 2164 "core/cfg.y"
                                           {
		LM_DBG("loading module %s\n", (yyvsp[-1].strval));
			if (ksr_load_modulex((yyvsp[-1].strval), NULL)!=0) {
				yyerror("failed to load module");
			}
	}
#line 9416 "core/cfg.tab.c"
    break;

  case 561: /* module_stm: LOADMODULEX LPAREN STRING COMMA STRING RPAREN  */
#line 2170 "core/cfg.y"
                                                        {
		LM_DBG("loading module %s opts %s\n", (yyvsp[-3].strval), (yyvsp[-1].strval));
			if (ksr_load_modulex((yyvsp[-3].strval), (yyvsp[-1].strval))!=0) {
				yyerror("failed to load module");
			}
	}
#line 9427 "core/cfg.tab.c"
    break;

  case 562: /* module_stm: LOADMODULEX error  */
#line 2176 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9433 "core/cfg.tab.c"
    break;

  case 563: /* module_stm: LOADPATH STRING  */
#line 2177 "core/cfg.y"
                          {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 9448 "core/cfg.tab.c"
    break;

  case 564: /* module_stm: LOADPATH error  */
#line 2187 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9454 "core/cfg.tab.c"
    break;

  case 565: /* module_stm: LOADPATH EQUAL STRING  */
#line 2188 "core/cfg.y"
                                {
		if(mods_dir_cmd==0) {
			LM_DBG("loading modules under %s\n", (yyvsp[0].strval));
			printf("loading modules under config path: %s\n", (yyvsp[0].strval));
			mods_dir = (yyvsp[0].strval);
		} else {
			LM_DBG("ignoring mod path given in config: %s\n", (yyvsp[0].strval));
			printf("loading modules under command line path: %s\n", mods_dir);
		}
	}
#line 9469 "core/cfg.tab.c"
    break;

  case 566: /* module_stm: LOADPATH EQUAL error  */
#line 2198 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9475 "core/cfg.tab.c"
    break;

  case 567: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2199 "core/cfg.y"
                                                                  {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9489 "core/cfg.tab.c"
    break;

  case 568: /* module_stm: MODPARAM LPAREN STRING COMMA STRING COMMA intno RPAREN  */
#line 2208 "core/cfg.y"
                                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (set_mod_param_regex((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9503 "core/cfg.tab.c"
    break;

  case 569: /* module_stm: MODPARAM error  */
#line 2217 "core/cfg.y"
                         { yyerror("Invalid arguments"); }
#line 9509 "core/cfg.tab.c"
    break;

  case 570: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA STRING RPAREN  */
#line 2218 "core/cfg.y"
                                                                   {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_STRING, (yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9523 "core/cfg.tab.c"
    break;

  case 571: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA intno RPAREN  */
#line 2227 "core/cfg.y"
                                                                  {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_INT, (void*)(yyvsp[-1].intval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9537 "core/cfg.tab.c"
    break;

  case 572: /* module_stm: MODPARAMX LPAREN STRING COMMA STRING COMMA PVAR RPAREN  */
#line 2236 "core/cfg.y"
                                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (modparamx_set((yyvsp[-5].strval), (yyvsp[-3].strval), PARAM_VAR, (void*)(yyvsp[-1].strval)) != 0) {
			 yyerror("Can't set module parameter");
		}
	}
#line 9551 "core/cfg.tab.c"
    break;

  case 573: /* module_stm: MODPARAMX error  */
#line 2245 "core/cfg.y"
                          { yyerror("Invalid arguments"); }
#line 9557 "core/cfg.tab.c"
    break;

  case 574: /* module_stm: CFGENGINE STRING  */
#line 2246 "core/cfg.y"
                           {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9568 "core/cfg.tab.c"
    break;

  case 575: /* module_stm: CFGENGINE error  */
#line 2252 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9574 "core/cfg.tab.c"
    break;

  case 576: /* module_stm: CFGENGINE EQUAL STRING  */
#line 2253 "core/cfg.y"
                                 {
		if(sr_kemi_eng_setz((yyvsp[0].strval), NULL)) {
			yyerror("Can't set config routing engine");
			YYABORT;
		}
	}
#line 9585 "core/cfg.tab.c"
    break;

  case 577: /* module_stm: CFGENGINE EQUAL error  */
#line 2259 "core/cfg.y"
                                { yyerror("string expected"); }
#line 9591 "core/cfg.tab.c"
    break;

  case 578: /* ip: ipv4  */
#line 2263 "core/cfg.y"
              { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9597 "core/cfg.tab.c"
    break;

  case 579: /* ip: ipv6  */
#line 2264 "core/cfg.y"
                { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9603 "core/cfg.tab.c"
    break;

  case 580: /* ipv4: NUMBER DOT NUMBER DOT NUMBER DOT NUMBER  */
#line 2267 "core/cfg.y"
                                                {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET;
			(yyval.ipaddr)->len=4;
			if (((yyvsp[-6].intval)>255) || ((yyvsp[-6].intval)<0) ||
				((yyvsp[-4].intval)>255) || ((yyvsp[-4].intval)<0) ||
				((yyvsp[-2].intval)>255) || ((yyvsp[-2].intval)<0) ||
				((yyvsp[0].intval)>255) || ((yyvsp[0].intval)<0)) {
				yyerror("invalid ipv4 address");
				(yyval.ipaddr)->u.addr32[0]=0;
				/* $$=0; */
			} else {
				(yyval.ipaddr)->u.addr[0]=(yyvsp[-6].intval);
				(yyval.ipaddr)->u.addr[1]=(yyvsp[-4].intval);
				(yyval.ipaddr)->u.addr[2]=(yyvsp[-2].intval);
				(yyval.ipaddr)->u.addr[3]=(yyvsp[0].intval);
				/*
				$$=htonl( ($1<<24)|
				($3<<16)| ($5<<8)|$7 );
				*/
			}
		}
	}
#line 9635 "core/cfg.tab.c"
    break;

  case 581: /* ipv6addr: IPV6ADDR  */
#line 2296 "core/cfg.y"
                 {
		(yyval.ipaddr)=pkg_malloc(sizeof(struct ip_addr));
		if ((yyval.ipaddr)==0) {
			PKG_MEM_CRITICAL;
		} else {
			memset((yyval.ipaddr), 0, sizeof(struct ip_addr));
			(yyval.ipaddr)->af=AF_INET6;
			(yyval.ipaddr)->len=16;
			if (inet_pton(AF_INET6, (yyvsp[0].strval), (yyval.ipaddr)->u.addr)<=0) {
				yyerror("bad ipv6 address");
			}
		}
	}
#line 9653 "core/cfg.tab.c"
    break;

  case 582: /* ipv6: ipv6addr  */
#line 2311 "core/cfg.y"
                 { (yyval.ipaddr)=(yyvsp[0].ipaddr); }
#line 9659 "core/cfg.tab.c"
    break;

  case 583: /* ipv6: LBRACK ipv6addr RBRACK  */
#line 2312 "core/cfg.y"
                                 {(yyval.ipaddr)=(yyvsp[-1].ipaddr); }
#line 9665 "core/cfg.tab.c"
    break;

  case 584: /* route_name: NUMBER  */
#line 2316 "core/cfg.y"
                                {
					tmp=int2str((yyvsp[0].intval), &i_tmp);
					if (((yyval.strval)=pkg_malloc(i_tmp+1))==0) {
						yyerror("out of  memory");
						YYABORT;
					} else {
						memcpy((yyval.strval), tmp, i_tmp);
						(yyval.strval)[i_tmp]=0;
					}
					routename = tmp;
						}
#line 9681 "core/cfg.tab.c"
    break;

  case 585: /* route_name: ID  */
#line 2327 "core/cfg.y"
                                                { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9687 "core/cfg.tab.c"
    break;

  case 586: /* route_name: STRING  */
#line 2328 "core/cfg.y"
                                        { routename = (yyvsp[0].strval); (yyval.strval)=(yyvsp[0].strval); }
#line 9693 "core/cfg.tab.c"
    break;

  case 587: /* route_main: ROUTE  */
#line 2332 "core/cfg.y"
                      { routename=NULL; }
#line 9699 "core/cfg.tab.c"
    break;

  case 588: /* route_main: ROUTE_REQUEST  */
#line 2333 "core/cfg.y"
                                  { routename=NULL; }
#line 9705 "core/cfg.tab.c"
    break;

  case 589: /* route_stm: route_main LBRACE actions RBRACE  */
#line 2337 "core/cfg.y"
                                         {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[DEFAULT_RT]);
	}
#line 9717 "core/cfg.tab.c"
    break;

  case 590: /* route_stm: ROUTE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2344 "core/cfg.y"
                                                               {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&main_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (main_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &main_rt.rlist[i_tmp]);
	}
#line 9738 "core/cfg.tab.c"
    break;

  case 591: /* route_stm: ROUTE error  */
#line 2360 "core/cfg.y"
                      { yyerror("invalid  route  statement"); }
#line 9744 "core/cfg.tab.c"
    break;

  case 592: /* route_stm: ROUTE_REQUEST error  */
#line 2361 "core/cfg.y"
                              { yyerror("invalid  request_route  statement"); }
#line 9750 "core/cfg.tab.c"
    break;

  case 593: /* failure_route_main: ROUTE_FAILURE  */
#line 2364 "core/cfg.y"
                                  { routename=NULL; }
#line 9756 "core/cfg.tab.c"
    break;

  case 594: /* failure_route_stm: failure_route_main LBRACE actions RBRACE  */
#line 2367 "core/cfg.y"
                                                 {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[DEFAULT_RT]);
	}
#line 9768 "core/cfg.tab.c"
    break;

  case 595: /* failure_route_stm: ROUTE_FAILURE LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2374 "core/cfg.y"
                                                                       {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&failure_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (failure_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &failure_rt.rlist[i_tmp]);
	}
#line 9789 "core/cfg.tab.c"
    break;

  case 596: /* failure_route_stm: ROUTE_FAILURE error  */
#line 2390 "core/cfg.y"
                              { yyerror("invalid failure_route statement"); }
#line 9795 "core/cfg.tab.c"
    break;

  case 597: /* route_reply_main: ROUTE_ONREPLY  */
#line 2394 "core/cfg.y"
                                      { routename=NULL; }
#line 9801 "core/cfg.tab.c"
    break;

  case 598: /* route_reply_main: ROUTE_REPLY  */
#line 2395 "core/cfg.y"
                                { routename=NULL; }
#line 9807 "core/cfg.tab.c"
    break;

  case 599: /* $@7: %empty  */
#line 2400 "core/cfg.y"
                                {rt=CORE_ONREPLY_ROUTE;}
#line 9813 "core/cfg.tab.c"
    break;

  case 600: /* onreply_route_stm: route_reply_main LBRACE $@7 actions RBRACE  */
#line 2400 "core/cfg.y"
                                                                        {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
	}
#line 9825 "core/cfg.tab.c"
    break;

  case 601: /* onreply_route_stm: ROUTE_ONREPLY error  */
#line 2407 "core/cfg.y"
                              { yyerror("invalid onreply_route statement"); }
#line 9831 "core/cfg.tab.c"
    break;

  case 602: /* onreply_route_stm: ROUTE_REPLY error  */
#line 2408 "core/cfg.y"
                            { yyerror("invalid onreply_route statement"); }
#line 9837 "core/cfg.tab.c"
    break;

  case 603: /* $@8: %empty  */
#line 2410 "core/cfg.y"
                {rt=(*(yyvsp[-1].strval)=='0' && (yyvsp[-1].strval)[1]==0)?CORE_ONREPLY_ROUTE:TM_ONREPLY_ROUTE;}
#line 9843 "core/cfg.tab.c"
    break;

  case 604: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK $@8 LBRACE actions RBRACE  */
#line 2411 "core/cfg.y"
                                      {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		if (*(yyvsp[-5].strval)=='0' && (yyvsp[-5].strval)[1]==0){
			/* onreply_route[0] {} is equivalent with onreply_route {}*/
			push((yyvsp[-1].action), &onreply_rt.rlist[DEFAULT_RT]);
		}else{
			i_tmp=route_get(&onreply_rt, (yyvsp[-5].strval));
			if (i_tmp==-1){
				yyerror("internal error");
				YYABORT;
			}
			if (onreply_rt.rlist[i_tmp]){
				yyerror("duplicate route");
				YYABORT;
			}
			push((yyvsp[-1].action), &onreply_rt.rlist[i_tmp]);
		}
	}
#line 9869 "core/cfg.tab.c"
    break;

  case 605: /* onreply_route_stm: ROUTE_ONREPLY LBRACK route_name RBRACK error  */
#line 2432 "core/cfg.y"
                                                       {
		yyerror("invalid onreply_route statement");
	}
#line 9877 "core/cfg.tab.c"
    break;

  case 606: /* branch_route_main: ROUTE_BRANCH  */
#line 2437 "core/cfg.y"
                                { routename=NULL; }
#line 9883 "core/cfg.tab.c"
    break;

  case 607: /* branch_route_stm: branch_route_main LBRACE actions RBRACE  */
#line 2440 "core/cfg.y"
                                                {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[DEFAULT_RT]);
	}
#line 9895 "core/cfg.tab.c"
    break;

  case 608: /* branch_route_stm: ROUTE_BRANCH LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2447 "core/cfg.y"
                                                                      {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&branch_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (branch_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &branch_rt.rlist[i_tmp]);
	}
#line 9916 "core/cfg.tab.c"
    break;

  case 609: /* branch_route_stm: ROUTE_BRANCH error  */
#line 2463 "core/cfg.y"
                             { yyerror("invalid branch_route statement"); }
#line 9922 "core/cfg.tab.c"
    break;

  case 610: /* send_route_main: ROUTE_SEND  */
#line 2466 "core/cfg.y"
                            { routename=NULL; }
#line 9928 "core/cfg.tab.c"
    break;

  case 611: /* send_route_stm: send_route_main LBRACE actions RBRACE  */
#line 2469 "core/cfg.y"
                                              {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[DEFAULT_RT]);
	}
#line 9940 "core/cfg.tab.c"
    break;

  case 612: /* send_route_stm: ROUTE_SEND LBRACK route_name RBRACK LBRACE actions RBRACE  */
#line 2476 "core/cfg.y"
                                                                    {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&onsend_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (onsend_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &onsend_rt.rlist[i_tmp]);
	}
#line 9961 "core/cfg.tab.c"
    break;

  case 613: /* send_route_stm: ROUTE_SEND error  */
#line 2492 "core/cfg.y"
                           { yyerror("invalid onsend_route statement"); }
#line 9967 "core/cfg.tab.c"
    break;

  case 614: /* event_route_main: ROUTE_EVENT  */
#line 2495 "core/cfg.y"
                              { routename=NULL; }
#line 9973 "core/cfg.tab.c"
    break;

  case 615: /* event_route_stm: event_route_main LBRACK EVENT_RT_NAME RBRACK LBRACE actions RBRACE  */
#line 2498 "core/cfg.y"
                                                                           {
		if (!shm_initialized() && init_shm()<0) {
			yyerror("Can't initialize shared memory");
			YYABORT;
		}
		i_tmp=route_get(&event_rt, (yyvsp[-4].strval));
		if (i_tmp==-1){
			yyerror("internal error");
			YYABORT;
		}
		if (event_rt.rlist[i_tmp]){
			yyerror("duplicate route");
			YYABORT;
		}
		push((yyvsp[-1].action), &event_rt.rlist[i_tmp]);
	}
#line 9994 "core/cfg.tab.c"
    break;

  case 616: /* event_route_stm: ROUTE_EVENT error  */
#line 2515 "core/cfg.y"
                            { yyerror("invalid event_route statement"); }
#line 10000 "core/cfg.tab.c"
    break;

  case 617: /* preprocess_stm: SUBST STRING  */
#line 2518 "core/cfg.y"
                     { if(pp_subst_add((yyvsp[0].strval))<0) YYERROR; }
#line 10006 "core/cfg.tab.c"
    break;

  case 618: /* preprocess_stm: SUBST error  */
#line 2519 "core/cfg.y"
                      { yyerror("invalid subst preprocess statement"); }
#line 10012 "core/cfg.tab.c"
    break;

  case 619: /* preprocess_stm: SUBSTDEF STRING  */
#line 2520 "core/cfg.y"
                          { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_NORMAL)<0) YYERROR; }
#line 10018 "core/cfg.tab.c"
    break;

  case 620: /* preprocess_stm: SUBSTDEF error  */
#line 2521 "core/cfg.y"
                         { yyerror("invalid substdef preprocess statement"); }
#line 10024 "core/cfg.tab.c"
    break;

  case 621: /* preprocess_stm: SUBSTDEFS STRING  */
#line 2522 "core/cfg.y"
                           { if(pp_substdef_add((yyvsp[0].strval), KSR_PPDEF_QUOTED)<0) YYERROR; }
#line 10030 "core/cfg.tab.c"
    break;

  case 622: /* preprocess_stm: SUBSTDEFS error  */
#line 2523 "core/cfg.y"
                          { yyerror("invalid substdefs preprocess statement"); }
#line 10036 "core/cfg.tab.c"
    break;

  case 623: /* equalop: EQUAL_T  */
#line 2545 "core/cfg.y"
                {(yyval.intval)=EQUAL_OP; }
#line 10042 "core/cfg.tab.c"
    break;

  case 624: /* equalop: DIFF  */
#line 2546 "core/cfg.y"
                {(yyval.intval)=DIFF_OP; }
#line 10048 "core/cfg.tab.c"
    break;

  case 625: /* equalop: STREQ  */
#line 2547 "core/cfg.y"
                {(yyval.intval)=EQUAL_OP; }
#line 10054 "core/cfg.tab.c"
    break;

  case 626: /* equalop: STRDIFF  */
#line 2548 "core/cfg.y"
                  {(yyval.intval)=DIFF_OP; }
#line 10060 "core/cfg.tab.c"
    break;

  case 627: /* cmpop: GT  */
#line 2551 "core/cfg.y"
                {(yyval.intval)=GT_OP; }
#line 10066 "core/cfg.tab.c"
    break;

  case 628: /* cmpop: LT  */
#line 2552 "core/cfg.y"
                {(yyval.intval)=LT_OP; }
#line 10072 "core/cfg.tab.c"
    break;

  case 629: /* cmpop: GTE  */
#line 2553 "core/cfg.y"
                {(yyval.intval)=GTE_OP; }
#line 10078 "core/cfg.tab.c"
    break;

  case 630: /* cmpop: LTE  */
#line 2554 "core/cfg.y"
                {(yyval.intval)=LTE_OP; }
#line 10084 "core/cfg.tab.c"
    break;

  case 631: /* strop: equalop  */
#line 2557 "core/cfg.y"
                {(yyval.intval)=(yyvsp[0].intval); }
#line 10090 "core/cfg.tab.c"
    break;

  case 632: /* strop: MATCH  */
#line 2558 "core/cfg.y"
                {(yyval.intval)=MATCH_OP; }
#line 10096 "core/cfg.tab.c"
    break;

  case 633: /* rve_equalop: EQUAL_T  */
#line 2564 "core/cfg.y"
                {(yyval.intval)=RVE_EQ_OP; }
#line 10102 "core/cfg.tab.c"
    break;

  case 634: /* rve_equalop: DIFF  */
#line 2565 "core/cfg.y"
                {(yyval.intval)=RVE_DIFF_OP; }
#line 10108 "core/cfg.tab.c"
    break;

  case 635: /* rve_equalop: INTEQ  */
#line 2566 "core/cfg.y"
                {(yyval.intval)=RVE_IEQ_OP; }
#line 10114 "core/cfg.tab.c"
    break;

  case 636: /* rve_equalop: INTDIFF  */
#line 2567 "core/cfg.y"
                  {(yyval.intval)=RVE_IDIFF_OP; }
#line 10120 "core/cfg.tab.c"
    break;

  case 637: /* rve_equalop: STREQ  */
#line 2568 "core/cfg.y"
                {(yyval.intval)=RVE_STREQ_OP; }
#line 10126 "core/cfg.tab.c"
    break;

  case 638: /* rve_equalop: STRDIFF  */
#line 2569 "core/cfg.y"
                  {(yyval.intval)=RVE_STRDIFF_OP; }
#line 10132 "core/cfg.tab.c"
    break;

  case 639: /* rve_equalop: MATCH  */
#line 2570 "core/cfg.y"
                {(yyval.intval)=RVE_MATCH_OP; }
#line 10138 "core/cfg.tab.c"
    break;

  case 640: /* rve_cmpop: GT  */
#line 2573 "core/cfg.y"
                {(yyval.intval)=RVE_GT_OP; }
#line 10144 "core/cfg.tab.c"
    break;

  case 641: /* rve_cmpop: LT  */
#line 2574 "core/cfg.y"
                {(yyval.intval)=RVE_LT_OP; }
#line 10150 "core/cfg.tab.c"
    break;

  case 642: /* rve_cmpop: GTE  */
#line 2575 "core/cfg.y"
                {(yyval.intval)=RVE_GTE_OP; }
#line 10156 "core/cfg.tab.c"
    break;

  case 643: /* rve_cmpop: LTE  */
#line 2576 "core/cfg.y"
                {(yyval.intval)=RVE_LTE_OP; }
#line 10162 "core/cfg.tab.c"
    break;

  case 644: /* uri_type: URI  */
#line 2583 "core/cfg.y"
                        {(yyval.intval)=URI_O;}
#line 10168 "core/cfg.tab.c"
    break;

  case 645: /* uri_type: FROM_URI  */
#line 2584 "core/cfg.y"
                        {(yyval.intval)=FROM_URI_O;}
#line 10174 "core/cfg.tab.c"
    break;

  case 646: /* uri_type: TO_URI  */
#line 2585 "core/cfg.y"
                        {(yyval.intval)=TO_URI_O;}
#line 10180 "core/cfg.tab.c"
    break;

  case 647: /* eint_op_onsend: SNDPORT  */
#line 2592 "core/cfg.y"
                                        { (yyval.intval)=SNDPORT_O; }
#line 10186 "core/cfg.tab.c"
    break;

  case 648: /* eint_op_onsend: TOPORT  */
#line 2593 "core/cfg.y"
                                        { (yyval.intval)=TOPORT_O; }
#line 10192 "core/cfg.tab.c"
    break;

  case 649: /* eint_op_onsend: SNDAF  */
#line 2594 "core/cfg.y"
                                        { (yyval.intval)=SNDAF_O; }
#line 10198 "core/cfg.tab.c"
    break;

  case 650: /* eint_op: SRCPORT  */
#line 2598 "core/cfg.y"
                                { (yyval.intval)=SRCPORT_O; }
#line 10204 "core/cfg.tab.c"
    break;

  case 651: /* eint_op: DSTPORT  */
#line 2599 "core/cfg.y"
                                        { (yyval.intval)=DSTPORT_O; }
#line 10210 "core/cfg.tab.c"
    break;

  case 652: /* eint_op: AF  */
#line 2600 "core/cfg.y"
                                                { (yyval.intval)=AF_O; }
#line 10216 "core/cfg.tab.c"
    break;

  case 653: /* eint_op: MSGLEN  */
#line 2601 "core/cfg.y"
                                        { (yyval.intval)=MSGLEN_O; }
#line 10222 "core/cfg.tab.c"
    break;

  case 655: /* eip_op_onsend: SNDIP  */
#line 2607 "core/cfg.y"
                                        { onsend_check("snd_ip"); (yyval.intval)=SNDIP_O; }
#line 10228 "core/cfg.tab.c"
    break;

  case 656: /* eip_op_onsend: TOIP  */
#line 2608 "core/cfg.y"
                                        { onsend_check("to_ip");  (yyval.intval)=TOIP_O; }
#line 10234 "core/cfg.tab.c"
    break;

  case 657: /* eip_op: SRCIP  */
#line 2611 "core/cfg.y"
                                { (yyval.intval)=SRCIP_O; }
#line 10240 "core/cfg.tab.c"
    break;

  case 658: /* eip_op: DSTIP  */
#line 2612 "core/cfg.y"
                                        { (yyval.intval)=DSTIP_O; }
#line 10246 "core/cfg.tab.c"
    break;

  case 660: /* exp_elem: METHOD strop rval_expr  */
#line 2620 "core/cfg.y"
                {(yyval.expr)= mk_elem((yyvsp[-1].intval), METHOD_O, 0, RVE_ST, (yyvsp[0].rv_expr));}
#line 10252 "core/cfg.tab.c"
    break;

  case 661: /* exp_elem: METHOD strop ID  */
#line 2622 "core/cfg.y"
                {(yyval.expr) = mk_elem((yyvsp[-1].intval), METHOD_O, 0, STRING_ST,(yyvsp[0].strval)); }
#line 10258 "core/cfg.tab.c"
    break;

  case 662: /* exp_elem: METHOD strop error  */
#line 2623 "core/cfg.y"
                             { (yyval.expr)=0; yyerror("string expected"); }
#line 10264 "core/cfg.tab.c"
    break;

  case 663: /* exp_elem: METHOD error  */
#line 2625 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator,== , !=, or =~ expected"); }
#line 10270 "core/cfg.tab.c"
    break;

  case 664: /* exp_elem: uri_type strop rval_expr  */
#line 2627 "core/cfg.y"
                {(yyval.expr) = mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr)); }
#line 10276 "core/cfg.tab.c"
    break;

  case 665: /* exp_elem: uri_type strop MYSELF  */
#line 2629 "core/cfg.y"
                {(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 10282 "core/cfg.tab.c"
    break;

  case 666: /* exp_elem: uri_type strop error  */
#line 2631 "core/cfg.y"
                { (yyval.expr)=0; yyerror("string or MYSELF expected"); }
#line 10288 "core/cfg.tab.c"
    break;

  case 667: /* exp_elem: uri_type error  */
#line 2633 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator, == , != or =~ expected"); }
#line 10294 "core/cfg.tab.c"
    break;

  case 668: /* exp_elem: eint_op cmpop rval_expr  */
#line 2634 "core/cfg.y"
                                           { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10300 "core/cfg.tab.c"
    break;

  case 669: /* exp_elem: eint_op equalop rval_expr  */
#line 2636 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10306 "core/cfg.tab.c"
    break;

  case 670: /* exp_elem: eint_op cmpop error  */
#line 2637 "core/cfg.y"
                                { (yyval.expr)=0; yyerror("number expected"); }
#line 10312 "core/cfg.tab.c"
    break;

  case 671: /* exp_elem: eint_op equalop error  */
#line 2638 "core/cfg.y"
                                { (yyval.expr)=0; yyerror("number expected"); }
#line 10318 "core/cfg.tab.c"
    break;

  case 672: /* exp_elem: eint_op error  */
#line 2639 "core/cfg.y"
                        { (yyval.expr)=0; yyerror("==, !=, <,>, >= or <=  expected"); }
#line 10324 "core/cfg.tab.c"
    break;

  case 673: /* exp_elem: PROTO equalop eqproto  */
#line 2641 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 10330 "core/cfg.tab.c"
    break;

  case 674: /* exp_elem: PROTO equalop rval_expr  */
#line 2643 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), PROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10336 "core/cfg.tab.c"
    break;

  case 675: /* exp_elem: PROTO equalop error  */
#line 2645 "core/cfg.y"
                { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 10342 "core/cfg.tab.c"
    break;

  case 676: /* exp_elem: SNDPROTO equalop eqproto  */
#line 2647 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, NUMBER_ST, (void*)(yyvsp[0].intval) ); }
#line 10348 "core/cfg.tab.c"
    break;

  case 677: /* exp_elem: SNDPROTO equalop rval_expr  */
#line 2649 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), SNDPROTO_O, 0, RVE_ST, (yyvsp[0].rv_expr) ); }
#line 10354 "core/cfg.tab.c"
    break;

  case 678: /* exp_elem: SNDPROTO equalop error  */
#line 2651 "core/cfg.y"
                { (yyval.expr)=0; yyerror("protocol expected (udp, tcp, tls, sctp, ws, or wss)"); }
#line 10360 "core/cfg.tab.c"
    break;

  case 679: /* exp_elem: eip_op strop ipnet  */
#line 2652 "core/cfg.y"
                                           { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST, (yyvsp[0].ipnet)); }
#line 10366 "core/cfg.tab.c"
    break;

  case 680: /* exp_elem: eip_op strop rval_expr  */
#line 2653 "core/cfg.y"
                                               {
			s_tmp.s=0;
			(yyval.expr)=0;
			if (rve_is_constant((yyvsp[0].rv_expr))){
				i_tmp=rve_guess_type((yyvsp[0].rv_expr));
				if (i_tmp==RV_LONG)
					yyerror("string expected");
				else if (i_tmp==RV_STR){
					if (((rval_tmp=rval_expr_eval(0, 0, (yyvsp[0].rv_expr)))==0) ||
								(rval_get_str(0, 0, &s_tmp, rval_tmp, 0)<0)){
						rval_destroy(rval_tmp);
						yyerror("bad rvalue expression");
					}else{
						rval_destroy(rval_tmp);
					}
				}else{
					yyerror("BUG: unexpected dynamic type");
				}
			}else{
					/* warn("non constant rvalue in ip comparison") */;
			}
			if (s_tmp.s){
				ip_tmp=str2ip(&s_tmp);
				if (ip_tmp==0)
					ip_tmp=str2ip6(&s_tmp);
				pkg_free(s_tmp.s);
				if (ip_tmp) {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, NET_ST,
								mk_new_net_bitlen(ip_tmp, ip_tmp->len*8) );
				} else {
					(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
				}
			}else{
				(yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, RVE_ST, (yyvsp[0].rv_expr));
			}
		}
#line 10407 "core/cfg.tab.c"
    break;

  case 681: /* exp_elem: eip_op strop host  */
#line 2690 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, STRING_ST, (yyvsp[0].strval)); }
#line 10413 "core/cfg.tab.c"
    break;

  case 682: /* exp_elem: eip_op strop MYSELF  */
#line 2692 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[-2].intval), 0, MYSELF_ST, 0); }
#line 10419 "core/cfg.tab.c"
    break;

  case 683: /* exp_elem: eip_op strop error  */
#line 2694 "core/cfg.y"
                { (yyval.expr)=0; yyerror( "ip address or hostname expected" ); }
#line 10425 "core/cfg.tab.c"
    break;

  case 684: /* exp_elem: eip_op error  */
#line 2696 "core/cfg.y"
                { (yyval.expr)=0; yyerror("invalid operator, ==, != or =~ expected");}
#line 10431 "core/cfg.tab.c"
    break;

  case 685: /* exp_elem: MYSELF equalop uri_type  */
#line 2699 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 10437 "core/cfg.tab.c"
    break;

  case 686: /* exp_elem: MYSELF equalop eip_op  */
#line 2701 "core/cfg.y"
                { (yyval.expr)=mk_elem((yyvsp[-1].intval), (yyvsp[0].intval), 0, MYSELF_ST, 0); }
#line 10443 "core/cfg.tab.c"
    break;

  case 687: /* exp_elem: MYSELF equalop error  */
#line 2703 "core/cfg.y"
                { (yyval.expr)=0; yyerror("URI, SRCIP or DSTIP expected"); }
#line 10449 "core/cfg.tab.c"
    break;

  case 688: /* exp_elem: MYSELF error  */
#line 2704 "core/cfg.y"
                        { (yyval.expr)=0; yyerror ("invalid operator, == or != expected"); }
#line 10455 "core/cfg.tab.c"
    break;

  case 689: /* ipnet: ip SLASH ip  */
#line 2708 "core/cfg.y"
                        { (yyval.ipnet)=mk_new_net((yyvsp[-2].ipaddr), (yyvsp[0].ipaddr)); }
#line 10461 "core/cfg.tab.c"
    break;

  case 690: /* ipnet: ip SLASH NUMBER  */
#line 2709 "core/cfg.y"
                          {
		if (((yyvsp[0].intval)<0) || ((yyvsp[0].intval)>(yyvsp[-2].ipaddr)->len*8)) {
			yyerror("invalid bit number in netmask");
			(yyval.ipnet)=0;
		} else {
			(yyval.ipnet)=mk_new_net_bitlen((yyvsp[-2].ipaddr), (yyvsp[0].intval));
		/*
			$$=mk_new_net($1, htonl( ($3)?~( (1<<(32-$3))-1 ):0 ) );
		*/
		}
	}
#line 10477 "core/cfg.tab.c"
    break;

  case 691: /* ipnet: ip  */
#line 2720 "core/cfg.y"
                { (yyval.ipnet)=mk_new_net_bitlen((yyvsp[0].ipaddr), (yyvsp[0].ipaddr)->len*8); }
#line 10483 "core/cfg.tab.c"
    break;

  case 692: /* ipnet: ip SLASH error  */
#line 2721 "core/cfg.y"
                         { (yyval.ipnet)=0; yyerror("netmask (eg:255.0.0.0 or 8) expected"); }
#line 10489 "core/cfg.tab.c"
    break;

  case 693: /* host: ID  */
#line 2725 "core/cfg.y"
           { (yyval.strval)=(yyvsp[0].strval); }
#line 10495 "core/cfg.tab.c"
    break;

  case 694: /* host: host DOT ID  */
#line 2726 "core/cfg.y"
                      {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10515 "core/cfg.tab.c"
    break;

  case 695: /* host: host MINUS ID  */
#line 2741 "core/cfg.y"
                        {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10535 "core/cfg.tab.c"
    break;

  case 696: /* host: host DOT error  */
#line 2756 "core/cfg.y"
                         { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10541 "core/cfg.tab.c"
    break;

  case 697: /* host: host MINUS error  */
#line 2757 "core/cfg.y"
                           { (yyval.strval)=0; pkg_free((yyvsp[-2].strval)); yyerror("invalid hostname"); }
#line 10547 "core/cfg.tab.c"
    break;

  case 700: /* host_if_id: NUMBER  */
#line 2762 "core/cfg.y"
                         {
			/* get string version */
			i_tmp = strlen(yy_number_str);
			(yyval.strval)=pkg_malloc(i_tmp + 1);
			if ((yyval.strval)==0) {
				PKG_MEM_ERROR;
			} else {
				memcpy((yyval.strval), yy_number_str, i_tmp);
				(yyval.strval)[i_tmp] = '\0';
			}
		}
#line 10563 "core/cfg.tab.c"
    break;

  case 701: /* host_or_if: host_if_id  */
#line 2776 "core/cfg.y"
                   { (yyval.strval)=(yyvsp[0].strval); }
#line 10569 "core/cfg.tab.c"
    break;

  case 702: /* host_or_if: host_or_if DOT host_if_id  */
#line 2777 "core/cfg.y"
                                    {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='.';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10589 "core/cfg.tab.c"
    break;

  case 703: /* host_or_if: host_or_if MINUS host_if_id  */
#line 2792 "core/cfg.y"
                                      {
		if ((yyvsp[-2].strval)){
			(yyval.strval)=(char*)pkg_malloc(strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))+1);
			if ((yyval.strval)==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy((yyval.strval), (yyvsp[-2].strval), strlen((yyvsp[-2].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))]='-';
				memcpy((yyval.strval)+strlen((yyvsp[-2].strval))+1, (yyvsp[0].strval), strlen((yyvsp[0].strval)));
				(yyval.strval)[strlen((yyvsp[-2].strval))+1+strlen((yyvsp[0].strval))]=0;
			}
			pkg_free((yyvsp[-2].strval));
		}
		if ((yyvsp[0].strval)) pkg_free((yyvsp[0].strval));
	}
#line 10609 "core/cfg.tab.c"
    break;

  case 704: /* host_or_if: host_or_if DOT error  */
#line 2807 "core/cfg.y"
                               { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10616 "core/cfg.tab.c"
    break;

  case 705: /* host_or_if: host_or_if MINUS error  */
#line 2809 "core/cfg.y"
                                 { (yyval.strval)=0; pkg_free((yyvsp[-2].strval));
								yyerror("invalid host or interface name"); }
#line 10623 "core/cfg.tab.c"
    break;

  case 706: /* fcmd: cmd  */
#line 2816 "core/cfg.y"
            {
		/* check if allowed */
		if ((yyvsp[0].action) && rt==ONSEND_ROUTE) {
			switch((yyvsp[0].action)->type) {
				case DROP_T:
				case LOG_T:
				case SETFLAG_T:
				case RESETFLAG_T:
				case ISFLAGSET_T:
				case IF_T:
				case MODULE0_T:
				case MODULE1_T:
				case MODULE2_T:
				case MODULE3_T:
				case MODULE4_T:
				case MODULE5_T:
				case MODULE6_T:
				case MODULEX_T:
				case SET_FWD_NO_CONNECT_T:
				case SET_RPL_NO_CONNECT_T:
				case SET_FWD_CLOSE_T:
				case SET_RPL_CLOSE_T:
					(yyval.action)=(yyvsp[0].action);
					break;
				default:
					(yyval.action)=0;
					yyerror("command not allowed in onsend_route\n");
			}
		} else {
			(yyval.action)=(yyvsp[0].action);
		}
	}
#line 10660 "core/cfg.tab.c"
    break;

  case 707: /* stm: action  */
#line 2858 "core/cfg.y"
                { (yyval.action)=(yyvsp[0].action); }
#line 10666 "core/cfg.tab.c"
    break;

  case 708: /* stm: LBRACE actions RBRACE  */
#line 2859 "core/cfg.y"
                                { (yyval.action)=(yyvsp[-1].action); }
#line 10672 "core/cfg.tab.c"
    break;

  case 709: /* actions: actions action  */
#line 2862 "core/cfg.y"
                        {(yyval.action)=append_action((yyvsp[-1].action), (yyvsp[0].action)); }
#line 10678 "core/cfg.tab.c"
    break;

  case 710: /* actions: action  */
#line 2863 "core/cfg.y"
                        {(yyval.action)=(yyvsp[0].action);}
#line 10684 "core/cfg.tab.c"
    break;

  case 711: /* actions: actions error  */
#line 2864 "core/cfg.y"
                        { (yyval.action)=0; yyerror("bad command"); }
#line 10690 "core/cfg.tab.c"
    break;

  case 712: /* action: fcmd SEMICOLON  */
#line 2867 "core/cfg.y"
                       {(yyval.action)=(yyvsp[-1].action);}
#line 10696 "core/cfg.tab.c"
    break;

  case 713: /* action: if_cmd  */
#line 2868 "core/cfg.y"
                 {(yyval.action)=(yyvsp[0].action);}
#line 10702 "core/cfg.tab.c"
    break;

  case 714: /* action: switch_cmd  */
#line 2869 "core/cfg.y"
                     {(yyval.action)=(yyvsp[0].action);}
#line 10708 "core/cfg.tab.c"
    break;

  case 715: /* action: while_cmd  */
#line 2870 "core/cfg.y"
                    { (yyval.action)=(yyvsp[0].action); }
#line 10714 "core/cfg.tab.c"
    break;

  case 716: /* action: ret_cmd SEMICOLON  */
#line 2871 "core/cfg.y"
                            { (yyval.action)=(yyvsp[-1].action); }
#line 10720 "core/cfg.tab.c"
    break;

  case 717: /* action: assign_action SEMICOLON  */
#line 2872 "core/cfg.y"
                                  {(yyval.action)=(yyvsp[-1].action);}
#line 10726 "core/cfg.tab.c"
    break;

  case 718: /* action: SEMICOLON  */
#line 2873 "core/cfg.y"
                                      {(yyval.action)=0;}
#line 10732 "core/cfg.tab.c"
    break;

  case 719: /* action: fcmd error  */
#line 2874 "core/cfg.y"
                     { (yyval.action)=0; yyerror("bad command: missing ';'?"); }
#line 10738 "core/cfg.tab.c"
    break;

  case 720: /* if_cmd: IF rval_expr stm  */
#line 2877 "core/cfg.y"
                                {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action), NOSUBTYPE, 0);
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10751 "core/cfg.tab.c"
    break;

  case 721: /* if_cmd: IF rval_expr stm ELSE stm  */
#line 2885 "core/cfg.y"
                                        {
		if ((yyvsp[-3].rv_expr) && rval_expr_int_check((yyvsp[-3].rv_expr))>=0){
			warn_ct_rve((yyvsp[-3].rv_expr), "if");
			(yyval.action)=mk_action( IF_T, 3, RVE_ST, (yyvsp[-3].rv_expr), ACTIONS_ST, (yyvsp[-2].action), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else
			YYERROR;
	}
#line 10764 "core/cfg.tab.c"
    break;

  case 722: /* ct_rval: rval_expr  */
#line 2895 "core/cfg.y"
                   {
			(yyval.rv_expr)=0;
			if ((yyvsp[0].rv_expr) && !rve_is_constant((yyvsp[0].rv_expr))){
				yyerror("constant expected");
				YYERROR;
			/*
			} else if ($1 &&
						!rve_check_type((enum rval_type*)&i_tmp, $1, 0, 0 ,0)){
				yyerror("invalid expression (bad type)");
			}else if ($1 && i_tmp!=RV_LONG){
				yyerror("invalid expression type, int expected\n");
			*/
			}else
				(yyval.rv_expr)=(yyvsp[0].rv_expr);
		}
#line 10784 "core/cfg.tab.c"
    break;

  case 723: /* single_case: CASE ct_rval COLON actions  */
#line 2912 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10796 "core/cfg.tab.c"
    break;

  case 724: /* single_case: CASE SLASH ct_rval COLON actions  */
#line 2919 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-2].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-2].rv_expr), 1, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10808 "core/cfg.tab.c"
    break;

  case 725: /* single_case: CASE ct_rval COLON  */
#line 2926 "core/cfg.y"
                             {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10820 "core/cfg.tab.c"
    break;

  case 726: /* single_case: CASE SLASH ct_rval COLON  */
#line 2933 "core/cfg.y"
                                   {
		(yyval.case_stms)=0;
		if ((yyvsp[-1].rv_expr)==0) { yyerror ("bad regex case label"); YYERROR; }
		else if ((((yyval.case_stms)=mk_case_stm((yyvsp[-1].rv_expr), 1, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10832 "core/cfg.tab.c"
    break;

  case 727: /* single_case: DEFAULT COLON actions  */
#line 2940 "core/cfg.y"
                                {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, (yyvsp[0].action), &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10842 "core/cfg.tab.c"
    break;

  case 728: /* single_case: DEFAULT COLON  */
#line 2945 "core/cfg.y"
                        {
		if ((((yyval.case_stms)=mk_case_stm(0, 0, 0, &i_tmp))==0) && (i_tmp==-10)){
				YYABORT;
		}
	}
#line 10852 "core/cfg.tab.c"
    break;

  case 729: /* single_case: CASE error COLON actions  */
#line 2950 "core/cfg.y"
                                   { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10858 "core/cfg.tab.c"
    break;

  case 730: /* single_case: CASE SLASH error COLON actions  */
#line 2951 "core/cfg.y"
                                         { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10864 "core/cfg.tab.c"
    break;

  case 731: /* single_case: CASE error COLON  */
#line 2952 "core/cfg.y"
                           { (yyval.case_stms)=0; yyerror("bad case label"); }
#line 10870 "core/cfg.tab.c"
    break;

  case 732: /* single_case: CASE SLASH error COLON  */
#line 2953 "core/cfg.y"
                                 { (yyval.case_stms)=0; yyerror("bad case regex label"); }
#line 10876 "core/cfg.tab.c"
    break;

  case 733: /* single_case: CASE ct_rval COLON error  */
#line 2954 "core/cfg.y"
                                   { (yyval.case_stms)=0; yyerror ("bad case body"); }
#line 10882 "core/cfg.tab.c"
    break;

  case 734: /* case_stms: case_stms single_case  */
#line 2957 "core/cfg.y"
                              {
		(yyval.case_stms)=(yyvsp[-1].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		if ((yyval.case_stms)){
			*((yyval.case_stms)->append)=(yyvsp[0].case_stms);
			if (*((yyval.case_stms)->append)!=0)
				(yyval.case_stms)->append=&((*((yyval.case_stms)->append))->next);
		}
	}
#line 10896 "core/cfg.tab.c"
    break;

  case 735: /* case_stms: single_case  */
#line 2966 "core/cfg.y"
                      {
		(yyval.case_stms)=(yyvsp[0].case_stms);
		if ((yyvsp[0].case_stms)==0) yyerror ("bad case");
		else (yyval.case_stms)->append=&((yyval.case_stms)->next);
	}
#line 10906 "core/cfg.tab.c"
    break;

  case 736: /* switch_cmd: SWITCH rval_expr LBRACE case_stms RBRACE  */
#line 2973 "core/cfg.y"
                                                   {
		(yyval.action)=0;
		if ((yyvsp[-3].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else if ((yyvsp[-1].case_stms)==0){
			yyerror ("bad switch body");
			YYERROR;
		}else if (case_check_default((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): too many "
							"\"default:\" labels\n");
			YYERROR;
		}else if (case_check_type((yyvsp[-1].case_stms))!=0){
			yyerror_at(&(yyvsp[-3].rv_expr)->fpos, "bad switch(): mixed integer and"
							" string/RE cases not allowed\n");
			YYERROR;
		}else{
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-3].rv_expr), CASE_ST, (yyvsp[-1].case_stms));
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10936 "core/cfg.tab.c"
    break;

  case 737: /* switch_cmd: SWITCH rval_expr LBRACE RBRACE  */
#line 2998 "core/cfg.y"
                                         {
		(yyval.action)=0;
		warn("empty switch()");
		if ((yyvsp[-2].rv_expr)==0){
			yyerror("bad expression in switch(...)");
			YYERROR;
		}else{
			/* it might have sideffects, so leave it for the optimizer */
			(yyval.action)=mk_action(SWITCH_T, 2, RVE_ST, (yyvsp[-2].rv_expr), CASE_ST, 0);
			if ((yyval.action)==0) {
				yyerror("internal error");
				YYABORT;
			}
			set_cfg_pos((yyval.action));
		}
	}
#line 10957 "core/cfg.tab.c"
    break;

  case 738: /* switch_cmd: SWITCH error  */
#line 3014 "core/cfg.y"
                       { (yyval.action)=0; yyerror ("bad expression in switch(...)"); }
#line 10963 "core/cfg.tab.c"
    break;

  case 739: /* switch_cmd: SWITCH rval_expr LBRACE error RBRACE  */
#line 3016 "core/cfg.y"
                {(yyval.action)=0; yyerror ("bad switch body"); }
#line 10969 "core/cfg.tab.c"
    break;

  case 740: /* while_cmd: WHILE rval_expr stm  */
#line 3020 "core/cfg.y"
                            {
		if ((yyvsp[-1].rv_expr) && rval_expr_int_check((yyvsp[-1].rv_expr))>=0){
			warn_ct_rve((yyvsp[-1].rv_expr), "while");
			(yyval.action)=mk_action( WHILE_T, 2, RVE_ST, (yyvsp[-1].rv_expr), ACTIONS_ST, (yyvsp[0].action));
			set_cfg_pos((yyval.action));
		}else{
			yyerror_at(&(yyvsp[-1].rv_expr)->fpos, "bad while(...) expression");
			YYERROR;
		}
	}
#line 10984 "core/cfg.tab.c"
    break;

  case 741: /* select_param: ID  */
#line 3039 "core/cfg.y"
           {
		if (sel.n >= MAX_SELECT_PARAMS-1) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[0].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[0].strval));
		sel.n++;
	}
#line 10998 "core/cfg.tab.c"
    break;

  case 742: /* select_param: ID LBRACK intno RBRACK  */
#line 3048 "core/cfg.y"
                                 {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_INT;
		sel.params[sel.n].v.i = (yyvsp[-1].intval);
		sel.n++;
	}
#line 11015 "core/cfg.tab.c"
    break;

  case 743: /* select_param: ID LBRACK STRING RBRACK  */
#line 3060 "core/cfg.y"
                                  {
		if (sel.n >= MAX_SELECT_PARAMS-2) {
			yyerror("Select identifier too long\n");
		}
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-3].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-3].strval));
		sel.n++;
		sel.params[sel.n].type = SEL_PARAM_STR;
		sel.params[sel.n].v.s.s = (yyvsp[-1].strval);
		sel.params[sel.n].v.s.len = strlen((yyvsp[-1].strval));
		sel.n++;
	}
#line 11033 "core/cfg.tab.c"
    break;

  case 746: /* $@9: %empty  */
#line 3079 "core/cfg.y"
                    { sel.n = 0; sel.f[0] = 0; }
#line 11039 "core/cfg.tab.c"
    break;

  case 747: /* select_id: SELECT_MARK $@9 select_params  */
#line 3079 "core/cfg.y"
                                                               {
		sel_ptr = (select_t*)pkg_malloc(sizeof(select_t));
		if (!sel_ptr) {
			yyerror("No memory left to allocate select structure\n");
		}
		memcpy(sel_ptr, &sel, sizeof(select_t));
		(yyval.select) = sel_ptr;
	}
#line 11052 "core/cfg.tab.c"
    break;

  case 748: /* attr_class_spec: ATTR_FROM  */
#line 3089 "core/cfg.y"
                  { s_attr->type |= AVP_TRACK_FROM; }
#line 11058 "core/cfg.tab.c"
    break;

  case 749: /* attr_class_spec: ATTR_TO  */
#line 3090 "core/cfg.y"
                  { s_attr->type |= AVP_TRACK_TO; }
#line 11064 "core/cfg.tab.c"
    break;

  case 750: /* attr_class_spec: ATTR_FROMURI  */
#line 3091 "core/cfg.y"
                       { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_URI; }
#line 11070 "core/cfg.tab.c"
    break;

  case 751: /* attr_class_spec: ATTR_TOURI  */
#line 3092 "core/cfg.y"
                     { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_URI; }
#line 11076 "core/cfg.tab.c"
    break;

  case 752: /* attr_class_spec: ATTR_FROMUSER  */
#line 3093 "core/cfg.y"
                        { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_USER; }
#line 11082 "core/cfg.tab.c"
    break;

  case 753: /* attr_class_spec: ATTR_TOUSER  */
#line 3094 "core/cfg.y"
                      { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_USER; }
#line 11088 "core/cfg.tab.c"
    break;

  case 754: /* attr_class_spec: ATTR_FROMDOMAIN  */
#line 3095 "core/cfg.y"
                          { s_attr->type |= AVP_TRACK_FROM | AVP_CLASS_DOMAIN; }
#line 11094 "core/cfg.tab.c"
    break;

  case 755: /* attr_class_spec: ATTR_TODOMAIN  */
#line 3096 "core/cfg.y"
                        { s_attr->type |= AVP_TRACK_TO | AVP_CLASS_DOMAIN; }
#line 11100 "core/cfg.tab.c"
    break;

  case 756: /* attr_class_spec: ATTR_GLOBAL  */
#line 3097 "core/cfg.y"
                      { s_attr->type |= AVP_TRACK_ALL | AVP_CLASS_GLOBAL; }
#line 11106 "core/cfg.tab.c"
    break;

  case 757: /* attr_name_spec: ID  */
#line 3100 "core/cfg.y"
           { s_attr->type |= AVP_NAME_STR; s_attr->name.s.s = (yyvsp[0].strval); s_attr->name.s.len = strlen ((yyvsp[0].strval)); }
#line 11112 "core/cfg.tab.c"
    break;

  case 760: /* attr_mark: ATTR_MARK  */
#line 3107 "core/cfg.y"
                  {
		s_attr = (struct avp_spec*)pkg_malloc(sizeof(struct avp_spec));
		if (!s_attr) { yyerror("No memory left"); YYABORT; }
		else { memset(s_attr, 0, (sizeof(struct avp_spec))); }
	}
#line 11122 "core/cfg.tab.c"
    break;

  case 761: /* attr_id: attr_mark attr_spec  */
#line 3114 "core/cfg.y"
                            { (yyval.attr) = s_attr; }
#line 11128 "core/cfg.tab.c"
    break;

  case 762: /* attr_id_num_idx: attr_mark attr_spec LBRACK intno RBRACK  */
#line 3117 "core/cfg.y"
                                                {
		s_attr->type|= (AVP_NAME_STR | ((yyvsp[-1].intval)<0?AVP_INDEX_BACKWARD:AVP_INDEX_FORWARD));
		s_attr->index = ((yyvsp[-1].intval)<0?-(yyvsp[-1].intval):(yyvsp[-1].intval));
		(yyval.attr) = s_attr;
	}
#line 11138 "core/cfg.tab.c"
    break;

  case 763: /* attr_id_no_idx: attr_mark attr_spec LBRACK RBRACK  */
#line 3124 "core/cfg.y"
                                          {
		s_attr->type|= AVP_INDEX_ALL;
		(yyval.attr) = s_attr;
	}
#line 11147 "core/cfg.tab.c"
    break;

  case 770: /* attr_id_any_str: avp_pvar  */
#line 3146 "core/cfg.y"
                   {
		if ((yyvsp[0].lval)->type==LV_AVP){
			s_attr = pkg_malloc(sizeof(struct avp_spec));
			if (!s_attr) { yyerror("No memory left"); YYABORT; }
			else{
				*s_attr=(yyvsp[0].lval)->lv.avps;
			}
			(yyval.attr)=s_attr;
		}else
			(yyval.attr)=0; /* not an avp, a pvar */
		pkg_free((yyvsp[0].lval));
	}
#line 11164 "core/cfg.tab.c"
    break;

  case 771: /* attr_id_any_str: STRING  */
#line 3158 "core/cfg.y"
                 {
		avp_spec_t *avp_spec;
		str s;
		int type, idx;
		avp_spec = pkg_malloc(sizeof(*avp_spec));
		if (!avp_spec) {
			yyerror("Not enough memory");
			YYABORT;
		}
		s.s = (yyvsp[0].strval);
		if (s.s[0] == '$')
			s.s++;
		s.len = strlen(s.s);
		if (parse_avp_name(&s, &type, &avp_spec->name, &idx)) {
			yyerror("error when parsing AVP");
			pkg_free(avp_spec);
			YYABORT;
		}
		avp_spec->type = type;
		avp_spec->index = idx;
		(yyval.attr) = avp_spec;
	}
#line 11191 "core/cfg.tab.c"
    break;

  case 772: /* pvar: PVAR  */
#line 3182 "core/cfg.y"
             {
			s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
			pv_spec=pv_cache_get(&s_tmp);
			if (!pv_spec) {
				yyerror("Can't get from cache: %s", (yyvsp[0].strval));
				YYABORT;
			}
			(yyval.pvar)=pv_spec;
		}
#line 11205 "core/cfg.tab.c"
    break;

  case 773: /* avp_pvar: AVP_OR_PVAR  */
#line 3193 "core/cfg.y"
                            {
				lval_tmp=pkg_malloc(sizeof(*lval_tmp));
				if (!lval_tmp) {
					yyerror("Not enough memory");
					YYABORT;
				}
				memset(lval_tmp, 0, sizeof(*lval_tmp));
				s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen(s_tmp.s);
				lval_tmp->lv.pvs = pv_cache_get(&s_tmp);
				if (lval_tmp->lv.pvs==NULL){
					lval_tmp->lv.avps.type|= AVP_NAME_STR;
					lval_tmp->lv.avps.name.s.s = s_tmp.s+1;
					lval_tmp->lv.avps.name.s.len = s_tmp.len-1;
					lval_tmp->type=LV_AVP;
				}else{
					lval_tmp->type=LV_PVAR;
				}
				(yyval.lval) = lval_tmp;
				DBG("parsed ambiguous avp/pvar \"%.*s\" to %d\n",
							s_tmp.len, s_tmp.s, lval_tmp->type);
			}
#line 11231 "core/cfg.tab.c"
    break;

  case 774: /* assign_op: EQUAL  */
#line 3224 "core/cfg.y"
              { (yyval.intval) = ASSIGN_T; }
#line 11237 "core/cfg.tab.c"
    break;

  case 775: /* lval: attr_id_ass  */
#line 3228 "core/cfg.y"
                  {
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_AVP; lval_tmp->lv.avps=*(yyvsp[0].attr);
					pkg_free((yyvsp[0].attr)); /* free the avp spec we just copied */
					(yyval.lval)=lval_tmp;
				}
#line 11252 "core/cfg.tab.c"
    break;

  case 776: /* lval: pvar  */
#line 3238 "core/cfg.y"
                      {
					if (!pv_is_w((yyvsp[0].pvar)))
						yyerror("read only pvar in assignment left side");
					if ((yyvsp[0].pvar)->trans!=0)
						yyerror("pvar with transformations in assignment"
								" left side");
					lval_tmp=pkg_malloc(sizeof(*lval_tmp));
					if (!lval_tmp) {
						yyerror("Not enough memory");
						YYABORT;
					}
					lval_tmp->type=LV_PVAR; lval_tmp->lv.pvs=(yyvsp[0].pvar);
					(yyval.lval)=lval_tmp;
				}
#line 11271 "core/cfg.tab.c"
    break;

  case 777: /* lval: avp_pvar  */
#line 3252 "core/cfg.y"
                      {
					if (((yyvsp[0].lval))->type==LV_PVAR){
						if (!pv_is_w((yyvsp[0].lval)->lv.pvs))
							yyerror("read only pvar in assignment left side");
						if ((yyvsp[0].lval)->lv.pvs->trans!=0)
							yyerror("pvar with transformations in assignment"
									" left side");
					}
					(yyval.lval)=(yyvsp[0].lval);
				}
#line 11286 "core/cfg.tab.c"
    break;

  case 778: /* rval: intno  */
#line 3264 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_LONG, (void*)(yyvsp[0].intval)); }
#line 11292 "core/cfg.tab.c"
    break;

  case 779: /* rval: STRING  */
#line 3265 "core/cfg.y"
                                        {	s_tmp.s=(yyvsp[0].strval); s_tmp.len=strlen((yyvsp[0].strval));
							(yyval.rv_expr)=mk_rve_rval(RV_STR, &s_tmp); }
#line 11299 "core/cfg.tab.c"
    break;

  case 780: /* rval: attr_id_any  */
#line 3267 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_AVP, (yyvsp[0].attr)); pkg_free((yyvsp[0].attr)); }
#line 11305 "core/cfg.tab.c"
    break;

  case 781: /* rval: pvar  */
#line 3268 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].pvar)); }
#line 11311 "core/cfg.tab.c"
    break;

  case 782: /* rval: avp_pvar  */
#line 3269 "core/cfg.y"
                                        {
							switch((yyvsp[0].lval)->type){
								case LV_AVP:
									(yyval.rv_expr)=mk_rve_rval(RV_AVP, &(yyvsp[0].lval)->lv.avps);
									break;
								case LV_PVAR:
									(yyval.rv_expr)=mk_rve_rval(RV_PVAR, (yyvsp[0].lval)->lv.pvs);
									break;
								default:
									yyerror("BUG: invalid lvalue type ");
									YYABORT;
							}
							pkg_free((yyvsp[0].lval)); /* not needed anymore */
						}
#line 11330 "core/cfg.tab.c"
    break;

  case 783: /* rval: select_id  */
#line 3283 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_SEL, (yyvsp[0].select)); pkg_free((yyvsp[0].select)); }
#line 11336 "core/cfg.tab.c"
    break;

  case 784: /* rval: fcmd  */
#line 3284 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[0].action)); }
#line 11342 "core/cfg.tab.c"
    break;

  case 785: /* rval: exp_elem  */
#line 3285 "core/cfg.y"
                   { (yyval.rv_expr)=mk_rve_rval(RV_BEXPR, (yyvsp[0].expr)); }
#line 11348 "core/cfg.tab.c"
    break;

  case 786: /* rval: LBRACE actions RBRACE  */
#line 3286 "core/cfg.y"
                                {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 11354 "core/cfg.tab.c"
    break;

  case 787: /* rval: LBRACE error RBRACE  */
#line 3287 "core/cfg.y"
                                { (yyval.rv_expr)=0; yyerror("bad command block"); }
#line 11360 "core/cfg.tab.c"
    break;

  case 788: /* rval: LPAREN assign_action RPAREN  */
#line 3288 "core/cfg.y"
                                        {(yyval.rv_expr)=mk_rve_rval(RV_ACTION_ST, (yyvsp[-1].action)); }
#line 11366 "core/cfg.tab.c"
    break;

  case 789: /* rval: LPAREN error RPAREN  */
#line 3289 "core/cfg.y"
                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11372 "core/cfg.tab.c"
    break;

  case 790: /* rve_un_op: NOT  */
#line 3293 "core/cfg.y"
                { (yyval.intval)=RVE_LNOT_OP; }
#line 11378 "core/cfg.tab.c"
    break;

  case 791: /* rve_un_op: BIN_NOT  */
#line 3294 "core/cfg.y"
                                { (yyval.intval)=RVE_BNOT_OP; }
#line 11384 "core/cfg.tab.c"
    break;

  case 792: /* rve_un_op: MINUS  */
#line 3295 "core/cfg.y"
                                        { (yyval.intval)=RVE_UMINUS_OP; }
#line 11390 "core/cfg.tab.c"
    break;

  case 793: /* rval_expr: rval  */
#line 3308 "core/cfg.y"
                                                        { (yyval.rv_expr)=(yyvsp[0].rv_expr);
										if ((yyval.rv_expr)==0){
											/*yyerror("out of memory\n");*/
											YYERROR;
										}
									}
#line 11401 "core/cfg.tab.c"
    break;

  case 794: /* rval_expr: rve_un_op rval_expr  */
#line 3314 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve1((yyvsp[-1].intval), (yyvsp[0].rv_expr)); }
#line 11407 "core/cfg.tab.c"
    break;

  case 795: /* rval_expr: INTCAST rval_expr  */
#line 3315 "core/cfg.y"
                                                                {(yyval.rv_expr)=mk_rve1(RVE_LONG_OP, (yyvsp[0].rv_expr)); }
#line 11413 "core/cfg.tab.c"
    break;

  case 796: /* rval_expr: STRCAST rval_expr  */
#line 3316 "core/cfg.y"
                                                                {(yyval.rv_expr)=mk_rve1(RVE_STR_OP, (yyvsp[0].rv_expr)); }
#line 11419 "core/cfg.tab.c"
    break;

  case 797: /* rval_expr: rval_expr PLUS rval_expr  */
#line 3317 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_PLUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11425 "core/cfg.tab.c"
    break;

  case 798: /* rval_expr: rval_expr MINUS rval_expr  */
#line 3318 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_MINUS_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11431 "core/cfg.tab.c"
    break;

  case 799: /* rval_expr: rval_expr STAR rval_expr  */
#line 3319 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_MUL_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11437 "core/cfg.tab.c"
    break;

  case 800: /* rval_expr: rval_expr SLASH rval_expr  */
#line 3320 "core/cfg.y"
                                                        {(yyval.rv_expr)=mk_rve2(RVE_DIV_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11443 "core/cfg.tab.c"
    break;

  case 801: /* rval_expr: rval_expr MODULO rval_expr  */
#line 3321 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_MOD_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr)); }
#line 11449 "core/cfg.tab.c"
    break;

  case 802: /* rval_expr: rval_expr BIN_OR rval_expr  */
#line 3322 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr)); }
#line 11455 "core/cfg.tab.c"
    break;

  case 803: /* rval_expr: rval_expr BIN_AND rval_expr  */
#line 3323 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BAND_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11461 "core/cfg.tab.c"
    break;

  case 804: /* rval_expr: rval_expr BIN_XOR rval_expr  */
#line 3324 "core/cfg.y"
                                                {(yyval.rv_expr)=mk_rve2(RVE_BXOR_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11467 "core/cfg.tab.c"
    break;

  case 805: /* rval_expr: rval_expr BIN_LSHIFT rval_expr  */
#line 3325 "core/cfg.y"
                                                 {(yyval.rv_expr)=mk_rve2(RVE_BLSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11473 "core/cfg.tab.c"
    break;

  case 806: /* rval_expr: rval_expr BIN_RSHIFT rval_expr  */
#line 3326 "core/cfg.y"
                                                 {(yyval.rv_expr)=mk_rve2(RVE_BRSHIFT_OP, (yyvsp[-2].rv_expr),  (yyvsp[0].rv_expr));}
#line 11479 "core/cfg.tab.c"
    break;

  case 807: /* rval_expr: rval_expr rve_cmpop rval_expr  */
#line 3327 "core/cfg.y"
                                                         { (yyval.rv_expr)=mk_rve2( (yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11485 "core/cfg.tab.c"
    break;

  case 808: /* rval_expr: rval_expr rve_equalop rval_expr  */
#line 3328 "core/cfg.y"
                                                                {
			/* comparing with $null => treat as defined or !defined */
			if((yyvsp[0].rv_expr) != NULL && (yyvsp[0].rv_expr)->op==RVE_RVAL_OP && (yyvsp[0].rv_expr)->left.rval.type==RV_PVAR
					&& (yyvsp[0].rv_expr)->left.rval.v.pvs.type==PVT_NULL) {
				if((yyvsp[-1].intval)==RVE_DIFF_OP || (yyvsp[-1].intval)==RVE_IDIFF_OP
						|| (yyvsp[-1].intval)==RVE_STRDIFF_OP) {
					DBG("comparison with $null switched to notdefined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[-2].rv_expr));
				} else {
					DBG("comparison with $null switched to defined operator\n");
					(yyval.rv_expr)=mk_rve1(RVE_NOTDEFINED_OP, (yyvsp[-2].rv_expr));
				}
				/* free rve struct for $null */
				rve_destroy((yyvsp[0].rv_expr));
			} else {
				(yyval.rv_expr)=mk_rve2((yyvsp[-1].intval), (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));
			}
		}
#line 11508 "core/cfg.tab.c"
    break;

  case 809: /* rval_expr: rval_expr LOG_AND rval_expr  */
#line 3346 "core/cfg.y"
                                                { (yyval.rv_expr)=mk_rve2(RVE_LAND_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11514 "core/cfg.tab.c"
    break;

  case 810: /* rval_expr: rval_expr LOG_OR rval_expr  */
#line 3347 "core/cfg.y"
                                                { (yyval.rv_expr)=mk_rve2(RVE_LOR_OP, (yyvsp[-2].rv_expr), (yyvsp[0].rv_expr));}
#line 11520 "core/cfg.tab.c"
    break;

  case 811: /* rval_expr: LPAREN rval_expr RPAREN  */
#line 3348 "core/cfg.y"
                                                        { (yyval.rv_expr)=(yyvsp[-1].rv_expr);}
#line 11526 "core/cfg.tab.c"
    break;

  case 812: /* rval_expr: STRLEN LPAREN rval_expr RPAREN  */
#line 3349 "core/cfg.y"
                                                 { (yyval.rv_expr)=mk_rve1(RVE_STRLEN_OP, (yyvsp[-1].rv_expr));}
#line 11532 "core/cfg.tab.c"
    break;

  case 813: /* rval_expr: STREMPTY LPAREN rval_expr RPAREN  */
#line 3350 "core/cfg.y"
                                                   {(yyval.rv_expr)=mk_rve1(RVE_STREMPTY_OP, (yyvsp[-1].rv_expr));}
#line 11538 "core/cfg.tab.c"
    break;

  case 814: /* rval_expr: DEFINED rval_expr  */
#line 3351 "core/cfg.y"
                                                                { (yyval.rv_expr)=mk_rve1(RVE_DEFINED_OP, (yyvsp[0].rv_expr));}
#line 11544 "core/cfg.tab.c"
    break;

  case 815: /* rval_expr: SELVAL LPAREN rval_expr COMMA rval_expr COMMA rval_expr RPAREN  */
#line 3352 "core/cfg.y"
                                                                                 {
				rve_tmp=mk_rve2(RVE_SELVALOPT_OP, (yyvsp[-3].rv_expr), (yyvsp[-1].rv_expr));
				if(rve_tmp == NULL) {
					(yyval.rv_expr)=0;
					yyerror("failed to create tenary target expression");
				}
				(yyval.rv_expr)=mk_rve2(RVE_SELVALEXP_OP, (yyvsp[-5].rv_expr), rve_tmp);
		}
#line 11557 "core/cfg.tab.c"
    break;

  case 816: /* rval_expr: rve_un_op error  */
#line 3360 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11563 "core/cfg.tab.c"
    break;

  case 817: /* rval_expr: INTCAST error  */
#line 3361 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11569 "core/cfg.tab.c"
    break;

  case 818: /* rval_expr: STRCAST error  */
#line 3362 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11575 "core/cfg.tab.c"
    break;

  case 819: /* rval_expr: rval_expr PLUS error  */
#line 3363 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11581 "core/cfg.tab.c"
    break;

  case 820: /* rval_expr: rval_expr MINUS error  */
#line 3364 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11587 "core/cfg.tab.c"
    break;

  case 821: /* rval_expr: rval_expr STAR error  */
#line 3365 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11593 "core/cfg.tab.c"
    break;

  case 822: /* rval_expr: rval_expr SLASH error  */
#line 3366 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11599 "core/cfg.tab.c"
    break;

  case 823: /* rval_expr: rval_expr MODULO error  */
#line 3367 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11605 "core/cfg.tab.c"
    break;

  case 824: /* rval_expr: rval_expr BIN_OR error  */
#line 3368 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11611 "core/cfg.tab.c"
    break;

  case 825: /* rval_expr: rval_expr BIN_AND error  */
#line 3369 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11617 "core/cfg.tab.c"
    break;

  case 826: /* rval_expr: rval_expr rve_cmpop error  */
#line 3371 "core/cfg.y"
                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11623 "core/cfg.tab.c"
    break;

  case 827: /* rval_expr: rval_expr rve_equalop error  */
#line 3373 "core/cfg.y"
                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11629 "core/cfg.tab.c"
    break;

  case 828: /* rval_expr: rval_expr LOG_AND error  */
#line 3374 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11635 "core/cfg.tab.c"
    break;

  case 829: /* rval_expr: rval_expr LOG_OR error  */
#line 3375 "core/cfg.y"
                                                        { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11641 "core/cfg.tab.c"
    break;

  case 830: /* rval_expr: STRLEN LPAREN error RPAREN  */
#line 3376 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11647 "core/cfg.tab.c"
    break;

  case 831: /* rval_expr: STREMPTY LPAREN error RPAREN  */
#line 3377 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11653 "core/cfg.tab.c"
    break;

  case 832: /* rval_expr: SELVAL LPAREN error RPAREN  */
#line 3378 "core/cfg.y"
                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11659 "core/cfg.tab.c"
    break;

  case 833: /* rval_expr: DEFINED error  */
#line 3379 "core/cfg.y"
                                                                { (yyval.rv_expr)=0; yyerror("bad expression"); }
#line 11665 "core/cfg.tab.c"
    break;

  case 834: /* assign_action: lval assign_op rval_expr  */
#line 3382 "core/cfg.y"
                                                { (yyval.action)=mk_action((yyvsp[-1].intval), 2, LVAL_ST, (yyvsp[-2].lval),
														 	  RVE_ST, (yyvsp[0].rv_expr));
											set_cfg_pos((yyval.action));
										}
#line 11674 "core/cfg.tab.c"
    break;

  case 835: /* avpflag_oper: SETAVPFLAG  */
#line 3400 "core/cfg.y"
                   { (yyval.intval) = 1; }
#line 11680 "core/cfg.tab.c"
    break;

  case 836: /* avpflag_oper: RESETAVPFLAG  */
#line 3401 "core/cfg.y"
                       { (yyval.intval) = 0; }
#line 11686 "core/cfg.tab.c"
    break;

  case 837: /* avpflag_oper: ISAVPFLAGSET  */
#line 3402 "core/cfg.y"
                       { (yyval.intval) = -1; }
#line 11692 "core/cfg.tab.c"
    break;

  case 838: /* cmd: FORWARD LPAREN RPAREN  */
#line 3405 "core/cfg.y"
                              { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11698 "core/cfg.tab.c"
    break;

  case 839: /* cmd: FORWARD LPAREN host RPAREN  */
#line 3406 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11704 "core/cfg.tab.c"
    break;

  case 840: /* cmd: FORWARD LPAREN STRING RPAREN  */
#line 3407 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11710 "core/cfg.tab.c"
    break;

  case 841: /* cmd: FORWARD LPAREN ip RPAREN  */
#line 3408 "core/cfg.y"
                                        { (yyval.action)=mk_action(	FORWARD_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11716 "core/cfg.tab.c"
    break;

  case 842: /* cmd: FORWARD LPAREN host COMMA NUMBER RPAREN  */
#line 3409 "core/cfg.y"
                                                  { (yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11722 "core/cfg.tab.c"
    break;

  case 843: /* cmd: FORWARD LPAREN STRING COMMA NUMBER RPAREN  */
#line 3410 "core/cfg.y"
                                                    {(yyval.action)=mk_action(FORWARD_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11728 "core/cfg.tab.c"
    break;

  case 844: /* cmd: FORWARD LPAREN ip COMMA NUMBER RPAREN  */
#line 3411 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11734 "core/cfg.tab.c"
    break;

  case 845: /* cmd: FORWARD LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3412 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11740 "core/cfg.tab.c"
    break;

  case 846: /* cmd: FORWARD LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3413 "core/cfg.y"
                                                     {(yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11746 "core/cfg.tab.c"
    break;

  case 847: /* cmd: FORWARD LPAREN URIHOST RPAREN  */
#line 3414 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11752 "core/cfg.tab.c"
    break;

  case 848: /* cmd: FORWARD error  */
#line 3415 "core/cfg.y"
                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11758 "core/cfg.tab.c"
    break;

  case 849: /* cmd: FORWARD LPAREN error RPAREN  */
#line 3416 "core/cfg.y"
                                      { (yyval.action)=0; yyerror("bad forward argument"); }
#line 11764 "core/cfg.tab.c"
    break;

  case 850: /* cmd: FORWARD_UDP LPAREN host RPAREN  */
#line 3417 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11770 "core/cfg.tab.c"
    break;

  case 851: /* cmd: FORWARD_UDP LPAREN STRING RPAREN  */
#line 3418 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11776 "core/cfg.tab.c"
    break;

  case 852: /* cmd: FORWARD_UDP LPAREN ip RPAREN  */
#line 3419 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11782 "core/cfg.tab.c"
    break;

  case 853: /* cmd: FORWARD_UDP LPAREN host COMMA NUMBER RPAREN  */
#line 3420 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11788 "core/cfg.tab.c"
    break;

  case 854: /* cmd: FORWARD_UDP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3421 "core/cfg.y"
                                                        {(yyval.action)=mk_action(FORWARD_UDP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11794 "core/cfg.tab.c"
    break;

  case 855: /* cmd: FORWARD_UDP LPAREN ip COMMA NUMBER RPAREN  */
#line 3422 "core/cfg.y"
                                                    { (yyval.action)=mk_action(FORWARD_UDP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11800 "core/cfg.tab.c"
    break;

  case 856: /* cmd: FORWARD_UDP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3423 "core/cfg.y"
                                                          {(yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11806 "core/cfg.tab.c"
    break;

  case 857: /* cmd: FORWARD_UDP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3424 "core/cfg.y"
                                                         { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11812 "core/cfg.tab.c"
    break;

  case 858: /* cmd: FORWARD_UDP LPAREN URIHOST RPAREN  */
#line 3425 "core/cfg.y"
                                            { (yyval.action)=mk_action(FORWARD_UDP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11818 "core/cfg.tab.c"
    break;

  case 859: /* cmd: FORWARD_UDP error  */
#line 3426 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11824 "core/cfg.tab.c"
    break;

  case 860: /* cmd: FORWARD_UDP LPAREN error RPAREN  */
#line 3427 "core/cfg.y"
                                          { (yyval.action)=0; yyerror("bad forward_udp argument"); }
#line 11830 "core/cfg.tab.c"
    break;

  case 861: /* cmd: FORWARD_TCP LPAREN host RPAREN  */
#line 3428 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11836 "core/cfg.tab.c"
    break;

  case 862: /* cmd: FORWARD_TCP LPAREN STRING RPAREN  */
#line 3429 "core/cfg.y"
                                                { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11842 "core/cfg.tab.c"
    break;

  case 863: /* cmd: FORWARD_TCP LPAREN ip RPAREN  */
#line 3430 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11848 "core/cfg.tab.c"
    break;

  case 864: /* cmd: FORWARD_TCP LPAREN host COMMA NUMBER RPAREN  */
#line 3431 "core/cfg.y"
                                                      { (yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11854 "core/cfg.tab.c"
    break;

  case 865: /* cmd: FORWARD_TCP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3432 "core/cfg.y"
                                                        {(yyval.action)=mk_action(FORWARD_TCP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11860 "core/cfg.tab.c"
    break;

  case 866: /* cmd: FORWARD_TCP LPAREN ip COMMA NUMBER RPAREN  */
#line 3433 "core/cfg.y"
                                                    { (yyval.action)=mk_action(FORWARD_TCP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11866 "core/cfg.tab.c"
    break;

  case 867: /* cmd: FORWARD_TCP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3434 "core/cfg.y"
                                                          {(yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action)); }
#line 11872 "core/cfg.tab.c"
    break;

  case 868: /* cmd: FORWARD_TCP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3435 "core/cfg.y"
                                                         { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 11878 "core/cfg.tab.c"
    break;

  case 869: /* cmd: FORWARD_TCP LPAREN URIHOST RPAREN  */
#line 3436 "core/cfg.y"
                                            { (yyval.action)=mk_action(FORWARD_TCP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action)); }
#line 11884 "core/cfg.tab.c"
    break;

  case 870: /* cmd: FORWARD_TCP error  */
#line 3437 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 11890 "core/cfg.tab.c"
    break;

  case 871: /* cmd: FORWARD_TCP LPAREN error RPAREN  */
#line 3438 "core/cfg.y"
                                          { (yyval.action)=0; yyerror("bad forward_tcp argument"); }
#line 11896 "core/cfg.tab.c"
    break;

  case 872: /* cmd: FORWARD_TLS LPAREN host RPAREN  */
#line 3439 "core/cfg.y"
                                         {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11909 "core/cfg.tab.c"
    break;

  case 873: /* cmd: FORWARD_TLS LPAREN STRING RPAREN  */
#line 3447 "core/cfg.y"
                                           {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11922 "core/cfg.tab.c"
    break;

  case 874: /* cmd: FORWARD_TLS LPAREN ip RPAREN  */
#line 3455 "core/cfg.y"
                                        {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11935 "core/cfg.tab.c"
    break;

  case 875: /* cmd: FORWARD_TLS LPAREN host COMMA NUMBER RPAREN  */
#line 3463 "core/cfg.y"
                                                      {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11948 "core/cfg.tab.c"
    break;

  case 876: /* cmd: FORWARD_TLS LPAREN STRING COMMA NUMBER RPAREN  */
#line 3471 "core/cfg.y"
                                                        {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11961 "core/cfg.tab.c"
    break;

  case 877: /* cmd: FORWARD_TLS LPAREN ip COMMA NUMBER RPAREN  */
#line 3479 "core/cfg.y"
                                                    {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
					}
#line 11974 "core/cfg.tab.c"
    break;

  case 878: /* cmd: FORWARD_TLS LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3487 "core/cfg.y"
                                                          {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 11987 "core/cfg.tab.c"
    break;

  case 879: /* cmd: FORWARD_TLS LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3495 "core/cfg.y"
                                                         {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12000 "core/cfg.tab.c"
    break;

  case 880: /* cmd: FORWARD_TLS LPAREN URIHOST RPAREN  */
#line 3503 "core/cfg.y"
                                            {
		#ifdef USE_TLS
			(yyval.action)=mk_action(FORWARD_TLS_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12013 "core/cfg.tab.c"
    break;

  case 881: /* cmd: FORWARD_TLS error  */
#line 3511 "core/cfg.y"
                            { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12019 "core/cfg.tab.c"
    break;

  case 882: /* cmd: FORWARD_TLS LPAREN error RPAREN  */
#line 3512 "core/cfg.y"
                                          { (yyval.action)=0;
									yyerror("bad forward_tls argument"); }
#line 12026 "core/cfg.tab.c"
    break;

  case 883: /* cmd: FORWARD_SCTP LPAREN host RPAREN  */
#line 3514 "core/cfg.y"
                                          {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12039 "core/cfg.tab.c"
    break;

  case 884: /* cmd: FORWARD_SCTP LPAREN STRING RPAREN  */
#line 3522 "core/cfg.y"
                                            {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-1].strval), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12052 "core/cfg.tab.c"
    break;

  case 885: /* cmd: FORWARD_SCTP LPAREN ip RPAREN  */
#line 3530 "core/cfg.y"
                                        {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-1].ipaddr), NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12065 "core/cfg.tab.c"
    break;

  case 886: /* cmd: FORWARD_SCTP LPAREN host COMMA NUMBER RPAREN  */
#line 3538 "core/cfg.y"
                                                       {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12079 "core/cfg.tab.c"
    break;

  case 887: /* cmd: FORWARD_SCTP LPAREN STRING COMMA NUMBER RPAREN  */
#line 3547 "core/cfg.y"
                                                         {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12093 "core/cfg.tab.c"
    break;

  case 888: /* cmd: FORWARD_SCTP LPAREN ip COMMA NUMBER RPAREN  */
#line 3556 "core/cfg.y"
                                                     {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, IP_ST, (void*)(yyvsp[-3].ipaddr), NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
					}
#line 12107 "core/cfg.tab.c"
    break;

  case 889: /* cmd: FORWARD_SCTP LPAREN URIHOST COMMA URIPORT RPAREN  */
#line 3565 "core/cfg.y"
                                                           {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, URIPORT_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12120 "core/cfg.tab.c"
    break;

  case 890: /* cmd: FORWARD_SCTP LPAREN URIHOST COMMA NUMBER RPAREN  */
#line 3573 "core/cfg.y"
                                                          {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST,
							(void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("sctp support not compiled in");
		#endif
	}
#line 12134 "core/cfg.tab.c"
    break;

  case 891: /* cmd: FORWARD_SCTP LPAREN URIHOST RPAREN  */
#line 3582 "core/cfg.y"
                                             {
		#ifdef USE_SCTP
			(yyval.action)=mk_action(FORWARD_SCTP_T, 2, URIHOST_ST, 0, NUMBER_ST, 0); set_cfg_pos((yyval.action));
		#else
			(yyval.action)=0;
			yyerror("tls support not compiled in");
		#endif
	}
#line 12147 "core/cfg.tab.c"
    break;

  case 892: /* cmd: FORWARD_SCTP error  */
#line 3590 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12153 "core/cfg.tab.c"
    break;

  case 893: /* cmd: FORWARD_SCTP LPAREN error RPAREN  */
#line 3591 "core/cfg.y"
                                           { (yyval.action)=0;
									yyerror("bad forward_sctp argument"); }
#line 12160 "core/cfg.tab.c"
    break;

  case 894: /* cmd: LOG_TOK LPAREN STRING RPAREN  */
#line 3593 "core/cfg.y"
                                        {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST,
										(void*)(L_DBG+1), STRING_ST, (yyvsp[-1].strval));
									set_cfg_pos((yyval.action)); }
#line 12168 "core/cfg.tab.c"
    break;

  case 895: /* cmd: LOG_TOK LPAREN NUMBER COMMA STRING RPAREN  */
#line 3596 "core/cfg.y"
                                                        {(yyval.action)=mk_action(LOG_T, 2, NUMBER_ST, (void*)(yyvsp[-3].intval), STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12174 "core/cfg.tab.c"
    break;

  case 896: /* cmd: LOG_TOK error  */
#line 3597 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12180 "core/cfg.tab.c"
    break;

  case 897: /* cmd: LOG_TOK LPAREN error RPAREN  */
#line 3598 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("bad log argument"); }
#line 12186 "core/cfg.tab.c"
    break;

  case 898: /* cmd: SETFLAG LPAREN NUMBER RPAREN  */
#line 3599 "core/cfg.y"
                                        {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
													(void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12198 "core/cfg.tab.c"
    break;

  case 899: /* cmd: SETFLAG LPAREN flag_name RPAREN  */
#line 3606 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(SETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12210 "core/cfg.tab.c"
    break;

  case 900: /* cmd: SETFLAG error  */
#line 3613 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12216 "core/cfg.tab.c"
    break;

  case 901: /* cmd: RESETFLAG LPAREN NUMBER RPAREN  */
#line 3614 "core/cfg.y"
                                         {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12227 "core/cfg.tab.c"
    break;

  case 902: /* cmd: RESETFLAG LPAREN flag_name RPAREN  */
#line 3620 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(RESETFLAG_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12239 "core/cfg.tab.c"
    break;

  case 903: /* cmd: RESETFLAG error  */
#line 3627 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12245 "core/cfg.tab.c"
    break;

  case 904: /* cmd: ISFLAGSET LPAREN NUMBER RPAREN  */
#line 3628 "core/cfg.y"
                                         {
							if (check_flag((yyvsp[-1].intval))==-1)
								yyerror("bad flag value");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
							set_cfg_pos((yyval.action));
									}
#line 12256 "core/cfg.tab.c"
    break;

  case 905: /* cmd: ISFLAGSET LPAREN flag_name RPAREN  */
#line 3634 "core/cfg.y"
                                                {
							i_tmp=get_flag_no((yyvsp[-1].strval), strlen((yyvsp[-1].strval)));
							if (i_tmp<0) yyerror("flag not declared");
							(yyval.action)=mk_action(ISFLAGSET_T, 1, NUMBER_ST,
										(void*)(long)i_tmp);
							set_cfg_pos((yyval.action));
									}
#line 12268 "core/cfg.tab.c"
    break;

  case 906: /* cmd: ISFLAGSET error  */
#line 3641 "core/cfg.y"
                          { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12274 "core/cfg.tab.c"
    break;

  case 907: /* cmd: avpflag_oper LPAREN attr_id_any_str COMMA flag_name RPAREN  */
#line 3642 "core/cfg.y"
                                                                     {
		i_tmp=get_avpflag_no((yyvsp[-1].strval));
		if (i_tmp==0) yyerror("avpflag not declared");
		(yyval.action)=mk_action(AVPFLAG_OPER_T, 3, AVP_ST, (yyvsp[-3].attr), NUMBER_ST, (void*)(long)i_tmp, NUMBER_ST, (void*)(yyvsp[-5].intval));
		set_cfg_pos((yyval.action));
	}
#line 12285 "core/cfg.tab.c"
    break;

  case 908: /* cmd: avpflag_oper LPAREN attr_id_any_str COMMA error RPAREN  */
#line 3648 "core/cfg.y"
                                                                 {
		(yyval.action)=0; yyerror("error parsing flag name");
	}
#line 12293 "core/cfg.tab.c"
    break;

  case 909: /* cmd: avpflag_oper LPAREN error COMMA flag_name RPAREN  */
#line 3651 "core/cfg.y"
                                                           {
		(yyval.action)=0; yyerror("error parsing first parameter (avp or string)");
	}
#line 12301 "core/cfg.tab.c"
    break;

  case 910: /* cmd: avpflag_oper LPAREN error RPAREN  */
#line 3654 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad parameters"); }
#line 12307 "core/cfg.tab.c"
    break;

  case 911: /* cmd: avpflag_oper error  */
#line 3655 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')'?"); }
#line 12313 "core/cfg.tab.c"
    break;

  case 912: /* cmd: ERROR LPAREN STRING COMMA STRING RPAREN  */
#line 3656 "core/cfg.y"
                                                  {(yyval.action)=mk_action(ERROR_T, 2, STRING_ST, (yyvsp[-3].strval), STRING_ST, (yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
	}
#line 12321 "core/cfg.tab.c"
    break;

  case 913: /* cmd: ERROR error  */
#line 3659 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12327 "core/cfg.tab.c"
    break;

  case 914: /* cmd: ERROR LPAREN error RPAREN  */
#line 3660 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad error argument"); }
#line 12333 "core/cfg.tab.c"
    break;

  case 915: /* cmd: ROUTE LPAREN rval_expr RPAREN  */
#line 3661 "core/cfg.y"
                                        {
		if ((yyvsp[-1].rv_expr)) {
			(yyval.action) = mk_action(ROUTE_T, 1, RVE_ST, (void*)(yyvsp[-1].rv_expr));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 12347 "core/cfg.tab.c"
    break;

  case 916: /* cmd: ROUTE LPAREN ID RPAREN  */
#line 3670 "core/cfg.y"
                                        {
		if ((yyvsp[-1].strval)) {
			(yyval.action) = mk_action(ROUTE_T, 1, STRING_ST, (void*)(yyvsp[-1].strval));
			set_cfg_pos((yyval.action));
		} else {
			(yyval.action) = 0;
			YYERROR;
		}
	}
#line 12361 "core/cfg.tab.c"
    break;

  case 917: /* cmd: ROUTE error  */
#line 3679 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12367 "core/cfg.tab.c"
    break;

  case 918: /* cmd: ROUTE LPAREN error RPAREN  */
#line 3680 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad route argument"); }
#line 12373 "core/cfg.tab.c"
    break;

  case 919: /* cmd: EXEC LPAREN STRING RPAREN  */
#line 3681 "core/cfg.y"
                                        { (yyval.action)=mk_action(EXEC_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12379 "core/cfg.tab.c"
    break;

  case 920: /* cmd: SET_HOST LPAREN STRING RPAREN  */
#line 3682 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_HOST_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12385 "core/cfg.tab.c"
    break;

  case 921: /* cmd: SET_HOST error  */
#line 3683 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12391 "core/cfg.tab.c"
    break;

  case 922: /* cmd: SET_HOST LPAREN error RPAREN  */
#line 3684 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12397 "core/cfg.tab.c"
    break;

  case 923: /* cmd: PREFIX LPAREN STRING RPAREN  */
#line 3685 "core/cfg.y"
                                      { (yyval.action)=mk_action(PREFIX_T, 1, STRING_ST,  (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12403 "core/cfg.tab.c"
    break;

  case 924: /* cmd: PREFIX error  */
#line 3686 "core/cfg.y"
                       { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12409 "core/cfg.tab.c"
    break;

  case 925: /* cmd: PREFIX LPAREN error RPAREN  */
#line 3687 "core/cfg.y"
                                     { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12415 "core/cfg.tab.c"
    break;

  case 926: /* cmd: STRIP_TAIL LPAREN NUMBER RPAREN  */
#line 3688 "core/cfg.y"
                                          { (yyval.action)=mk_action(STRIP_TAIL_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12421 "core/cfg.tab.c"
    break;

  case 927: /* cmd: STRIP_TAIL error  */
#line 3689 "core/cfg.y"
                           { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12427 "core/cfg.tab.c"
    break;

  case 928: /* cmd: STRIP_TAIL LPAREN error RPAREN  */
#line 3690 "core/cfg.y"
                                         { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12433 "core/cfg.tab.c"
    break;

  case 929: /* cmd: STRIP LPAREN NUMBER RPAREN  */
#line 3691 "core/cfg.y"
                                     { (yyval.action)=mk_action(STRIP_T, 1, NUMBER_ST, (void*) (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12439 "core/cfg.tab.c"
    break;

  case 930: /* cmd: STRIP error  */
#line 3692 "core/cfg.y"
                      { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12445 "core/cfg.tab.c"
    break;

  case 931: /* cmd: STRIP LPAREN error RPAREN  */
#line 3693 "core/cfg.y"
                                    { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12451 "core/cfg.tab.c"
    break;

  case 932: /* cmd: SET_USERPHONE LPAREN RPAREN  */
#line 3694 "core/cfg.y"
                                      { (yyval.action)=mk_action(SET_USERPHONE_T, 0); set_cfg_pos((yyval.action)); }
#line 12457 "core/cfg.tab.c"
    break;

  case 933: /* cmd: SET_USERPHONE error  */
#line 3695 "core/cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12463 "core/cfg.tab.c"
    break;

  case 934: /* cmd: REMOVE_BRANCH LPAREN intno RPAREN  */
#line 3696 "core/cfg.y"
                                            {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
	}
#line 12472 "core/cfg.tab.c"
    break;

  case 935: /* cmd: REMOVE_BRANCH LPAREN RPAREN  */
#line 3700 "core/cfg.y"
                                      {
			(yyval.action)=mk_action(REMOVE_BRANCH_T, 0);
			set_cfg_pos((yyval.action));
	}
#line 12481 "core/cfg.tab.c"
    break;

  case 936: /* cmd: REMOVE_BRANCH error  */
#line 3704 "core/cfg.y"
                              { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12487 "core/cfg.tab.c"
    break;

  case 937: /* cmd: REMOVE_BRANCH LPAREN error RPAREN  */
#line 3705 "core/cfg.y"
                                            { (yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12493 "core/cfg.tab.c"
    break;

  case 938: /* cmd: CLEAR_BRANCHES LPAREN RPAREN  */
#line 3706 "core/cfg.y"
                                       { (yyval.action)=mk_action(CLEAR_BRANCHES_T, 0); set_cfg_pos((yyval.action)); }
#line 12499 "core/cfg.tab.c"
    break;

  case 939: /* cmd: SET_HOSTPORT LPAREN STRING RPAREN  */
#line 3707 "core/cfg.y"
                                            { (yyval.action)=mk_action(SET_HOSTPORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12505 "core/cfg.tab.c"
    break;

  case 940: /* cmd: SET_HOSTPORT error  */
#line 3708 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12511 "core/cfg.tab.c"
    break;

  case 941: /* cmd: SET_HOSTPORT LPAREN error RPAREN  */
#line 3709 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12517 "core/cfg.tab.c"
    break;

  case 942: /* cmd: SET_HOSTPORTTRANS LPAREN STRING RPAREN  */
#line 3710 "core/cfg.y"
                                                 { (yyval.action)=mk_action(SET_HOSTPORTTRANS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12523 "core/cfg.tab.c"
    break;

  case 943: /* cmd: SET_HOSTPORTTRANS error  */
#line 3711 "core/cfg.y"
                                  { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12529 "core/cfg.tab.c"
    break;

  case 944: /* cmd: SET_HOSTPORTTRANS LPAREN error RPAREN  */
#line 3712 "core/cfg.y"
                                                { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12535 "core/cfg.tab.c"
    break;

  case 945: /* cmd: SET_PORT LPAREN STRING RPAREN  */
#line 3713 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_PORT_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12541 "core/cfg.tab.c"
    break;

  case 946: /* cmd: SET_PORT error  */
#line 3714 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12547 "core/cfg.tab.c"
    break;

  case 947: /* cmd: SET_PORT LPAREN error RPAREN  */
#line 3715 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12553 "core/cfg.tab.c"
    break;

  case 948: /* cmd: SET_USER LPAREN STRING RPAREN  */
#line 3716 "core/cfg.y"
                                        { (yyval.action)=mk_action(SET_USER_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12559 "core/cfg.tab.c"
    break;

  case 949: /* cmd: SET_USER error  */
#line 3717 "core/cfg.y"
                         { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12565 "core/cfg.tab.c"
    break;

  case 950: /* cmd: SET_USER LPAREN error RPAREN  */
#line 3718 "core/cfg.y"
                                       { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12571 "core/cfg.tab.c"
    break;

  case 951: /* cmd: SET_USERPASS LPAREN STRING RPAREN  */
#line 3719 "core/cfg.y"
                                            { (yyval.action)=mk_action(SET_USERPASS_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12577 "core/cfg.tab.c"
    break;

  case 952: /* cmd: SET_USERPASS error  */
#line 3720 "core/cfg.y"
                             { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12583 "core/cfg.tab.c"
    break;

  case 953: /* cmd: SET_USERPASS LPAREN error RPAREN  */
#line 3721 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12589 "core/cfg.tab.c"
    break;

  case 954: /* cmd: SET_URI LPAREN STRING RPAREN  */
#line 3722 "core/cfg.y"
                                       { (yyval.action)=mk_action(SET_URI_T, 1, STRING_ST,(yyvsp[-1].strval)); set_cfg_pos((yyval.action)); }
#line 12595 "core/cfg.tab.c"
    break;

  case 955: /* cmd: SET_URI error  */
#line 3723 "core/cfg.y"
                        { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12601 "core/cfg.tab.c"
    break;

  case 956: /* cmd: SET_URI LPAREN error RPAREN  */
#line 3724 "core/cfg.y"
                                      { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12607 "core/cfg.tab.c"
    break;

  case 957: /* cmd: REVERT_URI LPAREN RPAREN  */
#line 3725 "core/cfg.y"
                                   { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12613 "core/cfg.tab.c"
    break;

  case 958: /* cmd: REVERT_URI  */
#line 3726 "core/cfg.y"
                     { (yyval.action)=mk_action(REVERT_URI_T, 0); set_cfg_pos((yyval.action)); }
#line 12619 "core/cfg.tab.c"
    break;

  case 959: /* cmd: FORCE_RPORT LPAREN RPAREN  */
#line 3727 "core/cfg.y"
                                        { (yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12625 "core/cfg.tab.c"
    break;

  case 960: /* cmd: FORCE_RPORT  */
#line 3728 "core/cfg.y"
                        {(yyval.action)=mk_action(FORCE_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12631 "core/cfg.tab.c"
    break;

  case 961: /* cmd: ADD_LOCAL_RPORT LPAREN RPAREN  */
#line 3729 "core/cfg.y"
                                        { (yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12637 "core/cfg.tab.c"
    break;

  case 962: /* cmd: ADD_LOCAL_RPORT  */
#line 3730 "core/cfg.y"
                                {(yyval.action)=mk_action(ADD_LOCAL_RPORT_T, 0); set_cfg_pos((yyval.action)); }
#line 12643 "core/cfg.tab.c"
    break;

  case 963: /* cmd: FORCE_TCP_ALIAS LPAREN NUMBER RPAREN  */
#line 3731 "core/cfg.y"
                                                {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 1, NUMBER_ST, (void*)(yyvsp[-1].intval));
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12656 "core/cfg.tab.c"
    break;

  case 964: /* cmd: FORCE_TCP_ALIAS LPAREN RPAREN  */
#line 3739 "core/cfg.y"
                                        {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12669 "core/cfg.tab.c"
    break;

  case 965: /* cmd: FORCE_TCP_ALIAS  */
#line 3747 "core/cfg.y"
                                                        {
		#ifdef USE_TCP
			(yyval.action)=mk_action(FORCE_TCP_ALIAS_T, 0);
			set_cfg_pos((yyval.action));
		#else
			yyerror("tcp support not compiled in");
		#endif
	}
#line 12682 "core/cfg.tab.c"
    break;

  case 966: /* cmd: FORCE_TCP_ALIAS LPAREN error RPAREN  */
#line 3755 "core/cfg.y"
                                                {(yyval.action)=0; yyerror("bad argument, number expected"); }
#line 12688 "core/cfg.tab.c"
    break;

  case 967: /* cmd: UDP_MTU_TRY_PROTO LPAREN proto RPAREN  */
#line 3757 "core/cfg.y"
                { (yyval.action)=mk_action(UDP_MTU_TRY_PROTO_T, 1, NUMBER_ST, (yyvsp[-1].intval)); set_cfg_pos((yyval.action)); }
#line 12694 "core/cfg.tab.c"
    break;

  case 968: /* cmd: UDP_MTU_TRY_PROTO LPAREN error RPAREN  */
#line 3759 "core/cfg.y"
                { (yyval.action)=0; yyerror("bad argument, UDP, TCP, TLS or SCTP expected"); }
#line 12700 "core/cfg.tab.c"
    break;

  case 969: /* cmd: SET_ADV_ADDRESS LPAREN listen_id RPAREN  */
#line 3760 "core/cfg.y"
                                                  {
		(yyval.action)=0;
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			str_tmp->s=(yyvsp[-1].strval);
			str_tmp->len=(yyvsp[-1].strval)?strlen((yyvsp[-1].strval)):0;
			(yyval.action)=mk_action(SET_ADV_ADDR_T, 1, STR_ST, str_tmp);
			set_cfg_pos((yyval.action));
		}
	}
#line 12716 "core/cfg.tab.c"
    break;

  case 970: /* cmd: SET_ADV_ADDRESS LPAREN error RPAREN  */
#line 3771 "core/cfg.y"
                                              { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12722 "core/cfg.tab.c"
    break;

  case 971: /* cmd: SET_ADV_ADDRESS error  */
#line 3772 "core/cfg.y"
                                {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12728 "core/cfg.tab.c"
    break;

  case 972: /* cmd: SET_ADV_PORT LPAREN NUMBER RPAREN  */
#line 3773 "core/cfg.y"
                                            {
		(yyval.action)=0;
		tmp=int2str((yyvsp[-1].intval), &i_tmp);
		if ((str_tmp=pkg_malloc(sizeof(str)))==0) {
			PKG_MEM_CRITICAL;
		} else {
			if ((str_tmp->s=pkg_malloc(i_tmp))==0) {
				PKG_MEM_CRITICAL;
			} else {
				memcpy(str_tmp->s, tmp, i_tmp);
				str_tmp->len=i_tmp;
				(yyval.action)=mk_action(SET_ADV_PORT_T, 1, STR_ST, str_tmp);
				set_cfg_pos((yyval.action));
			}
		}
	}
#line 12749 "core/cfg.tab.c"
    break;

  case 973: /* cmd: SET_ADV_PORT LPAREN error RPAREN  */
#line 3789 "core/cfg.y"
                                           { (yyval.action)=0; yyerror("bad argument, string expected"); }
#line 12755 "core/cfg.tab.c"
    break;

  case 974: /* cmd: SET_ADV_PORT error  */
#line 3790 "core/cfg.y"
                              {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12761 "core/cfg.tab.c"
    break;

  case 975: /* cmd: FORCE_SEND_SOCKET LPAREN phostport RPAREN  */
#line 3791 "core/cfg.y"
                                                    {
		(yyval.action)=mk_action(FORCE_SEND_SOCKET_T, 1, SOCKID_ST, (yyvsp[-1].sockid));
		set_cfg_pos((yyval.action));
	}
#line 12770 "core/cfg.tab.c"
    break;

  case 976: /* cmd: FORCE_SEND_SOCKET LPAREN error RPAREN  */
#line 3795 "core/cfg.y"
                                                {
		(yyval.action)=0; yyerror("bad argument, [proto:]host[:port] expected");
	}
#line 12778 "core/cfg.tab.c"
    break;

  case 977: /* cmd: FORCE_SEND_SOCKET error  */
#line 3798 "core/cfg.y"
                                  {(yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12784 "core/cfg.tab.c"
    break;

  case 978: /* cmd: SET_FWD_NO_CONNECT LPAREN RPAREN  */
#line 3799 "core/cfg.y"
                                                {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12792 "core/cfg.tab.c"
    break;

  case 979: /* cmd: SET_FWD_NO_CONNECT  */
#line 3802 "core/cfg.y"
                                {
		(yyval.action)=mk_action(SET_FWD_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12800 "core/cfg.tab.c"
    break;

  case 980: /* cmd: SET_RPL_NO_CONNECT LPAREN RPAREN  */
#line 3805 "core/cfg.y"
                                                {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12808 "core/cfg.tab.c"
    break;

  case 981: /* cmd: SET_RPL_NO_CONNECT  */
#line 3808 "core/cfg.y"
                                {
		(yyval.action)=mk_action(SET_RPL_NO_CONNECT_T, 0); set_cfg_pos((yyval.action));
	}
#line 12816 "core/cfg.tab.c"
    break;

  case 982: /* cmd: SET_FWD_CLOSE LPAREN RPAREN  */
#line 3811 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12824 "core/cfg.tab.c"
    break;

  case 983: /* cmd: SET_FWD_CLOSE  */
#line 3814 "core/cfg.y"
                        {
		(yyval.action)=mk_action(SET_FWD_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12832 "core/cfg.tab.c"
    break;

  case 984: /* cmd: SET_RPL_CLOSE LPAREN RPAREN  */
#line 3817 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12840 "core/cfg.tab.c"
    break;

  case 985: /* cmd: SET_RPL_CLOSE  */
#line 3820 "core/cfg.y"
                        {
		(yyval.action)=mk_action(SET_RPL_CLOSE_T, 0); set_cfg_pos((yyval.action));
	}
#line 12848 "core/cfg.tab.c"
    break;

  case 986: /* cmd: CFG_SELECT LPAREN STRING COMMA NUMBER RPAREN  */
#line 3823 "core/cfg.y"
                                                       {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), NUMBER_ST, (void*)(yyvsp[-1].intval)); set_cfg_pos((yyval.action));
	}
#line 12856 "core/cfg.tab.c"
    break;

  case 987: /* cmd: CFG_SELECT LPAREN STRING COMMA rval_expr RPAREN  */
#line 3826 "core/cfg.y"
                                                          {
		(yyval.action)=mk_action(CFG_SELECT_T, 2, STRING_ST, (yyvsp[-3].strval), RVE_ST, (yyvsp[-1].rv_expr)); set_cfg_pos((yyval.action));
	}
#line 12864 "core/cfg.tab.c"
    break;

  case 988: /* cmd: CFG_SELECT error  */
#line 3829 "core/cfg.y"
                           { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12870 "core/cfg.tab.c"
    break;

  case 989: /* cmd: CFG_SELECT LPAREN error RPAREN  */
#line 3830 "core/cfg.y"
                                         { (yyval.action)=0; yyerror("bad arguments, string and number expected"); }
#line 12876 "core/cfg.tab.c"
    break;

  case 990: /* cmd: CFG_RESET LPAREN STRING RPAREN  */
#line 3831 "core/cfg.y"
                                         {
		(yyval.action)=mk_action(CFG_RESET_T, 1, STRING_ST, (yyvsp[-1].strval)); set_cfg_pos((yyval.action));
	}
#line 12884 "core/cfg.tab.c"
    break;

  case 991: /* cmd: CFG_RESET error  */
#line 3834 "core/cfg.y"
                          { (yyval.action)=0; yyerror("missing '(' or ')' ?"); }
#line 12890 "core/cfg.tab.c"
    break;

  case 992: /* cmd: CFG_RESET LPAREN error RPAREN  */
#line 3835 "core/cfg.y"
                                        { (yyval.action)=0; yyerror("bad arguments, string expected"); }
#line 12896 "core/cfg.tab.c"
    break;

  case 993: /* $@10: %empty  */
#line 3836 "core/cfg.y"
             {
		if (mod_func_action != NULL) {
			LM_ERR("function used inside params of another function: %s\n", (yyvsp[0].strval));
			yyerror("use of function execution inside params not allowed\n");
			ksr_exit(-1);
		}
		mod_func_action = mk_action(MODULE0_T, 2, MODEXP_ST, NULL, NUMBER_ST, 0);
		}
#line 12909 "core/cfg.tab.c"
    break;

  case 994: /* cmd: ID $@10 LPAREN func_params RPAREN  */
#line 3843 "core/cfg.y"
                                                {
		mod_func_action->val[0].u.data =
			find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, rt);
		if (mod_func_action->val[0].u.data == 0) {
			if (find_export_record((yyvsp[-4].strval), mod_func_action->val[1].u.number, 0) ) {
					LM_ERR("misused command %s\n", (yyvsp[-4].strval));
					yyerror("Command cannot be used in the block\n");
			} else {
				LM_ERR("cfg. parser: failed to find command %s (params %ld)\n",
						(yyvsp[-4].strval), mod_func_action->val[1].u.number);
				yyerror("unknown command, missing loadmodule?\n");
			}
			free_mod_func_action(mod_func_action);
			mod_func_action=0;
		}else{
			if (mod_func_action && mod_f_params_pre_fixup(mod_func_action)<0) {
				/* error messages are printed inside the function */
				/* free_mod_func_action(mod_func_action); */
				mod_func_action = 0;
				YYERROR;
			}
		}
		(yyval.action) = mod_func_action;
		set_cfg_pos((yyval.action));
		mod_func_action = NULL;
	}
#line 12940 "core/cfg.tab.c"
    break;

  case 995: /* cmd: ID error  */
#line 3869 "core/cfg.y"
                                                        { yyerror("'('')' expected (function call)");}
#line 12946 "core/cfg.tab.c"
    break;

  case 997: /* func_params: func_params COMMA func_param  */
#line 3873 "core/cfg.y"
                                       { }
#line 12952 "core/cfg.tab.c"
    break;

  case 998: /* func_params: func_param  */
#line 3874 "core/cfg.y"
                     {}
#line 12958 "core/cfg.tab.c"
    break;

  case 999: /* func_param: rval_expr  */
#line 3877 "core/cfg.y"
                  {
		if ((yyvsp[0].rv_expr) && mod_func_action->val[1].u.number < MAX_ACTIONS-2) {
			mod_func_action->val[mod_func_action->val[1].u.number+2].type =
				RVE_ST;
			mod_func_action->val[mod_func_action->val[1].u.number+2].u.data =
				(yyvsp[0].rv_expr);
			mod_func_action->val[1].u.number++;
		} else if ((yyvsp[0].rv_expr)) {
			yyerror("Too many arguments\n");
			YYERROR;
		} else {
			YYERROR;
		}
	}
#line 12977 "core/cfg.tab.c"
    break;

  case 1000: /* ret_cmd: DROP LPAREN RPAREN  */
#line 3894 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12986 "core/cfg.tab.c"
    break;

  case 1001: /* ret_cmd: DROP rval_expr  */
#line 3898 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 12995 "core/cfg.tab.c"
    break;

  case 1002: /* ret_cmd: DROP  */
#line 3902 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST,
						(void*)(DROP_R_F|EXIT_R_F)); set_cfg_pos((yyval.action));
	}
#line 13004 "core/cfg.tab.c"
    break;

  case 1003: /* ret_cmd: EXIT LPAREN RPAREN  */
#line 3906 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13014 "core/cfg.tab.c"
    break;

  case 1004: /* ret_cmd: EXIT rval_expr  */
#line 3911 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13023 "core/cfg.tab.c"
    break;

  case 1005: /* ret_cmd: EXIT  */
#line 3915 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)EXIT_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13033 "core/cfg.tab.c"
    break;

  case 1006: /* ret_cmd: RETURN  */
#line 3920 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 13042 "core/cfg.tab.c"
    break;

  case 1007: /* ret_cmd: RETURN LPAREN RPAREN  */
#line 3924 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, (void*)1, NUMBER_ST,
						(void*)RETURN_R_F); set_cfg_pos((yyval.action));
	}
#line 13051 "core/cfg.tab.c"
    break;

  case 1008: /* ret_cmd: RETURN rval_expr  */
#line 3928 "core/cfg.y"
                                {
		(yyval.action)=mk_action(DROP_T, 2, RVE_ST, (yyvsp[0].rv_expr), NUMBER_ST, (void*)RETURN_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13060 "core/cfg.tab.c"
    break;

  case 1009: /* ret_cmd: BREAK  */
#line 3932 "core/cfg.y"
                                        {
		(yyval.action)=mk_action(DROP_T, 2, NUMBER_ST, 0, NUMBER_ST, (void*)BREAK_R_F);
		set_cfg_pos((yyval.action));
	}
#line 13069 "core/cfg.tab.c"
    break;


#line 13073 "core/cfg.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 3938 "core/cfg.y"


static void get_cpos(struct cfg_pos* pos)
{
	pos->s_line=startline;
	pos->e_line=line;
	pos->s_col=startcolumn;
	pos->e_col=column-1;
	if(finame==0)
		finame = (cfg_file!=0)?cfg_file:"default";
	pos->fname=finame;
	pos->rname=(routename!=0)?routename:default_routename;
}


static void warn_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_WARN("warning in config file %s, from line %d, column %d to"
					" line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_WARN("warning in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_WARN("warning in config file %s, line %d, column %d: %s\n",
				p->fname, p->s_line, p->s_col, s);
	cfg_warnings++;
}



static void yyerror_at(struct cfg_pos* p, char* format, ...)
{
	va_list ap;
	char s[256];

	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	if (p->e_line!=p->s_line)
		LM_CRIT("parse error in config file %s, from line %d, column %d"
					" to line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_line, p->e_col, s);
	else if (p->s_col!=p->e_col)
		LM_CRIT("parse error in config file %s, line %d, column %d-%d: %s\n",
					p->fname, p->s_line, p->s_col, p->e_col, s);
	else
		LM_CRIT("parse error in config file %s, line %d, column %d: %s\n",
					p->fname, p->s_line, p->s_col, s);
	cfg_errors++;
	if(ksr_all_errors==0) {
		ksr_exit(-1);
	}
}



static void warn(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	warn_at(&pos, s);
}



static void yyerror(char* format, ...)
{
	va_list ap;
	char s[256];
	struct cfg_pos pos;

	get_cpos(&pos);
	va_start(ap, format);
	vsnprintf(s, sizeof(s), format, ap);
	va_end(ap);
	yyerror_at(&pos, s);
}



/** mk_rval_expr_v wrapper.
 *  checks mk_rval_expr_v return value and sets the cfg. pos
 *  (line and column numbers)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr_v)
 */
static struct rval_expr* mk_rve_rval(enum rval_type type, void* v)
{
	struct rval_expr* ret;
	struct cfg_pos pos;

	get_cpos(&pos);
	ret=mk_rval_expr_v(type, v, &pos);
	if (ret==0){
		yyerror("internal error: failed to create rval expr");
		/* YYABORT; */
	}
	return ret;
}


/** mk_rval_expr1 wrapper.
 *  checks mk_rval_expr1 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr1)
 */
static struct rval_expr* mk_rve1(enum rval_expr_op op, struct rval_expr* rve1)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve1==0)
		return 0;
	ret=mk_rval_expr1(op, rve1, &rve1->fpos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		yyerror_at(&rve1->fpos, "bad expression: type mismatch"
					" (%s instead of %s)", rval_type_name(bad_t),
					rval_type_name(exp_t));
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** mk_rval_expr2 wrapper.
 *  checks mk_rval_expr2 return value (!=0 and type checking)
 *  @return rval_expr* on success, 0 on error (@see mk_rval_expr2)
 */
static struct rval_expr* mk_rve2(enum rval_expr_op op, struct rval_expr* rve1,
									struct rval_expr* rve2)
{
	struct rval_expr* ret;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	struct cfg_pos pos;

	if ((rve1==0) || (rve2==0))
		return 0;
	bad_rve=0;
	bad_t=0;
	exp_t=0;
	cfg_pos_join(&pos, &rve1->fpos, &rve2->fpos);
	ret=mk_rval_expr2(op, rve1, rve2, &pos);
	if (ret && (rve_check_type(&type, ret, &bad_rve, &bad_t, &exp_t)!=1)){
		if (bad_rve)
			yyerror_at(&pos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		rve_destroy(ret);
		ret=0;
	}
	return ret;
}


/** check if the expression is an int.
 * if the expression does not evaluate to an int return -1 and
 * log an error.
 * @return 0 success, no warnings; 1 success but warnings; -1 on error */
static int rval_expr_int_check(struct rval_expr *rve)
{
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;

	if (rve==0){
		yyerror("invalid expression");
		return -1;
	}else if (!rve_check_type(&type, rve, &bad_rve, &bad_t ,&exp_t)){
		if (bad_rve)
			yyerror_at(&rve->fpos, "bad expression: type mismatch:"
						" %s instead of %s at (%d,%d)",
						rval_type_name(bad_t), rval_type_name(exp_t),
						bad_rve->fpos.s_line, bad_rve->fpos.s_col);
		else
			yyerror("BUG: unexpected null \"bad\" expression\n");
		return -1;
	}else if (type!=RV_LONG && type!=RV_NONE){
		warn_at(&rve->fpos, "non-int expression (you might want to use"
				" casts)\n");
		return 1;
	}
	return 0;
}


/** warn if the expression is constant.
 * @return 0 on success (no warning), 1 when warning */
static int warn_ct_rve(struct rval_expr *rve, char* name)
{
	if (rve && rve_is_constant(rve)){
		warn_at(&rve->fpos, "constant value in %s%s",
				name?name:"expression", name?"(...)":"");
		return 1;
	}
	return 0;
}


static struct name_lst* mk_name_lst(char* host, int flags)
{
	struct name_lst* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct name_lst));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct name_lst));
		l->name=host;
		l->flags=flags;
		l->next=0;
	}
	return l;
}


static struct socket_id* mk_listen_id(char* host, int proto, int port)
{
	struct socket_id* l;
	if (host==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->addr_lst=mk_name_lst(host, 0);
		if (l->addr_lst==0){
			pkg_free(l);
			return 0;
		}
		l->flags=0;
		l->port=port;
		l->proto=proto;
		l->next=0;
	}
	return l;
}


static void free_name_lst(struct name_lst* lst)
{
	struct name_lst* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		pkg_free(tmp);
	}
}


static struct socket_id* mk_listen_id2(struct name_lst* addr_l, int proto,
										int port)
{
	struct socket_id* l;
	if (addr_l==0) return 0;
	l=pkg_malloc(sizeof(struct socket_id));
	if (l==0) {
		PKG_MEM_CRITICAL;
	} else {
		memset(l, 0, sizeof(struct socket_id));
		l->flags=addr_l->flags;
		l->port=port;
		l->proto=proto;
		l->addr_lst=addr_l;
		l->next=0;
	}
	return l;
}


static void free_socket_id(struct socket_id* i)
{
	free_name_lst(i->addr_lst);
	pkg_free(i);
}


static void free_socket_id_lst(struct socket_id* lst)
{
	struct socket_id* tmp;

	while(lst){
		tmp=lst;
		lst=lst->next;
		free_socket_id(tmp);
	}
}


/** create a temporary case statmenet structure.
 *  *err will be filled in case of error (return == 0):
 *   -1 - non constant expression
 *   -2 - expression error (bad type)
 *   -10 - memory allocation error
 */
static struct case_stms* mk_case_stm(struct rval_expr* ct, int is_re,
											struct action* a, int* err)
{
	struct case_stms* s;
	struct rval_expr* bad_rve;
	enum rval_type type, bad_t, exp_t;
	enum match_str_type t;

	t=MATCH_UNKNOWN;
	if (ct){
		/* if ct!=0 => case, else if ct==0 is a default */
		if (!rve_is_constant(ct)){
			yyerror_at(&ct->fpos, "non constant expression in case");
			*err=-1;
			return 0;
		}
		if (rve_check_type(&type, ct, &bad_rve, &bad_t, &exp_t)!=1){
			yyerror_at(&ct->fpos, "bad expression: type mismatch:"
							" %s instead of %s at (%d,%d)",
							rval_type_name(bad_t), rval_type_name(exp_t),
							bad_rve->fpos.s_line, bad_rve->fpos.s_col);
			*err=-2;
			return 0;
		}
		if (is_re)
			t=MATCH_RE;
		else if (type==RV_STR)
			t=MATCH_STR;
		else
			t=MATCH_INT;
	}

	s=pkg_malloc(sizeof(*s));
	if (s==0) {
		yyerror("internal error: memory allocation failure");
		*err=-10;
	} else {
		memset(s, 0, sizeof(*s));
		s->ct_rve=ct;
		s->type=t;
		s->actions=a;
		s->next=0;
		s->append=0;
	}
	return s;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_type(struct case_stms* stms)
{
	struct case_stms* c;
	struct case_stms* s;

	for(c=stms; c ; c=c->next){
		if (!c->ct_rve) continue;
		for (s=c->next; s; s=s->next){
			if (!s->ct_rve) continue;
			if ((s->type!=c->type) &&
				!(	(c->type==MATCH_STR || c->type==MATCH_RE) &&
					(s->type==MATCH_STR || s->type==MATCH_RE) ) ){
					yyerror_at(&s->ct_rve->fpos, "type mismatch in case");
					return -1;
			}
		}
	}
	return 0;
}


/*
 * @return 0 on success, -1 on error.
 */
static int case_check_default(struct case_stms* stms)
{
	struct case_stms* c;
	int default_no;

	default_no=0;
	for(c=stms; c ; c=c->next)
		if (c->ct_rve==0) default_no++;
	return (default_no<=1)?0:-1;
}



/** fixes the parameters and the type of a module function call.
 * It is done here instead of fix action, to have quicker feedback
 * on error cases (e.g. passing a non constant to a function with a
 * declared fixup)
 * The rest of the fixup is done inside do_action().
 * @param a - filled module function call (MODULE*_T) action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 * @return 0 on success, -1 on error (it will also print the error msg.).
 *
 */
static int mod_f_params_pre_fixup(struct action* a)
{
	ksr_cmd_export_t* cmd_exp;
	action_u_t* params;
	int param_no;
	struct rval_expr* rve;
	struct rvalue* rv;
	int r;
	str s;

	cmd_exp = a->val[0].u.data;
	param_no = a->val[1].u.number;
	params = &a->val[2];

	switch(cmd_exp->param_no) {
		case 0:
			a->type = MODULE0_T;
			break;
		case 1:
			a->type = MODULE1_T;
			break;
		case 2:
			a->type = MODULE2_T;
			break;
		case 3:
			a->type = MODULE3_T;
			break;
		case 4:
			a->type = MODULE4_T;
			break;
		case 5:
			a->type = MODULE5_T;
			break;
		case 6:
			a->type = MODULE6_T;
			break;
		case VAR_PARAM_NO:
			a->type = MODULEX_T;
			break;
		default:
			yyerror("function %s: bad definition"
					" (invalid number of parameters)", cmd_exp->name);
			return -1;
	}

	if ( cmd_exp->fixup) {
		if (is_fparam_rve_fixup(cmd_exp->fixup))
			/* mark known fparam rve safe fixups */
			cmd_exp->fixup_flags  |= FIXUP_F_FPARAM_RVE;
		else if (!(cmd_exp->fixup_flags & FIXUP_F_FPARAM_RVE) &&
				 cmd_exp->free_fixup == 0) {
			/* v0 or v1 functions that have fixups and no corresp. fixup_free
			   functions, need constant, string params.*/
			for (r=0; r < param_no; r++) {
				rve=params[r].u.data;
				if (!rve_is_constant(rve)) {
					yyerror_at(&rve->fpos, "function %s: parameter %d is not"
								" constant\n", cmd_exp->name, r+1);
					return -1;
				}
				if ((rv = rval_expr_eval(0, 0, rve)) == 0 ||
						rval_get_str(0, 0, &s, rv, 0) < 0 ) {
					/* out of mem or bug ? */
					rval_destroy(rv);
					yyerror_at(&rve->fpos, "function %s: bad parameter %d"
									" expression\n", cmd_exp->name, r+1);
					return -1;
				}
				rval_destroy(rv);
				rve_destroy(rve);
				params[r].type = STRING_ST; /* asciiz */
				params[r].u.string = s.s;
				params[r].u.str.len = s.len; /* not used right now */
			}
		}
	}/* else
		if no fixups are present, the RVEs can be transformed
		into strings at runtime, allowing seamless var. use
		even with old functions.
		Further optimizations -> in fix_actions()
		*/
	return 0;
}



/** frees a filled module function call action structure.
 * @param a - filled module function call action structure
 *            complete with parameters, starting at val[2] and parameter
 *            number at val[1].
 */
static void free_mod_func_action(struct action* a)
{
	action_u_t* params;
	int param_no;
	int r;

	param_no = a->val[1].u.number;
	params = &a->val[2];

	for (r=0; r < param_no; r++)
		if (params[r].u.data)
			rve_destroy(params[r].u.data);
	pkg_free(a);
}



/*
int main(int argc, char ** argv)
{
	if (yyparse()!=0)
		fprintf(stderr, "parsing error\n");
}
*/
